#ifndef _BCSDRV_H_
#define _BCSDRV_H_

#include "BcsTcpLink.h"
#include "BcsTangoLink.h"
#include "Drv.h"
#include <stdio.h>
#include <math.h>
#include <map>
#include <string>
#include <vector>

#include <cstdlib>
#include <unistd.h>

namespace Controller_ns {

class BcsDrv : public Drv {

private:
	Link_ns::BcsTangoLink *_bcslink;

	mconf_t _mc;

public:
	BcsDrv(string target, string extra);
	~BcsDrv();

	bool  	speed(string channel, double v)			{ return false; };
	double  speed(string channel) 				{ return nan(""); };

	bool  	acceleration(string channel, double a) 		{ return true; };
	double  acceleration(string channel) 			{ return nan(""); };

	bool  	deceleration(string channel, double a) 		{ return true; };
	double  deceleration(string channel) 			{ return nan(""); };

	bool 	forward(string channel, double v) 		{ return false;};		// v = speed
	bool    backward(string channel, double v) 		{ return false;};		// v = speed

	bool    stop(string channel) 				{ return false;};

	double  mpos(string channel) 				;
	bool    mpos(string channel, double p);		       // mpos : motor position
	bool    xpos(string channel, double p);		       // xpos : motor position in encoder units

	bool    rpos(string channel, double p);		       // rpos : motor relative position

	bool    motor_off(string channel) 			{ return false;};
        bool    motor_on(string channel) 			{ return false;};

	bool    mconf(string channel, mconf_t mc);
	mconf_t mconf(string channel);


	bool    econf(string channel, econf_t ec)		{ return true; };
	econf_t econf(string channel)				{ econf_t ec; return ec; };

	bool    defmpos(string channel, double p);       	// define motor position
        bool    defepos(string channel, double p)     		{ return true;};	// define encoder position


	bool    program_running() 				{ return true;};

        bool    bcsinit(string channel);        		// true = INIT / false = NO INIT
        bool    bcsinit(string channel, bool b); 		// true = INIT / false = DEINIT

	Link_ns::rvalues_t      refresh(string channel)		{ Link_ns::rvalues_t rt; return rt;};

        unsigned long   yCC_code(string channel);
        unsigned long   yCC_code(string channel, bool do_update);
        bool            yCC_code(string channel, unsigned long CC_code);

        unsigned long   yCC_status(string channel);


	//================================
	int8_t  		opmode(string channel)  	{ int8_t v = 0; return v; };
	bool    		opmode(string channel, int8_t op) { return false; };
	bool  			stop_no_brake(string channel) 	{ return false; };
	bool    		findedge(string channel, double v) { return false; };
	bool    		findindex(string channel, double v) { return false; };
	bool  			brake(string channel, bool b) 	{ return false; };
	int     		hw_brake_conf(string channel) 	{ return 0; };
	string  		stop_code2str(unsigned long stop_code) { return "NONE"; };
	long  			get_ls_tolerance(string channel) { return -1; };

	bool                    Cia402HomingStart(int mode) 	{ return false; };
	bool                    Cia402HomingEndRestore(int mode) { return false; };
	Cia402HomingState_t     Cia402HomingState() 		{ Cia402HomingState_t hs = CIA402_HOME_INTERRUPTED; return hs; };
	Cia402HomingParams_t 	Cia402HomingParams() 		{ Cia402HomingParams_t hp; return hp; };
	bool   			Cia402HomingParams(Cia402HomingParams_t p) { return false; };

}; /* class SimulDrv */


} /* namespace Controller_ns */

#endif /* _BCSDRV_H_ */
