#ifndef _DMC2XXXINCHDRV_H_
#define _DMC2XXXINCHDRV_H_

#include "Drv.h"
#include <stdio.h>
#include <math.h>
#include <algorithm>
#include <map>
#include <string>
#include <vector>


namespace Controller_ns {

#define MIN_SPx_VALUE 2
#define MIN_DMC_FLOAT 0.0001

class DMC2xxxPiezoDrv : public Drv {

public:
	DMC2xxxPiezoDrv(string target, string extra);
	~DMC2xxxPiezoDrv();

        string  raw_io(string quest);
	int 	cnt_io(string quest);
	int 	chk_io(string ans);


	Link_ns::rvalues_t      refresh(string channel);
	Link_ns::uvalues_t 	update(string channel);

	bool 	stop(VNOTU string channel)				{ return false; };
	bool 	stop_no_brake(VNOTU string channel)			{ return DMC2xxxPiezoDrv::stop(channel); };

	bool 	speed(VNOTU string channel, VNOTU double v)		{ return false; };
	double 	speed(VNOTU string channel)				{ return nan(""); };

	bool 	acceleration(VNOTU string channel, VNOTU double a) 	{ return false; };
	double 	acceleration(VNOTU string channel) 			{ return nan(""); };
	bool 	deceleration(VNOTU string channel, VNOTU double a) 	{ return false; };
	double 	deceleration(VNOTU string channel) 			{ return nan(""); };

	bool 	forward(VNOTU string channel, VNOTU double v) 		{ return false; };
	bool 	backward(VNOTU string channel, VNOTU double v) 		{ return false; };

	bool    findedge(VNOTU string channel, VNOTU double v) 		{ return false; };
	bool    findindex(VNOTU string channel, VNOTU double v) 	{ return false; };

        double  mpos(string channel);
	bool    mpos(string channel, double p);       			// mpos : motor position

	bool    xpos(VNOTU string channel, VNOTU double p);		// xpos : motor position in encoder units

	bool    defmpos(string channel, double p);       		// define motor position
	bool    defepos(string channel, double p);       		// define hw encoder position

        bool    rpos(string channel, double p);       			// rpos : motor relative position

	bool    brake(VNOTU string channel, VNOTU bool b) 		{ return true; }
        int     hw_brake_conf(VNOTU string channel)			{ return 0; };

     	bool    motor_off(VNOTU string channel) 			{ return false; };
        bool    motor_on(VNOTU string channel) 				{ return false; };

	string 	stop_code2str(VNOTU unsigned long stop_code) 		{ return "*"; };

	bool    mconf(string channel, VNOTU mconf_t mc);
	mconf_t mconf(string channel);

	bool    econf(VNOTU string channel, VNOTU econf_t ec) 		{ return true; };
	econf_t econf(VNOTU string channel) 				{ econf_t ec; return ec; };

	bool	program_running();

        bool yinit(string channel);         // true = INIT / false = NO INIT
        bool yinit(string channel, bool b); // true = INIT / false = DEINIT

        long  get_ls_tolerance(string channel)  { return (long)(-1); };

private:
        int AXIS_OUT[8];
        std::map<std::string, int> _idxchannel;


}; /* class DMC2xxxPiezoDrv */


} /* namespace Controller_ns */

#endif /* _DMC2XXXINCHDRV_H_ */
