#include "Axis.h"

#include <stdlib.h>
#include <string>
#include <algorithm>
#include <iostream>

namespace Axis_ns {

/*============================================================================================
*
*	start on IFSM_IDLE
*
*	return true/false
*	change _mInitFSM
*
*	true  + IFSM_DONE	=> done with success
*	false + IFSM_ERROR 	=> end with error
*
*
*============================================================================================*/
bool Axis::absoluteInit(){
	string obj("Axis::absoluteInit()");

	std::stringstream ss;
	
	ss.str("");
	prtverbose(1, obj, ss.str());

	#ifdef _DBG_TRACE_MINIT
       		ss.str("");
       		ss << "== == == MINIT: " << AxisIFSMName[_mInitFSM];
       		prtverbose(0, "Axis::absoluteInit()", ss.str());
       	#endif /* _DBG_TRACE_MINIT */

	switch (_mInitFSM){
		case IFSM_ERROR:
			#ifdef _DBG_ABSINIT_IFSM
				cout << "absoluteInit() " << AxisIFSMName[_mInitFSM] << endl;
			#endif
			prtverbose(0, obj, "IFSM_ERROR");
			break;

		case IFSM_IDLE:
			#ifdef _DBG_ABSINIT_IFSM
				cout << "absoluteInit() " << AxisIFSMName[_mInitFSM] << endl;
			#endif
			//Motor::stop();
			_mInitFSM =IFSM_WAIT;
			break;

		case IFSM_WAIT:
			#ifdef _DBG_ABSINIT_IFSM
				cout << "absoluteInit() " << AxisIFSMName[_mInitFSM] << endl;
			#endif
			_mInitFSM =IFSM_DONE;
			return true;
			break;

		default:
			#ifdef _DBG_ABSINIT_IFSM
				cout << "absoluteInit() " << "default" << endl;
			#endif
			break;
	};

	return false;
}

} /* namespace Axis_ns */
