#include "Axis.h"

#include <stdlib.h>
#include <string>
#include <algorithm>
#include <iostream>

namespace Axis_ns {

/*============================================================================================
*
*	start on IFSM_IDLE
*
* AxisFindHomeVersus_t v = FIND_HOME_PLUS/FIND_HOME_MINUS
*
*	return true/false
*	change _mInitFSM
*
*	true  + IFSM_DONE	=> done with success
*	false + IFSM_ERROR 	=> end with error
*
*	false + ....  in progress
*
*============================================================================================*/
bool Axis::homeInit(AxisFindHomeVersus_t v){
	string obj("Axis::homeInit()");

	bool b1 = false;

	std::stringstream ss;
	
	ss.str("");
	prtverbose(1, obj, ss.str());

	AxisFindHomeVersus_t fev = findedge_versus();

#ifdef _DBG_HOMEINIT
	cout << "Axis::homeInit" << endl;
	cout << "Axis::homeInit _home_conf.extra.home.htype	= " << AxisHomeTypeName[_home_conf.extra.home.htype] << endl;
	cout << "Axis::homeInit AxisFindHomeVersus		= " << v << " " << AxisFindHomeVersusName[v] << endl;
	cout << "Axis::homeInit findedge_versus()		= " << fev << " " << AxisFindHomeVersusName[fev] << endl;
	cout << "Axis::homeInit FIND_HOME_PLUS 			= " << FIND_HOME_PLUS << endl;
	cout << "Axis::homeInit FIND_HOME_MINUS			= " << FIND_HOME_MINUS << endl;
#endif /* _DBG_HOMEINIT */

	if ( (_home_conf.extra.home.htype == HOME_POINT) && (v == FIND_HOME_HALFTRAVEL) ) {
		_mInitFSM = IFSM_ERROR;
		_FSMerror = FSM_E006;
		return false;
	};

#ifdef _DBG_HOMEINIT
	cout << "Axis::homeInit v / fev / FIND_HOME_PLUS / FIND_HOME_MINUS " << v << "/" << fev << "/" << FIND_HOME_PLUS << "/" << FIND_HOME_MINUS << endl;
#endif /* _DBG_HOMEINIT */

	if ( (v == FIND_HOME_PLUS) && (fev == FIND_HOME_MINUS) ) {
		// non riesco a trovare una transizione !home/home con la posizione che aumenta di valore.
		cout << "1" << endl;
		_mInitFSM = IFSM_ERROR;
		_FSMerror = FSM_E006;
		return false;
	}

	if ( (v == FIND_HOME_MINUS) && (fev == FIND_HOME_PLUS) ) {
		// non riesco a trovare una transizione !home/home con la posizione che diminuisce di valore.
		cout << "2" << endl;
		_mInitFSM = IFSM_ERROR;
		_FSMerror = FSM_E006;
		return false;
	};

#ifdef _DBG_HOMEINIT
	cout << "Axis::homeInit after FIND_HOME_PLUS/MINUS vs findedge_versus" << endl;
#endif /* _DBG_HOMEINIT */
	
	if (_find_speeds.size() < 2) {
		_mInitFSM = IFSM_ERROR;
		return false;
	};

	switch (_mInitFSM){
		case IFSM_ERROR:
			prtverbose(0, obj, "IFSM_ERROR");
			break;

		case IFSM_STOP:
			b1 = Motor::stop();
			_mInitFSM = IFSM_ERROR;
			break;

		case IFSM_IDLE:
		case IFSM_START_FE:
			#ifdef _DBG_HOMEINIT_IFSM
				cout << AxisIFSMName[_mInitFSM] << endl;
			#endif

			if ( home() ) { // mi sposto di un po' .... per poi arrivarci sempre nello stesso modo
				switch (v){
					case FIND_HOME_PLUS:
						b1 = backward(_find_speeds[0]);
						break;
					case FIND_HOME_MINUS:
						b1 = forward(_find_speeds[0]);
						break;
					default:
						b1 = false;
						break;
				}
				if (b1) { _mInitFSM = IFSM_WAIT_FEOFFSTART; }
				else    _mInitFSM = IFSM_ERROR;
			} else {
				switch (v){
					case FIND_HOME_PLUS:
						if ( fls() ){
							b1 = backward(_find_speeds[0]);
							if (b1) { _mInitFSM = IFSM_WAIT_FEONSTART; }
							else    _mInitFSM = IFSM_ERROR;
						} else {
							b1 = findedge(_find_speeds[1]);
							if (b1) { _mInitFSM = IFSM_WAIT_FESTART; }
							else    _mInitFSM = IFSM_ERROR;
						}
						break;
					case FIND_HOME_MINUS:
						if ( rls() ){
							b1 = forward(_find_speeds[0]);
							if (b1) { _mInitFSM = IFSM_WAIT_FEONSTART; }
							else    _mInitFSM = IFSM_ERROR;
						} else {
							b1 = findedge(_find_speeds[1]);
							if (b1) { _mInitFSM = IFSM_WAIT_FESTART; }
							else    _mInitFSM = IFSM_ERROR;
						}
						break;
					default:
						_mInitFSM = IFSM_ERROR;
						break;
				}
			}
			//_mInitFSM = IFSM_LEAVEHOME;
			break;

		case IFSM_WAIT_FESTART:
			#ifdef _DBG_HOMEINIT_IFSM
				cout << AxisIFSMName[_mInitFSM] << endl;
			#endif
			//===========update();
			if ( _mstate != Motor_ns::MOVING );
			else _mInitFSM = IFSM_WAIT_FE;
			break;

		case IFSM_WAIT_FE:
			#ifdef _DBG_HOMEINIT_IFSM
				cout << AxisIFSMName[_mInitFSM] << endl;
			#endif
			#ifdef _DBG_HOMEINIT
				cout << " ======================== ";
				cout << "Axis::homeInit IFSM_WAIT_FE" << endl;
			#endif /* _DBG_HOMEINIT */
			//se MOVING ... rimani in IFSM_WAIT_FE, altrimenti se home() allora finito se !home() allora ERROR .. BOH: il FE si ferma sul fronte
			// e quindi si puo' fermare con home disattivo.....  bisognerebbe sempre avere la transizione !home -> home

			if ( _mstate == Motor_ns::MOVING ) break;
			if ( (home()) || (!home() && stop_code() == 9)  ) { // 9=stop after FE
				#ifdef _DBG_HOMEINIT
					ss.str("");
					ss << "Axis::homeInit home() true pre stop()";
					prtverbose(0, obj, ss.str());
				#endif /* _DBG_HOMEINIT */
				Motor::stop();
				#ifdef _DBG_HOMEINIT
					ss.str("");
					ss << "Axis::homeInit home() true post stop()";
					prtverbose(0, obj, ss.str());
				#endif /* _DBG_HOMEINIT */
				_mInitFSM = IFSM_DONE;
				return true;
			}
			switch (v){
				case FIND_HOME_PLUS:
					if ( fls() ) b1 = backward(_find_speeds[0]);
					break;
				case FIND_HOME_MINUS:
					if ( rls() ) b1 = forward(_find_speeds[0]);
					break;
				default:
					b1 = false;
					break;
			}
			if (b1) { _mInitFSM = IFSM_WAIT_FEONSTART; }
			else    _mInitFSM = IFSM_ERROR;
			break;

		case IFSM_WAIT_FEONSTART:
			#ifdef _DBG_HOMEINIT_IFSM
				cout << AxisIFSMName[_mInitFSM] << endl;
			#endif
				//===========update();
				if  ( _mstate == Motor_ns::MOVING )_mInitFSM = IFSM_WAIT_FEON;
			break;

		case IFSM_WAIT_FEON:
			#ifdef _DBG_HOMEINIT_IFSM
				cout << AxisIFSMName[_mInitFSM] << endl;
			#endif
			switch (v){
				case FIND_HOME_PLUS:
					if ( rls() ) _mInitFSM = IFSM_ERROR; // trovato rls dopo aver trovato fls SENZA home!
					break;
				case FIND_HOME_MINUS:
					if ( fls() ) _mInitFSM = IFSM_ERROR; // trovato fls dopo aver trovato rls SENZA home!
					break;
				default:
					_mInitFSM = IFSM_ERROR;	
					break;
			}
			if ( home() ) { _mInitFSM = IFSM_WAIT_FEOFF; update();}
			break;

		case IFSM_WAIT_FEOFFSTART:
			#ifdef _DBG_HOMEINIT_IFSM
				cout << AxisIFSMName[_mInitFSM] << endl;
			#endif
				//===========update();
				if  ( _mstate == Motor_ns::MOVING )_mInitFSM = IFSM_WAIT_FEOFF;
			break;


		case IFSM_WAIT_FEOFF:
			#ifdef _DBG_HOMEINIT_IFSM
				cout << AxisIFSMName[_mInitFSM] << endl;
			#endif
			switch (v){
				case FIND_HOME_PLUS:
					if ( rls() ) _mInitFSM = IFSM_ERROR; // trovato rls dopo aver trovato fls SU home!
					break;
				case FIND_HOME_MINUS:
					if ( fls() ) _mInitFSM = IFSM_ERROR; // trovato fls dopo aver trovato rls SU home!
					break;
				default:
					_mInitFSM = IFSM_ERROR;	
					break;
			}
			if ( !home() ) {
				Motor::stop_no_brake();		// da stop() a stop_no_brake()
				_mInitFSM = IFSM_WAIT_FEOFFSTOP;
			}
			break;
		

		case IFSM_WAIT_FEOFFSTOP:
			#ifdef _DBG_HOMEINIT_IFSM
				cout << AxisIFSMName[_mInitFSM] << endl;
			#endif
				//===========update();
				if  ( _mstate == Motor_ns::MOVING );
				else _mInitFSM = IFSM_START_FE;
			break;

		default:
			break;
	};


	return false;
}


} /* namespace Axis_ns */
