#include "Axis.h"

#include <stdlib.h>
#include <string>
#include <algorithm>
#include <iostream>

namespace Axis_ns {


/*===============================
*
*
*
*===============================*/
bool Axis::__rawposition(double p, bool rel){
        string obj("Axis::__rawposition(.)");
        std::stringstream ss;
        ss.str("");
        ss << "p = " << p ;
        prtverbose(1, obj, ss.str());

	if ( !check_mconf_mt() ) {
		_AXISError = AXIS_E001;
		return false;
	}

	//cout << "__rawposition: : " << p << endl;

	double netx_dir = p - position();
	if ( (netx_dir > 0) && fls() ) return false;
	if ( (netx_dir < 0) && rls() ) return false;

        ss.str("");
        ss << "__rawposition: p: " << p ;
        prtverbose(1, obj, ss.str());

	double m;
	double _p = position();
        ss.str("");

#if 0
	if (rel) {
		if ( pmr() != 0 ) m = p / pmr(); else m = 0;
        	ss << "__rawposition: m: " << m << " [rel] ";
	} else {
		m = position2motor(p);
        	ss << "__rawposition: m: " << m ;
	}
        prtverbose(1, obj, ss.str());

	switch (_controller->controller()){
        	case Controller_ns::Yams:
        	case Controller_ns::DMC2xxxPiezo:
			if (rel) return rpos(m);
			else return mpos(m);
                        break;
                default:
			return false;
                        break;
       	};
#else
       	ss << "__rawposition: ";
	if (!rel) {
       		ss << " p: " << p << " [abs to rel >> ] ";
		p -= _p;
       		ss << " p: " << p << " ";
	}
	if ( pmr() != 0 ) m = p / pmr(); else m = 0;
       	ss << " m: " << m << " [rel] ";
        prtverbose(1, obj, ss.str());

	switch (_controller->controller()){
        	case Controller_ns::Yams:
        	case Controller_ns::DMC2xxxPiezo:
        	case Controller_ns::SIMUL:
			return rpos(m);
                        break;
                default:
			return false;
                        break;
       	};
#endif
	return false;
}

/*===============================
*
*
*
*===============================*/
bool Axis::rawposition(double p, bool rel){
        string obj("Axis::rawposition(.)");
        std::stringstream ss;
        ss.str("");
        ss << "p = " << p << "___";
        prtverbose(1, obj, ss.str());

	if ( !check_mconf_mt() ) {
		_AXISError = AXIS_E001;
		return false;
	}

	Motor_ns::MotorOnStopConf_t bc = brake_conf();
	Motor_ns::MotorState_t ms = mstate();
	ss.str("");
        ss << "Before brake_conf()/mstate()=" << (int)bc << "/" << Motor_ns::MotorStateName[ms];
        prtverbose(1, obj, ss.str());
	
	switch (bc){
        	case Motor_ns::NONE:
        	case Motor_ns::MOTOROFF:
			switch(ms){
				case Motor_ns::STANDSTILL:
				case Motor_ns::SERVO:
				case Motor_ns::SWCTL:
					break;

				case Motor_ns::DEACTIVATED: //"DEENERGIZED" ex DEACTIVATED
					_AXISError = AXIS_E009;
					return false;
					break;

				case Motor_ns::MOVING:
				case Motor_ns::ACCELERATING:
				case Motor_ns::DECELERATING:
					break;

				case Motor_ns::BRAKED:
					break;

				case Motor_ns::UNKNOWN:
				case Motor_ns::OFFLINE:
				case Motor_ns::ERROR:
				default:
					_AXISError = AXIS_E008;
					return false;
			}
			break;
        	case Motor_ns::MOTORBRAKED:
			switch(ms){
				case Motor_ns::MOVING:
				case Motor_ns::ACCELERATING:
				case Motor_ns::DECELERATING:
					if (!rel) {
						_AXISError = AXIS_E007;
						return false;
					}
					break;
				default:
					break;
			}
			break;
	}

        ss.str("After brake_conf()/mstate()");
        prtverbose(1, obj, ss.str());

	switch (fsm_state()){
		case FSM_WAIT:
		case FSM_STANDSTILL:
		case FSM_RAWPOS_WAITTMO:
			break;

		case FSM_ERROR:
		case FSM_NOTINITED:
		case FSM_INITIALIZING:
			_AXISError = AXIS_E008;
			return false;
			break;

		default:
			_AXISError = AXIS_E007;
			return false;
			break;
	}
        ss.str("After fsm_state()");
        prtverbose(1, obj, ss.str());


	AxisFSM_t  _fsm __attribute__((unused)) = fsm(FSMT_RAWPOS_WAITTMO);
	bool ret = __rawposition(p, rel);
	if (!ret) _AXISError = AXIS_E012;
	else _AXISError = AXIS_E000;

        ss.str("Just before return");
        prtverbose(1, obj, ss.str());
	return ret;
}

} /* namespace Axis_ns */

