#include "Axis.h"

#include <stdlib.h>
#include <string>
#include <algorithm>
#include <iostream>

namespace Axis_ns {

/*============================================================================================
*
*       start on IFSM_IDLE
*
*       return true/false
*       change _mInitFSM
*
*       true  + IFSM_DONE       => done with success
*       false + IFSM_ERROR      => end with error
*
*
*============================================================================================*/
bool Axis::sencInit(AxisFindPolarity_t p){
        #if defined(_DBG_SENCINIT_IFSM) && (0)
		cout << " - - - - - - - sencInit() .... BEGIN - - - - - - - -" << endl;
        #endif
        string obj("Axis::sencInit()");

        bool b1 = false;

        std::stringstream ss;

        ss.str("");
        prtverbose(1, obj, ss.str());

	double speed;

	#ifdef _DBG_SENCINIT_VALUES
        	cout << "sencInit(): " << AxisIFSMName[_mInitFSM] << " entering with: " ;
		cout << "__current_versus= " << __current_versus ;
		cout << endl;
	#endif

        switch (_mInitFSM){
                case IFSM_ERROR:
                        #ifdef _DBG_SENCINIT_IFSM
                                cout << "sencInit(): " << AxisIFSMName[_mInitFSM] << endl;
                        #endif
                        prtverbose(0, obj, "IFSM_ERROR");
                        break;
                case IFSM_IDLE:
                        #ifdef _DBG_SENCINIT_IFSM
                                cout << "sencInit(): " << AxisIFSMName[_mInitFSM] << endl;
                        #endif

		        _epos0 = nan("");
        		_epos1 = nan("");
			switch (p){
				case FIND_NEG:
        				__current_versus=-1.0;
					break;
				case FIND_POS:
				default:
        				__current_versus=1.0;
					break;
			}
        		_howmany_success_fi =0;
        		_howmany_fi     = 0;
        		_howmany_switch = 0;

                        if ( motor_on() ) _mInitFSM = IFSM_START_FI;
			else {
				_mInitFSM = IFSM_ERROR;
			}

			if ( fls() &&  rls() ) _mInitFSM = IFSM_ERROR;
			if ( fls() && ( __current_versus >0) ) __current_versus *= -1.0;
			if ( rls() && ( __current_versus <0) ) __current_versus *= -1.0;

                        ss.str(AxisIFSMName[_mInitFSM]);
                        prtverbose(1, obj, "IFSM_IDLE: "+ss.str());

                        #ifdef _DBG_SENCINIT_IFSM_STOPCODE
                                cout << "IFSM_IDLE" << ": ";
				cout << "STOP_CODE: " << stop_code2str() << endl;
                        #endif /* _DBG_SENCINIT_IFSM_STOPCODE*/

                        break;

                case IFSM_START_FI:
                        #if defined(_DBG_SENCINIT_IFSM) || defined(_DBG_SENCINIT_IFSM_LS)
				cout << "sencInit(): " << "IFSM_START_FI entering... " ;
                                cout << AxisIFSMName[_mInitFSM] << endl;
                        #endif
				// Al max posso passare da qui 3 volte:
				// una volta per un FI andato a male per switch intervenuto prima
				// due volte per i due FI consecutivi.

			if (_howmany_fi > 3) {
				_mInitFSM = IFSM_ERROR;
				break;
			}
			_howmany_fi++;

			switch(_howmany_success_fi){
				case 0: speed = _find_speeds[0]; break;
				case 1: speed = _find_speeds[1]; break;
				default: break;
			}
                        #ifdef _DBG_SENCINIT_IFSM
				cout << "sencInit(): " << "IFSM_START_FI ... with " ;
				cout << "  __current_versus= " << __current_versus;
				cout << "  speed= " << speed;
				cout << endl;
			#endif
								  // speed e __current_versus rispetto "Position axis versus" (ne' encoder ne' motor dir)
			b1 = findindex(__current_versus * speed); // ritorna errore se non riesce a partire, es. gia' su micro
                        #ifdef _DBG_SENCINIT_IFSM_STOPCODE
                                cout << AxisIFSMName[_mInitFSM] << ": ";
				cout << "STOP_CODE: " << stop_code2str();
				cout << " | findindex = " << (b1?"ok":"err");
				cout  << endl;
                        #endif /* _DBG_SENCINIT_IFSM_STOPCODE*/
				//
				//
				// CASO di AXISINIT che parte gia sopra il reference
				//
				// controllo se siamo partiti proprio sopra il reference,
				// perche' in questo caso il moto potrebbe anche fermarsi subito
				// .... perche' trova subito il reference
				// o controllo che dopo un tempo ci sia moto
				// oppure posso giocare con lo stato (STOP CODE) del motore...
				//
#if defined(_WITH_GALILDMC2XXXDRV_) || defined(_WITH_YAMSDRV_)
			{ 
			  Controller_ns::stop_code_t sc = (Controller_ns::stop_code_t)stop_code();
			  switch (sc){
				case Controller_ns::MOTOR_STP_HM_FI:
					_howmany_fi--; if (_howmany_fi <0) _howmany_fi = 0;
					_mInitFSM = IFSM_LEAVEFI;
					break;
				default:
                        		if (b1) _mInitFSM = IFSM_WAIT_FISTART;
                        		else    _mInitFSM = IFSM_ERROR;
					break;
			  }
			}
#endif

                        #ifdef _DBG_SENCINIT_IFSM
				cout << "sencInit(): " << "IFSM_START_FI leaving... ";
                                cout << AxisIFSMName[_mInitFSM] << endl;
                        #endif
                        break;

                case IFSM_WAIT_FISTART:
                        #ifdef _DBG_SENCINIT_IFSM
                                cout << "sencInit(): " << AxisIFSMName[_mInitFSM] << endl;
                        #endif
                        #ifdef _DBG_SENCINIT_IFSM_STOPCODE
                                cout << AxisIFSMName[_mInitFSM] << ": ";
				cout << "STOP_CODE: " << stop_code2str() << endl;
                        #endif /* _DBG_SENCINIT_IFSM_STOPCODE*/
#if defined(_WITH_GALILDMC2XXXDRV_) || defined(_WITH_YAMSDRV_)
			{ 
			  Controller_ns::stop_code_t sc = (Controller_ns::stop_code_t)stop_code();
			  switch (sc){
				case Controller_ns::MOTOR_STP_HM_FI:
					_howmany_fi--; if (_howmany_fi <0) _howmany_fi = 0;
					_mInitFSM = IFSM_LEAVEFI;
					break;
				default:
                        		if ( _mstate != Motor_ns::MOVING );
                        		else _mInitFSM = IFSM_WAIT_FI;
					break;
			  }
			}
#endif
                        break;

                case IFSM_WAIT_FI:
                        #if defined(_DBG_SENCINIT_IFSM) || defined(_DBG_SENCINIT_IFSM_LS)
				cout << "sencInit(): " << "IFSM_WAIT_FI entering... " ;
                                cout << AxisIFSMName[_mInitFSM];
				cout << "  mpos()= " << mpos();
				cout << "  epos()= " << epos();
				cout << endl;
                        #endif
                        #if  defined(_DBG_SENCINIT_IFSM_LS)
				cout << "_mstate=" << Motor_ns::MotorStateName[_mstate] << " ";
				cout << "fls= " << fls() << " ";
				cout << "rls= " << rls() << " ";
				cout << endl;
                        #endif
                        #ifdef _DBG_SENCINIT_IFSM_STOPCODE
                                cout << AxisIFSMName[_mInitFSM] << ": ";
				cout << "STOP_CODE: " << stop_code2str() << endl;
                        #endif /* _DBG_SENCINIT_IFSM_STOPCODE*/
                        if ( _mstate == Motor_ns::MOVING ) break;
			if (fls() || rls()) {
                        	#if  defined(_DBG_SENCINIT_IFSM_LS)
					cout << "Inside if (fls() || rls()) :: fls()= " << (fls()?"true":"false") << "; rls()= " << (rls()?"true":"false") << endl;
                        	#endif
				if (_howmany_switch >=1) {_mInitFSM = IFSM_ERROR; break;}
				_howmany_switch ++;
				__current_versus *= -1;
				_howmany_success_fi = 0;
				_mInitFSM = IFSM_START_FI;
                        	#if  defined(_DBG_SENCINIT_IFSM_LS)
					cout << "Inside if (fls() || rls()): before break ";
                                	cout << AxisIFSMName[_mInitFSM] << endl;
                        	#endif
				break;
			}
			// ok motore fermo.
			if (mpos()==0) { // ok motore fermo per indice trovato.
                        	#ifdef _DBG_SENCINIT_IFSM
					cout << "sencInit(): IFSM_WAIT_FI :: mpos()==0" << endl;;
                        	#endif
				switch(_howmany_success_fi){
					case 0: _epos0 = epos(); _mInitFSM = IFSM_LEAVEFI;    break;
					case 1: _epos1 = epos(); _mInitFSM = IFSM_WAIT_FIDONE; break;
					default: break;
				}
				_howmany_success_fi++;
			} else  _mInitFSM = IFSM_ERROR;
                        #ifdef _DBG_SENCINIT_IFSM
				cout << "sencInit(): " << "IFSM_WAIT_FI leaving... " ;
                                cout << AxisIFSMName[_mInitFSM];
				cout << " _epos0= " << _epos0 << " _epos1= " << _epos1 << endl;
                        #endif
                        break;

		case IFSM_LEAVEFI:
                        #ifdef _DBG_SENCINIT_IFSM
                                cout << AxisIFSMName[_mInitFSM];
				cout << "  enc2motor((double)refwidth()) = " << enc2motor((double)refwidth());
				cout << "  enc2motor(0) = " << enc2motor(0);
				cout << "  __current_versus = " << __current_versus;
				cout << " pmr() = " << pmr();
				cout << endl;
                        #endif
			{
				double mot_inc;
				mot_inc =  __current_versus * 5 * fabs(enc2motor((double)refwidth()) - enc2motor(0));
				if (pmr() < 0) mot_inc *= -1;
                        	#ifdef _DBG_SENCINIT_LEAVEFI
					cout << "LEAVEFI values:" ;
					cout << "  __current_versus= " << __current_versus;
					cout << "  mot_inc= " << mot_inc;
					cout << endl;
                        	#endif
				if (mpos(mot_inc))  _mInitFSM = IFSM_WAIT_LEAVEFI;
				else _mInitFSM = IFSM_ERROR; 
			};
                        break;

		case IFSM_WAIT_LEAVEFI:
                        #if defined(_DBG_SENCINIT_IFSM) || defined(_DBG_SENCINIT_LEAVEFI)
                                cout << AxisIFSMName[_mInitFSM] ;
				cout << "  mpos()= " << mpos();
				cout << "  epos()= " << epos();
				cout << "  _mstate= " << _mstate;
				cout << "  STOP_CODE: " << stop_code2str();
				cout << endl;
                        #endif
			switch (_mstate){
				case Motor_ns::STANDSTILL:
				case Motor_ns::BRAKED:
					_mInitFSM = IFSM_LEAVEFIDONE;
					break;
				default:
					break;
			};
                        break;

		case IFSM_LEAVEFIDONE:
                        #ifdef _DBG_SENCINIT_IFSM
                                cout << AxisIFSMName[_mInitFSM] << endl;
                        #endif
			_mInitFSM = IFSM_START_FI;
                        break;

		case IFSM_WAIT_FIDONE:
                        #ifdef _DBG_SENCINIT_IFSM
                                cout << AxisIFSMName[_mInitFSM] << endl;
                        #endif
                        Motor::stop();

			if (SencAbsPos(_epos0, _epos1)){
			} else {
				_mInitFSM = IFSM_ERROR;
				break;
			}
			
                        _mInitFSM =IFSM_DONE;

			// da _epos0 ed _epos1 calcola la posizione "assoluta" dell'encoder

			//
        		#if defined(_DBG_SENCINIT_IFSM) && (0)
				cout << " - - - - - - - sencInit() .... DONE - - - - - - - -" << endl;
        		#endif
                        return true;
			break;
                default:
                        #ifdef _DBG_SENCINIT_IFSM
                                cout << "default" << endl;
                        #endif
                        break;
	}

       	#if defined(_DBG_SENCINIT_IFSM) && (0)
		cout << " - - - - - - - sencInit() .... END - - - - - - - -" << endl;
        #endif

	return false;
}

} // namespace
