#include <Link.h>

using namespace std;

namespace Link_ns {

Link::Link(LinkType t, std::string name) {
	_channel_type = t;  _verbose = 0; _linkstate = LINK_CLOSE;
	_name = name;
	bf = NULL;
	bf = new BriefLog_ns::BriefLog(_name);

        #ifdef _DBG_LINK
                _verbose = 1;
        #else
                _verbose = 0;
        #endif

        std::stringstream ss("");
        ss << " _verbose = " << _verbose;

        string obj("Link()");
        prtverbose(1, obj, ss.str());


}

string 		Link::raw_io(string quest) { return raw_io(quest, true); }

uvalues_t	Link::uv() { return _uv;}

double   	Link::updateDelay() { return _updateDelay; }
	
void 		Link::verbose(int b){
	#ifdef _DBG_VERBOSE
		cout << "Link.verbose()" << endl;
	#endif
	_verbose = b;
}

int 		Link::verbose()	{ return _verbose;}

double 		Link::update_etime() { return _last_update_ms; }

int 		Link::flag()      { return _flag; }
bool 		Link::flag(int v){ _flag = v; return true;}

bool  		Link::prtLog()      { return _prtLog; }
void  		Link::prtLog(bool v){ _prtLog = v; if (bf && !_prtLog) bf->nolog(); }

LinkState_t 	Link::linkstate()	{return _linkstate; }

string 		Link::linkstatus(){
			  switch(_linkstate){
				case LINK_CLOSE:
				case LINK_CONNECTED:
				case LINK_REACTIVE:
				case LINK_TIMEOUTED:
				case LINK_UNREACTIVE:
				case LINK_OTHEREXCEPT:
				case LINK_GENERALEXCEPT:
			  		return LinkStateNames[_linkstate];
					break;
				default:
					return "LINK_UNKNOWN";
					break;
			  };
}



} /* namespace Link_ns */
