#ifdef _WITH_YAMSDRV_
#include <iostream>
#include "YamsDrv.h"

#include <stdlib.h>
#include <string>
#include <algorithm>

#include <unistd.h>


namespace Controller_ns {


YamsDrv::YamsDrv(string target, string extra): GalilDMC2xxxDrv (target, extra){
	#ifdef _DBG_YAMSDRV
		_verbose = 1;
	#else
		_verbose = 0;
	#endif

	_name = target;

	std::stringstream ss("");

	if (_link) {
		ss << " lnk_verbose = " << _link->verbose();
	} else {
		ss << " NO LINK";
	}

        prtverbose(1, "YamsDrv::YamsDrv()", ss.str());

//cout << "YamsDrv()" << endl;
//cout << GalilDMC2xxxDrv::channel() << endl;
//cout << _channel<< endl;
	MOT_BRAKE[0]=5;
	MOT_BRAKE[1]=6;
	MOT_BRAKE[2]=7;
	MOT_BRAKE[3]=8;
	MOT_BRAKE[4]=13;
	MOT_BRAKE[5]=14;
	MOT_BRAKE[6]=15;
	MOT_BRAKE[7]=16;

	//cout << "MOT_BRAKE[0]= " << MOT_BRAKE[0] << endl;
	_idxchannel["A"] = 0;
	_idxchannel["B"] = 1;
	_idxchannel["C"] = 2;
	_idxchannel["D"] = 3;
	_idxchannel["E"] = 4;
	_idxchannel["F"] = 5;
	_idxchannel["G"] = 6;
	_idxchannel["H"] = 7;

	_yidentity = Controller_ns::GALIL;

	_nbrtr.resize(8);
	_nbrtr[0] = -1;
	_nbrtr[1] = -1;
	_nbrtr[2] = -1;
	_nbrtr[3] = -1;
	_nbrtr[4] = -1;
	_nbrtr[5] = -1;
	_nbrtr[6] = -1;
	_nbrtr[7] = -1;

	_hw_brake_conf[0]=-1;
	_hw_brake_conf[1]=-1;
	_hw_brake_conf[2]=-1;
	_hw_brake_conf[3]=-1;
	_hw_brake_conf[4]=-1;
	_hw_brake_conf[5]=-1;
	_hw_brake_conf[6]=-1;
	_hw_brake_conf[7]=-1;

	_brake_ONOFF_extra_TMO[0] = 1000000; // 1sec
	_brake_ONOFF_extra_TMO[1] = 1000000; // 1sec
	_brake_ONOFF_extra_TMO[2] = 1000000; // 1sec
	_brake_ONOFF_extra_TMO[3] = 1000000; // 1sec
	_brake_ONOFF_extra_TMO[4] = 1000000; // 1sec
	_brake_ONOFF_extra_TMO[5] = 1000000; // 1sec
	_brake_ONOFF_extra_TMO[6] = 1000000; // 1sec
	_brake_ONOFF_extra_TMO[7] = 1000000; // 1sec

	_raw_brakeON_TMO[0] = 10; // 10 sec
	_raw_brakeON_TMO[1] = 10; // 10 sec
	_raw_brakeON_TMO[2] = 10; // 10 sec
	_raw_brakeON_TMO[3] = 10; // 10 sec
	_raw_brakeON_TMO[4] = 10; // 10 sec
	_raw_brakeON_TMO[5] = 10; // 10 sec
	_raw_brakeON_TMO[6] = 10; // 10 sec
	_raw_brakeON_TMO[7] = 10; // 10 sec

	yrefresh("A");
	yrefresh("B");
	yrefresh("C");
	yrefresh("D");
	yrefresh("E");
	yrefresh("F");
	yrefresh("G");
	yrefresh("H");
}


string  YamsDrv::CC_code2str(unsigned long CC_code){

	string cc;

	if ( CC_code & 0x1     ) cc.append("[POS]: Positioning Cmd. ");
	if ( CC_code & 0x2     ) cc.append("[STP]: Stoping Cmd. ");
	if ( CC_code & 0x100   ) cc.append("[InPrgrss]: Movement in progress. ");
	if ( CC_code & 0x200   ) cc.append("[OK]: Positioning ended without error. ");
	if ( CC_code & 0x400   ) cc.append("[NOK]: Positioning ended with error. ");
	if ( CC_code & 0x10000 ) cc.append("[Ini]: Initialization done. ");
	if ( CC_code & 0x40000 ) cc.append("[LIni]: On board init routine in progress. ");
	return cc;
}

long YamsDrv::ytarget(string channel){
	std::stringstream ss;
	string obj("YamsDrv::ytarget("+channel+")");
        prtverbose(1, obj, "");

        string n, ans;
        n.assign("Pos");
        n.append(channel);
        n.append("=?");

	RAW_IO(1, 2, obj, n, ans, 0) 
        prtverbose(2, obj, "ans="+ans);

        char *endptr;
        long pos;
        pos = strtol(ans.c_str(), &endptr, 10);
        if ( endptr == ans.c_str())  pos = 0;
        return pos;
}

bool YamsDrv::ytarget(string channel, long p){
	std::stringstream ss;
	string obj("YamsDrv::ytarget("+channel+",.)");
	ss << "p= " << p;
        prtverbose(1, obj, ss.str());
	
	if (!__hw_write_enable) return true;

        string n, ans;
        n.assign("Pos");
        n.append(channel);
        n.append("=");

        char buff[100];
        snprintf(buff, 100, "%ld", p);
        n.append(buff);

	RAW_IO(1, 2, obj, n, ans, false) 
        prtverbose(2, obj, "ans="+ans);

        return true;
}

/*
 values for refresh
typedef struct {
        long target;                Target position provided by the client in encoder units.
        long dbw;                Dead Band Width = GalilMotionAccuracy positioning accuracy. Written by the client in encoder units
        double scale;            EncoderMotorRatio = encoder impulse / motor step. Written by the client
        double pc;               Percent of the movement to be performed from 0.0 to 1.0
        double bck;              Backlash. Encoder units
        long dir;                Direction of the last positioning movement in backlash compensation
        long nbrtr;              Number of retries before giving up/ending with movement
        double err;              Positioning error. Encoder units
        double olderr;           Previous positioning error. Encoder units
        long cp;                 Type/presence of encoder: 0 = no encoder
        unsigned long CC_code;
} yrvalues_t;
*/

yrvalues_t YamsDrv::yrefresh(string channel){
	std::stringstream ss;
	string obj("YamsDrv::yrefresh("+channel+")");
        prtverbose(1, obj, "");

	yrvalues_t yr;
	char nl='\n';
	char cr='\r';

        string n, ans;

	n.assign("");
        n.append("MT"); 	n.append(channel); n.append("=?;");
        n.append("Pos"); 	n.append(channel); n.append("=?;");
        n.append("Dbw"); 	n.append(channel); n.append("=?;");
        n.append("Scale"); 	n.append(channel); n.append("=?;");
        n.append("Pc"); 	n.append(channel); n.append("=?;");
        n.append("Bck"); 	n.append(channel); n.append("=?;");
        n.append("Dir"); 	n.append(channel); n.append("=?;");
        n.append("NbRtr"); 	n.append(channel); n.append("=?;");
        n.append("Err"); 	n.append(channel); n.append("=?;");
        n.append("OldErr"); 	n.append(channel); n.append("=?;");
        n.append("Cp"); 	n.append(channel); n.append("=?;");
        n.append("CC"); 	n.append(channel); n.append("=?;");
        n.append("MG _CN1"); 	n.append(";");	
	ss.str("");
	ss << _idxchannel[channel];
        n.append("Brake["); 	n.append(ss.str()); n.append("]=?");

	RAW_IO(1, 2, obj, n, ans, yr) 

	ans.erase(std::remove(ans.begin(),ans.end(),nl),ans.end());
	ans.erase(std::remove(ans.begin(),ans.end(),cr),ans.end());
	ans.erase(std::remove(ans.begin(),ans.end(),' '),ans.end());

        prtverbose(1, obj, "ans="+ans);

	float a0, a1, a2, a3, a4, a5, a6, a7, a8, a9, a10, a11, a12, a13;

	//cout << ans.c_str() << endl;

	sscanf(ans.c_str(), "%f:%f:%f:%f:%f:%f:%f:%f:%f:%f:%f:%f:%f:%f",
		&a0,
		&a1, &a2, &a3, &a4, &a5, &a6,
		&a7, &a8, &a9, &a10, &a11, &a12, &a13
		);

	yr.yc.mt	= (double) a0;
	yr.target	= (long)   a1;
	yr.err		= (double) a8;
	yr.olderr	= (double) a9;
	yr.CC_code	= (unsigned long)a11;
	yr.nbrtr	= (long)   a7;

	yr.yc.dbw	= (long)   a2;
	yr.yc.scale	= (double) a3;
	yr.yc.pc	= (double) a4;
	yr.yc.bck	= (double) a5;
	yr.yc.dir	= (long)   a6;
	yr.yc.cp	= (long)   a10;
	yr.yc.home_polarity = (int) a12;
	yr.yc.hw_brake_conf = (int) a13;

	_hw_brake_conf[_idxchannel[channel]] = yr.yc.hw_brake_conf;
	//cout << "yrefresh _hw_brake_conf = " << a13 << "|" << yr.yc.hw_brake_conf << endl;
	
	return yr;
}

bool YamsDrv::ystop(string channel){
	string obj("YamsDrv::ystop("+channel+")");
        prtverbose(1, obj, "");
	
	if (!__hw_write_enable) return true;

	bool b1, b2;
	b1 = yCC_cmd(channel,ycmd_stop);
	b2 = gstop(channel);

	std::stringstream ss;
	ss << b1 << " " << b2;
        prtverbose(2, obj, ss.str());

	return (b1 && b2);
}

unsigned long YamsDrv::yCC_code(string channel){
	return yCC_code(channel, true);
}

unsigned long YamsDrv::yCC_code(string channel, bool do_update){
	std::stringstream ss;
	string obj("YamsDrv::yCC_code("+channel+")");
        prtverbose(1, obj, "");

	if (do_update) update(channel);
	unsigned long a = uv().CC_code;

	return (unsigned long)a;
}

bool YamsDrv::yCC_code(string channel, unsigned long CC_code){
	std::stringstream ss;
	ss << " new code: 0x" << hex << CC_code << dec << "[" << CC_code << "]";
	string obj("YamsDrv::yCC_code("+channel+",)");
        prtverbose(1, obj, ss.str());
	
	if (!__hw_write_enable) return true;

        string n, ans;
	char buff[100];
        n.assign("CC");	n.append(channel); n.append("=");
        snprintf(buff, 100, "%lu", CC_code);
        n.append(buff);

	ss.str("");
	RAW_IO(1, 2, obj, n, ans, false) 

        return true;
}

bool YamsDrv::yCC_cmd(string channel, unsigned char cmd){
	std::stringstream ss;
	ss << " new cmd: 0x" << hex << ((int)cmd) << dec << "[" << ((int)cmd) << "]";
	string obj("YamsDrv::yCC_cmd("+channel+",)");
        prtverbose(1, obj, ss.str());
	
	if (!__hw_write_enable) return true;

	return yCC_code(channel, (yCC_code(channel) & 0xFFF00) | (unsigned long)cmd );
}


unsigned long YamsDrv::yCC_status(string channel){
	string obj("YamsDrv::yCC_status("+channel+")");
        prtverbose(1, obj, "");

	return yCC_code(channel) & 0x0FF00;
}


bool YamsDrv::ygo(string channel, long p, int nbrtr){
	std::stringstream ss;
	ss << "p= " << p ;
	string obj("YamsDrv::ygo("+channel+",.)");
        prtverbose(1, obj, ss.str());
	
	if (!__hw_write_enable) return true;

	bool b1, b2, b3;
	b1 = ytarget(channel, p);
	b2 = ynbrtr(channel, nbrtr);

	ss.str("");
	ss << "ycmd_go= " << ycmd_go << " -:" << ((int)ycmd_go) << ":-";
        prtverbose(2, obj, ss.str());

	//cout << "YamsDrv::ygo(" << channel << "," << p << "," << nbrtr << ")" << endl;

	b3 = yCC_cmd(channel, ycmd_go);

	return b1 && b2 && b3;
}

bool  YamsDrv::ynbrtr(string channel, int nbrtr){
	std::stringstream ss;
	ss << "nbrtr= " << nbrtr ;
	string obj("YamsDrv::ynbrtr("+channel+",.)");
        prtverbose(1, obj, ss.str());
	
	if (!__hw_write_enable) return true;

	_nbrtr[_idxchannel[channel]] = nbrtr;

        string n, ans;
	char buff[100];
        n.assign("NbRtr");	n.append(channel); n.append("=");
        snprintf(buff, 100, "%d", nbrtr);
        n.append(buff);

	RAW_IO(1, 2, obj, n, ans, false) 
        prtverbose(2, obj, "ans="+ans);

        return true;
}

bool YamsDrv::ybrake(string channel) {
	std::stringstream ss;
	string obj("YamsDrv::ybrake("+channel+")");
        prtverbose(1, obj, "");

	// true = brake-ON; false = brake-OFF
        string n, ans;
	char buff[100];
	char nl='\n';
	char cr='\r';

        n.assign("MG @OUT[");
       	snprintf(buff, 100, "%d", MOT_BRAKE[_idxchannel[channel]]);
	n.append(buff); n.append("];");
	n.append("MG _MO"); n.append(channel);

	RAW_IO(1, 2, obj, n, ans, false) 

	ans.erase(std::remove(ans.begin(),ans.end(),nl),ans.end());
	ans.erase(std::remove(ans.begin(),ans.end(),cr),ans.end());
	ans.erase(std::remove(ans.begin(),ans.end(),' '),ans.end());
        prtverbose(2, obj, "ans="+ans);

	float a1, a2;
	sscanf(ans.c_str(), "%f:%f", &a1, &a2);
	if ( (a1 == 0) && (a2 == 1) ) return true;
	return false;
}


bool YamsDrv::ybrake(string channel, bool b) {
	std::stringstream ss;
	ss << "b=" << b;
	string obj("YamsDrv::ybrake("+channel+",.)");
        prtverbose(1, obj, ss.str());

	#ifdef _DBG_BRAKE
		cout << "YamsDrv::ybrake("+channel+")" << (b?"brake-ON":"brake-OFF") << endl;
	#endif /* _DBG_BRAKE */
	
	
	if (!__hw_write_enable) return true;

	// true = brake-ON; false = brake-OFF
	string n, ans;
	char buff[100];

	switch (_hw_brake_conf[_idxchannel[channel]]){
		default:
			if (b) { // brake-ON i.e. MOTOR OFF
			} else { // brake-OFF i.e. MOTOR ON
				n.assign("SH"); n.append(channel);
				ss.str("");
				RAW_IO(1, 2, obj, n, ans, false) 
			}
			return true;
			break;

		case 1:
			if (b) {
				n.assign("MC"); n.append(channel);n.append(";");
				n.append("ST"); n.append(channel);n.append(";");
				n.append("CB"); 
       		 		snprintf(buff, 100, "%d", MOT_BRAKE[_idxchannel[channel]]);

		
				ss.str("");
				ss << " |channel:" << channel;
				ss << " |_idxchannel[channel]:" << _idxchannel[channel];
				ss << " |MOT_BRAKE[_idxchannel[channel]]:" << MOT_BRAKE[_idxchannel[channel]];
				ss << " |MOT_BRAKE[0]:" << MOT_BRAKE[0];
        			prtverbose(2, obj, ss.str());
	

				n.append(buff);
				n.append(";WT500;"); 
				n.append("MO"); n.append(channel);n.append(";");
			} else {
				n.assign("MC"); n.append(channel);n.append(";");
				n.append("SH"); n.append(channel);n.append(";");
				n.append("WT250;"); 
				n.append("SB"); 
        			snprintf(buff, 100, "%d", MOT_BRAKE[_idxchannel[channel]]);
				n.append(buff);
				n.append(";"); 
			};
			ss.str("");
			RAW_IO(1, 2, obj, n, ans, false) 

			{
			  double etmo = _brake_ONOFF_extra_TMO[_idxchannel[channel]];
			  if (etmo > 0) usleep(etmo);
			}

			return true;
			break;

		case -1:
			return false;
			break;
	} /* switch */
}

bool YamsDrv::forward(string channel, double v){
	string obj("YamsDrv::forward("+channel+",.)");
	std::stringstream ss;
	ss << "v=" << v;
        prtverbose(1, obj, ss.str());
	
	if (!__hw_write_enable) return true;

	bool b1, b2;
	b1 = ybrake(channel, false);
	b2 = GalilDMC2xxxDrv::forward(channel, v);

	ss.str("");
	ss << "ybrake(): " << b1 << " GalilDMC2xxxDrv::forward(): " << b2;
        prtverbose(2, obj, ss.str());

	return b1 && b2;
}

bool YamsDrv::backward(string channel, double v){
	string obj("YamsDrv::backward("+channel+",.)");
	std::stringstream ss;
	ss << "v=" << v;
        prtverbose(1, obj, ss.str());
	
	if (!__hw_write_enable) return true;

	bool b1, b2;
	b1 = ybrake(channel, false);
	b2 = GalilDMC2xxxDrv::backward(channel, v);

	ss.str("");
	ss << "ybrake(): " << b1  << " GalilDMC2xxxDrv::backward(): " << b2;
        prtverbose(2, obj, ss.str());

	return b1 && b2;
}

bool YamsDrv::gstop(string channel){
	std::stringstream ss;
	string obj("YamsDrv::gstop("+channel+")");
        prtverbose(1, obj, "");
	
	if (!__hw_write_enable) return true;

	bool b1, b2;
	ss.str("");

	b1 = GalilDMC2xxxDrv::stop(channel);
	b2 = ybrake(channel, true);

	ss << "GalilDMC2xxxDrv::stop(): " << b1  << " ybrake(): " << b2;

        prtverbose(2, obj, ss.str());

	return b1 && b2;
}
bool YamsDrv::stop(string channel){
	std::stringstream ss;
	string obj("YamsDrv::stop("+channel+")");
        prtverbose(1, obj, "");
	
	if (!__hw_write_enable) return true;

	switch (_yidentity){
		default:
		case Controller_ns::GALIL:
			return gstop(channel);
			break;
		case Controller_ns::YAMS:
			return ystop(channel);
			break;
	}
	return false;
}

bool YamsDrv::yinit(string channel){
	string obj("YamsDrv::yinit("+channel+")");
        prtverbose(1, obj, "");

	unsigned long  cc = yCC_code(channel, false);
	cc = ((cc & 0x10000) >> 16) & 0x1;
	return (bool)cc;
}

bool YamsDrv::yinit(string channel, bool b){
	std::stringstream ss;
	ss << "b=" << b;
	string obj("YamsDrv::yinit("+channel+")");
        prtverbose(1, obj, ss.str());
	
	if (!__hw_write_enable) return true;

	unsigned long CC_code;
	if (b) CC_code = 0x10000; else CC_code = 0x00000;

	ss.str("");
	ss << "new CC= 0x" << hex << ((yCC_code(channel) & 0xE0000) | CC_code) << dec;
        prtverbose(1, obj, ss.str());

	return yCC_code(channel, (yCC_code(channel) & 0xE0000) | CC_code );
}

bool YamsDrv::ycp(string channel, int e){
	std::stringstream ss;
	ss << "e=" << e;
	string obj("YamsDrv::ycp("+channel+",.)");
        prtverbose(1, obj, ss.str());
	
	if (!__hw_write_enable) return true;

        string n, ans;
	char buff[100];
	n.assign("Cp"); n.append(channel);
       	snprintf(buff, 100, "%d", e);
	n.append("="); 
	n.append(buff); 

	RAW_IO(1, 2, obj, n, ans, false) 
        prtverbose(2, obj, "ans="+ans);

	return true;
}

int YamsDrv::ycp(string channel){
	string obj("YamsDrv::ycp("+channel+")");
        prtverbose(1, obj, "");
	
	return 0;
}

bool    YamsDrv::mpos(string channel, double p){       // mpos : motor position
	std::stringstream ss;
	ss << "p=" << p;
	string obj("YamsDrv::mpos("+channel+",.)");
        prtverbose(1, obj, ss.str());
	
	if (!__hw_write_enable) return true;

	if (ybrake(channel, false)) return GalilDMC2xxxDrv::mpos(channel, p);
	else return false;
}

bool    YamsDrv::rpos(string channel, double p){       // rpos : motor relative position
	std::stringstream ss;
	ss << "p=" << p;
	string obj("YamsDrv::rpos("+channel+",.)");
        prtverbose(1, obj, ss.str());
	
	if (!__hw_write_enable) return true;


	if (ybrake(channel, false)) return GalilDMC2xxxDrv::rpos(channel, p);
	else return false;
}

bool YamsDrv::yconf(string channel, yconf_t yc){
	std::stringstream ss;
	string obj("YamsDrv::yconf("+channel+",.)");
        prtverbose(1, obj, "yc[]");
	
	if (!__hw_write_enable) return true;

        string n, ans;
	char buff[100];

	n.assign("MT"); n.append(channel);
       	snprintf(buff, 100, "%f", (float)yc.mt);
	n.append("="); 
	n.append(buff); 
	n.append(";"); 
#ifdef _DBG_CONF_MOT
	cout <<  "==== " << buff << endl;
#endif /* _DBG_CONF_MOT */


	n.append("Dbw"); n.append(channel);
       	snprintf(buff, 100, "%ld", yc.dbw);
	n.append("="); 
	n.append(buff); 
	n.append(";"); 
#ifdef _DBG_CONF_MOT
	cout <<  "==== " << buff << endl;
#endif /* _DBG_CONF_MOT */

	if ( fabs(yc.scale) < MIN_DMC_FLOAT ){
		cout << "ERROR abs(scale) << MIN_DMC_FLOAT " << yc.scale << "|" << MIN_DMC_FLOAT << endl;
		 return false;
	}
	n.append("Scale"); n.append(channel);
       	snprintf(buff, 100, "%f", (float)yc.scale);
	n.append("="); 
	n.append(buff); 
	n.append(";"); 
#ifdef _DBG_CONF_MOT
	cout <<  "==== " << buff << "|| " << n << endl;
#endif /* _DBG_CONF_MOT */

	if ( fabs(yc.pc) < MIN_DMC_FLOAT ){
		cout << "ERROR abs(percent) << MIN_DMC_FLOAT " << yc.pc << "|" << MIN_DMC_FLOAT << endl;
		 return false;
	}
	n.append("Pc"); n.append(channel);
       	snprintf(buff, 100, "%f", (float)yc.pc);
	n.append("="); 
	n.append(buff); 
	n.append(";"); 

	n.append("Bck"); n.append(channel);
       	snprintf(buff, 100, "%f", (float)yc.bck);
	n.append("="); 
	n.append(buff); 
	n.append(";"); 

	n.append("Dir"); n.append(channel);
       	snprintf(buff, 100, "%ld", yc.dir);
	n.append("="); 
	n.append(buff); 
	n.append(";"); 

	n.append("Cp"); n.append(channel);
       	snprintf(buff, 100, "%ld", yc.cp);
	n.append("="); 
	n.append(buff); 
#if 0
	n.append(";"); 

	n.append("CN,"); n.append(channel);
       	snprintf(buff, 100, "%1d", yc.home_polarity);
	n.append("="); 
	n.append(buff); 
#endif

	RAW_IO(1, 2, obj, n, ans, false) 
        prtverbose(2, obj, "ans="+ans);

	return true;
}


bool YamsDrv::mconf(string channel, mconf_t mc){
	string obj("YamsDrv::mconf("+channel+",.)");
	std::stringstream ss;
	ss << "mc.yc.mt =" << mc.yc.mt;
        prtverbose(1, obj, ss.str());
	
	if (!__hw_write_enable) return true;

	bool b1, b2, b3, b4;

	b1 = ynbrtr(channel, mc.yc.nbrtr);

	b2 = yconf(channel, mc.yc);
	if (!b2) {
		ss.str("");
		ss << "conf: false!";
		if (_prtLog) prtverbose(0, obj, ss.str());
		//cout << "YamsDrv::mconf() false" << endl;
	}

	b3 = ybconf(channel, mc.yc.brake_ONOFF_extra_TMO);

	b4 = yrawbconf(channel, mc.yc.raw_brakeON_TMO);

	return b1 && b2 && b3 && b4;
}

mconf_t YamsDrv::mconf(string channel){
	string obj("YamsDrv::mconf("+channel+")");
        prtverbose(1, obj, "");

	mconf_t mc;
	yrvalues_t yr = yrefresh(channel);
	mc.yc.nbrtr 	= _nbrtr[_idxchannel[channel]];
        mc.yc.dbw	= yr.yc.dbw;
        mc.yc.scale	= yr.yc.scale;
        mc.yc.pc	= yr.yc.pc;
        mc.yc.bck	= yr.yc.bck;
        mc.yc.dir	= yr.yc.dir;
        mc.yc.cp	= yr.yc.cp;
        mc.yc.mt	= yr.yc.mt;
	mc.yc.home_polarity = yr.yc.home_polarity;
	mc.yc.hw_brake_conf = yr.yc.hw_brake_conf;
	mc.yc.brake_ONOFF_extra_TMO = _brake_ONOFF_extra_TMO[_idxchannel[channel]];
	mc.yc.raw_brakeON_TMO = _raw_brakeON_TMO[_idxchannel[channel]];
	return mc;
}


bool YamsDrv::yrgo(VNOTU string channel, VNOTU long p, VNOTU int nbrtr){

	return false;
}

bool    YamsDrv::xpos(string channel, double p){ // xpos : motor position in encoder units
	//cout << "YamsDrv::xpos(" << channel << "," << p << ")" << endl;
	
	if (!__hw_write_enable) return true;

	if (program_running()) return ygo(channel, (long) p, _nbrtr[_idxchannel[channel]]);
	else  		    return false;
}

bool    YamsDrv::brake(string channel, bool b){
	
	if (!__hw_write_enable) return true;

	switch (_yidentity){
		default:
		case Controller_ns::GALIL:
			return true;
			break;
		case Controller_ns::YAMS:
			return ybrake(channel, b);
			break;
	}
}

bool    YamsDrv::motor_off(string channel){
	bool b1, b2;

	if (!__hw_write_enable) return true;

	switch (_yidentity){
		default:
		case Controller_ns::GALIL:
			b1 = true;
			break;
		case Controller_ns::YAMS:
			b1 = ybrake(channel, true);
			break;
	}
	b2 = GalilDMC2xxxDrv::motor_off(channel);
	return (b1 && b2);
}

bool    YamsDrv::motor_on(string channel){
	bool b1, b2;

	if (!__hw_write_enable) return true;

	b1 = GalilDMC2xxxDrv::motor_on(channel);
	switch (_yidentity){
		default:
		case Controller_ns::GALIL:
			b2 = true;
			break;
		case Controller_ns::YAMS:
			b2 = ybrake(channel, false);
			break;
	}
	//cout << "YamsDrv::motor_on().GalilDMC2xxxDrv::motor_on() " << b1 << " YamsDrv::motor_on().ybrake() " << b2 << endl;
	return (b1 && b2);
}


bool    YamsDrv::program_running(){
	string obj("YamsDrv::program_running()");
	std::stringstream ss;
        prtverbose(1, obj, "");

	if ( !GalilDMC2xxxDrv::program_running() ) return false;
	else {
       		string n, ans;
		float v;
		int r;
		n.assign("MG _XQ0");
		RAW_IO(1, 2, obj, n, ans, false) 
		r = sscanf(ans.c_str(), "%f", &v);
		if ( r != 1 ) return false;
		if ( v == -1 ) return false;
		return true;
	}
	return false;
}

bool    YamsDrv::findedge(string channel, double v){
	string obj("YamsDrv::findedge("+channel+",.)");
	std::stringstream ss;
	ss << "v=" << v;
        prtverbose(1, obj, ss.str());
	
	if (!__hw_write_enable) return true;

	bool b1, b2;
	b1 = ybrake(channel, false);
	b2 = GalilDMC2xxxDrv::findedge(channel, v);

	ss.str("");
	ss << "ybrake(): " << b1  << " GalilDMC2xxxDrv::findedge(): " << b2;
        prtverbose(2, obj, ss.str());

	return b1 && b2;
}


bool YamsDrv::ce_econf(string channel, econf_t ec){
	string obj("YamsDrv::ce_econf("+channel+",.)");
	std::stringstream ss;
	ss << "ec.ce =" << ec.ce;
        prtverbose(1, obj, ss.str());
	
	if (!__hw_write_enable) return true;

        string n, ans;
	char buff[100];
	n.assign("CE"); n.append(channel);
       	snprintf(buff, 100, "%d", ec.ce);
	n.append("="); 
	n.append(buff);

	RAW_IO(1, 2, obj, n, ans, false) 
        prtverbose(2, obj, "ans="+ans);

	return true;
}

bool YamsDrv::econf(string channel, econf_t ec){
	string obj("YamsDrv::econf("+channel+",.)");
	std::stringstream ss;
	ss << "ec.ce =" << ec.ce;
        prtverbose(1, obj, ss.str());

	switch (ec.which){
        	case Controller_ns::ECONF_CE:
			return ce_econf(channel, ec);
			break;

        	case Controller_ns::ECONF_MOFFON:
			return moffon_econf(channel, ec);
			break;

        	case Controller_ns::ECONF_ALL:
			{
			  bool b1, b2;
			  b1 = ce_econf(channel, ec);
			  b2 = moffon_econf(channel, ec);
			  return (b1 && b2);
			}
			break;

		case Controller_ns::ECONF_NONE:
			return true;
			break;

		default:
			return false;
			break;
	}
	return false;
}

econf_t YamsDrv::ce_econf(string channel){
	string obj("YamsDrv::ce_econf("+channel+")");
	std::stringstream ss;
        prtverbose(1, obj, "");

	econf_t ec;
	ec.ce = -1;

        string n, ans;
	n.assign("CE"); n.append(channel);
	n.append("=?"); 

	RAW_IO(1, 2, obj, n, ans, ec) 
        prtverbose(2, obj, "ans="+ans);
	
	int a, r;

	r = sscanf(ans.c_str(), "%d", &a);
	if ( r != 1 ) return ec;

	ec.ce = a;
	return ec;
}

econf_t YamsDrv::econf(string channel){
	string obj("YamsDrv::econf("+channel+")");
	std::stringstream ss;
        prtverbose(1, obj, "");

	econf_t ec;

	econf_t ec1 = ce_econf(channel);
	econf_t ec2 = moffon_econf(channel);

	ec.which          = Controller_ns::ECONF_ALL;
	ec.ce             = ec1.ce;
	ec.mOffOn.enabled = ec2.mOffOn.enabled;
	ec.mOffOn.m       = ec2.mOffOn.m;
	ec.mOffOn.q       = ec2.mOffOn.q;

	return ec;
}

bool    YamsDrv::moffon_econf(string channel, econf_t ec){
	string obj("YamsDrv::moffon_econf("+channel+",.)");
	std::stringstream ss;
	ss << "ec.mOffOn.m/q =" << ec.mOffOn.m << " / " << ec.mOffOn.q;
        prtverbose(1, obj, ss.str());

	// Quando si fara' la configurazione dal server al hw,
	// ricordarsi che AnCrM/Q sono in mV, mentre in axis 
	// si lavora in V

	return false;
}

econf_t YamsDrv::moffon_econf(string channel){
	string obj("YamsDrv::moffon_econf("+channel+")");
	std::stringstream ss;
        prtverbose(1, obj, "");

	econf_t ec;
	ec.mOffOn.enabled = false;
	ec.mOffOn.m       = nan("");
	ec.mOffOn.q       = nan("");

	std::stringstream qry;
        string n, ans;
	qry.str("");
	qry << "AnCrM[" << _idxchannel[channel] << "]=?";
	qry << ";";
	qry << "AnCrQ[" << _idxchannel[channel] << "]=?";

	n.assign(qry.str());
	RAW_IO(1, 2, obj, n, ans, ec) 
        prtverbose(2, obj, "ans="+ans);

	ans.erase(std::remove(ans.begin(),ans.end(),'\n'),ans.end());
	ans.erase(std::remove(ans.begin(),ans.end(),'\r'),ans.end());
	ans.erase(std::remove(ans.begin(),ans.end(),' '),ans.end());

	// ans del tipo : x.xxx : y.yyyy :  ... eventualm con un \n o \r prima del secondo :

	float m, q;

	//cout << ans.c_str() << endl;

	int r;
	r = sscanf(ans.c_str(), "%f:%f", &m, &q);
	if ( (r == 2) && (m != 0.0) ){ // m non puo' essere zero!, preso anche come risposta a variabile inesistente.
		ec.mOffOn.m = m;         // qui le unita' di misura sono irrilevati: m e' un rapporto
		ec.mOffOn.q = q / 1000;  //.... da mV a V
	};
	ss.str("");
	ss << "r= " << r << " m= " << m << " q= " << q;
        prtverbose(2, obj, ss.str());

	return ec;
}


int     YamsDrv::hw_brake_conf(string channel){
	string obj("YamsDrv::hw_brake_conf("+channel+")");
        prtverbose(1, obj, "");

	yrvalues_t yr = yrefresh(channel);
	return yr.yc.hw_brake_conf;
}


bool 	YamsDrv::ybconf(string channel, double etmo){ // configura _brake_ONOFF_extra_TMO
	std::stringstream ss;
	ss << "etmo= " << etmo ;
	string obj("YamsDrv::ybconf("+channel+",.)");
        prtverbose(1, obj, ss.str());

	if (etmo>=0){
		 _brake_ONOFF_extra_TMO[_idxchannel[channel]] = etmo;
		return true;
	} else
		return false;
}

bool 	YamsDrv::yrawbconf(string channel, double rtmo){ // configura _raw_brakeON_TMO
	std::stringstream ss;
	ss << "rtmo= " << rtmo ;
	string obj("YamsDrv::yrawbconf("+channel+",.)");
        prtverbose(1, obj, ss.str());

	if (rtmo>=0){
		 _raw_brakeON_TMO[_idxchannel[channel]] = rtmo;
		return true;
	} else
		return false;
}


} /* namespace Controller_ns */
#endif /* _WITH_YAMSDRV_ */
