#include "BcsTcpLink.h"
#include "BcsTangoLink.h"
#include "Axis.h"

#include <stdio.h>     /* for printf */
#include <stdlib.h>    /* for exit */
#include <getopt.h>

#include <iostream>     // std::cout, std::endl
#include <iomanip>      // std::setw

#include <algorithm>
#include <string>
#include <string_view>
#include <iostream>
#include <cctype>

#undef ___LINK
#undef ___CTRL
#undef ___TEST1
#define ___ACQ0

int main (int argc, char *argv[]){


//=========================================================================================================
//=========================================================================================================
#ifdef __BCS_TCPLINK__
	char ctrl[256] = "";
        snprintf(ctrl, 256, "tcp://022f-bcs.blcs.elettra.trieste.it:20000");

	string chan;
	chan  = "022B_UVASGM1B_HEIDENHAIN_30_ASSEX";
	chan += ";022B_UVASGM1B_BERGERD821_30_3ABACTPO";
	chan += ";022B_UVASGM1B_BERGERD821_30_3INSHST";


//=========================================================================================================
#ifdef ___ACQ0
	Link_ns::BcsTcpLink		*link		= new Link_ns::BcsTcpLink("tcp://022f-bcs.blcs.elettra.trieste.it:20000");
	usleep(1000 * 100);


	string ans;
	int howmany = 3;

	vector<string> quest = {
		 "022B_UVASGM1B_HEIDENHAIN_30_ASSEX"
		,"022B_UVASGM1B_BERGERD821_30_3ABACTPO"
		,"022B_UVASGM1B_BERGERD821_30_3INSHST"
#if 1
		,"022B_UVASGM1B_HEIDENHAIN_30_ASSEY"
		,"022B_UVASGM1B_BERGERD821_30_4ABACTPO"
		,"022B_UVASGM1B_BERGERD821_30_4INSHST"
#endif
#if 1
		,"022B_UVASGM1B_SGM_30_ENERGY"
#endif
	};

	vector<string>::iterator it;

	size_t w = 0;
	for (it = quest.begin(); it != quest.end(); ++it){
		if ( (*it).size() > w ) w = (*it).size();
	}
	w += 2;

	for (it = quest.begin(); it != quest.end(); ++it){
		cout << setw(w);
		cout << *it ;
	}
	cout << endl;

	for (int k=0; k<howmany; k++){
		for (it = quest.begin(); it != quest.end(); ++it){
			string q = "GET " + *it;
			ans = link->raw_io(q, false);
			ans.erase(std::remove(ans.begin(), ans.end(), '\n'), ans.end());
			ans.erase(std::remove(ans.begin(), ans.end(), '\r'), ans.end());
			ans.erase(std::remove(ans.begin(), ans.end(), ' '), ans.end());
			cout << setw(w);
			cout << ans ;
			usleep(1000 * 200);
		}
		cout << endl;
	}

	delete link;
#endif

//=========================================================================================================
#ifdef ___TEST1
	Link_ns::BcsTcpLink		*link		= new Link_ns::BcsTcpLink("tcp://022f-bcs.blcs.elettra.trieste.it:20000");

	/*
		GET 022B_UVASGM1B_BERGERD821_30_3STATUS1=*** ERROR input not configured
	*/

	string quest(""), ans;
	quest = "GET 022B_UVASGM1B_BERGERD821_30_3STATUS1";
	ans = link->raw_io(quest, false);
	cout << endl << quest << "=" << ans << endl;
	usleep(1000 * 500);

	delete link;
#endif

//=========================================================================================================
#ifdef ___LINK
	//Link_ns::BcsTcpLink		*link		= new Link_ns::BcsTcpLink("tcp://192.168.205.11:20000");
	//Link_ns::BcsTcpLink		*link		= new Link_ns::BcsTcpLink("tcp://061f-bcs.blcs.elettra.trieste.it:20000");
	Link_ns::BcsTcpLink		*link		= new Link_ns::BcsTcpLink("tcp://022f-bcs.blcs.elettra.trieste.it:20000");


	cout << endl;

	string quest(""), ans;

#if 0
	quest = "GET 022F_MACHINE_MACHINE_1_EENERGY";
	ans = link->raw_io(quest, false);
	cout << endl << quest << "=" << ans << endl;
	usleep(1000 * 500);

	quest = "GET 022B_UVASGM1B_HEIDENHAIN_30_ASSEX";
	ans = link->raw_io(quest, false);
	cout << endl << quest << "=" << ans << endl;
	usleep(1000 * 500);

	quest = "GET 022B_UVASGM1B_HEIDENHAIN_30_ASSEY";
	ans = link->raw_io(quest, false);
	cout << endl << quest << "=" << ans << endl;
	usleep(1000 * 500);
#endif

	Link_ns::uvalues_t uv = link->update(chan);

	cout << "uv.motor   = " << uv.motor << endl;
	cout << "uv.encoder = " << uv.encoder << endl;
	cout << "uv.fls = " << uv.fls << endl;
	cout << "uv.rls = " << uv.rls << endl;

	delete link;
#endif


//=========================================================================================================
#ifdef ___CTRL

        Controller_ns::Controller     *controller   = new Controller_ns::Controller(Controller_ns::BCS, ctrl, "", false);
        Controller_ns::BcsDrv         *bcsd         = (Controller_ns::BcsDrv*)controller->drv();

        Motor_ns::Motor                 *motor        = new Motor_ns::Motor("BcsMotor", chan, controller);
        Encoder_ns::Encoder             *enc          = new Encoder_ns::Encoder("BcsEncoder", chan, controller);

	double mpos = bcsd->mpos(chan);
	cout << "drv.mpos   = " << mpos << endl;

	enc->verbose(1);
        enc->etype(Encoder_ns::ENC_DIGITAL_INCREMENTAL, 1);

	motor->update();
	enc->update();

	cout << endl;
	cout << "motor.mpos() = " << motor->mpos() << endl;
	cout << "enc.epos()   = " << enc->epos() << endl;
#endif



#if 0
	for (size_t i = 0; i<5; i++){
		cout << __func__ << " ...:" << i << endl;
		usleep(1000000);
	}
#endif
#endif /* __BCS_TCPLINK__ */
//=========================================================================================================
//=========================================================================================================
	char ctrl[256] = "";
        //snprintf(ctrl, 256, "tango://srv-tango-ctrl-01:20000/abrami/2/2");
        snprintf(ctrl, 256, "tango://srv-tango-ctrl-01:20000/abrami/022b/uvasgm1b.3");
	Link_ns::BcsTangoLink		*link		= new Link_ns::BcsTangoLink(ctrl);

	Link_ns::uvalues_t uv = link->update("");


	cout << "uv.motor   = " << uv.motor << endl;
	cout << "uv.encoder = " << uv.encoder << endl;
	cout << "uv.fls = " << uv.fls << endl;
	cout << "uv.rls = " << uv.rls << endl;

	delete link;
}
