#include "Axis.h"

#include <stdio.h>     /* for printf */
#include <stdlib.h>    /* for exit */
#include <getopt.h>

//using namespace Axis_ns;

int main (int argc, char *argv[]){

bool ctrl_flg = false;
char ctrl[256];
char scmd[256] = "";

typedef enum {
	 CMD_NONE
	,CMD_CIA402
	,CMD_MOTOR_ONOFF
	,CMD_MOTOR_SPEED
	,CMD_MOTOR_POSITION
	,CMD_MOTOR_STOP
	,CMD_ENC_POSITION
	,CMD_GET_SWITCHES
	,CMD_MOTOR_ACCELERATION
	,CMD_MOTOR_DECELERATION
	,CMD_MOTOR_RELPOSITION
} cmd_t;

cmd_t cmd = CMD_NONE;


snprintf(ctrl, 256, "http://localhost:8080");
//==========================================================================================
//------- getopt
//				con optional_argument o '::' l'argomento deve essere appiccicato 
//				alla lettera dell'opzione (NO SPAZI!)
	bool preset = true;
    {
          int option_index = 0;
          int r;
          int c_c;
	
	  //opterr = NULL;

          static struct option long_options[] = {
                                {"help", 	no_argument, 		0, 'h'},
                                {"nopreset", 	no_argument, 		0, 'n'},
                                {"controller", 	required_argument, 	0, 'c'},
                                {"cia402", 	optional_argument, 	0, 'i'},
                                {"monoff", 	optional_argument, 	0, 'p'},
                                {"mspeed", 	optional_argument, 	0, 'v'},
                                {"mpos", 	optional_argument, 	0, 'm'},
                                {"stop", 	no_argument, 		0, 'x'},
                                {"epos", 	no_argument, 		0, 'e'},
                                {"switches", 	no_argument, 		0, 's'},
                                {"macceleration",optional_argument, 	0, 'a'},
                                {"mdeceleration",optional_argument, 	0, 'd'},
                                {"rpos", 	required_argument, 	0, 'r'},
                                {0, 0, 0, 0}
                                };
          c_c=0;
          while ( (c_c = getopt_long(argc, argv, "hnc:i::p::v::m::xesa::d::r:", long_options, &option_index)) != -1 ){
				//printf("optarg   = %s\n", optarg);
		snprintf(scmd, 256, "%s", optarg);
                switch (c_c) {
                                case 'h':
					cout << "--help/-h" << endl;
					cout << "--controller/-c addr" << endl;
					cout << "--cia402/-i['state']/[help]" << endl;
					cout << "--monoff/-p[on/off]" << endl;
					cout << "--mspeed/-v[value]" << endl;
					cout << "--mpos/-m[value]" << endl;
					cout << "--stop/-x" << endl;
					cout << "--epos/-e" << endl;
					cout << "--switches/-s" << endl;
					cout << "--macceleration/-a[value]" << endl;
					cout << "--mdeceleration/-d[value]" << endl;
					cout << "--rpos/-r value" << endl;
					exit(0);
                                        break;
                                case 'n':
                                        preset = false;
                                        break;
				case 'c':
					snprintf(ctrl, 256, "%s", optarg);
                                        break;
				case 'i':
					if ( strcmp(scmd, "help") == 0 ){
						cout << "cia402" << endl;
                                		cout << ".......: shutdown | switchon | enableop | disableop" << endl;
                                		cout << ".......: quickstop | removequickstop" << endl;
                                		cout << ".......: enablevoltage | disablevoltage" << endl;
                                		cout << ".......: faultreset | halt | clearhalt" << endl;
						
						exit(0);
					} else {
						cmd = CMD_CIA402;
					}
                                        break;
				case 'p':
					cmd = CMD_MOTOR_ONOFF;
                                        break;
				case 'v':
					cmd = CMD_MOTOR_SPEED;
                                        break;
				case 'm':
					cmd = CMD_MOTOR_POSITION;
                                        break;
				case 'x':
					cmd = CMD_MOTOR_STOP;
                                        break;
				case 'e':
					cmd = CMD_ENC_POSITION;
                                        break;
				case 's':
					cmd = CMD_GET_SWITCHES;
                                        break;
				case 'a':
					cmd = CMD_MOTOR_ACCELERATION;
                                        break;
				case 'd':
					cmd = CMD_MOTOR_DECELERATION;
                                        break;
				case 'r':
					cmd = CMD_MOTOR_RELPOSITION;
                                        break;
                                case '?':
                                        break;

                                default:
                                        printf("?? getopt returned character code 0%o ??\n", c_c);
					break;
                }
          }
    }
//==========================================================================================

	string name("N5Axis");
	string channel("");

        Controller_ns::Controller 	*controller	= new Controller_ns::Controller(Controller_ns::N5, ctrl, "");
	Controller_ns::N5Drv		*n5d		= (Controller_ns::N5Drv*)controller->drv();
	Motor_ns::Motor			*n5motor	= new Motor_ns::Motor("N5Motor", "", controller);
	Encoder_ns::Encoder		*n5enc		= new Encoder_ns::Encoder("N5Encoder", "", controller);

	n5enc->etype(Encoder_ns::ENC_DIGITAL_INCREMENTAL, 1);

	n5motor->verbose(0);
	n5motor->drv_verbose(0);
	n5d->hw_write_enable(true);

	cout << __func__ << " :: Controller : " << controller << endl;

	cout << endl;
	cout << "Controller type      : " << controller->controller_typeName() << endl;

	std::vector<std::string>::iterator it;

	std::vector<std::string> desc = n5d->describe();
	for (it = desc.begin(); it != desc.end(); ++it) cout << *it << endl;
	cout << endl;

	n5motor->update();
	n5motor->refresh();

	n5enc->update();

	#if 0
        cout << "cia402:" << n5d->CiA402() << endl;
	cout << "Motor status: " << n5motor->mstatus() << endl;
	#endif

	cout << endl;
	switch (cmd){
		case CMD_NONE:
			exit(0);
			break;
		case CMD_CIA402:
			{
                          bool cmd_f = false;
                          Controller_ns::stateCmd_t sc;
			  string s(scmd);
                          if ( s.find("shutdown") != string::npos ) {
						cmd_f = true; sc = Controller_ns::SHUTDOWN_CMD; } else
                          if ( s.find("switchon") != string::npos ) {
						cmd_f = true; sc = Controller_ns::SWITCH_ON_CMD; } else
                          if ( s.find("enableop") != string::npos ) {
						cmd_f = true; sc = Controller_ns::ENABLE_OPERATION_CMD; } else
                          if ( s.find("disableop") != string::npos ) {
						cmd_f = true; sc = Controller_ns::DISABLE_OPERATION_CMD; } else
                          if ( s.find("quickstop") != string::npos ) {
						cmd_f = true; sc = Controller_ns::QUICK_STOP_CMD; } else
                          if ( s.find("removequickstop") != string::npos ) {
						cmd_f = true; sc = Controller_ns::REMOVE_QUICK_STOP_CMD; } else
                          if ( s.find("enablevoltage") != string::npos ) {
						cmd_f = true; sc = Controller_ns::ENABLE_VOLTAGE_CMD; } else
                          if ( s.find("disablevoltage") != string::npos ) {
						cmd_f = true; sc = Controller_ns::DISABLE_VOLTAGE_CMD; } else
                          if ( s.find("faultreset") != string::npos ) {
						cmd_f = true; sc = Controller_ns::FAULT_RESET_CMD; } else
                          if ( s.find("halt") != string::npos ) {
						cmd_f = true; sc = Controller_ns::HALT_CMD; } else
                          if ( s.find("clearhalt") != string::npos ) {
						cmd_f = true; sc = Controller_ns::CLEAR_HALT_CMD; } else
                          {};

                          if (cmd_f) {
				cout << "cia402 ret:" << n5d->CiA402(sc) << endl;
			  	usleep(100000);
        			cout << "cia402:" << n5d->CiA402() << endl;
                          } else cout << "cia402:" << n5d->CiA402() << endl;
			}
			break;

		case CMD_MOTOR_ONOFF:
			{
			  string s(scmd);
                          bool cmd_f = false;
                          if ( s.find("on") != string::npos ) {
                          	cout << "motor_on ret:" << n5motor->motor_on() << endl;
			  } else
                          if ( s.find("off") != string::npos ) {
                          	cout << "motor_off ret:" << n5motor->motor_off() << endl;
			  } else
                          {};

			  usleep(100000);
			  n5motor->update();
			  n5motor->refresh();
			  cout << "Motor status: " << n5motor->mstatus() << endl;

			}
			break;

		case CMD_MOTOR_SPEED:
			{
			  char *endptr;
                          double v = strtod(scmd, &endptr);
                          if (endptr == scmd) cout << "mspeed:" << n5motor->mspeed() << endl;
                          else {
				cout << "mspeed ret:" << n5motor->mspeed(v) << endl;
				usleep(100000);
			  	n5motor->update();
			  	n5motor->refresh();
                          	cout << "mspeed:" << n5motor->mspeed() << endl;
			  }
			}
			break;

		case CMD_MOTOR_POSITION:
			{
			  char *endptr;
                          double v = strtod(scmd, &endptr);
                          if (endptr == scmd) cout << "mpos:" << n5motor->mpos() << endl;
                          else {
				cout << "mpos ret:" << n5motor->mpos(v) << endl;
			  }
			}
			break;

		case CMD_MOTOR_STOP:
			cout << "stop ret:" << n5motor->stop() << endl;
			break;

		case CMD_ENC_POSITION:
                        cout << "epos:" << n5enc->epos() << endl;
			break;

		case CMD_GET_SWITCHES:
			cout << "-Limit : " << (n5d->get_rls()?"true":"false") << endl;
			cout << "+Limit : " << (n5d->get_fls()?"true":"false") << endl;
			cout << " Home  : " << (n5d->get_home()?"true":"false") << endl;
			break;

		case CMD_MOTOR_ACCELERATION:
			{
			  char *endptr;
                          double v = strtod(scmd, &endptr);
                          if (endptr == scmd) cout << "macceleration:" << n5motor->macceleration() << endl;
                          else {
				cout << "macceleration ret:" << n5motor->macceleration(v) << endl;
			  }
			}
			break;

		case CMD_MOTOR_DECELERATION:
			{
			  char *endptr;
                          double v = strtod(scmd, &endptr);
                          if (endptr == scmd) cout << "mdeceleration:" << n5motor->mdeceleration() << endl;
                          else {
				cout << "mdeceleration ret:" << n5motor->mdeceleration(v) << endl;
			  }
			}
			break;

		case CMD_MOTOR_RELPOSITION:
			cout << "UNIMPLEMENTED!" << endl;
			exit(-1);
			{
			  char *endptr;
                          double v = strtod(scmd, &endptr);
                          if (endptr == scmd) cout << "rpos: must have param" << endl;
                          else {
				cout << "rpos ret:" << n5motor->rpos(v) << endl;
			  }
			}
			break;
	}

        return 0;

}
