#include "Axis.h"

#include <stdio.h>     /* for printf */
#include <stdlib.h>    /* for exit */
#include <getopt.h>

using namespace Axis_ns;

int main (int argc, char *argv[]){

bool ctrl_flg = false;
char ctrl[256];

snprintf(ctrl, 256, "http://localhost:8080");
//==========================================================================================
//------- getopt
	bool preset = true;
    {
          int option_index = 0;
          int r;
          int c_c;

          static struct option long_options[] = {
                                {"nopreset", no_argument, 0, 'n'},
                                {"controller", required_argument, 0, 'c'},
                                {0, 0, 0, 0}
                                };
          c_c=0;
          while ( (c_c = getopt_long(argc, argv, "nc:", long_options, &option_index)) != -1 ){
                switch (c_c) {
                                case 'n':
                                        preset = false;
                                        break;
				case 'c':
					snprintf(ctrl, 256, "%s", optarg);
                                case '?':
                                        break;

                                default:
                                        printf("?? getopt returned character code 0%o ??\n", c_c);
                }
          }
    }
//==========================================================================================

	string name("N5Axis");
	string channel("");

        Controller_ns::Controller 	*controller	= new Controller_ns::Controller(Controller_ns::N5, ctrl, "");
	Controller_ns::N5Drv		*n5d		= (Controller_ns::N5Drv*)controller->drv();

	cout << __func__ << " :: Controller : " << controller << endl;

	cout << endl;
	cout << "Controller type      : " << controller->controller_typeName() << endl;

	std::vector<std::string>::iterator it;

	std::vector<std::string> desc = n5d->describe();
	for (it = desc.begin(); it != desc.end(); ++it) cout << *it << endl;
	cout << endl;

	std::vector<std::string> dump = n5d->dumpConfig();
	for (it = dump.begin(); it != dump.end(); ++it) cout << *it << endl;
	cout << endl;

        return 0;

}
