/*----- PROTECTED REGION ID(AxisG2.cpp) ENABLED START -----*/
//=============================================================================
//
// file :        AxisG2.cpp
//
// description : C++ source for the AxisG2 class and its commands.
//               The class is derived from Device. It represents the
//               CORBA servant object which will be accessed from the
//               network. All commands which can be executed on the
//               AxisG2 are implemented in this file.
//
// project :     Axis
//
// This file is part of Tango device class.
// 
// Tango is free software: you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation, either version 3 of the License, or
// (at your option) any later version.
// 
// Tango is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
// 
// You should have received a copy of the GNU General Public License
// along with Tango.  If not, see <http://www.gnu.org/licenses/>.
// 
// $Author: abrami $
//
//
//=============================================================================
//                This file is generated by POGO
//        (Program Obviously used to Generate tango Object)
//=============================================================================


#include <AxisG2.h>
#include <AxisG2Class.h>

/*----- PROTECTED REGION END -----*/	//	AxisG2.cpp

/**
 *  AxisG2 class description:
 *    This class realizes the initialisation and positioning functionalities for a single axis.
 */

//================================================================
//  The following table gives the correspondence
//  between command and method names.
//
//  Command name          |  Method name
//================================================================
//  State                 |  dev_state
//  Status                |  dev_status
//  Forward               |  forward
//  Stop                  |  stop
//  Backward              |  backward
//  GoToRelativePosition  |  go_to_relative_position
//  GoToPosition          |  go_to_position
//  DefinePosition        |  define_position
//  GetMotionStatus       |  get_motion_status
//  FindEdge              |  find_edge
//  FindIndex             |  find_index
//  FindHome              |  find_home
//  GetErrorStatus        |  get_error_status
//  DirectCmd             |  direct_cmd
//  AxisInit              |  axis_init
//  MotorOFF              |  motor_off
//  MotorON               |  motor_on
//  ReadHWConf            |  read_hwconf
//  GetUserEncoderRatio   |  get_user_encoder_ratio
//  Service               |  service
//  GetMotionHistory      |  get_motion_history
//  RestoreLastPosition   |  restore_last_position
//  AckCheckEnc           |  ack_check_enc
//  RawAbsPos             |  raw_abs_pos
//  RawRelPos             |  raw_rel_pos
//  UserRawAbsPos         |  user_raw_abs_pos
//  UserRawRelPos         |  user_raw_rel_pos
//  get_p4e               |  get_p4e
//  get_e4p               |  get_e4p
//  get_u4p               |  get_u4p
//  get_p4u               |  get_p4u
//  get_u4e               |  get_u4e
//  get_e4u               |  get_e4u
//  StorePosition4Fake    |  store_position4_fake
//  FakeAxisInit          |  fake_axis_init
//================================================================

//================================================================
//  Attributes managed are:
//================================================================
//  Position             |  Tango::DevDouble	Scalar
//  PositiveLimitSwitch  |  Tango::DevBoolean	Scalar
//  NegativeLimitSwitch  |  Tango::DevBoolean	Scalar
//  HomeSwitch           |  Tango::DevBoolean	Scalar
//  MotorStatus          |  Tango::DevString	Scalar
//  EncoderPosition      |  Tango::DevDouble	Scalar
//  MotorPosition        |  Tango::DevLong	Scalar
//  UserPosition         |  Tango::DevDouble	Scalar
//  UserScale            |  Tango::DevDouble	Scalar
//  UserOffset           |  Tango::DevDouble	Scalar
//  UserSpeed            |  Tango::DevDouble	Scalar
//  Speed                |  Tango::DevDouble	Scalar
//  Acceleration         |  Tango::DevDouble	Scalar
//  Deceleration         |  Tango::DevDouble	Scalar
//  MotionAccuracy       |  Tango::DevDouble	Scalar
//  MotionPercent        |  Tango::DevDouble	Scalar
//  MotionRetry          |  Tango::DevDouble	Scalar
//  Backlash             |  Tango::DevDouble	Scalar
//  BacklashDirection    |  Tango::DevDouble	Scalar
//  Velocity             |  Tango::DevDouble	Scalar
//  IsInitialised        |  Tango::DevShort	Scalar
//  DeviceState          |  Tango::DevUShort	Scalar
//  DeviceStatus         |  Tango::DevString	Scalar
//  IsMicrocodeOK        |  Tango::DevBoolean	Scalar
//  CheckEncoder         |  Tango::DevBoolean	Scalar
//  CheckEncoderHoldOn   |  Tango::DevBoolean	Scalar
//  StoredPosition4Fake  |  Tango::DevDouble	Scalar
//  ExtStatus            |  Tango::DevString	Spectrum  ( max = 100)
//  History              |  Tango::DevString	Spectrum  ( max = 2000)
//================================================================

namespace AxisG2_ns
{
/*----- PROTECTED REGION ID(AxisG2::namespace_starting) ENABLED START -----*/

//	static initializations

/*----- PROTECTED REGION END -----*/	//	AxisG2::namespace_starting

//--------------------------------------------------------
/**
 *	Method      : AxisG2::AxisG2()
 *	Description : Constructors for a Tango device
 *                implementing the classAxisG2
 */
//--------------------------------------------------------
AxisG2::AxisG2(Tango::DeviceClass *cl, string &s)
 : TANGO_BASE_CLASS(cl, s.c_str())
{
	/*----- PROTECTED REGION ID(AxisG2::constructor_1) ENABLED START -----*/
	init_device();
	
	/*----- PROTECTED REGION END -----*/	//	AxisG2::constructor_1
}
//--------------------------------------------------------
AxisG2::AxisG2(Tango::DeviceClass *cl, const char *s)
 : TANGO_BASE_CLASS(cl, s)
{
	/*----- PROTECTED REGION ID(AxisG2::constructor_2) ENABLED START -----*/
	init_device();
	
	/*----- PROTECTED REGION END -----*/	//	AxisG2::constructor_2
}
//--------------------------------------------------------
AxisG2::AxisG2(Tango::DeviceClass *cl, const char *s, const char *d)
 : TANGO_BASE_CLASS(cl, s, d)
{
	/*----- PROTECTED REGION ID(AxisG2::constructor_3) ENABLED START -----*/
	init_device();
	
	/*----- PROTECTED REGION END -----*/	//	AxisG2::constructor_3
}

//--------------------------------------------------------
/**
 *	Method      : AxisG2::delete_device()
 *	Description : will be called at device destruction or at init command
 */
//--------------------------------------------------------
void AxisG2::delete_device()
{
	DEBUG_STREAM << "AxisG2::delete_device() " << device_name << endl;
	/*----- PROTECTED REGION ID(AxisG2::delete_device) ENABLED START -----*/
	
	//	Delete device allocated objects
	
	// MYCODE-START
        std::string obj("AxisG2::delete_device()");
        std::stringstream ss("");
        ss << " ::BEGIN:: ";
        prtlog(obj, ss.str());


	if (bf){
		delete bf;
		bf = NULL;
	}

	#ifdef HAVE_SAFETYMANAGER
	#ifdef _DBG_SM
		cout << "delete safety_manger" << endl;
	#endif /* _DBG_SM */
        if(safety_manger) {
                delete safety_manger;
                safety_manger = 0;
		#ifdef _DBG_SM
			cout << "safety_manger deleted" << endl;
		#endif /* _DBG_SM */
        }
	#endif

	#ifdef _DBG_EXTSTATUS
		cout << "Going to delete attr_ExtStatus_read[]" << endl;
	#endif
        for (int i=0; i<100; i++){
                if (attr_ExtStatus_read[i] != NULL){
			#ifdef _DBG_EXTSTATUS
				cout << "Going to delete attr_ExtStatus_read[" << i << "]" << endl;
			#endif
                        delete[] attr_ExtStatus_read[i];
                        attr_ExtStatus_read[i] = NULL;
                }
        }

	//cout << "Going to delete attr_DeviceStatus_read" << endl;
        if (*attr_DeviceStatus_read != NULL){
                delete[] *attr_DeviceStatus_read;
                *attr_DeviceStatus_read = NULL;
        }

	//cout << "Going to delete attr_MotorStatus_read" << endl;
        if (*attr_MotorStatus_read != NULL){
                delete[] *attr_MotorStatus_read;
                *attr_MotorStatus_read = NULL;
	}

	//cout << "Going to delete axis & controller)" << endl;
	if (axis)       {delete axis; axis = NULL; };
	if (controller) {delete controller; controller = NULL; };

        for (int i=0; i<2000; i++){
                if (attr_History_read[i] != NULL){
                        #ifdef _DBG_HISTORY
                                cout << "Going to delete attr_History_read[" << i << "]" << endl;
                        #endif
                        delete[] attr_History_read[i];
                        attr_History_read[i] = NULL;
                }
        }

        if (hist) {
                delete hist;
                hist = NULL;
        }


	// MYCODE-END

	delete[] attr_IsInitialised_old;

	ss.str("");
        ss << " ::END:: ";
        prtlog(obj, ss.str());
	
	/*----- PROTECTED REGION END -----*/	//	AxisG2::delete_device
	delete[] attr_Position_read;
	delete[] attr_PositiveLimitSwitch_read;
	delete[] attr_NegativeLimitSwitch_read;
	delete[] attr_HomeSwitch_read;
	delete[] attr_MotorStatus_read;
	delete[] attr_EncoderPosition_read;
	delete[] attr_MotorPosition_read;
	delete[] attr_UserPosition_read;
	delete[] attr_UserScale_read;
	delete[] attr_UserOffset_read;
	delete[] attr_UserSpeed_read;
	delete[] attr_Speed_read;
	delete[] attr_Acceleration_read;
	delete[] attr_Deceleration_read;
	delete[] attr_MotionAccuracy_read;
	delete[] attr_MotionPercent_read;
	delete[] attr_MotionRetry_read;
	delete[] attr_Backlash_read;
	delete[] attr_BacklashDirection_read;
	delete[] attr_Velocity_read;
	delete[] attr_IsInitialised_read;
	delete[] attr_DeviceState_read;
	delete[] attr_DeviceStatus_read;
	delete[] attr_IsMicrocodeOK_read;
	delete[] attr_CheckEncoder_read;
	delete[] attr_CheckEncoderHoldOn_read;
	delete[] attr_StoredPosition4Fake_read;
	delete[] attr_ExtStatus_read;
	delete[] attr_History_read;
}

//--------------------------------------------------------
/**
 *	Method      : AxisG2::init_device()
 *	Description : will be called at device initialization.
 */
//--------------------------------------------------------
void AxisG2::init_device()
{
	DEBUG_STREAM << "AxisG2::init_device() create device " << device_name << endl;
	/*----- PROTECTED REGION ID(AxisG2::init_device_before) ENABLED START -----*/
	
	//	Initialization before get_device_property() call

	std::string obj("AxisG2::init_device()");
 	std::stringstream ss("");


#if 0
	std::stringstream es;
	es << "AxisG2::init_device() " << RcsId;
	INFOLOG(es.str());
#endif


        bf = new AxisG2BriefLog_ns::AxisG2BriefLog(device_name);


	initType 		= -1;
	positionEncoderRatio 	= 0;
	encoderMotorRatio	= 0;
	encoderPrecision	= -1;
	encoderType		= -1;

	encoderDirection_defined = false;
	
	/*----- PROTECTED REGION END -----*/	//	AxisG2::init_device_before
	

	//	Get the device properties from database
	get_device_property();
	
	attr_Position_read = new Tango::DevDouble[1];
	attr_PositiveLimitSwitch_read = new Tango::DevBoolean[1];
	attr_NegativeLimitSwitch_read = new Tango::DevBoolean[1];
	attr_HomeSwitch_read = new Tango::DevBoolean[1];
	attr_MotorStatus_read = new Tango::DevString[1];
	attr_EncoderPosition_read = new Tango::DevDouble[1];
	attr_MotorPosition_read = new Tango::DevLong[1];
	attr_UserPosition_read = new Tango::DevDouble[1];
	attr_UserScale_read = new Tango::DevDouble[1];
	attr_UserOffset_read = new Tango::DevDouble[1];
	attr_UserSpeed_read = new Tango::DevDouble[1];
	attr_Speed_read = new Tango::DevDouble[1];
	attr_Acceleration_read = new Tango::DevDouble[1];
	attr_Deceleration_read = new Tango::DevDouble[1];
	attr_MotionAccuracy_read = new Tango::DevDouble[1];
	attr_MotionPercent_read = new Tango::DevDouble[1];
	attr_MotionRetry_read = new Tango::DevDouble[1];
	attr_Backlash_read = new Tango::DevDouble[1];
	attr_BacklashDirection_read = new Tango::DevDouble[1];
	attr_Velocity_read = new Tango::DevDouble[1];
	attr_IsInitialised_read = new Tango::DevShort[1];
	attr_DeviceState_read = new Tango::DevUShort[1];
	attr_DeviceStatus_read = new Tango::DevString[1];
	attr_IsMicrocodeOK_read = new Tango::DevBoolean[1];
	attr_CheckEncoder_read = new Tango::DevBoolean[1];
	attr_CheckEncoderHoldOn_read = new Tango::DevBoolean[1];
	attr_StoredPosition4Fake_read = new Tango::DevDouble[1];
	attr_ExtStatus_read = new Tango::DevString[100];
	attr_History_read = new Tango::DevString[2000];
	//	No longer if mandatory property not set. 
	if (mandatoryNotDefined)
		return;

	/*----- PROTECTED REGION ID(AxisG2::init_device) ENABLED START -----*/
	
	//	Initialize device

	// MYCODE-START

	attr_StoredPosition4Fake_read[0] = nan("");
	#ifdef _FAKE_AXIS_INIT_
		{
		  Tango::DbDatum dbdatum;
		  double v;
	
	          try {
	                if (read_memorized_attribute("StoredPosition4Fake", dbdatum)) {
	                        dbdatum >> v;
				attr_StoredPosition4Fake_read[0] = v;
				
	                };
	          } catch(Tango::DevFailed &ex) {
	                Tango::Except::throw_exception(
	                                        (const char *)"AxisG2",
	                                        (const char *)"Error on read memorized attribute StoredPosition4Fake",
	                                        (const char *)"AxisG2::init_device()");
	          }
		}
	#endif

	attr_Speed_read[0] = nan("");
	attr_Deceleration_read[0] = nan("");

        hist = new History_ns::history(this);
        hist->set_max_sample(2000);

        for (int i=0; i<2000; i++){
                attr_History_read[i] = new char[2];
                sprintf(attr_History_read[i], "-");
                #ifdef _DBG_HISTORY
                        cout << "attr_History_read[" << i << "]=" << attr_History_read[i] << "|" << endl;
                #endif /* _DBG_HISTORY*/
        }

        attr_IsInitialised_old = new Tango::DevShort[1];
	attr_IsInitialised_read[0] = attr_IsInitialised_old[0] = 0;

	prtTrue = _PRTTRUE_;

	#ifdef HAVE_SAFETYMANAGER
	prtlog(obj, ": HAVE_SAFETYMANAGER");

        safety_manger = NULL;

	vector<string>::iterator srit;
	bool have_rule = false;
	for (srit = safetyRules.begin(); srit != safetyRules.end(); ++srit){
		if ( (*srit).size() > 0 ) have_rule = true;
	};

	cout << device_name << " " << (have_rule?"":"not") << " have rules!" << endl;

	if ( have_rule ){
        	safety_manger = new SafetyManager(this);
        	try {
                	safety_manger->parseRules(safetyRules);
                	DEBUG_STREAM << "AxisG2::check_rules_validity(): rules parsed!" << endl;
        	} catch(int err) {
                	Tango::Except::throw_exception("",safety_manger->what(err),"check_rules_validity");
        	};
	};

        _delay_safety_manger = 4 ;
	#endif

	#ifdef _DBG_CONF
		cout << "----------------------------" << endl;
		cout << "initType             = " << initType << endl;
		cout << "findSpeeds.size()    = " << findSpeeds.size() << endl; // Db default;
		cout << "positionEncoderRatio = " << positionEncoderRatio << endl;
		cout << "encoderMotorRatio    = " << encoderMotorRatio << endl;
		cout << "encoderPrecision     = " << encoderPrecision << endl;
		cout << "encoderType          = " << encoderType << endl;

		cout << "----------------------------" << endl;
	#endif /* _DBG_CONF */

	*attr_CheckEncoderHoldOn_read = false;

	update_stat.min = MAXFLOAT;
	update_stat.max = MINFLOAT;

	_ctrl_up_dwn = 0;
	_ctrl_to_close = 0;
	_ALARMMsg = "";
	*attr_IsMicrocodeOK_read = true;

	#ifdef _DBG_EXTSTATUS
		cout << "Going to initialize attr_ExtStatus_read[]" << endl;
	#endif /* _DBG_EXTSTATUS*/

        for (int i=0; i<100; i++){
                attr_ExtStatus_read[i] = new char[2];
                sprintf(attr_ExtStatus_read[i], "-");
		#ifdef _DBG_EXTSTATUS
			cout << "attr_ExtStatus_read[" << i << "]=" << attr_ExtStatus_read[i] << "|" << endl;
		#endif /* _DBG_EXTSTATUS*/
        }

        __prevstate = Tango::UNKNOWN;
	__state = Tango::UNKNOWN;
        set_state(__prevstate);

//-----------------------------------------------
#ifdef _WITH_N5DRV_
 //N5N5
 	controller_type=Controller_ns::N5;
#else
	controller_type=Controller_ns::Yams;
#endif


	ss.str("");
	ss << "Default controller_type = " << Controller_ns::ControllerTypeName[controller_type];
	prtlog(obj, ss.str());

	string ct_galil(Controller_ns::ControllerTypeName[Controller_ns::GALILDMC2xxx]);
	string ct_yams(Controller_ns::ControllerTypeName[Controller_ns::Yams]);
	string ct_ginch(Controller_ns::ControllerTypeName[Controller_ns::DMC2xxxPiezo]);
	string ct_n5(Controller_ns::ControllerTypeName[Controller_ns::N5]);
	string ct_simul(Controller_ns::ControllerTypeName[Controller_ns::SIMUL]);
	string ct_bcs(Controller_ns::ControllerTypeName[Controller_ns::BCS]);

	if      ( 0 == driverType.compare(ct_yams) )  controller_type=Controller_ns::Yams;
	else if ( 0 == driverType.compare(ct_galil) ) controller_type=Controller_ns::GALILDMC2xxx;
	else if ( 0 == driverType.compare(ct_ginch) ) controller_type=Controller_ns::DMC2xxxPiezo;
 	else if ( 0 == driverType.compare(ct_n5) ) controller_type=Controller_ns::N5;
 	else if ( 0 == driverType.compare(ct_simul) ) controller_type=Controller_ns::SIMUL;
 	else if ( 0 == driverType.compare(ct_bcs) ) controller_type=Controller_ns::BCS;
#ifdef _WITH_N5DRV_
	else    controller_type=Controller_ns::N5;
#else
	else    controller_type=Controller_ns::Yams;
#endif

	ss.str("");
	ss << "Actual controller_type = " << Controller_ns::ControllerTypeName[controller_type];
	prtlog(obj, ss.str());
//-----------------------------------------------
	controller = NULL;
	__prev_ctrl_state = Controller_ns::CTRL_CLOSE;

	gettimeofday(&_last_create, NULL);
	_recreate_tmo = 5; //sec
	axis_init_at_first_fsm = false;

	axis = NULL;
	AxisCreate(false);

        *attr_DeviceState_read = 0;
        *attr_DeviceStatus_read = new char[DSTATUSMAX];
        snprintf(*attr_DeviceStatus_read, DSTATUSMAX, "UNKNOWN");
/*
typedef enum {
        UNKNOWN,
        ONLINE,
        OFFLINE,
        SERVICE,
        TEST
} devicestate_t;
*/
        DST.push_back("UNKNOWN");
        DST.push_back("ONLINE");
        DST.push_back("OFFLINE");
        DST.push_back("SERVICE");
        DST.push_back("TEST");

        *attr_MotorStatus_read = NULL;

/*
	ON, OFF, CLOSE, OPEN, INSERT, EXTRACT, MOVING, STANDBY, FAULT, INIT, RUNNING, ALARM, DISABLE, UNKNOWN
*/

	_chk_enc_onErr = string2state(encoderCheckOnError);
	switch (_chk_enc_onErr ){
		case Tango::EXTRACT:
		case Tango::FAULT:
		case Tango::RUNNING:
		case Tango::ALARM:
			break;
		default:
			_chk_enc_onErr = Tango::ALARM;
			break;
	}
	#ifdef _DBG_CONF
		cout << "EncoderCheckOnError = " << encoderCheckOnError << " _chk_enc_onErr = " << Tango::DevStateName[_chk_enc_onErr] << endl;
	#endif /* _DBG_CONF */

	*attr_CheckEncoder_read = checkEncoderEnable;
	__enc_err_state = Tango::UNKNOWN;
        __enc_err_status = "";


#ifdef FERMI2DB
                {
                  Tango::Database *db = new Tango::Database();
                  try {
                        Tango::DbData db_data;
                        db_data.push_back((Tango::DbDatum("Host")));
                        db_data.push_back((Tango::DbDatum("Port")));
                        db->get_property("Database",db_data);

                        db_data[0] >> host_rw;
                        db_data[1] >> port_rw;
                        INFO_STREAM << __FUNCTION__ << "host_rw:port_rw=" << host_rw << ":" << port_rw << "";
                  }catch(Tango::DevFailed &e) {
                        INFO_STREAM << __FUNCTION__ << " Error reading Database property='" << e.errors[0].desc << "'";
                  }
                  delete db;
                }
#endif

/*

        typedef struct _stat {
                float  mean;
                float  min;
                float  max;
        } stat_t;

        stat_t  statepos_stat;
*/

	statepos_stat.mean = 0;
	statepos_stat.min  = MAXFLOAT;
	statepos_stat.max  = MINFLOAT;

	chk_diff_on_run_stat.mean =  0;
	chk_diff_on_run_stat.min  = NAN;
	chk_diff_on_run_stat.max  = NAN;


	_il_last.clear();
	_il_count = 0;

/*------------------------------*/
// User Funcs related stuff:

        DirectFunc  = NULL;
        InverseFunc = NULL;
	lib_func_ok = false;

	#ifdef _DBG_AXISFUNCS_INIT
		cout << endl << endl;
        	cout << "Library of Func Stuff...   begin" << endl;
	#endif /* _DBG_AXISFUNCS_INIT */

	if ( (userFuncLibrary.size() != 0) && ( userFuncLibrary.compare("None") != 0 )) {

        	// open the library
	
		#ifdef _DBG_AXISFUNCS_INIT
			cout << endl;
	        	cout << "Opening Library of Func " << userFuncLibrary << "...\n";
		#endif /* _DBG_AXISFUNCS_INIT */
		
	        lib_handle = dlopen(userFuncLibrary.c_str(), RTLD_LAZY);
	
	        if (!lib_handle) {
	           cerr << "Cannot open library: " << dlerror() << '\n';
	        } else {
	
		        // load the symbol
			#ifdef _DBG_AXISFUNCS_INIT
		        	cout << "Loading symbol " << userDirectFuncName << "...\n";
			#endif /* _DBG_AXISFUNCS_INIT */
		
		        // reset errors
		        dlerror();
		
		        DirectFunc = (F00_funcptr_t) dlsym(lib_handle, userDirectFuncName.c_str());
		
		        dlsym_error = dlerror();
		        if (dlsym_error) {
		           cerr << "Cannot load symbol '" << userDirectFuncName << "': " << dlsym_error << '\n';
		           dlclose(lib_handle);
		        } else {
			
			        // load the symbol
				#ifdef _DBG_AXISFUNCS_INIT
			        	cout << "Loading symbol " << userInverseFuncName << "...\n";
				#endif /* _DBG_AXISFUNCS_INIT */
			
			        // reset errors
			        dlerror();
			
			        InverseFunc = (F00_funcptr_t) dlsym(lib_handle, userInverseFuncName.c_str());
			
			        dlsym_error = dlerror();
			        if (dlsym_error) {
			           cerr << "Cannot load symbol '" << userInverseFuncName << "': " << dlsym_error << '\n';
			           dlclose(lib_handle);
			        } else {
	
					lib_func_ok = true;
				};
			};
		};
	};

	if ( (userDirectFuncParams.size() == 0) || (userInverseFuncParams.size() == 0) ){
		if (lib_func_ok) dlclose(lib_handle);
		lib_func_ok = false;
	};

	if (lib_func_ok) {
		ss.str("");
		ss << "Using functions (direct/inverse): " << userDirectFuncName << "/" << userInverseFuncName << " ";
		ss << "in library: " << userFuncLibrary;
		prtlog(obj, ss.str());
	} else {
		ss.str("");
		ss << "Unable to get library/functions: " << userFuncLibrary << " " << userDirectFuncName << "/" << userInverseFuncName;
		ss << " ... NOT using library/functions!";
		prtlog(obj, ss.str());
        	DirectFunc  = NULL;
        	InverseFunc = NULL;
	}


	#ifdef _DBG_AXISFUNCS_INIT
        	cout << "Library of Func Stuff...   end" << endl;
		cout << endl << endl;
	#endif /* _DBG_AXISFUNCS_INIT */



	cached_with_microcode = with_microcode();
	#ifdef _DBG_CONF_2
		cout << "-------: cached_with_microcode=" << cached_with_microcode << endl;
	#endif
/*------------------------------*/

	ss.str("");
	ss << "! end !";
	prtlog(obj, ss.str());
	INFOLOG("AxisG2::init_device() end");
	// MYCODE-END
	
	/*----- PROTECTED REGION END -----*/	//	AxisG2::init_device
}

//--------------------------------------------------------
/**
 *	Method      : AxisG2::get_device_property()
 *	Description : Read database to initialize property data members.
 */
//--------------------------------------------------------
void AxisG2::get_device_property()
{
	/*----- PROTECTED REGION ID(AxisG2::get_device_property_before) ENABLED START -----*/
	
	//	Initialize property data members
	fLSStroke = nan("");
	rLSStroke = nan("");
	
	/*----- PROTECTED REGION END -----*/	//	AxisG2::get_device_property_before

	mandatoryNotDefined = false;

	//	Read device properties from database.
	Tango::DbData	dev_prop;
	dev_prop.push_back(Tango::DbDatum("Driver"));
	dev_prop.push_back(Tango::DbDatum("DriverType"));
	dev_prop.push_back(Tango::DbDatum("Channel"));
	dev_prop.push_back(Tango::DbDatum("EncoderType"));
	dev_prop.push_back(Tango::DbDatum("EncoderPrecision"));
	dev_prop.push_back(Tango::DbDatum("EncoderMotorRatio"));
	dev_prop.push_back(Tango::DbDatum("EncoderMotorOffset"));
	dev_prop.push_back(Tango::DbDatum("PositionEncoderRatio"));
	dev_prop.push_back(Tango::DbDatum("PositionEncoderOffset"));
	dev_prop.push_back(Tango::DbDatum("MotorSmoothing"));
	dev_prop.push_back(Tango::DbDatum("MotorDirection"));
	dev_prop.push_back(Tango::DbDatum("MotorBrakeExtraTMO"));
	dev_prop.push_back(Tango::DbDatum("MotorRawBrakeONTMO"));
	dev_prop.push_back(Tango::DbDatum("EncoderDirection"));
	dev_prop.push_back(Tango::DbDatum("EncoderExtras"));
	dev_prop.push_back(Tango::DbDatum("AxisForwardLimit"));
	dev_prop.push_back(Tango::DbDatum("AxisBackwardLimit"));
	dev_prop.push_back(Tango::DbDatum("InitType"));
	dev_prop.push_back(Tango::DbDatum("InitPosition"));
	dev_prop.push_back(Tango::DbDatum("MotoristMemo"));
	dev_prop.push_back(Tango::DbDatum("FindSpeeds"));
	dev_prop.push_back(Tango::DbDatum("UserEncoderRatio"));
	dev_prop.push_back(Tango::DbDatum("EncoderRippleOnStay"));
	dev_prop.push_back(Tango::DbDatum("EncoderCheckDelay"));
	dev_prop.push_back(Tango::DbDatum("EncoderRippleOnRun"));
	dev_prop.push_back(Tango::DbDatum("EncoderCheckOnError"));
	dev_prop.push_back(Tango::DbDatum("CheckEncoderEnable"));
	dev_prop.push_back(Tango::DbDatum("EncoderCheckOnErrorStop"));
	dev_prop.push_back(Tango::DbDatum("EncoderAnalogRatio"));
	dev_prop.push_back(Tango::DbDatum("EncoderAnalogOffset"));
	dev_prop.push_back(Tango::DbDatum("HWWriteEnable"));
	dev_prop.push_back(Tango::DbDatum("SafetyRules"));
	dev_prop.push_back(Tango::DbDatum("UserFuncLibrary"));
	dev_prop.push_back(Tango::DbDatum("UserDirectFuncName"));
	dev_prop.push_back(Tango::DbDatum("UserDirectFuncParams"));
	dev_prop.push_back(Tango::DbDatum("UserInverseFuncName"));
	dev_prop.push_back(Tango::DbDatum("UserInverseFuncParams"));
	dev_prop.push_back(Tango::DbDatum("RLSStroke"));
	dev_prop.push_back(Tango::DbDatum("FLSStroke"));
	dev_prop.push_back(Tango::DbDatum("FakeAxisInitEnable"));

	//	is there at least one property to be read ?
	if (dev_prop.size()>0)
	{
		//	Call database and extract values
		if (Tango::Util::instance()->_UseDb==true)
			get_db_device()->get_property(dev_prop);
	
		//	get instance on AxisG2Class to get class property
		Tango::DbDatum	def_prop, cl_prop;
		AxisG2Class	*ds_class =
			(static_cast<AxisG2Class *>(get_device_class()));
		int	i = -1;

		//	Try to initialize Driver from class property
		cl_prop = ds_class->get_class_property(dev_prop[++i].name);
		if (cl_prop.is_empty()==false)	cl_prop  >>  driver;
		else {
			//	Try to initialize Driver from default device value
			def_prop = ds_class->get_default_device_property(dev_prop[i].name);
			if (def_prop.is_empty()==false)	def_prop  >>  driver;
		}
		//	And try to extract Driver value from database
		if (dev_prop[i].is_empty()==false)	dev_prop[i]  >>  driver;

		//	Try to initialize DriverType from class property
		cl_prop = ds_class->get_class_property(dev_prop[++i].name);
		if (cl_prop.is_empty()==false)	cl_prop  >>  driverType;
		else {
			//	Try to initialize DriverType from default device value
			def_prop = ds_class->get_default_device_property(dev_prop[i].name);
			if (def_prop.is_empty()==false)	def_prop  >>  driverType;
		}
		//	And try to extract DriverType value from database
		if (dev_prop[i].is_empty()==false)	dev_prop[i]  >>  driverType;

		//	Try to initialize Channel from class property
		cl_prop = ds_class->get_class_property(dev_prop[++i].name);
		if (cl_prop.is_empty()==false)	cl_prop  >>  channel;
		else {
			//	Try to initialize Channel from default device value
			def_prop = ds_class->get_default_device_property(dev_prop[i].name);
			if (def_prop.is_empty()==false)	def_prop  >>  channel;
		}
		//	And try to extract Channel value from database
		if (dev_prop[i].is_empty()==false)	dev_prop[i]  >>  channel;

		//	Try to initialize EncoderType from class property
		cl_prop = ds_class->get_class_property(dev_prop[++i].name);
		if (cl_prop.is_empty()==false)	cl_prop  >>  encoderType;
		else {
			//	Try to initialize EncoderType from default device value
			def_prop = ds_class->get_default_device_property(dev_prop[i].name);
			if (def_prop.is_empty()==false)	def_prop  >>  encoderType;
		}
		//	And try to extract EncoderType value from database
		if (dev_prop[i].is_empty()==false)	dev_prop[i]  >>  encoderType;

		//	Try to initialize EncoderPrecision from class property
		cl_prop = ds_class->get_class_property(dev_prop[++i].name);
		if (cl_prop.is_empty()==false)	cl_prop  >>  encoderPrecision;
		else {
			//	Try to initialize EncoderPrecision from default device value
			def_prop = ds_class->get_default_device_property(dev_prop[i].name);
			if (def_prop.is_empty()==false)	def_prop  >>  encoderPrecision;
		}
		//	And try to extract EncoderPrecision value from database
		if (dev_prop[i].is_empty()==false)	dev_prop[i]  >>  encoderPrecision;

		//	Try to initialize EncoderMotorRatio from class property
		cl_prop = ds_class->get_class_property(dev_prop[++i].name);
		if (cl_prop.is_empty()==false)	cl_prop  >>  encoderMotorRatio;
		else {
			//	Try to initialize EncoderMotorRatio from default device value
			def_prop = ds_class->get_default_device_property(dev_prop[i].name);
			if (def_prop.is_empty()==false)	def_prop  >>  encoderMotorRatio;
		}
		//	And try to extract EncoderMotorRatio value from database
		if (dev_prop[i].is_empty()==false)	dev_prop[i]  >>  encoderMotorRatio;
		//	Property StartDsPath is mandatory, check if has been defined in database.
		check_mandatory_property(cl_prop, dev_prop[i]);

		//	Try to initialize EncoderMotorOffset from class property
		cl_prop = ds_class->get_class_property(dev_prop[++i].name);
		if (cl_prop.is_empty()==false)	cl_prop  >>  encoderMotorOffset;
		else {
			//	Try to initialize EncoderMotorOffset from default device value
			def_prop = ds_class->get_default_device_property(dev_prop[i].name);
			if (def_prop.is_empty()==false)	def_prop  >>  encoderMotorOffset;
		}
		//	And try to extract EncoderMotorOffset value from database
		if (dev_prop[i].is_empty()==false)	dev_prop[i]  >>  encoderMotorOffset;

		//	Try to initialize PositionEncoderRatio from class property
		cl_prop = ds_class->get_class_property(dev_prop[++i].name);
		if (cl_prop.is_empty()==false)	cl_prop  >>  positionEncoderRatio;
		else {
			//	Try to initialize PositionEncoderRatio from default device value
			def_prop = ds_class->get_default_device_property(dev_prop[i].name);
			if (def_prop.is_empty()==false)	def_prop  >>  positionEncoderRatio;
		}
		//	And try to extract PositionEncoderRatio value from database
		if (dev_prop[i].is_empty()==false)	dev_prop[i]  >>  positionEncoderRatio;
		//	Property StartDsPath is mandatory, check if has been defined in database.
		check_mandatory_property(cl_prop, dev_prop[i]);

		//	Try to initialize PositionEncoderOffset from class property
		cl_prop = ds_class->get_class_property(dev_prop[++i].name);
		if (cl_prop.is_empty()==false)	cl_prop  >>  positionEncoderOffset;
		else {
			//	Try to initialize PositionEncoderOffset from default device value
			def_prop = ds_class->get_default_device_property(dev_prop[i].name);
			if (def_prop.is_empty()==false)	def_prop  >>  positionEncoderOffset;
		}
		//	And try to extract PositionEncoderOffset value from database
		if (dev_prop[i].is_empty()==false)	dev_prop[i]  >>  positionEncoderOffset;

		//	Try to initialize MotorSmoothing from class property
		cl_prop = ds_class->get_class_property(dev_prop[++i].name);
		if (cl_prop.is_empty()==false)	cl_prop  >>  motorSmoothing;
		else {
			//	Try to initialize MotorSmoothing from default device value
			def_prop = ds_class->get_default_device_property(dev_prop[i].name);
			if (def_prop.is_empty()==false)	def_prop  >>  motorSmoothing;
		}
		//	And try to extract MotorSmoothing value from database
		if (dev_prop[i].is_empty()==false)	dev_prop[i]  >>  motorSmoothing;

		//	Try to initialize MotorDirection from class property
		cl_prop = ds_class->get_class_property(dev_prop[++i].name);
		if (cl_prop.is_empty()==false)	cl_prop  >>  motorDirection;
		else {
			//	Try to initialize MotorDirection from default device value
			def_prop = ds_class->get_default_device_property(dev_prop[i].name);
			if (def_prop.is_empty()==false)	def_prop  >>  motorDirection;
		}
		//	And try to extract MotorDirection value from database
		if (dev_prop[i].is_empty()==false)	dev_prop[i]  >>  motorDirection;

		//	Try to initialize MotorBrakeExtraTMO from class property
		cl_prop = ds_class->get_class_property(dev_prop[++i].name);
		if (cl_prop.is_empty()==false)	cl_prop  >>  motorBrakeExtraTMO;
		else {
			//	Try to initialize MotorBrakeExtraTMO from default device value
			def_prop = ds_class->get_default_device_property(dev_prop[i].name);
			if (def_prop.is_empty()==false)	def_prop  >>  motorBrakeExtraTMO;
		}
		//	And try to extract MotorBrakeExtraTMO value from database
		if (dev_prop[i].is_empty()==false)	dev_prop[i]  >>  motorBrakeExtraTMO;

		//	Try to initialize MotorRawBrakeONTMO from class property
		cl_prop = ds_class->get_class_property(dev_prop[++i].name);
		if (cl_prop.is_empty()==false)	cl_prop  >>  motorRawBrakeONTMO;
		else {
			//	Try to initialize MotorRawBrakeONTMO from default device value
			def_prop = ds_class->get_default_device_property(dev_prop[i].name);
			if (def_prop.is_empty()==false)	def_prop  >>  motorRawBrakeONTMO;
		}
		//	And try to extract MotorRawBrakeONTMO value from database
		if (dev_prop[i].is_empty()==false)	dev_prop[i]  >>  motorRawBrakeONTMO;

		//	Try to initialize EncoderDirection from class property
		cl_prop = ds_class->get_class_property(dev_prop[++i].name);
		if (cl_prop.is_empty()==false)	cl_prop  >>  encoderDirection;
		else {
			//	Try to initialize EncoderDirection from default device value
			def_prop = ds_class->get_default_device_property(dev_prop[i].name);
			if (def_prop.is_empty()==false)	def_prop  >>  encoderDirection;
		}
		//	And try to extract EncoderDirection value from database
		if (dev_prop[i].is_empty()==false)	dev_prop[i]  >>  encoderDirection;

		//	Try to initialize EncoderExtras from class property
		cl_prop = ds_class->get_class_property(dev_prop[++i].name);
		if (cl_prop.is_empty()==false)	cl_prop  >>  encoderExtras;
		else {
			//	Try to initialize EncoderExtras from default device value
			def_prop = ds_class->get_default_device_property(dev_prop[i].name);
			if (def_prop.is_empty()==false)	def_prop  >>  encoderExtras;
		}
		//	And try to extract EncoderExtras value from database
		if (dev_prop[i].is_empty()==false)	dev_prop[i]  >>  encoderExtras;

		//	Try to initialize AxisForwardLimit from class property
		cl_prop = ds_class->get_class_property(dev_prop[++i].name);
		if (cl_prop.is_empty()==false)	cl_prop  >>  axisForwardLimit;
		else {
			//	Try to initialize AxisForwardLimit from default device value
			def_prop = ds_class->get_default_device_property(dev_prop[i].name);
			if (def_prop.is_empty()==false)	def_prop  >>  axisForwardLimit;
		}
		//	And try to extract AxisForwardLimit value from database
		if (dev_prop[i].is_empty()==false)	dev_prop[i]  >>  axisForwardLimit;

		//	Try to initialize AxisBackwardLimit from class property
		cl_prop = ds_class->get_class_property(dev_prop[++i].name);
		if (cl_prop.is_empty()==false)	cl_prop  >>  axisBackwardLimit;
		else {
			//	Try to initialize AxisBackwardLimit from default device value
			def_prop = ds_class->get_default_device_property(dev_prop[i].name);
			if (def_prop.is_empty()==false)	def_prop  >>  axisBackwardLimit;
		}
		//	And try to extract AxisBackwardLimit value from database
		if (dev_prop[i].is_empty()==false)	dev_prop[i]  >>  axisBackwardLimit;

		//	Try to initialize InitType from class property
		cl_prop = ds_class->get_class_property(dev_prop[++i].name);
		if (cl_prop.is_empty()==false)	cl_prop  >>  initType;
		else {
			//	Try to initialize InitType from default device value
			def_prop = ds_class->get_default_device_property(dev_prop[i].name);
			if (def_prop.is_empty()==false)	def_prop  >>  initType;
		}
		//	And try to extract InitType value from database
		if (dev_prop[i].is_empty()==false)	dev_prop[i]  >>  initType;

		//	Try to initialize InitPosition from class property
		cl_prop = ds_class->get_class_property(dev_prop[++i].name);
		if (cl_prop.is_empty()==false)	cl_prop  >>  initPosition;
		else {
			//	Try to initialize InitPosition from default device value
			def_prop = ds_class->get_default_device_property(dev_prop[i].name);
			if (def_prop.is_empty()==false)	def_prop  >>  initPosition;
		}
		//	And try to extract InitPosition value from database
		if (dev_prop[i].is_empty()==false)	dev_prop[i]  >>  initPosition;

		//	Try to initialize MotoristMemo from class property
		cl_prop = ds_class->get_class_property(dev_prop[++i].name);
		if (cl_prop.is_empty()==false)	cl_prop  >>  motoristMemo;
		else {
			//	Try to initialize MotoristMemo from default device value
			def_prop = ds_class->get_default_device_property(dev_prop[i].name);
			if (def_prop.is_empty()==false)	def_prop  >>  motoristMemo;
		}
		//	And try to extract MotoristMemo value from database
		if (dev_prop[i].is_empty()==false)	dev_prop[i]  >>  motoristMemo;

		//	Try to initialize FindSpeeds from class property
		cl_prop = ds_class->get_class_property(dev_prop[++i].name);
		if (cl_prop.is_empty()==false)	cl_prop  >>  findSpeeds;
		else {
			//	Try to initialize FindSpeeds from default device value
			def_prop = ds_class->get_default_device_property(dev_prop[i].name);
			if (def_prop.is_empty()==false)	def_prop  >>  findSpeeds;
		}
		//	And try to extract FindSpeeds value from database
		if (dev_prop[i].is_empty()==false)	dev_prop[i]  >>  findSpeeds;

		//	Try to initialize UserEncoderRatio from class property
		cl_prop = ds_class->get_class_property(dev_prop[++i].name);
		if (cl_prop.is_empty()==false)	cl_prop  >>  userEncoderRatio;
		else {
			//	Try to initialize UserEncoderRatio from default device value
			def_prop = ds_class->get_default_device_property(dev_prop[i].name);
			if (def_prop.is_empty()==false)	def_prop  >>  userEncoderRatio;
		}
		//	And try to extract UserEncoderRatio value from database
		if (dev_prop[i].is_empty()==false)	dev_prop[i]  >>  userEncoderRatio;

		//	Try to initialize EncoderRippleOnStay from class property
		cl_prop = ds_class->get_class_property(dev_prop[++i].name);
		if (cl_prop.is_empty()==false)	cl_prop  >>  encoderRippleOnStay;
		else {
			//	Try to initialize EncoderRippleOnStay from default device value
			def_prop = ds_class->get_default_device_property(dev_prop[i].name);
			if (def_prop.is_empty()==false)	def_prop  >>  encoderRippleOnStay;
		}
		//	And try to extract EncoderRippleOnStay value from database
		if (dev_prop[i].is_empty()==false)	dev_prop[i]  >>  encoderRippleOnStay;

		//	Try to initialize EncoderCheckDelay from class property
		cl_prop = ds_class->get_class_property(dev_prop[++i].name);
		if (cl_prop.is_empty()==false)	cl_prop  >>  encoderCheckDelay;
		else {
			//	Try to initialize EncoderCheckDelay from default device value
			def_prop = ds_class->get_default_device_property(dev_prop[i].name);
			if (def_prop.is_empty()==false)	def_prop  >>  encoderCheckDelay;
		}
		//	And try to extract EncoderCheckDelay value from database
		if (dev_prop[i].is_empty()==false)	dev_prop[i]  >>  encoderCheckDelay;

		//	Try to initialize EncoderRippleOnRun from class property
		cl_prop = ds_class->get_class_property(dev_prop[++i].name);
		if (cl_prop.is_empty()==false)	cl_prop  >>  encoderRippleOnRun;
		else {
			//	Try to initialize EncoderRippleOnRun from default device value
			def_prop = ds_class->get_default_device_property(dev_prop[i].name);
			if (def_prop.is_empty()==false)	def_prop  >>  encoderRippleOnRun;
		}
		//	And try to extract EncoderRippleOnRun value from database
		if (dev_prop[i].is_empty()==false)	dev_prop[i]  >>  encoderRippleOnRun;

		//	Try to initialize EncoderCheckOnError from class property
		cl_prop = ds_class->get_class_property(dev_prop[++i].name);
		if (cl_prop.is_empty()==false)	cl_prop  >>  encoderCheckOnError;
		else {
			//	Try to initialize EncoderCheckOnError from default device value
			def_prop = ds_class->get_default_device_property(dev_prop[i].name);
			if (def_prop.is_empty()==false)	def_prop  >>  encoderCheckOnError;
		}
		//	And try to extract EncoderCheckOnError value from database
		if (dev_prop[i].is_empty()==false)	dev_prop[i]  >>  encoderCheckOnError;

		//	Try to initialize CheckEncoderEnable from class property
		cl_prop = ds_class->get_class_property(dev_prop[++i].name);
		if (cl_prop.is_empty()==false)	cl_prop  >>  checkEncoderEnable;
		else {
			//	Try to initialize CheckEncoderEnable from default device value
			def_prop = ds_class->get_default_device_property(dev_prop[i].name);
			if (def_prop.is_empty()==false)	def_prop  >>  checkEncoderEnable;
		}
		//	And try to extract CheckEncoderEnable value from database
		if (dev_prop[i].is_empty()==false)	dev_prop[i]  >>  checkEncoderEnable;

		//	Try to initialize EncoderCheckOnErrorStop from class property
		cl_prop = ds_class->get_class_property(dev_prop[++i].name);
		if (cl_prop.is_empty()==false)	cl_prop  >>  encoderCheckOnErrorStop;
		else {
			//	Try to initialize EncoderCheckOnErrorStop from default device value
			def_prop = ds_class->get_default_device_property(dev_prop[i].name);
			if (def_prop.is_empty()==false)	def_prop  >>  encoderCheckOnErrorStop;
		}
		//	And try to extract EncoderCheckOnErrorStop value from database
		if (dev_prop[i].is_empty()==false)	dev_prop[i]  >>  encoderCheckOnErrorStop;

		//	Try to initialize EncoderAnalogRatio from class property
		cl_prop = ds_class->get_class_property(dev_prop[++i].name);
		if (cl_prop.is_empty()==false)	cl_prop  >>  encoderAnalogRatio;
		else {
			//	Try to initialize EncoderAnalogRatio from default device value
			def_prop = ds_class->get_default_device_property(dev_prop[i].name);
			if (def_prop.is_empty()==false)	def_prop  >>  encoderAnalogRatio;
		}
		//	And try to extract EncoderAnalogRatio value from database
		if (dev_prop[i].is_empty()==false)	dev_prop[i]  >>  encoderAnalogRatio;

		//	Try to initialize EncoderAnalogOffset from class property
		cl_prop = ds_class->get_class_property(dev_prop[++i].name);
		if (cl_prop.is_empty()==false)	cl_prop  >>  encoderAnalogOffset;
		else {
			//	Try to initialize EncoderAnalogOffset from default device value
			def_prop = ds_class->get_default_device_property(dev_prop[i].name);
			if (def_prop.is_empty()==false)	def_prop  >>  encoderAnalogOffset;
		}
		//	And try to extract EncoderAnalogOffset value from database
		if (dev_prop[i].is_empty()==false)	dev_prop[i]  >>  encoderAnalogOffset;

		//	Try to initialize HWWriteEnable from class property
		cl_prop = ds_class->get_class_property(dev_prop[++i].name);
		if (cl_prop.is_empty()==false)	cl_prop  >>  hWWriteEnable;
		else {
			//	Try to initialize HWWriteEnable from default device value
			def_prop = ds_class->get_default_device_property(dev_prop[i].name);
			if (def_prop.is_empty()==false)	def_prop  >>  hWWriteEnable;
		}
		//	And try to extract HWWriteEnable value from database
		if (dev_prop[i].is_empty()==false)	dev_prop[i]  >>  hWWriteEnable;

		//	Try to initialize SafetyRules from class property
		cl_prop = ds_class->get_class_property(dev_prop[++i].name);
		if (cl_prop.is_empty()==false)	cl_prop  >>  safetyRules;
		else {
			//	Try to initialize SafetyRules from default device value
			def_prop = ds_class->get_default_device_property(dev_prop[i].name);
			if (def_prop.is_empty()==false)	def_prop  >>  safetyRules;
		}
		//	And try to extract SafetyRules value from database
		if (dev_prop[i].is_empty()==false)	dev_prop[i]  >>  safetyRules;

		//	Try to initialize UserFuncLibrary from class property
		cl_prop = ds_class->get_class_property(dev_prop[++i].name);
		if (cl_prop.is_empty()==false)	cl_prop  >>  userFuncLibrary;
		else {
			//	Try to initialize UserFuncLibrary from default device value
			def_prop = ds_class->get_default_device_property(dev_prop[i].name);
			if (def_prop.is_empty()==false)	def_prop  >>  userFuncLibrary;
		}
		//	And try to extract UserFuncLibrary value from database
		if (dev_prop[i].is_empty()==false)	dev_prop[i]  >>  userFuncLibrary;

		//	Try to initialize UserDirectFuncName from class property
		cl_prop = ds_class->get_class_property(dev_prop[++i].name);
		if (cl_prop.is_empty()==false)	cl_prop  >>  userDirectFuncName;
		else {
			//	Try to initialize UserDirectFuncName from default device value
			def_prop = ds_class->get_default_device_property(dev_prop[i].name);
			if (def_prop.is_empty()==false)	def_prop  >>  userDirectFuncName;
		}
		//	And try to extract UserDirectFuncName value from database
		if (dev_prop[i].is_empty()==false)	dev_prop[i]  >>  userDirectFuncName;

		//	Try to initialize UserDirectFuncParams from class property
		cl_prop = ds_class->get_class_property(dev_prop[++i].name);
		if (cl_prop.is_empty()==false)	cl_prop  >>  userDirectFuncParams;
		else {
			//	Try to initialize UserDirectFuncParams from default device value
			def_prop = ds_class->get_default_device_property(dev_prop[i].name);
			if (def_prop.is_empty()==false)	def_prop  >>  userDirectFuncParams;
		}
		//	And try to extract UserDirectFuncParams value from database
		if (dev_prop[i].is_empty()==false)	dev_prop[i]  >>  userDirectFuncParams;

		//	Try to initialize UserInverseFuncName from class property
		cl_prop = ds_class->get_class_property(dev_prop[++i].name);
		if (cl_prop.is_empty()==false)	cl_prop  >>  userInverseFuncName;
		else {
			//	Try to initialize UserInverseFuncName from default device value
			def_prop = ds_class->get_default_device_property(dev_prop[i].name);
			if (def_prop.is_empty()==false)	def_prop  >>  userInverseFuncName;
		}
		//	And try to extract UserInverseFuncName value from database
		if (dev_prop[i].is_empty()==false)	dev_prop[i]  >>  userInverseFuncName;

		//	Try to initialize UserInverseFuncParams from class property
		cl_prop = ds_class->get_class_property(dev_prop[++i].name);
		if (cl_prop.is_empty()==false)	cl_prop  >>  userInverseFuncParams;
		else {
			//	Try to initialize UserInverseFuncParams from default device value
			def_prop = ds_class->get_default_device_property(dev_prop[i].name);
			if (def_prop.is_empty()==false)	def_prop  >>  userInverseFuncParams;
		}
		//	And try to extract UserInverseFuncParams value from database
		if (dev_prop[i].is_empty()==false)	dev_prop[i]  >>  userInverseFuncParams;

		//	Try to initialize RLSStroke from class property
		cl_prop = ds_class->get_class_property(dev_prop[++i].name);
		if (cl_prop.is_empty()==false)	cl_prop  >>  rLSStroke;
		else {
			//	Try to initialize RLSStroke from default device value
			def_prop = ds_class->get_default_device_property(dev_prop[i].name);
			if (def_prop.is_empty()==false)	def_prop  >>  rLSStroke;
		}
		//	And try to extract RLSStroke value from database
		if (dev_prop[i].is_empty()==false)	dev_prop[i]  >>  rLSStroke;

		//	Try to initialize FLSStroke from class property
		cl_prop = ds_class->get_class_property(dev_prop[++i].name);
		if (cl_prop.is_empty()==false)	cl_prop  >>  fLSStroke;
		else {
			//	Try to initialize FLSStroke from default device value
			def_prop = ds_class->get_default_device_property(dev_prop[i].name);
			if (def_prop.is_empty()==false)	def_prop  >>  fLSStroke;
		}
		//	And try to extract FLSStroke value from database
		if (dev_prop[i].is_empty()==false)	dev_prop[i]  >>  fLSStroke;

		//	Try to initialize FakeAxisInitEnable from class property
		cl_prop = ds_class->get_class_property(dev_prop[++i].name);
		if (cl_prop.is_empty()==false)	cl_prop  >>  fakeAxisInitEnable;
		else {
			//	Try to initialize FakeAxisInitEnable from default device value
			def_prop = ds_class->get_default_device_property(dev_prop[i].name);
			if (def_prop.is_empty()==false)	def_prop  >>  fakeAxisInitEnable;
		}
		//	And try to extract FakeAxisInitEnable value from database
		if (dev_prop[i].is_empty()==false)	dev_prop[i]  >>  fakeAxisInitEnable;

	}

	/*----- PROTECTED REGION ID(AxisG2::get_device_property_after) ENABLED START -----*/
	
	//	Check device property data members init
	Tango::DbDatum	def_prop, cl_prop;
	AxisG2Class	*ds_class = (static_cast<AxisG2Class *>(get_device_class()));
	int	i = -1;
	string EDProp("EncoderDirection");
	for (i=0; i<(int)dev_prop.size(); i++) {
		if ((dev_prop[i].name).compare(EDProp) == 0){
			cl_prop = ds_class->get_class_property(EDProp);
			def_prop = ds_class->get_default_device_property(EDProp);
			if ( !cl_prop.is_empty() || !def_prop.is_empty() || !dev_prop[i].is_empty() ){
				encoderDirection_defined = true;
			} else {
				encoderDirection_defined = false;
				cout << device_name << " : EncoderDirection not defined!" << endl;
			}
		}
	}
	
	/*----- PROTECTED REGION END -----*/	//	AxisG2::get_device_property_after
}
//--------------------------------------------------------
/**
 *	Method      : AxisG2::check_mandatory_property()
 *	Description : For mandatory properties check if defined in database.
 */
//--------------------------------------------------------
void AxisG2::check_mandatory_property(Tango::DbDatum &class_prop, Tango::DbDatum &dev_prop)
{
	//	Check if all properties are empty
	if (class_prop.is_empty() && dev_prop.is_empty())
	{
		TangoSys_OMemStream	tms;
		tms << endl <<"Property \'" << dev_prop.name;
		if (Tango::Util::instance()->_UseDb==true)
			tms << "\' is mandatory but not defined in database";
		else
			tms << "\' is mandatory but cannot be defined without database";
		append_status(tms.str());
		mandatoryNotDefined = true;
		/*----- PROTECTED REGION ID(AxisG2::check_mandatory_property) ENABLED START -----*/
		cerr << tms.str() << " for " << device_name << endl;
		
		/*----- PROTECTED REGION END -----*/	//	AxisG2::check_mandatory_property
	}
}


//--------------------------------------------------------
/**
 *	Method      : AxisG2::always_executed_hook()
 *	Description : method always executed before any command is executed
 */
//--------------------------------------------------------
void AxisG2::always_executed_hook()
{
	DEBUG_STREAM << "AxisG2::always_executed_hook()  " << device_name << endl;
	if (mandatoryNotDefined)
	{
		Tango::Except::throw_exception(
					(const char *)"PROPERTY_NOT_SET",
					get_status().c_str(),
					(const char *)"AxisG2::always_executed_hook()");
	}
	/*----- PROTECTED REGION ID(AxisG2::always_executed_hook) ENABLED START -----*/
	
	//	code always executed before all requests

	// MYCODE-START
	#ifdef _DBG_AEH
		cout << "DBG_AEH:: AxisG2::always_executed_hook() MYSTART " << device_name << endl;
	#endif

	if (!axis) {
		#if 0
			cout << "AEH:: AxisG2::always_executed_hook() AxisCreate(true) " << device_name << endl;
		#endif
		AxisCreate(true); 
	}

	if (controller){
		ct = controller->state();
		if ( __prev_ctrl_state != ct ){
			if ( (__prev_ctrl_state == Controller_ns::CTRL_UP) && (ct == Controller_ns::CTRL_DOWN) ) _ctrl_up_dwn++ ; 
			if ( (__prev_ctrl_state != Controller_ns::CTRL_CLOSE) && (ct == Controller_ns::CTRL_CLOSE) ) _ctrl_to_close++ ; 
			__prev_ctrl_state = ct;
		}
	}
		
	#ifdef HAVE_SAFETYMANAGER
	if (_delay_safety_manger <= 0){
        	if( safety_manger) { 
			#ifdef _DBG_SAFETYMANAGER
				cout << device_name << " going to black_box() for SM ... " << endl;
			#endif
			Tango::DevVarStringArray* bb = black_box(1);
			#ifdef _DBG_SM
				cout << "AEH():: !safetyRules.empty():: ";
				cout << (bb[0])[0].in() << "|" << endl;
			#endif /* _DBG_SM */
                	safety_manger->check_action_safety((bb[0])[0].in());
			delete bb;
        	}
	} else {
		_delay_safety_manger--;
	}
	#endif

	#ifdef _DBG_AEH
		cout << "DBG_AEH:: AxisG2::always_executed_hook()  END " << device_name << endl;
	#endif
	// MYCODE-END
	
	/*----- PROTECTED REGION END -----*/	//	AxisG2::always_executed_hook
}

//--------------------------------------------------------
/**
 *	Method      : AxisG2::read_attr_hardware()
 *	Description : Hardware acquisition for attributes
 */
//--------------------------------------------------------
void AxisG2::read_attr_hardware(TANGO_UNUSED(vector<long> &attr_list))
{
	DEBUG_STREAM << "AxisG2::read_attr_hardware(vector<long> &attr_list) entering... " << endl;
	/*----- PROTECTED REGION ID(AxisG2::read_attr_hardware) ENABLED START -----*/
	
	//	Add your own code
	
	/*----- PROTECTED REGION END -----*/	//	AxisG2::read_attr_hardware
}
//--------------------------------------------------------
/**
 *	Method      : AxisG2::write_attr_hardware()
 *	Description : Hardware writing for attributes
 */
//--------------------------------------------------------
void AxisG2::write_attr_hardware(TANGO_UNUSED(vector<long> &attr_list))
{
	DEBUG_STREAM << "AxisG2::write_attr_hardware(vector<long> &attr_list) entering... " << endl;
	/*----- PROTECTED REGION ID(AxisG2::write_attr_hardware) ENABLED START -----*/
	
	//	Add your own code
	
	/*----- PROTECTED REGION END -----*/	//	AxisG2::write_attr_hardware
}

//--------------------------------------------------------
/**
 *	Read attribute Position related method
 *	Description: Position of the axis (<I><B>plant coordinates/units</B></I>).
 *
 *	Data type:	Tango::DevDouble
 *	Attr type:	Scalar
 */
//--------------------------------------------------------
void AxisG2::read_Position(Tango::Attribute &attr)
{
	DEBUG_STREAM << "AxisG2::read_Position(Tango::Attribute &attr) entering... " << endl;
	/*----- PROTECTED REGION ID(AxisG2::read_Position) ENABLED START -----*/
	//	Set the attribute value
	// MYCODE-START
	//INFO_STREAM << "AxisG2::read_Position(Tango::Attribute &attr) entering... " << endl;

	std::string obj("AxisG2::read_Position()");

	stringstream es;
	es.str("");



	try {
		AxisStatePosition();
		if (!axis) return;
		*attr_Position_read = axis->position();
	} catch (Tango::DevFailed &ex) {
		//Tango::Except::print_exception(ex);
		*attr_Position_read = NAN;
		attr.set_quality(Tango::ATTR_INVALID);
		//std::cout << "read_Position() Tango EXCEPT!" << std::endl;
		long int el = ex.errors.length();
		es << "Tango EXCEPT! err.stack(" << el << ")";
		if ( el > 0 ) {
			es << " " << ex.errors[el-1].reason.in();
			es << " " << ex.errors[el-1].origin.in();
			string str(ex.errors[el-1].desc.in());
			//str.erase(std::remove(str.begin(), str.end(), '\n'), str.end());
			std::replace(str.begin(), str.end(), '\n', ' ');
			es << " " << str;
		}
		//prtlog(obj, es.str());
		bf->log(obj, es.str());
		attr.set_value(attr_Position_read);
		return;
	} catch (...) {
		*attr_Position_read = NAN;
		attr.set_quality(Tango::ATTR_INVALID);
		std::cout << "read_Position() EXCEPT! ..." << std::endl;
		attr.set_value(attr_Position_read);
		return;
	};

	// MYCODE-END
	attr.set_value(attr_Position_read);
	
	// MYCODE-START
	bool ai = axis->isinit();
	if ( !ai ) attr.set_quality(Tango::ATTR_INVALID);
	if ( ((ct == Controller_ns::CTRL_DOWN) || (ct == Controller_ns::CTRL_CLOSE)) ) attr.set_quality(Tango::ATTR_INVALID);

	if ( (attr_IsInitialised_old[0] == 0) && ai ){
		double pos = attr_Position_read[0];
		UpdateRelative("Position", pos);

		double upos = pos;
		if ( lib_func_ok ) {
			upos = DirectFunc(upos, userDirectFuncParams);
		};

		upos = (*attr_UserScale_read) * upos + (*attr_UserOffset_read);
		UpdateRelative("UserPosition", upos);
	}
	attr_IsInitialised_old[0] = (Tango::DevShort)ai;

	bf->log();
	DEBUG_STREAM << "AxisG2::read_Position(Tango::Attribute &attr) leaving... " << endl;
	// MYCODE-END
	/*----- PROTECTED REGION END -----*/	//	AxisG2::read_Position
}
//--------------------------------------------------------
/**
 *	Write attribute Position related method
 *	Description: Position of the axis (<I><B>plant coordinates/units</B></I>).
 *
 *	Data type:	Tango::DevDouble
 *	Attr type:	Scalar
 */
//--------------------------------------------------------
void AxisG2::write_Position(Tango::WAttribute &attr)
{
	DEBUG_STREAM << "AxisG2::write_Position(Tango::WAttribute &attr) entering... " << endl;
	//	Retrieve write value
	Tango::DevDouble	w_val;
	attr.get_write_value(w_val);
	/*----- PROTECTED REGION ID(AxisG2::write_Position) ENABLED START -----*/
	// MYCODE-START

	std::stringstream es;
	es << "AxisG2::write_Position(" << w_val << ")";
	INFOLOG(es.str());

	std::stringstream ss;
        ss << __func__ << "(" << w_val << ")";
        hist->push_end(ss.str());

	if (!axis) return;
	if ( ct!=Controller_ns::CTRL_UP ) return;

        if ( isnan(w_val) ){
			INFOLOG("AxisG2::write_Position(): Invalid Value (NaN)");
                        Tango::Except::throw_exception (
				(const char *)"AxisG2",
                        	(const char *)"Invalid Value (NaN)",
                        	(const char *)"AxisG2::write_Position");
        }
        if ( !*attr_IsMicrocodeOK_read ){
			INFOLOG("AxisG2::write_Position(): Invalid Cmd while MicroCode NOT running !!");
                        Tango::Except::throw_exception (
				(const char *)"AxisG2",
                        	(const char *)"Invalid Cmd while MicroCode NOT running !!",
                        	(const char *)"AxisG2::write_Position");
        }
	if ( *attr_CheckEncoder_read ) {
		switch (_chk_enc){
			case Axis_ns::CHK_ENC_ERROR:
			case Axis_ns::CHK_ENC_ERROR_ONSTAY:
			case Axis_ns::CHK_ENC_ERROR_ONRUN:
				INFOLOG("AxisG2::write_Position(): Invalid Cmd while Check Encoder Enabled & not ok !!");
                        	Tango::Except::throw_exception (
					(const char *)"AxisG2",
                        		(const char *)"Invalid Cmd while Check Encoder Enabled & not ok !!",
                        		(const char *)"AxisG2::write_Position");
				break;
			default:
				break;
		}
	}
	if ( !axis->position(w_val) ){
			es.clear();
			es << "AxisG2::write_Position(): " << axis->axis_error_str();
			INFOLOG(es.str());
                        Tango::Except::throw_exception (
				(const char *)"AxisG2",
                        	(const char *)axis->axis_error_str().c_str(),
                        	(const char *)"AxisG2::write_Position()");
	}

	// se non esco per una eccezione ma normalmente, solo allora (sembra
	// da una prova) che Tango imposti la parte write dell'attributo
	// quindi ora posso/devo mettere a posto anche la parte write di UserPosition

	double upos = w_val;
	if ( lib_func_ok ) {
		upos = DirectFunc(upos, userDirectFuncParams);
	};

	upos = (*attr_UserScale_read) * upos + (*attr_UserOffset_read);

	UpdateRelative("UserPosition", upos);

	// MYCODE-END
	
	/*----- PROTECTED REGION END -----*/	//	AxisG2::write_Position
}
//--------------------------------------------------------
/**
 *	Read attribute PositiveLimitSwitch related method
 *	Description: Status of the forward/positive limit switch (<I><B>plant coordinates</B></I>).
 *
 *	Data type:	Tango::DevBoolean
 *	Attr type:	Scalar
 */
//--------------------------------------------------------
void AxisG2::read_PositiveLimitSwitch(Tango::Attribute &attr)
{
	DEBUG_STREAM << "AxisG2::read_PositiveLimitSwitch(Tango::Attribute &attr) entering... " << endl;
	/*----- PROTECTED REGION ID(AxisG2::read_PositiveLimitSwitch) ENABLED START -----*/
	//	Set the attribute value
	// MYCODE-START
	if ( (!axis) || (ct != Controller_ns::CTRL_UP) ) {
		attr.set_quality(Tango::ATTR_INVALID);
		return;
	}

	*attr_PositiveLimitSwitch_read = axis->fls();
	// MYCODE-END
	attr.set_value(attr_PositiveLimitSwitch_read);
	
	/*----- PROTECTED REGION END -----*/	//	AxisG2::read_PositiveLimitSwitch
}
//--------------------------------------------------------
/**
 *	Read attribute NegativeLimitSwitch related method
 *	Description: Status of the backward/negative limit switch (<I><B>plant coordinates</B></I>).
 *
 *	Data type:	Tango::DevBoolean
 *	Attr type:	Scalar
 */
//--------------------------------------------------------
void AxisG2::read_NegativeLimitSwitch(Tango::Attribute &attr)
{
	DEBUG_STREAM << "AxisG2::read_NegativeLimitSwitch(Tango::Attribute &attr) entering... " << endl;
	/*----- PROTECTED REGION ID(AxisG2::read_NegativeLimitSwitch) ENABLED START -----*/
	//	Set the attribute value
	// MYCODE-START
	if ( (!axis) || (ct != Controller_ns::CTRL_UP) ) {
		attr.set_quality(Tango::ATTR_INVALID);
		return;
	}

	*attr_NegativeLimitSwitch_read = axis->rls();
	// MYCODE-END
	attr.set_value(attr_NegativeLimitSwitch_read);
	
	/*----- PROTECTED REGION END -----*/	//	AxisG2::read_NegativeLimitSwitch
}
//--------------------------------------------------------
/**
 *	Read attribute HomeSwitch related method
 *	Description: Status of the home switch (<I><B>plant coordinates</B></I>).
 *
 *	Data type:	Tango::DevBoolean
 *	Attr type:	Scalar
 */
//--------------------------------------------------------
void AxisG2::read_HomeSwitch(Tango::Attribute &attr)
{
	DEBUG_STREAM << "AxisG2::read_HomeSwitch(Tango::Attribute &attr) entering... " << endl;
	/*----- PROTECTED REGION ID(AxisG2::read_HomeSwitch) ENABLED START -----*/
	//	Set the attribute value
	// MYCODE-START
	if ( (!axis) || (ct != Controller_ns::CTRL_UP) ) {
		attr.set_quality(Tango::ATTR_INVALID);
		return;
	}

	*attr_HomeSwitch_read = axis->home();
	// MYCODE-END
	attr.set_value(attr_HomeSwitch_read);
	
	if ( ((ct == Controller_ns::CTRL_DOWN) || (ct == Controller_ns::CTRL_CLOSE)) ) attr.set_quality(Tango::ATTR_INVALID);
	/*----- PROTECTED REGION END -----*/	//	AxisG2::read_HomeSwitch
}
//--------------------------------------------------------
/**
 *	Read attribute MotorStatus related method
 *	Description: Status of the motor, <I>example: MOVIMG</I>.
 *
 *	Data type:	Tango::DevString
 *	Attr type:	Scalar
 */
//--------------------------------------------------------
void AxisG2::read_MotorStatus(Tango::Attribute &attr)
{
	DEBUG_STREAM << "AxisG2::read_MotorStatus(Tango::Attribute &attr) entering... " << endl;
	/*----- PROTECTED REGION ID(AxisG2::read_MotorStatus) ENABLED START -----*/
	//	Set the attribute value

	// MYCODE-START
	if ( (!axis) || (ct != Controller_ns::CTRL_UP) ) {
		attr.set_quality(Tango::ATTR_INVALID);
		return;
	}


        if (*attr_MotorStatus_read != NULL){
                delete[] *attr_MotorStatus_read;
                *attr_MotorStatus_read = NULL;
	}

	char buff[1000];
        snprintf(buff, 1000, "%s", (axis->mstatus()).c_str());
        *attr_MotorStatus_read = new char[strlen(buff)+1];
        strcpy(*attr_MotorStatus_read, buff);

	// MYCODE-END

	attr.set_value(attr_MotorStatus_read);
	
	/*----- PROTECTED REGION END -----*/	//	AxisG2::read_MotorStatus
}
//--------------------------------------------------------
/**
 *	Read attribute EncoderPosition related method
 *	Description: Position of the axis as reported by the encoder, in <B>encoder units</B> (<I><B>plant coordinates/units</B></I>).
 *
 *	Data type:	Tango::DevDouble
 *	Attr type:	Scalar
 */
//--------------------------------------------------------
void AxisG2::read_EncoderPosition(Tango::Attribute &attr)
{
	DEBUG_STREAM << "AxisG2::read_EncoderPosition(Tango::Attribute &attr) entering... " << endl;
	/*----- PROTECTED REGION ID(AxisG2::read_EncoderPosition) ENABLED START -----*/
	//	Set the attribute value
	// MYCODE-END
	if ( (!axis) || (ct != Controller_ns::CTRL_UP) ) {
		attr.set_quality(Tango::ATTR_INVALID);
		return;
	}

	try {
		*attr_EncoderPosition_read = axis->epos();
	} catch(...) {
		cout <<"AxisG2::read_EncoderPosition() EXCEPT" << endl;
		*attr_EncoderPosition_read = NAN;
	}
	// MYCODE-END
	attr.set_value(attr_EncoderPosition_read);
	
	/*----- PROTECTED REGION END -----*/	//	AxisG2::read_EncoderPosition
}
//--------------------------------------------------------
/**
 *	Read attribute MotorPosition related method
 *	Description: Position of the axis as reported by the motor, in <B>motor steps</B> (<I><B>plant coordinates</B></I>).
 *
 *	Data type:	Tango::DevLong
 *	Attr type:	Scalar
 */
//--------------------------------------------------------
void AxisG2::read_MotorPosition(Tango::Attribute &attr)
{
	DEBUG_STREAM << "AxisG2::read_MotorPosition(Tango::Attribute &attr) entering... " << endl;
	/*----- PROTECTED REGION ID(AxisG2::read_MotorPosition) ENABLED START -----*/
	//	Set the attribute value
	// MYCODE-START
	if ( (!axis) || (ct != Controller_ns::CTRL_UP) ) {
		attr.set_quality(Tango::ATTR_INVALID);
		return;
	}

	*attr_MotorPosition_read = (Tango::DevLong)axis->mpos();
	// MYCODE-END
	attr.set_value(attr_MotorPosition_read);
	
	/*----- PROTECTED REGION END -----*/	//	AxisG2::read_MotorPosition
}
//--------------------------------------------------------
/**
 *	Write attribute MotorPosition related method
 *	Description: Position of the axis as reported by the motor, in <B>motor steps</B> (<I><B>plant coordinates</B></I>).
 *
 *	Data type:	Tango::DevLong
 *	Attr type:	Scalar
 */
//--------------------------------------------------------
void AxisG2::write_MotorPosition(Tango::WAttribute &attr)
{
	DEBUG_STREAM << "AxisG2::write_MotorPosition(Tango::WAttribute &attr) entering... " << endl;
	//	Retrieve write value
	Tango::DevLong	w_val;
	attr.get_write_value(w_val);
	/*----- PROTECTED REGION ID(AxisG2::write_MotorPosition) ENABLED START -----*/
	
	// MYCODE-START
	
	std::stringstream es;
	es << "AxisG2::write_MotorPosition(" << w_val << ")";
	INFOLOG(es.str());

	std::stringstream ss;
        ss << __func__ << "(" << w_val << ")";
        hist->push_end(ss.str());

	if (!axis) return;
	if ( ct!=Controller_ns::CTRL_UP ) return;

        if ( isnan(w_val) ){
			INFOLOG("AxisG2::write_MotorPosition(): Invalid Value (NaN)");
                        Tango::Except::throw_exception ((const char *)"AxisG2",
                        (const char *) "Invalid Value (NaN)",
                        (const char *)"AxisG2::write_MotorPosition");
        }
	axis->mpos((double)w_val);

	INFOLOG("AxisG2::write_MotorPosition(): done");
	// MYCODE-END
	
	/*----- PROTECTED REGION END -----*/	//	AxisG2::write_MotorPosition
}
//--------------------------------------------------------
/**
 *	Read attribute UserPosition related method
 *	Description: Position of the axis (<I><B>user coordinates</B></I>).
 *
 *	Data type:	Tango::DevDouble
 *	Attr type:	Scalar
 */
//--------------------------------------------------------
void AxisG2::read_UserPosition(Tango::Attribute &attr)
{
	DEBUG_STREAM << "AxisG2::read_UserPosition(Tango::Attribute &attr) entering... " << endl;
	/*----- PROTECTED REGION ID(AxisG2::read_UserPosition) ENABLED START -----*/
	//	Set the attribute value

	// MYCODE-START
	if (!axis) return;


	Tango::DevDouble pos = (*attr_Position_read);

	if ( lib_func_ok ) {
		pos = DirectFunc(pos, userDirectFuncParams);
	};

	*attr_UserPosition_read = (*attr_UserScale_read) * pos + (*attr_UserOffset_read);
	// MYCODE-END

	attr.set_value(attr_UserPosition_read);
	
	// MYCODE-START
	if ( !axis->isinit() ) attr.set_quality(Tango::ATTR_INVALID);
	if ( ((ct == Controller_ns::CTRL_DOWN) || (ct == Controller_ns::CTRL_CLOSE)) ) attr.set_quality(Tango::ATTR_INVALID);

	DEBUG_STREAM << "AxisG2::read_UserPosition(Tango::Attribute &attr) leaving... " << endl;
	// MYCODE-END

	
	/*----- PROTECTED REGION END -----*/	//	AxisG2::read_UserPosition
}
//--------------------------------------------------------
/**
 *	Write attribute UserPosition related method
 *	Description: Position of the axis (<I><B>user coordinates</B></I>).
 *
 *	Data type:	Tango::DevDouble
 *	Attr type:	Scalar
 */
//--------------------------------------------------------
void AxisG2::write_UserPosition(Tango::WAttribute &attr)
{
	DEBUG_STREAM << "AxisG2::write_UserPosition(Tango::WAttribute &attr) entering... " << endl;
	//	Retrieve write value
	Tango::DevDouble	w_val;
	attr.get_write_value(w_val);
	/*----- PROTECTED REGION ID(AxisG2::write_UserPosition) ENABLED START -----*/

	// MYCODE-START

	std::stringstream es;
	es << "AxisG2::write_UserPosition(" << w_val << ")";
	INFOLOG(es.str());

	std::stringstream ss;
        ss << __func__ << "(" << w_val << ")";
        hist->push_end(ss.str());

	if (!axis) return;
	if ( ct!=Controller_ns::CTRL_UP ) return;

	if ( *attr_UserScale_read == 0 ){
			INFOLOG("AxisG2::write_UserPosition(): Invalid User Scale (zero)");
	                Tango::Except::throw_exception ((const char *)"AxisG2",
                        (const char *) "Invalid User Scale (zero)",
                        (const char *)"AxisG2::write_UserPosition");
	}
        if ( isnan(w_val) ){
			INFOLOG("AxisG2::write_UserPosition(): Invalid Value (NaN)");
                        Tango::Except::throw_exception ((const char *)"AxisG2",
                        (const char *) "Invalid Value (NaN)",
                        (const char *)"AxisG2::write_UserPosition");
        }


	double v = (w_val - (*attr_UserOffset_read))/(*attr_UserScale_read);

	if ( lib_func_ok ) {
		v = InverseFunc(v, userInverseFuncParams);
	};

	Tango::WAttribute* w_att_ptr = get_wattr_by_name("Position");
	if (w_att_ptr){

		try {
			w_att_ptr->set_write_value(v);
			write_Position(*w_att_ptr);
			UpdateRelative("Position", v);
		} catch (...) {
			throw;
		}
	} else {
		cout << "***** NOT WAttr Position !!!!" << endl;
	}

	INFOLOG("AxisG2::write_UserPosition(): done");
	// MYCODE-END
	
	
	/*----- PROTECTED REGION END -----*/	//	AxisG2::write_UserPosition
}
//--------------------------------------------------------
/**
 *	Read attribute UserScale related method
 *	Description: UserScale (US) and UserOffset (UO)
 *               translate position from <B><I>plant to user coordinates/units</I></B>.
 *               
 *               <I>Formula:</I> 
 *               _ _ up = US * pp + UO
 *               _ _ up : user position value
 *               _ _ pp : plant position value
 *
 *	Data type:	Tango::DevDouble
 *	Attr type:	Scalar
 */
//--------------------------------------------------------
void AxisG2::read_UserScale(Tango::Attribute &attr)
{
	DEBUG_STREAM << "AxisG2::read_UserScale(Tango::Attribute &attr) entering... " << endl;
	/*----- PROTECTED REGION ID(AxisG2::read_UserScale) ENABLED START -----*/
	//	Set the attribute value
	attr.set_value(attr_UserScale_read);
	
	/*----- PROTECTED REGION END -----*/	//	AxisG2::read_UserScale
}
//--------------------------------------------------------
/**
 *	Write attribute UserScale related method
 *	Description: UserScale (US) and UserOffset (UO)
 *               translate position from <B><I>plant to user coordinates/units</I></B>.
 *               
 *               <I>Formula:</I> 
 *               _ _ up = US * pp + UO
 *               _ _ up : user position value
 *               _ _ pp : plant position value
 *
 *	Data type:	Tango::DevDouble
 *	Attr type:	Scalar
 */
//--------------------------------------------------------
void AxisG2::write_UserScale(Tango::WAttribute &attr)
{
	DEBUG_STREAM << "AxisG2::write_UserScale(Tango::WAttribute &attr) entering... " << endl;
	//	Retrieve write value
	Tango::DevDouble	w_val;
	attr.get_write_value(w_val);
	/*----- PROTECTED REGION ID(AxisG2::write_UserScale) ENABLED START -----*/

	// MYCODE-START

	std::stringstream es;
	es << "AxisG2::write_UserScale(" << w_val << ")";
	INFOLOG(es.str());

	std::stringstream ss;
        ss << __func__ << "(" << w_val << ")";
        hist->push_end(ss.str());

        if ( isnan(w_val) ){
			INFOLOG("AxisG2::write_UserScale(): Invalid Value (NaN)");
                        Tango::Except::throw_exception ((const char *)"AxisG2",
                        (const char *) "Invalid Value (NaN)",
                        (const char *)"AxisG2::write_UserScale");
        }
	*attr_UserScale_read = w_val;

	INFOLOG("AxisG2::write_UserScale(): done");
	// MYCODE-END
	
	/*----- PROTECTED REGION END -----*/	//	AxisG2::write_UserScale
}
//--------------------------------------------------------
/**
 *	Read attribute UserOffset related method
 *	Description: <I>See</I> : UserScale attribute description.
 *
 *	Data type:	Tango::DevDouble
 *	Attr type:	Scalar
 */
//--------------------------------------------------------
void AxisG2::read_UserOffset(Tango::Attribute &attr)
{
	DEBUG_STREAM << "AxisG2::read_UserOffset(Tango::Attribute &attr) entering... " << endl;
	/*----- PROTECTED REGION ID(AxisG2::read_UserOffset) ENABLED START -----*/
	//	Set the attribute value
	attr.set_value(attr_UserOffset_read);
	
	/*----- PROTECTED REGION END -----*/	//	AxisG2::read_UserOffset
}
//--------------------------------------------------------
/**
 *	Write attribute UserOffset related method
 *	Description: <I>See</I> : UserScale attribute description.
 *
 *	Data type:	Tango::DevDouble
 *	Attr type:	Scalar
 */
//--------------------------------------------------------
void AxisG2::write_UserOffset(Tango::WAttribute &attr)
{
	DEBUG_STREAM << "AxisG2::write_UserOffset(Tango::WAttribute &attr) entering... " << endl;
	//	Retrieve write value
	Tango::DevDouble	w_val;
	attr.get_write_value(w_val);
	/*----- PROTECTED REGION ID(AxisG2::write_UserOffset) ENABLED START -----*/
	
	// MYCODE-START

	std::stringstream es;
	es << "AxisG2::write_UserOffset(" << w_val << ")";
	INFOLOG(es.str());

	std::stringstream ss;
        ss << __func__ << "(" << w_val << ")";
        hist->push_end(ss.str());

        if ( isnan(w_val) ){
			INFOLOG("AxisG2::write_UserOffset(): Invalid Value (NaN)");
                        Tango::Except::throw_exception ((const char *)"AxisG2",
                        (const char *) "Invalid Value (NaN)",
                        (const char *)"AxisG2::write_UserOffset");
        }

	*attr_UserOffset_read = w_val;

	INFOLOG("AxisG2::write_UserOffset(): done");
	// MYCODE-END
	
	/*----- PROTECTED REGION END -----*/	//	AxisG2::write_UserOffset
}
//--------------------------------------------------------
/**
 *	Read attribute UserSpeed related method
 *	Description: Requested speed of the axis (<I><B>user coordinates/units</B></I>).
 *
 *	Data type:	Tango::DevDouble
 *	Attr type:	Scalar
 */
//--------------------------------------------------------
void AxisG2::read_UserSpeed(Tango::Attribute &attr)
{
	DEBUG_STREAM << "AxisG2::read_UserSpeed(Tango::Attribute &attr) entering... " << endl;
	/*----- PROTECTED REGION ID(AxisG2::read_UserSpeed) ENABLED START -----*/
	//	Set the attribute value

	// MYCODE-START
	if (!axis) return;


	double speed = axis->speed();
	Tango::DevDouble pos = (*attr_Position_read);

	*attr_UserSpeed_read = Speed2UserSpeed(speed, pos);

	//cout << "read_UserSpeed(), *attr_UserSpeed_read = " << (*attr_UserSpeed_read) << endl;

	// MYCODE-END
	attr.set_value(attr_UserSpeed_read);
	
	if ( ((ct == Controller_ns::CTRL_DOWN) || (ct == Controller_ns::CTRL_CLOSE)) ) attr.set_quality(Tango::ATTR_INVALID);
	/*----- PROTECTED REGION END -----*/	//	AxisG2::read_UserSpeed
}
//--------------------------------------------------------
/**
 *	Write attribute UserSpeed related method
 *	Description: Requested speed of the axis (<I><B>user coordinates/units</B></I>).
 *
 *	Data type:	Tango::DevDouble
 *	Attr type:	Scalar
 */
//--------------------------------------------------------
void AxisG2::write_UserSpeed(Tango::WAttribute &attr)
{
	DEBUG_STREAM << "AxisG2::write_UserSpeed(Tango::WAttribute &attr) entering... " << endl;
	//	Retrieve write value
	Tango::DevDouble	w_val;
	attr.get_write_value(w_val);
	/*----- PROTECTED REGION ID(AxisG2::write_UserSpeed) ENABLED START -----*/
	// MYCODE-START

	std::stringstream es;
	es << "AxisG2::write_UserSpeed(" << w_val << ")";
	INFOLOG(es.str());

	std::stringstream ss;
        ss << __func__ << "(" << w_val << ")";
        hist->push_end(ss.str());

	if (!axis) return;
	if ( ct!=Controller_ns::CTRL_UP ) return;

	if ( *attr_UserScale_read == 0 ){
			INFOLOG("AxisG2::write_UserSpeed(): Invalid User Scale (zero)");
	                Tango::Except::throw_exception ((const char *)"AxisG2",
                        (const char *) "Invalid User Scale (zero)",
                        (const char *)"AxisG2::write_UserSpeed");
	}
        if ( isnan(w_val) ){
		INFOLOG("AxisG2::write_UserSpeed(): Invalid Value (NaN)");
        	Tango::Except::throw_exception (
			(const char *)"INVALID VALUE",
                        (const char *)"Invalid Value (NaN)",
                        (const char *)"AxisG2::write_UserSpeed");
        }
#if 0
        if (axis->speed(w_val / (*attr_UserScale_read)))  axis->refresh();
	else Tango::Except::throw_exception (
		(const char *)"OPERATION FAILED",
		(const char *)"Write to hw failed",
		(const char *)"AxisG2::write_UserSpeed");
#else
	double v = w_val / (*attr_UserScale_read);

	__attribute__ ((unused)) Tango::DevDouble upos = (*attr_UserPosition_read);
	Tango::DevDouble pos = (*attr_Position_read);

#if 0
	double p0, p1;

	if ( lib_func_ok ) {
		p0 = InverseFunc(upos, userInverseFuncParams);
		p1 = InverseFunc(upos + 0.01, userInverseFuncParams);
		cout << "p0= " << p0 << endl;
		cout << "p1= " << p1 << endl;
		cout << "p1-p0= " << p1-p0 << endl;
		v *= fabs((p1-p0)/0.01);
	};
#else
	double p[5];
	int i = 2;
	double t = 0.00001;

	if ( lib_func_ok ) {
		p[0] = DirectFunc(pos - 2*t, userDirectFuncParams);
		p[1] = DirectFunc(pos - t, userDirectFuncParams);
		p[2] = DirectFunc(pos, userDirectFuncParams);
		p[3] = DirectFunc(pos + t, userDirectFuncParams);
		p[4] = DirectFunc(pos + 2*t, userDirectFuncParams);


		//Calcolo derivata come suggerito in http://www.cplusplus.com/forum/general/103788/ 
		// con algoritmo derivante da http://www.stat.physik.uni-potsdam.de/~kahnert/publications/COMPHY3395.pdf 
		// formula (12) a pg 768
		
		double firstDer = (   4.0 / 3.0 * (p[i + 1] - p[i - 1]) / (2.0 * t)
               		     - 1.0 / 3.0 * (p[i + 2] - p[i - 2]) / (4.0 * t) );

		#if 0
		for (i=0; i<5; i++){
			cout << p[i] << " ";
		}
		cout << endl;
		#endif

		//cout << "firstDer= " << firstDer << endl;

		if ( firstDer == 0 ){
			INFOLOG("AxisG2::write_UserSpeed(): Invalid Conversion to Speed (zero)");
	                Tango::Except::throw_exception ((const char *)"AxisG2",
                        (const char *) "Invalid Conversion to Speed (zero)",
                        (const char *)"AxisG2::write_UserSpeed");
		}

		v /= firstDer;
		//cout << "old w_val= " << w_val << endl;
		//cout << "new w_val= " << v << endl;
	};
#endif


	Tango::WAttribute* w_att_ptr = get_wattr_by_name("Speed");
	if (w_att_ptr){
		try {
			w_att_ptr->set_write_value(v); /// altrimenti uso il valore VECCHIO dell'attributo Speed
			write_Speed(*w_att_ptr);
			UpdateRelative("Speed", v);   /// qui lo riscrive nella parte write di Speed e lo memorizza in db
		} catch (...) {
			throw;
		}
	} else {
		cout << "***** NOT WAttr Speed !!!!" << endl;
	}
#endif

	INFOLOG("AxisG2::write_UserSpeed(): done");
	// MYCODE-END
	
	
	/*----- PROTECTED REGION END -----*/	//	AxisG2::write_UserSpeed
}
//--------------------------------------------------------
/**
 *	Read attribute Speed related method
 *	Description: Requested speed of the axis (<I><B>plant coordinates/units</B></I>).
 *
 *	Data type:	Tango::DevDouble
 *	Attr type:	Scalar
 */
//--------------------------------------------------------
void AxisG2::read_Speed(Tango::Attribute &attr)
{
	DEBUG_STREAM << "AxisG2::read_Speed(Tango::Attribute &attr) entering... " << endl;
	/*----- PROTECTED REGION ID(AxisG2::read_Speed) ENABLED START -----*/
	//	Set the attribute value
	// MYCODE-START
	if (!axis) return;

	*attr_Speed_read = fabs(axis->speed());
	// MYCODE-END
	attr.set_value(attr_Speed_read);
	
	if ( ((ct == Controller_ns::CTRL_DOWN) || (ct == Controller_ns::CTRL_CLOSE)) ) attr.set_quality(Tango::ATTR_INVALID);
	/*----- PROTECTED REGION END -----*/	//	AxisG2::read_Speed
}
//--------------------------------------------------------
/**
 *	Write attribute Speed related method
 *	Description: Requested speed of the axis (<I><B>plant coordinates/units</B></I>).
 *
 *	Data type:	Tango::DevDouble
 *	Attr type:	Scalar
 */
//--------------------------------------------------------
void AxisG2::write_Speed(Tango::WAttribute &attr)
{
	DEBUG_STREAM << "AxisG2::write_Speed(Tango::WAttribute &attr) entering... " << endl;
	//	Retrieve write value
	Tango::DevDouble	w_val;
	attr.get_write_value(w_val);
	/*----- PROTECTED REGION ID(AxisG2::write_Speed) ENABLED START -----*/
	// MYCODE-START

	std::stringstream es;
	es << "AxisG2::write_Speed(" << w_val << ")";
	INFOLOG(es.str());

	std::stringstream ss;
        ss << __func__ << "(" << w_val << ")";
        hist->push_end(ss.str());

	if (!axis) return;
	if ( ct!=Controller_ns::CTRL_UP ) return;

        if ( isnan(w_val) ){
		INFOLOG("AxisG2::write_Speed(): Invalid Value (NaN)");
        	Tango::Except::throw_exception (
			(const char *)"INVALID VALUE",
                        (const char *)"Invalid Value (NaN)",
                        (const char *)"AxisG2::write_AxisVelocity");
        }
	#ifdef _DBG_CHECK_LSSTROKE
		cout << __func__ << endl;
	#endif
        if ( !check_lsstroke(w_val, attr_Deceleration_read[0])){
			INFOLOG("AxisG2::write_Speed(): Invalid speed/deceleration values vs limitswitch stroke");
                        Tango::Except::throw_exception (
				(const char *)"AxisG2",
                        	(const char *)"Invalid speed/deceleration values vs limitswitch stroke",
                        	(const char *)"AxisG2::write_Speed");
        }
        if (axis->speed(w_val))  axis->refresh();
	else {
		INFOLOG("AxisG2::write_Speed(): Write to hw failed");
		Tango::Except::throw_exception (
			(const char *)"OPERATION FAILED",
			(const char *)"Write to hw failed",
			(const char *)"AxisG2::write_AxisVelocity");
	}

	
	double speed = w_val;
	Tango::DevDouble pos = (*attr_Position_read);
	double uspeed = Speed2UserSpeed(speed, pos);
	UpdateRelative("UserSpeed", uspeed);

	INFOLOG("AxisG2::write_Speed(): done");
	// MYCODE-END
	
	
	/*----- PROTECTED REGION END -----*/	//	AxisG2::write_Speed
}
//--------------------------------------------------------
/**
 *	Read attribute Acceleration related method
 *	Description: Requested acceleration of the axis (<I><B>plant coordinates/units</B></I>).
 *
 *	Data type:	Tango::DevDouble
 *	Attr type:	Scalar
 */
//--------------------------------------------------------
void AxisG2::read_Acceleration(Tango::Attribute &attr)
{
	DEBUG_STREAM << "AxisG2::read_Acceleration(Tango::Attribute &attr) entering... " << endl;
	/*----- PROTECTED REGION ID(AxisG2::read_Acceleration) ENABLED START -----*/
	//	Set the attribute value
	// MYCODE-START
	if (!axis) return;

	*attr_Acceleration_read = fabs(axis->acceleration());
	// MYCODE-END
	attr.set_value(attr_Acceleration_read);
	
	if ( ((ct == Controller_ns::CTRL_DOWN) || (ct == Controller_ns::CTRL_CLOSE)) ) attr.set_quality(Tango::ATTR_INVALID);
	/*----- PROTECTED REGION END -----*/	//	AxisG2::read_Acceleration
}
//--------------------------------------------------------
/**
 *	Write attribute Acceleration related method
 *	Description: Requested acceleration of the axis (<I><B>plant coordinates/units</B></I>).
 *
 *	Data type:	Tango::DevDouble
 *	Attr type:	Scalar
 */
//--------------------------------------------------------
void AxisG2::write_Acceleration(Tango::WAttribute &attr)
{
	DEBUG_STREAM << "AxisG2::write_Acceleration(Tango::WAttribute &attr) entering... " << endl;
	//	Retrieve write value
	Tango::DevDouble	w_val;
	attr.get_write_value(w_val);
	/*----- PROTECTED REGION ID(AxisG2::write_Acceleration) ENABLED START -----*/
	// MYCODE-START

	std::stringstream es;
	es << "AxisG2::write_Acceleration(" << w_val << ")";
	INFOLOG(es.str());

	std::stringstream ss;
        ss << __func__ << "(" << w_val << ")";
        hist->push_end(ss.str());

	if (!axis) return;
	if ( ct!=Controller_ns::CTRL_UP ) return;

        if ( isnan(w_val) ){
			INFOLOG("AxisG2::write_Acceleration(): Invalid Value (NaN)");
                        Tango::Except::throw_exception ((const char *)"AxisG2",
                        (const char *) "Invalid Value (NaN)",
                        (const char *)"AxisG2::write_AxisAcceleration");
        }
        if (axis->acceleration(w_val))  axis->refresh();
	else {
		INFOLOG("AxisG2::write_Acceleration(): Write to hw failed");
		Tango::Except::throw_exception (
			(const char *)"OPERATION FAILED",
			(const char *)"Write to hw failed",
			(const char *)"AxisG2::write_AxisAcceleration");
	}

	INFOLOG("AxisG2::write_Acceleration(): done");
	// MYCODE-END
	
	
	/*----- PROTECTED REGION END -----*/	//	AxisG2::write_Acceleration
}
//--------------------------------------------------------
/**
 *	Read attribute Deceleration related method
 *	Description: Requested deceleration of the axis (<I><B>plant coordinates/units</B></I>).
 *
 *	Data type:	Tango::DevDouble
 *	Attr type:	Scalar
 */
//--------------------------------------------------------
void AxisG2::read_Deceleration(Tango::Attribute &attr)
{
	DEBUG_STREAM << "AxisG2::read_Deceleration(Tango::Attribute &attr) entering... " << endl;
	/*----- PROTECTED REGION ID(AxisG2::read_Deceleration) ENABLED START -----*/
	//	Set the attribute value
	// MYCODE-START
	if (!axis) return;

	*attr_Deceleration_read = fabs(axis->deceleration());
	// MYCODE-END
	attr.set_value(attr_Deceleration_read);
	
	if ( ((ct == Controller_ns::CTRL_DOWN) || (ct == Controller_ns::CTRL_CLOSE)) ) attr.set_quality(Tango::ATTR_INVALID);
	/*----- PROTECTED REGION END -----*/	//	AxisG2::read_Deceleration
}
//--------------------------------------------------------
/**
 *	Write attribute Deceleration related method
 *	Description: Requested deceleration of the axis (<I><B>plant coordinates/units</B></I>).
 *
 *	Data type:	Tango::DevDouble
 *	Attr type:	Scalar
 */
//--------------------------------------------------------
void AxisG2::write_Deceleration(Tango::WAttribute &attr)
{
	DEBUG_STREAM << "AxisG2::write_Deceleration(Tango::WAttribute &attr) entering... " << endl;
	//	Retrieve write value
	Tango::DevDouble	w_val;
	attr.get_write_value(w_val);
	/*----- PROTECTED REGION ID(AxisG2::write_Deceleration) ENABLED START -----*/
	// MYCODE-START

	std::stringstream es;
	es << "AxisG2::write_Deceleration(" << w_val << ")";
	INFOLOG(es.str());

	std::stringstream ss;
        ss << __func__ << "(" << w_val << ")";
        hist->push_end(ss.str());

	if (!axis) return;
	if ( ct!=Controller_ns::CTRL_UP ) return;

        if ( isnan(w_val) ){
			INFOLOG("AxisG2::write_Deceleration(): Invalid Value (NaN)");
                        Tango::Except::throw_exception ((const char *)"AxisG2",
                        (const char *) "Invalid Value (NaN)",
                        (const char *)"AxisG2::write_AxisDeceleration");
        }
	#ifdef _DBG_CHECK_LSSTROKE
		cout << __func__ << endl;
	#endif
        if ( !check_lsstroke(attr_Speed_read[0], w_val)){
			INFOLOG("AxisG2::write_Deceleration(): Invalid speed/deceleration values vs limitswitch stroke");
                        Tango::Except::throw_exception (
				(const char *)"AxisG2",
                        	(const char *)"Invalid speed/deceleration values vs limitswitch stroke",
                        	(const char *)"AxisG2::write_Deceleration");
        }
        if (axis->deceleration(w_val))  axis->refresh();
	else {
		INFOLOG("AxisG2::write_Deceleration(): Write to hw failed");
		Tango::Except::throw_exception (
			(const char *)"OPERATION FAILED",
			(const char *)"Write to hw failed",
			(const char *)"AxisG2::write_AxisDeceleration");
	}

	INFOLOG("AxisG2::write_Deceleration(): done");
	// MYCODE-END
	
	/*----- PROTECTED REGION END -----*/	//	AxisG2::write_Deceleration
}
//--------------------------------------------------------
/**
 *	Read attribute MotionAccuracy related method
 *	Description: Minimun allowable displacement, i.e. maximum positioning error of the axis (<I><B>plant coordinates/units</B></I>).
 *
 *	Data type:	Tango::DevDouble
 *	Attr type:	Scalar
 */
//--------------------------------------------------------
void AxisG2::read_MotionAccuracy(Tango::Attribute &attr)
{
	DEBUG_STREAM << "AxisG2::read_MotionAccuracy(Tango::Attribute &attr) entering... " << endl;
	/*----- PROTECTED REGION ID(AxisG2::read_MotionAccuracy) ENABLED START -----*/
	//	Set the attribute value

	if (!cached_with_microcode) *attr_MotionAccuracy_read = nan("");

	attr.set_value(attr_MotionAccuracy_read);
	
	if ( ((ct == Controller_ns::CTRL_DOWN) || (ct == Controller_ns::CTRL_CLOSE)) ) attr.set_quality(Tango::ATTR_INVALID);
	/*----- PROTECTED REGION END -----*/	//	AxisG2::read_MotionAccuracy
}
//--------------------------------------------------------
/**
 *	Write attribute MotionAccuracy related method
 *	Description: Minimun allowable displacement, i.e. maximum positioning error of the axis (<I><B>plant coordinates/units</B></I>).
 *
 *	Data type:	Tango::DevDouble
 *	Attr type:	Scalar
 */
//--------------------------------------------------------
void AxisG2::write_MotionAccuracy(Tango::WAttribute &attr)
{
	DEBUG_STREAM << "AxisG2::write_MotionAccuracy(Tango::WAttribute &attr) entering... " << endl;
	//	Retrieve write value
	Tango::DevDouble	w_val;
	attr.get_write_value(w_val);
	/*----- PROTECTED REGION ID(AxisG2::write_MotionAccuracy) ENABLED START -----*/
	// MYCODE-START

	std::stringstream es;
	es << "AxisG2::write_MotionAccuracy(" << w_val << ")";
	INFOLOG(es.str());

	std::stringstream ss;
        ss << __func__ << "(" << w_val << ")";
        hist->push_end(ss.str());

	if (!axis) return;
	if ( ct!=Controller_ns::CTRL_UP ) return;

	if ( !with_microcode() ) {
		*attr_MotionAccuracy_read = nan("");
		INFOLOG("AxisG2::write_MotionAccuracy(): skip");
		return;
	}

        if ( isnan(w_val) ){
		INFOLOG("AxisG2::write_MotionAccuracy(): Invalid Value (NaN)");
        	Tango::Except::throw_exception (
			(const char *)"INVALID VALUE",
                        (const char *)"Invalid Value (NaN)",
                        (const char *)"AxisG2::write_MotionAccuracy");
        }
        if ( w_val < 0 ){
		INFOLOG("AxisG2::write_MotionAccuracy(): Invalid Value (Negative)");
        	Tango::Except::throw_exception (
			(const char *)"INVALID VALUE",
                        (const char *)"Invalid Value (Negative)",
                        (const char *)"AxisG2::write_MotionAccuracy");
        }
        if (!check_MotionAccuracy(w_val) ){
		INFOLOG("AxisG2::write_MotionAccuracy(): Invalid Value (< Minimum Movement)");
        	Tango::Except::throw_exception (
			(const char *)"INVALID VALUE",
                        (const char *)"Invalid Value (< Minimum Movement)",
                        (const char *)"AxisG2::write_MotionAccuracy");
        }
        if (sethw_MotionAccuracy(w_val)) *attr_MotionAccuracy_read = w_val;
	else {
		INFOLOG("AxisG2::write_MotionAccuracy(): Write to hw failed");
		Tango::Except::throw_exception (
			(const char *)"OPERATION FAILED",
			(const char *)"Write to hw failed",
			(const char *)"AxisG2::write_MotionAccuracy");
	}

	INFOLOG("AxisG2::write_MotionAccuracy(): done");
	// MYCODE-END
	
	/*----- PROTECTED REGION END -----*/	//	AxisG2::write_MotionAccuracy
}
//--------------------------------------------------------
/**
 *	Read attribute MotionPercent related method
 *	Description: Coefficient for successive approach positioning
 *
 *	Data type:	Tango::DevDouble
 *	Attr type:	Scalar
 */
//--------------------------------------------------------
void AxisG2::read_MotionPercent(Tango::Attribute &attr)
{
	DEBUG_STREAM << "AxisG2::read_MotionPercent(Tango::Attribute &attr) entering... " << endl;
	/*----- PROTECTED REGION ID(AxisG2::read_MotionPercent) ENABLED START -----*/
	//	Set the attribute value

	if (!cached_with_microcode) *attr_MotionPercent_read = nan("");

	attr.set_value(attr_MotionPercent_read);
	
	if ( ((ct == Controller_ns::CTRL_DOWN) || (ct == Controller_ns::CTRL_CLOSE)) ) attr.set_quality(Tango::ATTR_INVALID);
	/*----- PROTECTED REGION END -----*/	//	AxisG2::read_MotionPercent
}
//--------------------------------------------------------
/**
 *	Write attribute MotionPercent related method
 *	Description: Coefficient for successive approach positioning
 *
 *	Data type:	Tango::DevDouble
 *	Attr type:	Scalar
 */
//--------------------------------------------------------
void AxisG2::write_MotionPercent(Tango::WAttribute &attr)
{
	DEBUG_STREAM << "AxisG2::write_MotionPercent(Tango::WAttribute &attr) entering... " << endl;
	//	Retrieve write value
	Tango::DevDouble	w_val;
	attr.get_write_value(w_val);
	/*----- PROTECTED REGION ID(AxisG2::write_MotionPercent) ENABLED START -----*/
	// MYCODE-START

	std::stringstream es;
	es << "AxisG2::write_MotionPercent(" << w_val << ")";
	INFOLOG(es.str());

	std::stringstream ss;
        ss << __func__ << "(" << w_val << ")";
        hist->push_end(ss.str());

	if (!axis) return;
	if ( ct!=Controller_ns::CTRL_UP ) return;

	if ( !with_microcode() ) {
		*attr_MotionPercent_read = nan("");
		INFOLOG("AxisG2::write_MotionPercent(): skip");
		return;
	}

        if ( isnan(w_val) ){
		INFOLOG("AxisG2::write_MotionPercent(): Invalid Value (NaN)");
        	Tango::Except::throw_exception (
			(const char *)"INVALID VALUE",
                        (const char *)"Invalid Value (NaN)",
                        (const char *)"AxisG2::write_MotionPercent");
        }
        if ( (w_val<0) || (w_val>1) ){
		INFOLOG("AxisG2::write_MotionPercent(): Invalid Value (<0 || >1)");
        	Tango::Except::throw_exception (
			(const char *)"INVALID VALUE",
                        (const char *)"Invalid Value (<0 || >1)",
                        (const char *)"AxisG2::write_MotionPercent");
        }
        if (sethw_MotionPercent(w_val)) *attr_MotionPercent_read = w_val;
	else {
		INFOLOG("AxisG2::write_MotionPercent(): Write to hw failed");
		Tango::Except::throw_exception (
			(const char *)"OPERATION FAILED",
			(const char *)"Write to hw failed",
			(const char *)"AxisG2::write_MotionPercent");
	}
	// MYCODE-END
	
	/*----- PROTECTED REGION END -----*/	//	AxisG2::write_MotionPercent
}
//--------------------------------------------------------
/**
 *	Read attribute MotionRetry related method
 *	Description: Number of retries done by the controller closed control loop algorithm.
 *
 *	Data type:	Tango::DevDouble
 *	Attr type:	Scalar
 */
//--------------------------------------------------------
void AxisG2::read_MotionRetry(Tango::Attribute &attr)
{
	DEBUG_STREAM << "AxisG2::read_MotionRetry(Tango::Attribute &attr) entering... " << endl;
	/*----- PROTECTED REGION ID(AxisG2::read_MotionRetry) ENABLED START -----*/
	//	Set the attribute value

	if (!cached_with_microcode) *attr_MotionRetry_read = nan("");

	attr.set_value(attr_MotionRetry_read);
	
	/*----- PROTECTED REGION END -----*/	//	AxisG2::read_MotionRetry
}
//--------------------------------------------------------
/**
 *	Write attribute MotionRetry related method
 *	Description: Number of retries done by the controller closed control loop algorithm.
 *
 *	Data type:	Tango::DevDouble
 *	Attr type:	Scalar
 */
//--------------------------------------------------------
void AxisG2::write_MotionRetry(Tango::WAttribute &attr)
{
	DEBUG_STREAM << "AxisG2::write_MotionRetry(Tango::WAttribute &attr) entering... " << endl;
	//	Retrieve write value
	Tango::DevDouble	w_val;
	attr.get_write_value(w_val);
	/*----- PROTECTED REGION ID(AxisG2::write_MotionRetry) ENABLED START -----*/
	// MYCODE-START

	std::stringstream es;
	es << "AxisG2::write_MotionRetry(" << w_val << ")";
	INFOLOG(es.str());

	std::stringstream ss;
        ss << __func__ << "(" << w_val << ")";
        hist->push_end(ss.str());

	if (!axis) return;
	if ( ct!=Controller_ns::CTRL_UP ) return;

	if ( !with_microcode() ) {
		*attr_MotionRetry_read = nan("");
		INFOLOG("AxisG2::write_MotionRetry(): skip");
		return;
	}

        if ( isnan(w_val) ){
		INFOLOG("AxisG2::write_MotionRetry(): Invalid Value (NaN)");
        	Tango::Except::throw_exception (
			(const char *)"INVALID VALUE",
                        (const char *)"Invalid Value (NaN)",
                        (const char *)"AxisG2::write_MotionRetry");
        }
        if ( w_val < 0 ){
		INFOLOG("AxisG2::write_MotionRetry(): Invalid Value (<0)");
        	Tango::Except::throw_exception (
			(const char *)"INVALID VALUE",
                        (const char *)"Invalid Value (<0)",
                        (const char *)"AxisG2::write_MotionRetry");
        }
        if (sethw_MotionRetry(w_val))  *attr_MotionRetry_read = w_val;
	else {
		INFOLOG("AxisG2::write_MotionRetry(): Write to hw failed");
		Tango::Except::throw_exception (
			(const char *)"OPERATION FAILED",
			(const char *)"Write to hw failed",
			(const char *)"AxisG2::write_MotionRetry");
	}

	INFOLOG("AxisG2::write_MotionRetry(): done");
	// MYCODE-END
	
	
	/*----- PROTECTED REGION END -----*/	//	AxisG2::write_MotionRetry
}
//--------------------------------------------------------
/**
 *	Read attribute Backlash related method
 *	Description: Value for the compensation for mechanical backlash by doing final move in the direction defined by BacklashDirection (<I><B>plant coordinates/units</B></I>).
 *
 *	Data type:	Tango::DevDouble
 *	Attr type:	Scalar
 */
//--------------------------------------------------------
void AxisG2::read_Backlash(Tango::Attribute &attr)
{
	DEBUG_STREAM << "AxisG2::read_Backlash(Tango::Attribute &attr) entering... " << endl;
	/*----- PROTECTED REGION ID(AxisG2::read_Backlash) ENABLED START -----*/
	//	Set the attribute value

	if (!cached_with_microcode) *attr_Backlash_read = nan("");

	attr.set_value(attr_Backlash_read);
	
	/*----- PROTECTED REGION END -----*/	//	AxisG2::read_Backlash
}
//--------------------------------------------------------
/**
 *	Write attribute Backlash related method
 *	Description: Value for the compensation for mechanical backlash by doing final move in the direction defined by BacklashDirection (<I><B>plant coordinates/units</B></I>).
 *
 *	Data type:	Tango::DevDouble
 *	Attr type:	Scalar
 */
//--------------------------------------------------------
void AxisG2::write_Backlash(Tango::WAttribute &attr)
{
	DEBUG_STREAM << "AxisG2::write_Backlash(Tango::WAttribute &attr) entering... " << endl;
	//	Retrieve write value
	Tango::DevDouble	w_val;
	attr.get_write_value(w_val);
	/*----- PROTECTED REGION ID(AxisG2::write_Backlash) ENABLED START -----*/
	// MYCODE-START

	std::stringstream es;
	es << "AxisG2::write_Backlash(" << w_val << ")";
	INFOLOG(es.str());

	std::stringstream ss;
        ss << __func__ << "(" << w_val << ")";
        hist->push_end(ss.str());

	if (!axis) return;
	if ( ct!=Controller_ns::CTRL_UP ) return;

	if ( !with_microcode() ) {
		*attr_Backlash_read = nan("");
		INFOLOG("AxisG2::write_Backlash(): skip");
		return;
	}

        if ( isnan(w_val) ){
			INFOLOG("AxisG2::write_Backlash(): Invalid Value (NaN)");
                        Tango::Except::throw_exception ((const char *)"AxisG2",
                        (const char *) "Invalid Value (NaN)",
                        (const char *)"AxisG2::write_Backlash");
        }
        if (!check_Backlash(w_val) ){
		INFOLOG("AxisG2::write_Backlash(): Invalid Value (< Minimum Movement)");
        	Tango::Except::throw_exception (
			(const char *)"INVALID VALUE",
                        (const char *)"Invalid Value (< Minimum Movement)",
                        (const char *)"AxisG2::write_Backlash");
        }
        if (sethw_Backlash(w_val)) *attr_Backlash_read = w_val;
	else {
		INFOLOG("AxisG2::write_Backlash(): Write to hw failed");
		Tango::Except::throw_exception (
			(const char *)"OPERATION FAILED",
			(const char *)"Write to hw failed",
			(const char *)"AxisG2::write_Backlash");
	}

	INFOLOG("AxisG2::write_Backlash(): done");
	// MYCODE-END
	
	
	/*----- PROTECTED REGION END -----*/	//	AxisG2::write_Backlash
}
//--------------------------------------------------------
/**
 *	Read attribute BacklashDirection related method
 *	Description: Direction of final move (for mechanical backlash compensation). 
 *               
 *               _ <B> 0</B> : no mechanical backlash compensation
 *               _ <B> 1</B> : final move direction = positive direction as defined in <I><B>plant coordinates/units</B></I>
 *               _<B>-1</B> : final move direction = negative direction as defined in <I><B>plant coordinates/units</B></I>
 *
 *	Data type:	Tango::DevDouble
 *	Attr type:	Scalar
 */
//--------------------------------------------------------
void AxisG2::read_BacklashDirection(Tango::Attribute &attr)
{
	DEBUG_STREAM << "AxisG2::read_BacklashDirection(Tango::Attribute &attr) entering... " << endl;
	/*----- PROTECTED REGION ID(AxisG2::read_BacklashDirection) ENABLED START -----*/
	//	Set the attribute value

	if (!cached_with_microcode) *attr_BacklashDirection_read = nan("");

	attr.set_value(attr_BacklashDirection_read);
	
	if ( ((ct == Controller_ns::CTRL_DOWN) || (ct == Controller_ns::CTRL_CLOSE)) ) attr.set_quality(Tango::ATTR_INVALID);
	/*----- PROTECTED REGION END -----*/	//	AxisG2::read_BacklashDirection
}
//--------------------------------------------------------
/**
 *	Write attribute BacklashDirection related method
 *	Description: Direction of final move (for mechanical backlash compensation). 
 *               
 *               _ <B> 0</B> : no mechanical backlash compensation
 *               _ <B> 1</B> : final move direction = positive direction as defined in <I><B>plant coordinates/units</B></I>
 *               _<B>-1</B> : final move direction = negative direction as defined in <I><B>plant coordinates/units</B></I>
 *
 *	Data type:	Tango::DevDouble
 *	Attr type:	Scalar
 */
//--------------------------------------------------------
void AxisG2::write_BacklashDirection(Tango::WAttribute &attr)
{
	DEBUG_STREAM << "AxisG2::write_BacklashDirection(Tango::WAttribute &attr) entering... " << endl;
	//	Retrieve write value
	Tango::DevDouble	w_val;
	attr.get_write_value(w_val);
	/*----- PROTECTED REGION ID(AxisG2::write_BacklashDirection) ENABLED START -----*/
	// MYCODE-START

	std::stringstream es;
	es << "AxisG2::write_BacklashDirection(" << w_val << ")";
	INFOLOG(es.str());

	std::stringstream ss;
        ss << __func__ << "(" << w_val << ")";
        hist->push_end(ss.str());

	if (!axis) return;
	if ( ct!=Controller_ns::CTRL_UP ) return;

	if ( !with_microcode() ) {
		*attr_BacklashDirection_read = nan("");
		INFOLOG("AxisG2::write_BacklashDirection(): skip");
		return;
	}

        if ( isnan(w_val) ){
			INFOLOG("AxisG2::write_BacklashDirection(): Invalid Value (NaN)");
                        Tango::Except::throw_exception ((const char *)"AxisG2",
                        (const char *) "Invalid Value (NaN)",
                        (const char *)"AxisG2::write_BacklashDirection");
        }
        if ( !((w_val==-1)||(w_val==0)||(w_val==1)) ){
		INFOLOG("AxisG2::write_BacklashDirection(): Invalid Value (!-1/0/+1)");
        	Tango::Except::throw_exception (
			(const char *)"INVALID VALUE",
                        (const char *)"Invalid Value (!-1/0/+1)",
                        (const char *)"AxisG2::write_BacklashDirection");
        }
        if (sethw_BacklashDirection(w_val)) *attr_BacklashDirection_read = w_val;
	else {
		INFOLOG("AxisG2::write_BacklashDirection(): Write to hw failed");
		Tango::Except::throw_exception (
			(const char *)"OPERATION FAILED",
			(const char *)"Write to hw failed",
			(const char *)"AxisG2::write_BacklashDirection");
	}

	INFOLOG("AxisG2::write_BacklashDirection(): done");
	// MYCODE-END
	
	/*----- PROTECTED REGION END -----*/	//	AxisG2::write_BacklashDirection
}
//--------------------------------------------------------
/**
 *	Read attribute Velocity related method
 *	Description: Actual speed of the axis (<I><B>plant coordinates/units</B></I>),
 *               as retorted by the underneath controller.
 *
 *	Data type:	Tango::DevDouble
 *	Attr type:	Scalar
 */
//--------------------------------------------------------
void AxisG2::read_Velocity(Tango::Attribute &attr)
{
	DEBUG_STREAM << "AxisG2::read_Velocity(Tango::Attribute &attr) entering... " << endl;
	/*----- PROTECTED REGION ID(AxisG2::read_Velocity) ENABLED START -----*/
	// MYCODE-START
	if ( (!axis) || (ct != Controller_ns::CTRL_UP) ) {
		attr.set_quality(Tango::ATTR_INVALID);
		return;
	}

	*attr_Velocity_read = axis->velocity();
	// MYCODE-END
	//	Set the attribute value
	attr.set_value(attr_Velocity_read);
	
	/*----- PROTECTED REGION END -----*/	//	AxisG2::read_Velocity
}
//--------------------------------------------------------
/**
 *	Read attribute IsInitialised related method
 *	Description: Final state of the initialisation phase:
 *                
 *               _<B> 0 </B> : axis is not initialised
 *               _<B> 1 </B> : iaxis is initialized
 *
 *	Data type:	Tango::DevShort
 *	Attr type:	Scalar
 */
//--------------------------------------------------------
void AxisG2::read_IsInitialised(Tango::Attribute &attr)
{
	DEBUG_STREAM << "AxisG2::read_IsInitialised(Tango::Attribute &attr) entering... " << endl;
	/*----- PROTECTED REGION ID(AxisG2::read_IsInitialised) ENABLED START -----*/
	//	Set the attribute value

	// MYCODE-START
	if ( (!axis) || (ct != Controller_ns::CTRL_UP) ) {
		attr.set_quality(Tango::ATTR_INVALID);
		return;
	}

	*attr_IsInitialised_read = (Tango::DevShort)axis->isinit();
	// MYCODE-START

	attr.set_value(attr_IsInitialised_read);
	
	/*----- PROTECTED REGION END -----*/	//	AxisG2::read_IsInitialised
}
//--------------------------------------------------------
/**
 *	Read attribute DeviceState related method
 *	Description: Additional device state (numeric value).
 *               
 *               _<B> 0 </B> : UNKNOWN
 *               _<B> 1 </B> : ONLINE
 *               _<B> 2 </B> : OFFLINE
 *               _<B> 3 </B> : SERVICE
 *               _<B> 4 </B> : TEST
 *               
 *               <I>See</I> : DeviceStatus
 *
 *	Data type:	Tango::DevUShort
 *	Attr type:	Scalar
 */
//--------------------------------------------------------
void AxisG2::read_DeviceState(Tango::Attribute &attr)
{
	DEBUG_STREAM << "AxisG2::read_DeviceState(Tango::Attribute &attr) entering... " << endl;
	/*----- PROTECTED REGION ID(AxisG2::read_DeviceState) ENABLED START -----*/
	//	Set the attribute value
	attr.set_value(attr_DeviceState_read);
	
	/*----- PROTECTED REGION END -----*/	//	AxisG2::read_DeviceState
}
//--------------------------------------------------------
/**
 *	Write attribute DeviceState related method
 *	Description: Additional device state (numeric value).
 *               
 *               _<B> 0 </B> : UNKNOWN
 *               _<B> 1 </B> : ONLINE
 *               _<B> 2 </B> : OFFLINE
 *               _<B> 3 </B> : SERVICE
 *               _<B> 4 </B> : TEST
 *               
 *               <I>See</I> : DeviceStatus
 *
 *	Data type:	Tango::DevUShort
 *	Attr type:	Scalar
 */
//--------------------------------------------------------
void AxisG2::write_DeviceState(Tango::WAttribute &attr)
{
	DEBUG_STREAM << "AxisG2::write_DeviceState(Tango::WAttribute &attr) entering... " << endl;
	//	Retrieve write value
	Tango::DevUShort	w_val;
	attr.get_write_value(w_val);
	/*----- PROTECTED REGION ID(AxisG2::write_DeviceState) ENABLED START -----*/
	
	// MYCODE-START

	std::stringstream es;
	es << "AxisG2::write_DeviceState(" << w_val << ")";
	INFOLOG(es.str());

	std::stringstream ss;
        ss << __func__ << "(" << w_val << ")";
        hist->push_end(ss.str());

	*attr_DeviceState_read = w_val;

	INFOLOG("AxisG2::write_DeviceState(): done");
	// MYCODE-END
	
	/*----- PROTECTED REGION END -----*/	//	AxisG2::write_DeviceState
}
//--------------------------------------------------------
/**
 *	Read attribute DeviceStatus related method
 *	Description: Additional device status (string value).
 *               
 *               UNKNOWN, ONLINE, OFFLINE, SERVICE, TEST
 *
 *	Data type:	Tango::DevString
 *	Attr type:	Scalar
 */
//--------------------------------------------------------
void AxisG2::read_DeviceStatus(Tango::Attribute &attr)
{
	DEBUG_STREAM << "AxisG2::read_DeviceStatus(Tango::Attribute &attr) entering... " << endl;
	/*----- PROTECTED REGION ID(AxisG2::read_DeviceStatus) ENABLED START -----*/
	//	Set the attribute value

	// MYCODE-START
	#if 1
	snprintf(*attr_DeviceStatus_read, DSTATUSMAX, "%s", DST[(*attr_DeviceState_read)].c_str());
	#endif
	// MYCODE-END

	attr.set_value(attr_DeviceStatus_read);
	
	/*----- PROTECTED REGION END -----*/	//	AxisG2::read_DeviceStatus
}
//--------------------------------------------------------
/**
 *	Read attribute IsMicrocodeOK related method
 *	Description: <B>false</B> : micro code is not running on the underneath controller
 *                <B>true</B> : micro code is running on the underneath controller
 *
 *	Data type:	Tango::DevBoolean
 *	Attr type:	Scalar
 */
//--------------------------------------------------------
void AxisG2::read_IsMicrocodeOK(Tango::Attribute &attr)
{
	DEBUG_STREAM << "AxisG2::read_IsMicrocodeOK(Tango::Attribute &attr) entering... " << endl;
	/*----- PROTECTED REGION ID(AxisG2::read_IsMicrocodeOK) ENABLED START -----*/
	//	Set the attribute value

	#ifdef _DBG_IS_MC_OK
		cout  << "AxisG2::read_IsMicrocodeOK() entering... " << endl;
	#endif /* _DBG_IS_MC_OK */

	if ( (!axis) || (ct != Controller_ns::CTRL_UP) ) {
		attr.set_quality(Tango::ATTR_INVALID);
		return;
	}

	*attr_IsMicrocodeOK_read = controller->drv()->program_running();

	attr.set_value(attr_IsMicrocodeOK_read);

	/*----- PROTECTED REGION END -----*/	//	AxisG2::read_IsMicrocodeOK
}
//--------------------------------------------------------
/**
 *	Read attribute CheckEncoder related method
 *	Description: <B>false</B> : deactivate the check controller functions.
 *                <B>true</B> : activate the check controller functions.
 *               This value may be modified only through the CheckEncoderEnable property or the relevant service function.
 *
 *	Data type:	Tango::DevBoolean
 *	Attr type:	Scalar
 */
//--------------------------------------------------------
void AxisG2::read_CheckEncoder(Tango::Attribute &attr)
{
	DEBUG_STREAM << "AxisG2::read_CheckEncoder(Tango::Attribute &attr) entering... " << endl;
	/*----- PROTECTED REGION ID(AxisG2::read_CheckEncoder) ENABLED START -----*/
	//	Set the attribute value
	attr.set_value(attr_CheckEncoder_read);
	
	/*----- PROTECTED REGION END -----*/	//	AxisG2::read_CheckEncoder
}
//--------------------------------------------------------
/**
 *	Read attribute CheckEncoderHoldOn related method
 *	Description: <B>false</B> : the signalling status follows that of the check controller functions.
 *                <B>true</B> : the signalling status holds the first error/warning of the check controller functions.
 *
 *	Data type:	Tango::DevBoolean
 *	Attr type:	Scalar
 */
//--------------------------------------------------------
void AxisG2::read_CheckEncoderHoldOn(Tango::Attribute &attr)
{
	DEBUG_STREAM << "AxisG2::read_CheckEncoderHoldOn(Tango::Attribute &attr) entering... " << endl;
	/*----- PROTECTED REGION ID(AxisG2::read_CheckEncoderHoldOn) ENABLED START -----*/
	//	Set the attribute value
	attr.set_value(attr_CheckEncoderHoldOn_read);
	
	/*----- PROTECTED REGION END -----*/	//	AxisG2::read_CheckEncoderHoldOn
}
//--------------------------------------------------------
/**
 *	Write attribute CheckEncoderHoldOn related method
 *	Description: <B>false</B> : the signalling status follows that of the check controller functions.
 *                <B>true</B> : the signalling status holds the first error/warning of the check controller functions.
 *
 *	Data type:	Tango::DevBoolean
 *	Attr type:	Scalar
 */
//--------------------------------------------------------
void AxisG2::write_CheckEncoderHoldOn(Tango::WAttribute &attr)
{
	DEBUG_STREAM << "AxisG2::write_CheckEncoderHoldOn(Tango::WAttribute &attr) entering... " << endl;
	//	Retrieve write value
	Tango::DevBoolean	w_val;
	attr.get_write_value(w_val);
	/*----- PROTECTED REGION ID(AxisG2::write_CheckEncoderHoldOn) ENABLED START -----*/

	// MYCODE-START

	std::stringstream es;
	es << "AxisG2::write_CheckEncoderHoldOn(" << w_val << ")";
	INFOLOG(es.str());

	std::stringstream ss;
        ss << __func__ << "(" << w_val << ")";
        hist->push_end(ss.str());

	*attr_CheckEncoderHoldOn_read = w_val;
	
	INFOLOG("AxisG2::write_CheckEncoderHoldOn(): done");
	// MYCODE-END
	
	/*----- PROTECTED REGION END -----*/	//	AxisG2::write_CheckEncoderHoldOn
}
//--------------------------------------------------------
/**
 *	Read attribute StoredPosition4Fake related method
 *	Description: 
 *
 *	Data type:	Tango::DevDouble
 *	Attr type:	Scalar
 */
//--------------------------------------------------------
void AxisG2::read_StoredPosition4Fake(Tango::Attribute &attr)
{
	DEBUG_STREAM << "AxisG2::read_StoredPosition4Fake(Tango::Attribute &attr) entering... " << endl;
	/*----- PROTECTED REGION ID(AxisG2::read_StoredPosition4Fake) ENABLED START -----*/
	//	Set the attribute value
	attr.set_value(attr_StoredPosition4Fake_read);
	
	/*----- PROTECTED REGION END -----*/	//	AxisG2::read_StoredPosition4Fake
}
//--------------------------------------------------------
/**
 *	Read attribute ExtStatus related method
 *	Description: Inner states/values pertinent to all the functionalities.
 *
 *	Data type:	Tango::DevString
 *	Attr type:	Spectrum max = 100
 */
//--------------------------------------------------------
void AxisG2::read_ExtStatus(Tango::Attribute &attr)
{
	DEBUG_STREAM << "AxisG2::read_ExtStatus(Tango::Attribute &attr) entering... " << endl;
	/*----- PROTECTED REGION ID(AxisG2::read_ExtStatus) ENABLED START -----*/
	//	Set the attribute value

	// MYCODE-START
	//INFO_STREAM << "AxisG2::read_ExtStatus(Tango::Attribute &attr) entering... " << endl;
	#ifdef _DBG_EXTSTATUS
		cout << "AxisG2::read_ExtStatus(Tango::Attribute &attr) entering... " << endl;
	#endif /*_DBG_EXTSTATUS*/
	std::stringstream ss;

	int riga = 0;
	int howmany = 0;

	#ifdef _DBG_EXTSTATUS
		cout << "== A ==" << endl;
		
		cout << "0:{" << (AxisG2_ns::AxisG2::attr_ExtStatus_read[0]) << "}" << endl;


		cout << controller->linkstatus() << endl;
		cout << controller->status() << endl;
	#endif /*_DBG_EXTSTATUS*/

	ss.str("");
	ss << "link status = " << controller->linkstatus();
        ExtStatus(attr_ExtStatus_read, &riga, ss.str());
	howmany++;

	#ifdef _DBG_EXTSTATUS
		cout << "== A0 ==" << endl;
	#endif /*_DBG_EXTSTATUS*/

	ss.str("");
	ss << "ctrl status = " << controller->status();
        ExtStatus(attr_ExtStatus_read, &riga, ss.str());
	howmany++;

	#ifdef _DBG_EXTSTATUS
		cout << "== A1 ==" << endl;
		cout << _ctrl_up_dwn << endl;
		cout << _ctrl_to_close << endl;
	#endif /*_DBG_EXTSTATUS*/

	ss.str("");
	ss << _ctrl_up_dwn;
        ExtStatus(attr_ExtStatus_read, &riga, "ctrl _ctrl_up_dwn = " + ss.str());
	howmany++;

	ss.str("");
	ss << _ctrl_to_close;
        ExtStatus(attr_ExtStatus_read, &riga, "ctrl _ctrl_to_close = " + ss.str());
	howmany++;


	#ifdef _DBG_EXTSTATUS
		cout << "== B ==" << endl;
	#endif /*_DBG_EXTSTATUS*/

	ss.str("");
	if (  !((ct==Controller_ns::CTRL_DOWN)||(ct==Controller_ns::CTRL_UNKNOWN)) )  {
		if (axis) {
			#ifdef _DBG_EXTSTATUS
				cout << "== C ==" << endl;
			#endif /*_DBG_EXTSTATUS*/

        		ExtStatus(attr_ExtStatus_read, &riga, "     fsm  = " + axis->fsm_status());
			howmany++;
        		ExtStatus(attr_ExtStatus_read, &riga, "fsm error = " + axis->fsm_error_status());
			howmany++;
        		ExtStatus(attr_ExtStatus_read, &riga, "     ifsm = " + axis->ifsm_status());
			howmany++;
        		ExtStatus(attr_ExtStatus_read, &riga, "stop_code = " + axis->stop_code2str());
			howmany++;
        		ExtStatus(attr_ExtStatus_read, &riga, "  CC_code = " + axis->CC_code2str());
			howmany++;


			#ifdef _DBG_EXTSTATUS
				cout << "== B ==" << endl;
			#endif /*_DBG_EXTSTATUS*/

			switch (controller->controller()){
				case Controller_ns::Yams:
					#ifdef _WITH_YAMSDRV_
					{
        				  Controller_ns::YamsDrv* yd = (Controller_ns::YamsDrv*)controller->drv();
                			  Controller_ns::yrvalues_t yrvals = yd->yrefresh(channel);

                			  ss << "target: "    << yrvals.target << " | ";
                			  ss << "err: "       << yrvals.err << " | ";
                			  ss << "olderr: "    << yrvals.olderr << " | ";
                			  ss << "CC_code: 0X" << hex << yrvals.CC_code << dec << " | ";
                			  ss << "nbrtr: "     << yrvals.nbrtr << " | ";
                			  ss << "dbw: "       << yrvals.yc.dbw << " | ";
                			  ss << "scale: "     << yrvals.yc.scale << " | ";
                			  ss << "pc: "        << yrvals.yc.pc << " | ";
                			  ss << "bck: "       << yrvals.yc.bck << " | ";
                			  ss << "dir: "       << yrvals.yc.dir << " | ";
                			  ss << "cp: "        << yrvals.yc.cp;
					}
        				ExtStatus(attr_ExtStatus_read, &riga, ss.str());
					howmany++;
					#endif
					break;
 //N5N5
				case Controller_ns::N5:
					#ifdef _WITH_N5DRV_
					{
        				  std::vector<std::string> desc = n5d->describe();
        				  std::vector<std::string>::iterator it;
        				  for (it = desc.begin(); it != desc.end(); ++it) {
        				  	ExtStatus(attr_ExtStatus_read, &riga, std::string("N5: ")+(*it));
					  	howmany++;
					  }
					}
					#ifdef _WITH_N5MICROCODE_
					{
                			  Controller_ns::n5rvalues_t yrvals = n5d->n5refresh(channel);

                			  ss << "target: "    << yrvals.target << " | ";
                			  ss << "err: "       << yrvals.err << " | ";
                			  ss << "olderr: "    << yrvals.olderr << " | ";
                			  ss << "CC_code: 0X" << hex << yrvals.CC_code << dec << " | ";
                			  ss << "nbrtr: "     << yrvals.nbrtr << " | ";
                			  ss << "dbw: "       << yrvals.yc.dbw << " | ";
                			  ss << "scale: "     << yrvals.yc.scale << " | ";
                			  ss << "pc: "        << yrvals.yc.pc << " | ";
                			  ss << "bck: "       << yrvals.yc.bck << " | ";
                			  ss << "dir: "       << yrvals.yc.dir << " | ";
                			  ss << "cp: "        << yrvals.yc.cp;
					}
        				ExtStatus(attr_ExtStatus_read, &riga, ss.str());
					howmany++;
					#endif
					#endif
					break;
				default:
					break;
			}

			#ifdef _DBG_EXTSTATUS
				cout << "== C ==" << endl;
			#endif /*_DBG_EXTSTATUS*/

			ss.str("");
			ss << "Axis Limit switches f/r/h=" << axis->fls() << "/" << axis->rls() << "/" << axis->home();
        		ExtStatus(attr_ExtStatus_read, &riga, ss.str());
			howmany++;

			#ifdef _DBG_EXTSTATUS
				cout << "== D ==" << endl;
			#endif /*_DBG_EXTSTATUS*/

			ss.str("");
			ss << "Hardware Limit switches f/r=" << axis->hwfls() << "/" << axis->hwrls();
        		ExtStatus(attr_ExtStatus_read, &riga, ss.str());
			howmany++;

			#ifdef _DBG_EXTSTATUS
				cout << "== E ==" << endl;
			#endif /*_DBG_EXTSTATUS*/

			ss.str("");
			ss << "motor status =" << axis->mstatus();
        		ExtStatus(attr_ExtStatus_read, &riga, ss.str());
			howmany++;

			ss.str("");
			ss << "brake conf = " << axis->brake_conf_str();
        		ExtStatus(attr_ExtStatus_read, &riga, ss.str());
			howmany++;

			Axis_ns::chk_enc_t ce;
                	{omni_mutex_lock guard(lock1);
                        	ce = _chk_enc;
                	}

			#ifdef _DBG_EXTSTATUS
				cout << "== F ==" << endl;
			#endif /*_DBG_EXTSTATUS*/

			ss.str("");
			ss << axis->check_enc_name_str(ce);
			ss << " | ";
			double p = axis->chk_enc_last_value();
			ss << "chk_enc_last_value enc/pos= " << p << "/" << axis->enc2position(p);
			ss << " | ";
			p = axis->chk_mot_last_value();
			ss << "chk_mot_last_value mot(in enc units)/pos= " << p << "/" << axis->enc2position(p);
        		ExtStatus(attr_ExtStatus_read, &riga, "     _chk_enc  = " + ss.str());
			howmany++;

			#ifdef _DBG_EXTSTATUS
				cout << "== G ==" << endl;
			#endif /*_DBG_EXTSTATUS*/

			ss.str("");
			float c_curr, c_min, c_max;
			{omni_mutex_lock guard(lock1);
				c_curr = chk_diff_on_run_stat.current;
				c_min  = chk_diff_on_run_stat.min;
				c_max  = chk_diff_on_run_stat.max;
			}
			ss << "chk_diff_on_run = " << c_curr;
			ss << " [m/M]=" << c_min << "/" <<  c_max;
			ss << " max(fabs()) = ";
			if ( fabs(c_min) > fabs(c_max) ) ss << fabs(c_min); else ss << fabs(c_max);
			ss << " [encoder units]";
        		ExtStatus(attr_ExtStatus_read, &riga, ss.str());
			howmany++;


			//cout << "== B ==" << endl;
			ss.str("");
			vector<double>::iterator it;
			vector<double> v = axis->saved_mpos();
			for (it = v.begin() ; it != v.end(); ++it) ss << " " << *it;
			ss << "  |  _relative_mpos_preinit = " << axis->relative_mpos_preinit();
			double rmp = axis->motor2position(axis->relative_mpos_preinit()) -  axis->motor2position(0);
			ss << " => relative position preinit = " << rmp;
        		ExtStatus(attr_ExtStatus_read, &riga, "     __save_mpos  = " + ss.str());
			howmany++;

			ss.str("");
			v = axis->saved_epos();
			for (it = v.begin() ; it != v.end(); ++it) ss << " " << *it;
			ss << "  |  _relative_epos_preinit = " << axis->relative_epos_preinit();
			double rep = axis->enc2position(axis->relative_epos_preinit()) - axis->enc2position(0);
			ss << " => relative position preinit = " << rep;
        		ExtStatus(attr_ExtStatus_read, &riga, "     __save_epos  = " + ss.str());
			howmany++;

/*
typedef struct {
        bool       data_valid;
        double     last_position;
        chk_enc_t  chk_enc;
        int        nb_of_restoration;
        int        max_nb_of_restoration;
} restore_last_position_t;
*/
			Axis_ns::restore_last_position_t rlp;
			rlp = axis->get_restore_last_position();
			ss.str("");
			ss << "restore_last_position values: data_valid = " << rlp.data_valid << " | ";
			ss << "last_position = " << rlp.last_position ;
        		ExtStatus(attr_ExtStatus_read, &riga, ss.str());
			howmany++;

			ss.str("");
			ss << "restore_last_position values: ";
			ss << "nb_of_restoration/max_nb_of_restoration = " << rlp.nb_of_restoration << "/" << rlp.max_nb_of_restoration;
        		ExtStatus(attr_ExtStatus_read, &riga, ss.str());
			howmany++;

		} /* if (axis) */
	} /* if (controller in not CTRL_DOWN) */

	//cout << "== C ==" << endl;
	if (ct!=Controller_ns::CTRL_CLOSE) {
		ss.str("");
		ss << "Controller/Link update_etime() =" << controller->drv()->update_etime();
		ss << " [m/M]=" << update_stat.min << "/" << update_stat.max;
		ss << " | refresh_etime() =" << controller->drv()->refresh_etime();
        	ExtStatus(attr_ExtStatus_read, &riga, ss.str());
		howmany++;
	}

	//cout << "== D ==" << endl;
	float s_curr, s_min, s_max;
	{omni_mutex_lock guard(lock1);
		s_curr = statepos_stat.current;
		s_min  = statepos_stat.min;
		s_max  = statepos_stat.max;
	}
	ss.str("");
	ss << "statepos_stat =" << s_curr ;
	ss << " [m/M]=" << s_min << "/" << s_max << " ms";
       	ExtStatus(attr_ExtStatus_read, &riga, ss.str());
	howmany++;

	if (axis) {
		Controller_ns::mOffOn_t mOffOn;
		mOffOn = axis->mOffOn();
		ss.str("");
		ss << "mOffOn enable / m /q = " << (mOffOn.enabled?"enabled":"disabled") << " / " << mOffOn.m << " / " << mOffOn.q;
       		ExtStatus(attr_ExtStatus_read, &riga, ss.str());
		howmany++;
	}

	//Spazio di arresto / Stop space
	if (axis) {
		double v = axis->speed();
		double a = axis->deceleration();
		double s = nan("");
		if ( (a != 0) && !isnan(a) ){
			s = pow(v,2) / a / 2.0;
		}
		ss.str("");
		ss << "Stop space = " << s << "[.] = " << axis->position2motor(s) << " [steps]";
       		ExtStatus(attr_ExtStatus_read, &riga, ss.str());
		howmany++;
	}
	

	if ( howmany > 100 ) howmany = 100;
        attr.set_value(attr_ExtStatus_read, howmany);

	#ifdef _DBG_EXTSTATUS
		cout << "AxisG2::read_ExtStatus(Tango::Attribute &attr) exiting... " << endl;
	#endif /*_DBG_EXTSTATUS*/

	// MYCODE-END
	// TO BE REAMOVED, POGO WROTE IT attr.set_value(attr_ExtStatus_read, 100);
	
	/*----- PROTECTED REGION END -----*/	//	AxisG2::read_ExtStatus
}
//--------------------------------------------------------
/**
 *	Read attribute History related method
 *	Description: 
 *
 *	Data type:	Tango::DevString
 *	Attr type:	Spectrum max = 2000
 */
//--------------------------------------------------------
void AxisG2::read_History(Tango::Attribute &attr)
{
	DEBUG_STREAM << "AxisG2::read_History(Tango::Attribute &attr) entering... " << endl;
	/*----- PROTECTED REGION ID(AxisG2::read_History) ENABLED START -----*/

        int howmany = hist->copyto(attr_History_read);
        if (howmany > 0) attr.set_value(attr_History_read, howmany);

	//	Set the attribute value
	//attr.set_value(attr_History_read, 2000);
	
	/*----- PROTECTED REGION END -----*/	//	AxisG2::read_History
}

//--------------------------------------------------------
/**
 *	Method      : AxisG2::add_dynamic_attributes()
 *	Description : Create the dynamic attributes if any
 *                for specified device.
 */
//--------------------------------------------------------
void AxisG2::add_dynamic_attributes()
{
	/*----- PROTECTED REGION ID(AxisG2::add_dynamic_attributes) ENABLED START -----*/
	
	//	Add your own code to create and add dynamic attributes if any
	
	/*----- PROTECTED REGION END -----*/	//	AxisG2::add_dynamic_attributes
}

//--------------------------------------------------------
/**
 *	Command State related method
 *	Description: This command gets the device state (stored in its <i>device_state</i> data member) and returns it to the caller.
 *
 *	@returns State Code
 */
//--------------------------------------------------------
Tango::DevState AxisG2::dev_state()
{
	DEBUG_STREAM << "AxisG2::State()  - " << device_name << endl;
	/*----- PROTECTED REGION ID(AxisG2::dev_state) ENABLED START -----*/
	
	Tango::DevState	argout = Tango::UNKNOWN; // replace by your own algorithm
	//	Add your own code

	// MYCODE-START

	{ omni_mutex_lock guard(lock1); argout = __state; };

	// MYCODE-END
	
	/*----- PROTECTED REGION END -----*/	//	AxisG2::dev_state
	set_state(argout);    // Give the state to Tango.
	if (argout!=Tango::ALARM)
		Tango::DeviceImpl::dev_state();
	return get_state();  // Return it after Tango management.
}
//--------------------------------------------------------
/**
 *	Command Status related method
 *	Description: This command gets the device status (stored in its <i>device_status</i> data member) and returns it to the caller.
 *
 *	@returns Status description
 */
//--------------------------------------------------------
Tango::ConstDevString AxisG2::dev_status()
{
	DEBUG_STREAM << "AxisG2::Status()  - " << device_name << endl;
	/*----- PROTECTED REGION ID(AxisG2::dev_status) ENABLED START -----*/
	
	string	status = "Device is OK";
	//	Add your own code

	// MYCODE-START

	{ omni_mutex_lock guard(lock1); status = __status; };

	// MYCODE-END
	
	/*----- PROTECTED REGION END -----*/	//	AxisG2::dev_status
	set_status(status);               // Give the status to Tango.
	return Tango::DeviceImpl::dev_status();  // Return it.
}
//--------------------------------------------------------
/**
 *	Command Forward related method
 *	Description: Move the axis in the forward (positive) direction (<I><B>plant coordinates/units</B></I>).
 *
 */
//--------------------------------------------------------
void AxisG2::forward()
{
	DEBUG_STREAM << "AxisG2::Forward()  - " << device_name << endl;
	/*----- PROTECTED REGION ID(AxisG2::forward) ENABLED START -----*/
	
	//	Add your own code
	// MYCODE-START

	INFOLOG("AxisG2::forward()");

	std::stringstream ss;
        ss << __func__ << "()";
        hist->push_end(ss.str());

	if (!axis) return;
	if ( ct!=Controller_ns::CTRL_UP ) return;


	if ( !axis->forward(axis->speed()) ) {
			std::stringstream es;
			es << "AxisG2::forward(): " << axis->axis_error_str();
			INFOLOG(es.str());
                        Tango::Except::throw_exception (
				(const char *)"AxisG2",
                        	(const char *)axis->axis_error_str().c_str(),
                        	(const char *)"AxisG2::Forward()");
	}

	INFOLOG("AxisG2::forward(): done");
	// MYCODE-END
	
	/*----- PROTECTED REGION END -----*/	//	AxisG2::forward
}
//--------------------------------------------------------
/**
 *	Command Stop related method
 *	Description: Stop the actual movement.
 *
 */
//--------------------------------------------------------
void AxisG2::stop()
{
	DEBUG_STREAM << "AxisG2::Stop()  - " << device_name << endl;
	/*----- PROTECTED REGION ID(AxisG2::stop) ENABLED START -----*/
	
	//	Add your own code
	// MYCODE-START

	INFOLOG("AxisG2::stop()");

	std::stringstream ss;
        ss << __func__ << "()";
        hist->push_end(ss.str());

	if (!axis) return;
	if ( ct!=Controller_ns::CTRL_UP ) return;

	axis->stop();

	INFOLOG("AxisG2::stop(): done");
	// MYCODE-END
	
	/*----- PROTECTED REGION END -----*/	//	AxisG2::stop
}
//--------------------------------------------------------
/**
 *	Command Backward related method
 *	Description: Move the axis in the backward (negative) direction (<I><B>plant coordinates/units</B></I>).
 *
 */
//--------------------------------------------------------
void AxisG2::backward()
{
	DEBUG_STREAM << "AxisG2::Backward()  - " << device_name << endl;
	/*----- PROTECTED REGION ID(AxisG2::backward) ENABLED START -----*/
	
	//	Add your own code
	// MYCODE-START

	INFOLOG("AxisG2::backward()");

	std::stringstream ss;
        ss << __func__ << "()";
        hist->push_end(ss.str());

	if (!axis) return;
	if ( ct!=Controller_ns::CTRL_UP ) return;


	if (!axis->backward(axis->speed())) {
			std::stringstream es;
			es << "AxisG2::backward(): " << axis->axis_error_str();
			INFOLOG(es.str());
                        Tango::Except::throw_exception (
				(const char *)"AxisG2",
                        	(const char *)axis->axis_error_str().c_str(),
                        	(const char *)"AxisG2::Backward()");
	}

	INFOLOG("AxisG2::backward(): done");
	// MYCODE-END
	
	/*----- PROTECTED REGION END -----*/	//	AxisG2::backward
}
//--------------------------------------------------------
/**
 *	Command GoToRelativePosition related method
 *	Description: Move the axis of the given displacement, relative positioning (<I><B>plant coordinates/units</B></I>).
 *
 *	@param argin Relative move in plant unit
 */
//--------------------------------------------------------
void AxisG2::go_to_relative_position(Tango::DevDouble argin)
{
	DEBUG_STREAM << "AxisG2::GoToRelativePosition()  - " << device_name << endl;
	/*----- PROTECTED REGION ID(AxisG2::go_to_relative_position) ENABLED START -----*/
	
	//	Add your own code
	// MYCODE-START

	std::stringstream es;
	es << "AxisG2::go_to_relative_position(" << argin << ")";
	INFOLOG(es.str());

	std::stringstream ss;
        ss << __func__ << "(" << argin << ")";
        hist->push_end(ss.str());

	cout << "AxisG2::axis_go_to_relative_position(" << argin << ")" << endl;
        if ( isnan(argin) ) {
			INFOLOG("AxisG2::go_to_relative_position(): Invalid Value (NaN)");
			Tango::Except::throw_exception (
				(const char *)"AxisG2",
                        	(const char *)"Invalid Value (NaN)",
                        	(const char *)"AxisG2::GoToRelativePosition()");
	}

	if ( !axis ){
			INFOLOG("AxisG2::go_to_relative_position(): Axis not created!");
			Tango::Except::throw_exception (
				(const char *)"AxisG2",
               			(const char *)"Axis not created!",
               			(const char *)"AxisG2::GoToRelativePosition()");
	}

	if ( ct!=Controller_ns::CTRL_UP ) {
			INFOLOG("AxisG2::go_to_relative_position(): lack of Controller comm");
			Tango::Except::throw_exception (
				(const char *)"AxisG2",
               			(const char *)"Lack of Controller comm!",
               			(const char *)"AxisG2::GoToRelativePosition()");
	}


        if ( !*attr_IsMicrocodeOK_read ){
			INFOLOG("AxisG2::go_to_relative_position(): Invalid Cmd while MicroCode NOT running !!");
                        Tango::Except::throw_exception (
				(const char *)"AxisG2",
                        	(const char *)"Invalid Cmd while MicroCode NOT running !!",
                        	(const char *)"AxisG2::GoToRelativePosition()");
        }
	if ( *attr_CheckEncoder_read ) {
		switch (_chk_enc){
			case Axis_ns::CHK_ENC_ERROR:
			case Axis_ns::CHK_ENC_ERROR_ONSTAY:
			case Axis_ns::CHK_ENC_ERROR_ONRUN:
				INFOLOG("AxisG2::go_to_relative_position(): Invalid Cmd while Check Encoder Enabled & not ok !!");
                        	Tango::Except::throw_exception (
					(const char *)"AxisG2",
                        		(const char *)"Invalid Cmd while Check Encoder Enabled & not ok !!",
                        		(const char *)"AxisG2::GoToRelativePosition()");
				break;
			default:
				break;
		}
	}
	double v = axis->position() + argin;
	if ( !axis->position(v) ){
			std::stringstream es;
			es << "AxisG2::go_to_relative_position(): " << axis->axis_error_str();
			INFOLOG(es.str());
                        Tango::Except::throw_exception (
				(const char *)"AxisG2",
                        	(const char *)axis->axis_error_str().c_str(),
                        	(const char *)"AxisG2::GoToRelativePosition()");
	}

	UpdateRelative("Position", v);

//... and UserPosition

	double upos = v;
	if ( lib_func_ok ) {
		upos = DirectFunc(upos, userDirectFuncParams);
	};

	upos = (*attr_UserScale_read) * upos + (*attr_UserOffset_read);

	UpdateRelative("UserPosition", upos);

	INFOLOG("AxisG2::go_to_relative_position(): done");
	// MYCODE-END
	
	/*----- PROTECTED REGION END -----*/	//	AxisG2::go_to_relative_position
}
//--------------------------------------------------------
/**
 *	Command GoToPosition related method
 *	Description: Move the axis of the given position, absolute positioning (<I><B>plant coordinates/units</B></I>).
 *
 *	@param argin Absolute position in plant units
 */
//--------------------------------------------------------
void AxisG2::go_to_position(Tango::DevDouble argin)
{
	DEBUG_STREAM << "AxisG2::GoToPosition()  - " << device_name << endl;
	/*----- PROTECTED REGION ID(AxisG2::go_to_position) ENABLED START -----*/
	
	//	Add your own code
	// MYCODE-START

	std::stringstream es;
	es << "AxisG2::go_to_position(" << argin << ")";
	INFOLOG(es.str());

	std::stringstream ss;
        ss << __func__ << "(" << argin << ")";
        hist->push_end(ss.str());

	cout << "AxisG2::AxisGoToPosition(" << argin << ")" << endl;
        if ( isnan(argin) ) {
			INFOLOG("AxisG2::go_to_position(): Invalid Value (NaN)");
			Tango::Except::throw_exception (
				(const char *)"AxisG2",
                        	(const char *)"Invalid Value (NaN)",
                        	(const char *)"AxisG2::GoToPosition()");
	}
	if ( !axis ){
			INFOLOG("AxisG2::go_to_position(): Axis not created!");
			Tango::Except::throw_exception (
				(const char *)"AxisG2",
               			(const char *)"Axis not created!",
               			(const char *)"AxisG2::GoToPosition()");
	}

	if ( ct!=Controller_ns::CTRL_UP ) {
			INFOLOG("AxisG2::go_to_position(): lack of Controller comm");
			Tango::Except::throw_exception (
				(const char *)"AxisG2",
               			(const char *)"Lack of Controller comm!",
               			(const char *)"AxisG2::GoToPosition()");
	}

        if ( !*attr_IsMicrocodeOK_read ){
			INFOLOG("AxisG2::go_to_position(): Invalid Cmd while MicroCode NOT running !!");
                        Tango::Except::throw_exception (
				(const char *)"AxisG2",
                        	(const char *)"Invalid Cmd while MicroCode NOT running !!",
                        	(const char *)"AxisG2::GoToPosition()");
        }
	if ( *attr_CheckEncoder_read ) {
		switch (_chk_enc){
			case Axis_ns::CHK_ENC_ERROR:
			case Axis_ns::CHK_ENC_ERROR_ONSTAY:
			case Axis_ns::CHK_ENC_ERROR_ONRUN:
				INFOLOG("AxisG2::go_to_position(): Invalid Cmd while Check Encoder Enabled & not ok !!");
                        	Tango::Except::throw_exception (
					(const char *)"AxisG2",
                        		(const char *)"Invalid Cmd while Check Encoder Enabled & not ok !!",
                        		(const char *)"AxisG2::GoToPosition()");
				break;
			default:
				break;
		}
	}
	double v = argin;
	if ( !axis->position(v)){
			std::stringstream es;
			es << "AxisG2::go_to_position(): " << axis->axis_error_str();
			INFOLOG(es.str());
                        Tango::Except::throw_exception (
				(const char *)"AxisG2",
                        	(const char *)axis->axis_error_str().c_str(),
                        	(const char *)"AxisG2::GoToPosition()");
	}

	UpdateRelative("Position", v);

//... and UserPosition

	double upos = v;
	if ( lib_func_ok ) {
		upos = DirectFunc(upos, userDirectFuncParams);
	};

	upos = (*attr_UserScale_read) * upos + (*attr_UserOffset_read);

	UpdateRelative("UserPosition", upos);

	INFOLOG("AxisG2::go_to_position(): done");
	// MYCODE-END
	
	/*----- PROTECTED REGION END -----*/	//	AxisG2::go_to_position
}
//--------------------------------------------------------
/**
 *	Command DefinePosition related method
 *	Description: Set the value of the actual position (<I><B>plant coordinates/units</B></I>).
 *
 *	@param argin Actual position in plant units
 *	@returns 
 */
//--------------------------------------------------------
Tango::DevString AxisG2::define_position(Tango::DevDouble argin)
{
	Tango::DevString argout;
	DEBUG_STREAM << "AxisG2::DefinePosition()  - " << device_name << endl;
	/*----- PROTECTED REGION ID(AxisG2::define_position) ENABLED START -----*/
	
	//	Add your own code

//DPP

	// MYCODE-START
	std::string obj("AxisG2::define_position()");

	std::stringstream es;
	es << "AxisG2::define_position(" << argin << ")";
	INFOLOG(es.str());

	std::stringstream ss;
        ss << __func__ << "(" << argin << ")";
        hist->push_end(ss.str());

	es.str("");
	es << "argin= " << argin;
	prtlog(obj, es.str());

        if ( isnan(argin) ) {
			INFOLOG("AxisG2::define_position(): Invalid Value (NaN)");
			Tango::Except::throw_exception (
				(const char *)"AxisG2",
                        	(const char *)"Invalid Value (NaN)",
                        	(const char *)"AxisG2::DefinePosition()");
	}
	if ( initType != 0 ) {
			INFOLOG("AxisG2::define_position(): AxisDefinePosition and AxisInitType are inconsistent");
			Tango::Except::throw_exception (
					(const char *)"AxisG2",
					(const char *)"AxisDefinePosition and AxisInitType are inconsistent",
					(const char *)"AxisG2::DefinePosition()");
	}
	//*attr_IsMicrocodeOK_read = controller->drv()->program_running();
	if ( !*attr_IsMicrocodeOK_read ) {
					INFOLOG("AxisG2::define_position(): MicroCode NOT running!");
					Tango::Except::throw_exception (
						(const char *)"AxisG2",
                        			(const char *)"MicroCode NOT running!",
                        			(const char *)"AxisG2::DefinePosition()");
	}
	if ( !axis ){
			INFOLOG("AxisG2::define_position(): Axis not created!");
			Tango::Except::throw_exception (
				(const char *)"AxisG2",
               			(const char *)"Axis not created!",
               			(const char *)"AxisG2::DefinePosition()");
	}

	if ( ct!=Controller_ns::CTRL_UP ) {
			INFOLOG("AxisG2::define_position(): lack of Controller comm");
			Tango::Except::throw_exception (
				(const char *)"AxisG2",
               			(const char *)"Lack of Controller comm!",
               			(const char *)"AxisG2::DefinePosition()");
	}

	if (!_conf_flag) _conf_flag = AxisConf();
	axis->force_init(argin);
	argout = CORBA::string_dup("OK");

	UpdateRelative("Position", argin);
	double upos = argin;
	if ( lib_func_ok ) {
		upos = DirectFunc(upos, userDirectFuncParams);
	};
	upos = (*attr_UserScale_read) * upos + (*attr_UserOffset_read);
	UpdateRelative("UserPosition", upos);

	INFOLOG("AxisG2::define_position(): done");
	// MYCODE-END
	
	/*----- PROTECTED REGION END -----*/	//	AxisG2::define_position
	return argout;
}
//--------------------------------------------------------
/**
 *	Command GetMotionStatus related method
 *	Description: Currently unimplemented
 *
 *	@returns 
 */
//--------------------------------------------------------
Tango::DevLong AxisG2::get_motion_status()
{
	Tango::DevLong argout;
	DEBUG_STREAM << "AxisG2::GetMotionStatus()  - " << device_name << endl;
	/*----- PROTECTED REGION ID(AxisG2::get_motion_status) ENABLED START -----*/
	
	//	Add your own code

	INFOLOG("AxisG2::get_motion_status(): UNIMPLEMENTED!");

	std::stringstream ss;
        ss << __func__ << "()";
        hist->push_end(ss.str());

	argout = 0;
	
	/*----- PROTECTED REGION END -----*/	//	AxisG2::get_motion_status
	return argout;
}
//--------------------------------------------------------
/**
 *	Command FindEdge related method
 *	Description: Currently unimplemented
 *
 */
//--------------------------------------------------------
void AxisG2::find_edge()
{
	DEBUG_STREAM << "AxisG2::FindEdge()  - " << device_name << endl;
	/*----- PROTECTED REGION ID(AxisG2::find_edge) ENABLED START -----*/
	
	//	Add your own code

	INFOLOG("AxisG2::find_edge(): UNIMPLEMENTED!");

	std::stringstream ss;
        ss << __func__ << "()";
        hist->push_end(ss.str());
	
	/*----- PROTECTED REGION END -----*/	//	AxisG2::find_edge
}
//--------------------------------------------------------
/**
 *	Command FindIndex related method
 *	Description: Currently unimplemented
 *
 */
//--------------------------------------------------------
void AxisG2::find_index()
{
	DEBUG_STREAM << "AxisG2::FindIndex()  - " << device_name << endl;
	/*----- PROTECTED REGION ID(AxisG2::find_index) ENABLED START -----*/
	
	//	Add your own code

	INFOLOG("AxisG2::find_index(): UNIMPLEMENTED!");

	std::stringstream ss;
        ss << __func__ << "()";
        hist->push_end(ss.str());
	
	/*----- PROTECTED REGION END -----*/	//	AxisG2::find_index
}
//--------------------------------------------------------
/**
 *	Command FindHome related method
 *	Description: Move to the home switch.
 *
 */
//--------------------------------------------------------
void AxisG2::find_home()
{
	DEBUG_STREAM << "AxisG2::FindHome()  - " << device_name << endl;
	/*----- PROTECTED REGION ID(AxisG2::find_home) ENABLED START -----*/
	
	//	Add your own code
	// MYCODE-START
	std::string obj("AxisG2::find_home()");

	INFOLOG("AxisG2::find_home()");

	std::stringstream ss;
        ss << __func__ << "()";
        hist->push_end(ss.str());

	prtlog(obj, "");
	if ( !axis )	{
			INFOLOG("AxisG2::find_home(): Axis not created!");
			Tango::Except::throw_exception (
				(const char *)"AxisG2",
               			(const char *)"Axis not created!",
               			(const char *)"AxisG2::FindHome()");
	}

	if ( ct!=Controller_ns::CTRL_UP ) {
			INFOLOG("AxisG2::find_home(): lack of Controller comm");
			Tango::Except::throw_exception (
				(const char *)"AxisG2",
               			(const char *)"Lack of Controller comm!",
               			(const char *)"AxisG2::FindHome()");
	}

	if ( !axis->findhome()){
			std::stringstream es;
			es << "AxisG2::find_home(): " << axis->axis_error_str();
			INFOLOG(es.str());
                        Tango::Except::throw_exception (
				(const char *)"AxisG2",
                        	(const char *)axis->axis_error_str().c_str(),
                        	(const char *)"AxisG2::FindHome()");
	}

	INFOLOG("AxisG2::find_home(): done");
	// MYCODE-END
	
	/*----- PROTECTED REGION END -----*/	//	AxisG2::find_home
}
//--------------------------------------------------------
/**
 *	Command GetErrorStatus related method
 *	Description: Currently unimplemented
 *
 *	@returns 
 */
//--------------------------------------------------------
Tango::DevLong AxisG2::get_error_status()
{
	Tango::DevLong argout;
	DEBUG_STREAM << "AxisG2::GetErrorStatus()  - " << device_name << endl;
	/*----- PROTECTED REGION ID(AxisG2::get_error_status) ENABLED START -----*/
	
	//	Add your own code

	INFOLOG("AxisG2::get_error_status(): UNIMPLEMENTED!");

	std::stringstream ss;
        ss << __func__ << "()";
        hist->push_end(ss.str());

	argout = 0;
	
	/*----- PROTECTED REGION END -----*/	//	AxisG2::get_error_status
	return argout;
}
//--------------------------------------------------------
/**
 *	Command DirectCmd related method
 *	Description: Currently unimplemented
 *
 *	@param argin 
 *	@returns 
 */
//--------------------------------------------------------
Tango::DevString AxisG2::direct_cmd(Tango::DevString argin)
{
	Tango::DevString argout;
	DEBUG_STREAM << "AxisG2::DirectCmd()  - " << device_name << endl;
	/*----- PROTECTED REGION ID(AxisG2::direct_cmd) ENABLED START -----*/
	
	//	Add your own code
	std::string obj("AxisG2::direct_cmd()");

	std::stringstream es;
	es << "AxisG2::direct_cmd(" << argin << "): UNIMPLEMENTED!";
	INFOLOG(es.str());

	std::stringstream ss;
        ss << __func__ << "()";
        hist->push_end(ss.str());

	es.str("");
	es << "argin= " << argin << " -UNIMPLEMENTED!-";
	prtlog(obj, es.str());

	argout = CORBA::string_dup("-UNIMPLEMENTED!-");
	
	/*----- PROTECTED REGION END -----*/	//	AxisG2::direct_cmd
	return argout;
}
//--------------------------------------------------------
/**
 *	Command AxisInit related method
 *	Description: Start the axis initialisation.
 *
 */
//--------------------------------------------------------
void AxisG2::axis_init()
{
	DEBUG_STREAM << "AxisG2::AxisInit()  - " << device_name << endl;
	/*----- PROTECTED REGION ID(AxisG2::axis_init) ENABLED START -----*/
	
	//	Add your own code
//AII

	// MYCODE-START
	std::string obj("AxisG2::axis_init()");
	prtlog(obj, "");

	std::stringstream es;
	es << "AxisG2::axis_init(): " << device_name;
	INFOLOG(es.str());

	std::stringstream ss;
        ss << __func__ << "()";
        hist->push_end(ss.str());

	//INFO_STREAM << "AxisG2::AxisInit()  - " << device_name << endl;

	if ( !axis )	{
					INFOLOG("AxisG2::axis_init(): Axis not created!");
					Tango::Except::throw_exception (
						(const char *)"AxisG2",
                        			(const char *)"Axis not created!",
                        			(const char *)"AxisG2::AxisInit()");
	}

	if ( ct!=Controller_ns::CTRL_UP ) {
			INFOLOG("AxisG2::axis_init(): lack of Controller comm");
			Tango::Except::throw_exception (
				(const char *)"AxisG2",
               			(const char *)"Lack of Controller comm!",
               			(const char *)"AxisG2::AxisInit()");
	}

	if ( initType == 0 ) {
				INFOLOG("AxisG2::axis_init(): AxisInit and AxisInitType are inconsistent");
				Tango::Except::throw_exception (
					(const char *)"AxisG2",
					(const char *)"AxisInit and AxisInitType are inconsistent",
					(const char *)"AxisG2::AxisInit()");
	}
        if ( !check_lsstroke_oninit()){
			INFOLOG("AxisG2::axis_init(): Invalid speed/deceleration values vs limitswitch stroke");
                        Tango::Except::throw_exception (
				(const char *)"AxisG2",
                        	(const char *)"Invalid speed/deceleration values vs limitswitch stroke",
                        	(const char *)"AxisG2::axis_init");
        }
	axis->fsm(Axis_ns::FSMT_INIT);
	
	time_t rawtime;
  	struct tm * timeinfo;
  	char buffer [80];

  	time (&rawtime);
  	timeinfo = localtime (&rawtime);

  	strftime (buffer,80,"%F %T ",timeinfo);

	string when(buffer);
	Tango::DbDatum _attr_prop("__when");
        _attr_prop << when;

        if ( !put_memorized_attribute("IsInitialised", _attr_prop) ){	
				INFOLOG("AxisG2::axis_init(): Error in put new memorized value");
                                Tango::Except::throw_exception (
                                        (const char *)"AxisG2",
                                        (const char *)"Error in put new memorized value",
                                        (const char *)"AxisG2::AxisInit()");
	}

	INFOLOG("AxisG2::axis_init(): done");
	// MYCODE-END
	
	/*----- PROTECTED REGION END -----*/	//	AxisG2::axis_init
}
//--------------------------------------------------------
/**
 *	Command MotorOFF related method
 *	Description: Switch off the power of the motor, and (if configured) do a brake on.
 *
 */
//--------------------------------------------------------
void AxisG2::motor_off()
{
	DEBUG_STREAM << "AxisG2::MotorOFF()  - " << device_name << endl;
	/*----- PROTECTED REGION ID(AxisG2::motor_off) ENABLED START -----*/
	
	//	Add your own code
	// MYCODE-START

	INFOLOG("AxisG2::motor_off()");

	std::stringstream ss;
        ss << __func__ << "()";
        hist->push_end(ss.str());

	if (!axis) return;
	if ( ct!=Controller_ns::CTRL_UP ) return;

	//INFO_STREAM << "AxisG2::MotorOFF()  - " << device_name << endl;
	axis->motor_off();

	INFOLOG("AxisG2::motor_off(): done");
	// MYCODE-END
	
	/*----- PROTECTED REGION END -----*/	//	AxisG2::motor_off
}
//--------------------------------------------------------
/**
 *	Command MotorON related method
 *	Description: Switch on the power of the motor, and (if configured) do a brake off.
 *
 */
//--------------------------------------------------------
void AxisG2::motor_on()
{
	DEBUG_STREAM << "AxisG2::MotorON()  - " << device_name << endl;
	/*----- PROTECTED REGION ID(AxisG2::motor_on) ENABLED START -----*/
	
	//	Add your own code
	// MYCODE-START

	INFOLOG("AxisG2::motor_on()");

	std::stringstream ss;
        ss << __func__ << "()";
        hist->push_end(ss.str());

	if (!axis) return;
	if ( ct!=Controller_ns::CTRL_UP ) return;

	//INFO_STREAM << "AxisG2::MotorON()  - " << device_name << endl;
	axis->motor_on();

	INFOLOG("AxisG2::motor_on(): done");
	// MYCODE-END
	
	/*----- PROTECTED REGION END -----*/	//	AxisG2::motor_on
}
//--------------------------------------------------------
/**
 *	Command ReadHWConf related method
 *	Description: Currently unimplemented
 *
 *	@returns 
 */
//--------------------------------------------------------
Tango::DevVarStringArray *AxisG2::read_hwconf()
{
	Tango::DevVarStringArray *argout;
	DEBUG_STREAM << "AxisG2::ReadHWConf()  - " << device_name << endl;
	/*----- PROTECTED REGION ID(AxisG2::read_hwconf) ENABLED START -----*/
	
	//	Add your own code

	INFOLOG("AxisG2::read_hwconf(): UNIMPLEMENTED!");

	std::stringstream ss;
        ss << __func__ << "()";
        hist->push_end(ss.str());

        argout  = new Tango::DevVarStringArray();
        argout->length(1);
        (*argout)[0] = CORBA::string_dup("-NONE-");
	
	/*----- PROTECTED REGION END -----*/	//	AxisG2::read_hwconf
	return argout;
}
//--------------------------------------------------------
/**
 *	Command GetUserEncoderRatio related method
 *	Description: Currently unimplemented
 *
 *	@returns 
 */
//--------------------------------------------------------
Tango::DevDouble AxisG2::get_user_encoder_ratio()
{
	Tango::DevDouble argout;
	DEBUG_STREAM << "AxisG2::GetUserEncoderRatio()  - " << device_name << endl;
	/*----- PROTECTED REGION ID(AxisG2::get_user_encoder_ratio) ENABLED START -----*/
	
	//	Add your own code

	INFOLOG("AxisG2::get_user_encoder_ratio(): UNIMPLEMENTED!");

	std::stringstream ss;
        ss << __func__ << "()";
        hist->push_end(ss.str());

	argout = 0;
	
	/*----- PROTECTED REGION END -----*/	//	AxisG2::get_user_encoder_ratio
	return argout;
}
//--------------------------------------------------------
/**
 *	Command Service related method
 *	Description: Service command interface.
 *
 *	@param argin command
 *	@returns 
 */
//--------------------------------------------------------
Tango::DevString AxisG2::service(Tango::DevString argin)
{
	Tango::DevString argout;
	DEBUG_STREAM << "AxisG2::Service()  - " << device_name << endl;
	/*----- PROTECTED REGION ID(AxisG2::service) ENABLED START -----*/
	
	//	Add your own code

	// MYCODE-START

	std::stringstream es;
	es << "AxisG2::service(" << argin << ")";
	INFOLOG(es.str());

	std::stringstream ss;
        ss << __func__ << "(" << argin << ")";
        hist->push_end(ss.str());

	return _service(argin);

	INFOLOG("AxisG2::service(): done");
	// MYCODE-END
	
	/*----- PROTECTED REGION END -----*/	//	AxisG2::service
	return argout;
}
//--------------------------------------------------------
/**
 *	Command GetMotionHistory related method
 *	Description: Return the last movements history.
 *
 *	@returns 
 */
//--------------------------------------------------------
Tango::DevVarStringArray *AxisG2::get_motion_history()
{
	Tango::DevVarStringArray *argout;
	DEBUG_STREAM << "AxisG2::GetMotionHistory()  - " << device_name << endl;
	/*----- PROTECTED REGION ID(AxisG2::get_motion_history) ENABLED START -----*/
	
	//	Add your own code

	// MYCODE-START

	INFOLOG("AxisG2::get_motion_history()");

	std::stringstream ss;
        ss << __func__ << "()";
        hist->push_end(ss.str());

        argout  = new Tango::DevVarStringArray();

	//std::stringstream ss;
	ss.str("");

	try {
		Tango::Database *db = Tango::Util::instance()->get_database();
		vector<Tango::DbHistory> hist;
		Tango::DbDatum result;

		string attrname("Position");
		string propname("__value");

		hist = db->get_device_attribute_property_history(device_name, attrname, propname);

		// Print the modification history of the specified property
		//cout << "hist.size() = " << hist.size() << endl;
	
		argout->length(hist.size());
		for(int i=0;i<(int)hist.size();i++) {
			//cout << "Name: " << hist[i].get_name() << " ";
			//cout << "Date: " << hist[i].get_date() << " ";
			ss.str("");
			ss << hist[i].get_name() << " ";
			ss << hist[i].get_date() << " ";
			if( hist[i].is_deleted() ) {
				//cout << "Deleted !" << endl;
				ss << "Deleted !";
			} else {
				#if 0
					// come da esempio nel manuale ma non funzina!
					hist[i].get_value() >> result;
					for (int j=0; j<result.size(); j++)
					cout << "Value:" << result[j] << endl;
				#else
					double v;
					hist[i].get_value() >> v;
					//cout << "Value:" << v << endl;
					ss << v << " ";
				#endif
			}
        		(*argout)[i] = CORBA::string_dup(ss.str().c_str());
		}
	} catch(...) {
		INFOLOG("AxisG2::get_motion_history(): DB except!");
        	argout->length(1);
        	(*argout)[0] = CORBA::string_dup("DB except!");
	}
	
	INFOLOG("AxisG2::get_motion_history(): done");
	// MYCODE-END
	
	/*----- PROTECTED REGION END -----*/	//	AxisG2::get_motion_history
	return argout;
}
//--------------------------------------------------------
/**
 *	Command RestoreLastPosition related method
 *	Description: May restore the last known position in case of loss of initialisation.
 *               Axis must not have been moved ``externally``.
 *
 */
//--------------------------------------------------------
void AxisG2::restore_last_position()
{
	DEBUG_STREAM << "AxisG2::RestoreLastPosition()  - " << device_name << endl;
	/*----- PROTECTED REGION ID(AxisG2::restore_last_position) ENABLED START -----*/
	
	//	Add your own code

	// MYCODE-START

	INFOLOG("AxisG2::restore_last_position()");

	std::stringstream ss;
        ss << __func__ << "()";
        hist->push_end(ss.str());

	if ( !axis->restore_last_position() ){
			std::stringstream es;
			es << "AxisG2::restore_last_position(): " << axis->axis_error_str();
			INFOLOG(es.str());
                        Tango::Except::throw_exception (
				(const char *)"AxisG2",
                        	(const char *)axis->axis_error_str().c_str(),
                        	(const char *)"AxisG2::RestoreLastPosition()");
	}

	INFOLOG("AxisG2::restore_last_position(): done");
	// MYCODE-END
	
	/*----- PROTECTED REGION END -----*/	//	AxisG2::restore_last_position
}
//--------------------------------------------------------
/**
 *	Command AckCheckEnc related method
 *	Description: Acknowledge the last check encoder alarm/state,
 *               restore state if encoder alarm is not still active.
 *
 */
//--------------------------------------------------------
void AxisG2::ack_check_enc()
{
	DEBUG_STREAM << "AxisG2::AckCheckEnc()  - " << device_name << endl;
	/*----- PROTECTED REGION ID(AxisG2::ack_check_enc) ENABLED START -----*/
	
	//	Add your own code

	// MYCODE-START

	INFOLOG("AxisG2::ack_check_enc()");

	std::stringstream ss;
        ss << __func__ << "()";
        hist->push_end(ss.str());

	{omni_mutex_lock guard(lock1);
		__enc_err_state = Tango::UNKNOWN;
        	__enc_err_status = "";
	}

	INFOLOG("AxisG2::ack_check_enc(): done");
	// MYCODE-END
	
	/*----- PROTECTED REGION END -----*/	//	AxisG2::ack_check_enc
}
//--------------------------------------------------------
/**
 *	Command RawAbsPos related method
 *	Description: <B><I>Open loop movement: i.e. without encoder feedback</I></B>.
 *               Move the axis of the given position, absolute positioning (<I><B>plant coordinates/units</B></I>).
 *               Possible brake is hold off during the next MotorRawBrakeONTMO time.
 *
 *	@param argin Absolute move in plant unit
 */
//--------------------------------------------------------
void AxisG2::raw_abs_pos(Tango::DevDouble argin)
{
	DEBUG_STREAM << "AxisG2::RawAbsPos()  - " << device_name << endl;
	/*----- PROTECTED REGION ID(AxisG2::raw_abs_pos) ENABLED START -----*/
	
	//	Add your own code
	// MYCODE-START

	std::stringstream es;
	es << "AxisG2::raw_abs_pos(" << argin << ")";
	INFOLOG(es.str());

	std::stringstream ss;
        ss << __func__ << "(" << argin << ")";
        hist->push_end(ss.str());

	//cout << "AxisG2::RawAbsPos(" << argin << ")" << endl;

	__attribute__ ((unused)) bool ret = RawPos(argin, false);

	INFOLOG("AxisG2::raw_abs_pos(): done");
	// MYCODE-END
	
	/*----- PROTECTED REGION END -----*/	//	AxisG2::raw_abs_pos
}
//--------------------------------------------------------
/**
 *	Command RawRelPos related method
 *	Description: <B><I>Open loop movement: i.e. without encoder feedback</I></B>.
 *               Move the axis of the given displacement, relative positioning (<I><B>plant coordinates/units</B></I>).
 *               Possible brake is hold off during the next MotorRawBrakeONTMO time.
 *
 *	@param argin Relative move in plant unit
 */
//--------------------------------------------------------
void AxisG2::raw_rel_pos(Tango::DevDouble argin)
{
	DEBUG_STREAM << "AxisG2::RawRelPos()  - " << device_name << endl;
	/*----- PROTECTED REGION ID(AxisG2::raw_rel_pos) ENABLED START -----*/
	
	//	Add your own code
	// MYCODE-START

	std::stringstream es;
	es << "AxisG2::raw_rel_pos(" << argin << ")";
	INFOLOG(es.str());

	std::stringstream ss;
        ss << __func__ << "(" << argin << ")";
        hist->push_end(ss.str());

	//cout << "AxisG2::RawRelPos(" << argin << ")" << endl;

	__attribute__ ((unused)) bool ret = RawPos(argin, true);

	INFOLOG("AxisG2::raw_rel_pos(): done");
	// MYCODE-END
	
	/*----- PROTECTED REGION END -----*/	//	AxisG2::raw_rel_pos
}
//--------------------------------------------------------
/**
 *	Command UserRawAbsPos related method
 *	Description: <B><I>Open loop movement: i.e. without encoder feedback</I></B>.
 *               Absolute positioning (<I><B>user coordinates/units</B></I>).
 *               <I>See</I> : RawAbsPos
 *
 *	@param argin Absolute move in user unit
 */
//--------------------------------------------------------
void AxisG2::user_raw_abs_pos(Tango::DevDouble argin)
{
	DEBUG_STREAM << "AxisG2::UserRawAbsPos()  - " << device_name << endl;
	/*----- PROTECTED REGION ID(AxisG2::user_raw_abs_pos) ENABLED START -----*/
	
	//	Add your own code
        // MYCODE-START

        std::stringstream es;
        es << "AxisG2::UserRawAbsPos(" << argin << ")";
        INFOLOG(es.str());

	std::stringstream ss;
        ss << __func__ << "(" << argin << ")";
        hist->push_end(ss.str());

        if (!axis) return;
	if ( ct!=Controller_ns::CTRL_UP ) return;

        if ( *attr_UserScale_read == 0 ){
                        INFOLOG("AxisG2::UserRawAbsPos(): Invalid User Scale (zero)");
                        Tango::Except::throw_exception ((const char *)"AxisG2",
                        (const char *) "Invalid User Scale (zero)",
                        (const char *)"AxisG2::UserRawAbsPos");
        }
        if ( isnan(argin) ){
                        INFOLOG("AxisG2::UserRawAbsPos(): Invalid Value (NaN)");
                        Tango::Except::throw_exception ((const char *)"AxisG2",
                        (const char *) "Invalid Value (NaN)",
                        (const char *)"AxisG2::UserRawAbsPos");
        }


        double v = (argin - (*attr_UserOffset_read))/(*attr_UserScale_read);
        __attribute__ ((unused)) bool ret = RawPos(v, false);


        // MYCODE-END
	/*----- PROTECTED REGION END -----*/	//	AxisG2::user_raw_abs_pos
}
//--------------------------------------------------------
/**
 *	Command UserRawRelPos related method
 *	Description: <B><I>Open loop movement: i.e. without encoder feedback</I></B>.
 *               Relative positioning (<I><B>user coordinates/units</B></I>).
 *               <I>See</I> : RawRelPos
 *
 *	@param argin Relative move in user unit
 */
//--------------------------------------------------------
void AxisG2::user_raw_rel_pos(Tango::DevDouble argin)
{
	DEBUG_STREAM << "AxisG2::UserRawRelPos()  - " << device_name << endl;
	/*----- PROTECTED REGION ID(AxisG2::user_raw_rel_pos) ENABLED START -----*/
	
	//	Add your own code
        // MYCODE-START

        std::stringstream es;
        es << "AxisG2::UserRawRelPos(" << argin << ")";
        INFOLOG(es.str());

	std::stringstream ss;
        ss << __func__ << "(" << argin << ")";
        hist->push_end(ss.str());

        if (!axis) return;
	if ( ct!=Controller_ns::CTRL_UP ) return;

        if ( *attr_UserScale_read == 0 ){
                        INFOLOG("AxisG2::UserRawRelPos(): Invalid User Scale (zero)");
                        Tango::Except::throw_exception ((const char *)"AxisG2",
                        (const char *) "Invalid User Scale (zero)",
                        (const char *)"AxisG2::UserRawRelPos");
        }
        if ( isnan(argin) ){
                        INFOLOG("AxisG2::UserRawRelPos(): Invalid Value (NaN)");
                        Tango::Except::throw_exception ((const char *)"AxisG2",
                        (const char *) "Invalid Value (NaN)",
                        (const char *)"AxisG2::UserRawRelPos");
        }


        double v = (argin)/(*attr_UserScale_read);
	__attribute__ ((unused)) bool ret = RawPos(v, true);

	
        // MYCODE-END
	/*----- PROTECTED REGION END -----*/	//	AxisG2::user_raw_rel_pos
}
//--------------------------------------------------------
/**
 *	Command get_p4e related method
 *	Description: Return position value (p) for given encoder (e),
 *               NO motion, ONLY calculation
 *
 *	@param argin 
 *	@returns 
 */
//--------------------------------------------------------
Tango::DevDouble AxisG2::get_p4e(Tango::DevDouble argin)
{
	Tango::DevDouble argout;
	DEBUG_STREAM << "AxisG2::get_p4e()  - " << device_name << endl;
	/*----- PROTECTED REGION ID(AxisG2::get_p4e) ENABLED START -----*/
	
	//	Add your own code

	if (axis) argout = axis->enc2position((double) argin);
	else argout = nan("");
	
	/*----- PROTECTED REGION END -----*/	//	AxisG2::get_p4e
	return argout;
}
//--------------------------------------------------------
/**
 *	Command get_e4p related method
 *	Description: Return encoder value (e) for given position (p),
 *               NO motion, ONLY calculation
 *
 *	@param argin 
 *	@returns 
 */
//--------------------------------------------------------
Tango::DevDouble AxisG2::get_e4p(Tango::DevDouble argin)
{
	Tango::DevDouble argout;
	DEBUG_STREAM << "AxisG2::get_e4p()  - " << device_name << endl;
	/*----- PROTECTED REGION ID(AxisG2::get_e4p) ENABLED START -----*/
	
	//	Add your own code

	if (axis) argout = axis->position2enc((double) argin);
	else argout = nan("");
	
	/*----- PROTECTED REGION END -----*/	//	AxisG2::get_e4p
	return argout;
}
//--------------------------------------------------------
/**
 *	Command get_u4p related method
 *	Description: Return user position value (u) for given position (p),
 *               NO motion, ONLY calculation
 *
 *	@param argin 
 *	@returns 
 */
//--------------------------------------------------------
Tango::DevDouble AxisG2::get_u4p(Tango::DevDouble argin)
{
	Tango::DevDouble argout;
	DEBUG_STREAM << "AxisG2::get_u4p()  - " << device_name << endl;
	/*----- PROTECTED REGION ID(AxisG2::get_u4p) ENABLED START -----*/
	
	//	Add your own code
	double upos = argin;

	if ( lib_func_ok ) {
		upos = DirectFunc(upos, userDirectFuncParams);
	};

        upos = (*attr_UserScale_read) * upos + (*attr_UserOffset_read);

	argout = upos;

	#ifdef _DBG_AXISFUNCS_PRECISION
		cout << "--------------------- " << __func__ << " ---------------------" << endl;
		printf("p=%20.14f [] -->> u=%20.14f[rad]/%20.14f[*]\n", argin, argout, (argout/M_PI*180.0));
	#endif
	
	/*----- PROTECTED REGION END -----*/	//	AxisG2::get_u4p
	return argout;
}
//--------------------------------------------------------
/**
 *	Command get_p4u related method
 *	Description: Return position value (p) for given user position (u),
 *               NO motion, ONLY calculation
 *
 *	@param argin 
 *	@returns 
 */
//--------------------------------------------------------
Tango::DevDouble AxisG2::get_p4u(Tango::DevDouble argin)
{
	Tango::DevDouble argout;
	DEBUG_STREAM << "AxisG2::get_p4u()  - " << device_name << endl;
	/*----- PROTECTED REGION ID(AxisG2::get_p4u) ENABLED START -----*/
	
	//	Add your own code
	double v = nan("");

	if ( *attr_UserScale_read != 0) v = (argin - (*attr_UserOffset_read))/(*attr_UserScale_read);

        if ( lib_func_ok ) {
                v = InverseFunc(v, userInverseFuncParams);
        };

	argout = v;
	
	#ifdef _DBG_AXISFUNCS_PRECISION
		cout << "--------------------- " << __func__ << " ---------------------" << endl;
		printf("u=%20.14f[rad]/%20.14f[*] -->> p=%20.14f []\n", argin, (argin/M_PI*180.0), argout);
	#endif
	/*----- PROTECTED REGION END -----*/	//	AxisG2::get_p4u
	return argout;
}
//--------------------------------------------------------
/**
 *	Command get_u4e related method
 *	Description: Return user position value (u) for given encoder (e),
 *               NO motion, ONLY calculation
 *
 *	@param argin 
 *	@returns 
 */
//--------------------------------------------------------
Tango::DevDouble AxisG2::get_u4e(Tango::DevDouble argin)
{
	Tango::DevDouble argout;
	DEBUG_STREAM << "AxisG2::get_u4e()  - " << device_name << endl;
	/*----- PROTECTED REGION ID(AxisG2::get_u4e) ENABLED START -----*/
	
	//	Add your own code

	argout = get_u4p(get_p4e(argin));
	
	/*----- PROTECTED REGION END -----*/	//	AxisG2::get_u4e
	return argout;
}
//--------------------------------------------------------
/**
 *	Command get_e4u related method
 *	Description: Return encoder value (e) for given user position (u),
 *               NO motion, ONLY calculation
 *
 *	@param argin 
 *	@returns 
 */
//--------------------------------------------------------
Tango::DevDouble AxisG2::get_e4u(Tango::DevDouble argin)
{
	Tango::DevDouble argout;
	DEBUG_STREAM << "AxisG2::get_e4u()  - " << device_name << endl;
	/*----- PROTECTED REGION ID(AxisG2::get_e4u) ENABLED START -----*/
	
	//	Add your own code

	argout = get_e4p(get_p4u(argin));
	
	/*----- PROTECTED REGION END -----*/	//	AxisG2::get_e4u
	return argout;
}
//--------------------------------------------------------
/**
 *	Command StorePosition4Fake related method
 *	Description: Store actual position for subsequent FakeAxisInit
 *
 */
//--------------------------------------------------------
void AxisG2::store_position4_fake()
{
	DEBUG_STREAM << "AxisG2::StorePosition4Fake()  - " << device_name << endl;
	/*----- PROTECTED REGION ID(AxisG2::store_position4_fake) ENABLED START -----*/
	
	//	Add your own code

	#ifdef _FAKE_AXIS_INIT_
		if (fakeAxisInitEnable) {

			double value = attr_Position_read[0];
			{
				Tango::DbDatum _attr_prop("__value");
	        		_attr_prop << value;
	
	        		if ( !put_memorized_attribute("StoredPosition4Fake", _attr_prop) ){	
					INFOLOG("AxisG2::store_position4_fake(): Error in put new memorized value");
	                                Tango::Except::throw_exception (
	                                        (const char *)"AxisG2",
	                                        (const char *)"Error in put new memorized value",
	                                        (const char *)"AxisG2::store_position4_fake()");
				};
			}
	
			time_t rawtime;
		  	struct tm * timeinfo;
		  	char buffer [80];
		
		  	time (&rawtime);
		  	timeinfo = localtime (&rawtime);
		
		  	strftime (buffer,80,"%F %T ",timeinfo);
		
			string when(buffer);
			{
				Tango::DbDatum _attr_prop("__when");
			        _attr_prop << when;
			
			        if ( !put_memorized_attribute("StoredPosition4Fake", _attr_prop) ){	
							INFOLOG("AxisG2::store_position4_fake(): Error in put new memorized value");
			                                Tango::Except::throw_exception (
			                                        (const char *)"AxisG2",
			                                        (const char *)"Error in put new memorized value",
			                                        (const char *)"AxisG2::store_position4_fake()");
				}
			}

			{
				Tango::DbDatum _attr_prop("__used");
			
			        if ( !delete_memorized_attribute_property("StoredPosition4Fake", _attr_prop) ){	
							INFOLOG("AxisG2::store_position4_fake(): Error in put new memorized value");
			                                Tango::Except::throw_exception (
			                                        (const char *)"AxisG2",
			                                        (const char *)"Error in delete memorized value",
			                                        (const char *)"AxisG2::store_position4_fake()");
				}
			}
			
			attr_StoredPosition4Fake_read[0] = value;

		} else {
        		Tango::Except::throw_exception (
                		(const char *)"AxisG2",
                        	(const char *)"Error: not enabled function",
                        	(const char *)"AxisG2::store_position4_fake()"
			);
		}
	#else
        	Tango::Except::throw_exception (
                	(const char *)"AxisG2",
                        (const char *)"Error: not implemented function",
                        (const char *)"AxisG2::store_position4_fake()"
		);
	#endif
	
	/*----- PROTECTED REGION END -----*/	//	AxisG2::store_position4_fake
}
//--------------------------------------------------------
/**
 *	Command FakeAxisInit related method
 *	Description: Do (if enabled) a fake initialization
 *
 */
//--------------------------------------------------------
void AxisG2::fake_axis_init()
{
	DEBUG_STREAM << "AxisG2::FakeAxisInit()  - " << device_name << endl;
	/*----- PROTECTED REGION ID(AxisG2::fake_axis_init) ENABLED START -----*/
	
	//	Add your own code
//FAI
	#ifdef _FAKE_AXIS_INIT_
		if (fakeAxisInitEnable) {
			// MYCODE-START
			std::string obj("AxisG2::fake_axis_init()");
			prtlog(obj, "");
		
			std::stringstream es;
			es << "AxisG2::fake_axis_init(): " << device_name;
			INFOLOG(es.str());
		
			std::stringstream ss;
		        ss << __func__ << "()";
		        hist->push_end(ss.str());


			double value = attr_StoredPosition4Fake_read[0];
			double value_used = attr_StoredPosition4Fake_read[0];

		
        		if ( isnan(value) ) {
				INFOLOG("AxisG2::fake_axis_init(): No valid value (NaN) previously memorized");
				Tango::Except::throw_exception (
					(const char *)"AxisG2",
                        		(const char *)"Invalid Value (NaN)",
                        		(const char *)"AxisG2::FakeAxisInit()");
			}
		
			if ( !axis )	{
					INFOLOG("AxisG2::fake_axis_init(): Axis not created!");
					Tango::Except::throw_exception (
						(const char *)"AxisG2",
	                       			(const char *)"Axis not created!",
	                       			(const char *)"AxisG2::FakeAxisInit()");
			}

			switch (axis->etype()){
				case Encoder_ns::ENC_DIGITAL_ABSOLUTE:
				case Encoder_ns::ENC_ANALOG_ABSOLUTE:
					INFOLOG("AxisG2::fake_axis_init(): Absolute Encoder!");
					Tango::Except::throw_exception (
						(const char *)"AxisG2",
	                       			(const char *)"Absolute Encoder!",
	                       			(const char *)"AxisG2::FakeAxisInit()");
					break;
				case Encoder_ns::ENC_NO:
				case Encoder_ns::ENC_DIGITAL_INCREMENTAL:
				case Encoder_ns::ENC_DIGITAL_SEMIABSOLUTE:
				default:
					break;
			}
		
			if ( ct!=Controller_ns::CTRL_UP ) {
					INFOLOG("AxisG2::fake_axis_init(): lack of Controller comm");
					Tango::Except::throw_exception (
						(const char *)"AxisG2",
		               			(const char *)"Lack of Controller comm!",
		               			(const char *)"AxisG2::FakeAxisInit()");
			}

			if ( !*attr_IsMicrocodeOK_read ) {
					INFOLOG("AxisG2::fake_axis_init(): MicroCode NOT running!");
					Tango::Except::throw_exception (
						(const char *)"AxisG2",
                        			(const char *)"MicroCode NOT running!",
                        			(const char *)"AxisG2::FakeAxisInit()");
			}

			if (!_conf_flag) _conf_flag = AxisConf();
			axis->force_init(value);
		
			UpdateRelative("Position", value);
			double upos = value;
			if ( lib_func_ok ) {
				upos = DirectFunc(upos, userDirectFuncParams);
			};
			upos = (*attr_UserScale_read) * upos + (*attr_UserOffset_read);
			UpdateRelative("UserPosition", upos);

			//
			// Fake Axis Init DONE! : clear memorized value!:
			//
		
			value = nan("");
			attr_StoredPosition4Fake_read[0] = value;

			{
				Tango::DbDatum _attr_prop("__value");
	        		_attr_prop << value;
	
	        		if ( !put_memorized_attribute("StoredPosition4Fake", _attr_prop) ){	
					INFOLOG("AxisG2::fake_axis_init(): Error in put new memorized value");
	                                Tango::Except::throw_exception (
	                                        (const char *)"AxisG2",
	                                        (const char *)"Error in put new memorized value",
	                                        (const char *)"AxisG2::FakeAxisInit()");
				}
			}
	
			time_t rawtime;
		  	struct tm * timeinfo;
		  	char buffer [256];
		  	char buffer2 [256];
		
		  	time (&rawtime);
		  	timeinfo = localtime (&rawtime);
		
		  	strftime (buffer,256,"%F %T",timeinfo);
			snprintf(buffer2,256," Position used: %f",value_used);
		  	strncat (buffer,buffer2,256);
		
			string when(buffer);
			{
				Tango::DbDatum _attr_prop("__used");
			        _attr_prop << when;
			
			        if ( !put_memorized_attribute("StoredPosition4Fake", _attr_prop) ){	
							INFOLOG("AxisG2::fake_axis_init(): Error in put new memorized value");
			                                Tango::Except::throw_exception (
			                                        (const char *)"AxisG2",
			                                        (const char *)"Error in put new memorized value",
			                                        (const char *)"AxisG2::FakeAxisInit()");
				}
			}

			{
				Tango::DbDatum _attr_prop("__when");
			
			        if ( !delete_memorized_attribute_property("StoredPosition4Fake", _attr_prop) ){	
							INFOLOG("AxisG2::store_position4_fake(): Error in put new memorized value");
			                                Tango::Except::throw_exception (
			                                        (const char *)"AxisG2",
			                                        (const char *)"Error in delete memorized value",
			                                        (const char *)"AxisG2::store_position4_fake()");
				}
			}
	
			INFOLOG("AxisG2::fake_axis_init(): done");
			// MYCODE-END
		} else {
        		Tango::Except::throw_exception (
                		(const char *)"AxisG2",
                        	(const char *)"Error: not enabled function",
                        	(const char *)"AxisG2::fake_axis_init()"
			);
		}
	#else
        	Tango::Except::throw_exception (
                	(const char *)"AxisG2",
                        (const char *)"Error: not implemented function",
                        (const char *)"AxisG2::fake_axis_init()"
		);
	#endif
	/*----- PROTECTED REGION END -----*/	//	AxisG2::fake_axis_init
}
//--------------------------------------------------------
/**
 *	Method      : AxisG2::add_dynamic_commands()
 *	Description : Create the dynamic commands if any
 *                for specified device.
 */
//--------------------------------------------------------
void AxisG2::add_dynamic_commands()
{
	/*----- PROTECTED REGION ID(AxisG2::add_dynamic_commands) ENABLED START -----*/
	
	//	Add your own code to create and add dynamic commands if any
	
	/*----- PROTECTED REGION END -----*/	//	AxisG2::add_dynamic_commands
}

/*----- PROTECTED REGION ID(AxisG2::namespace_ending) ENABLED START -----*/

void AxisG2::UpdateRelative(string RelativeName, double value){

        Tango::WAttribute* w_att_ptr = get_wattr_by_name(RelativeName);
        if (w_att_ptr){
                //cout << "***** " << w_att_ptr->get_name() << endl;
                w_att_ptr->set_write_value(value);

                Tango::DbDatum _attr_prop("__value");
                _attr_prop << value;

                if ( !put_memorized_attribute(RelativeName, _attr_prop) ) {
                                INFOLOG("AxisG2::UpdateRelative(): Error in put new memorized value");
                                /****************************************************************
                                NON attivo il seguente throw in quanto perderei l'aggiornamento della
                                parte write di Position
                                Tango::Except::throw_exception (
                                        (const char *)"AxisG2",
                                        (const char *)"Error in put new memorized value",
                                        (const char *)"AxisG2::write_Position()");
                                ****************************************************************/
                }
        } else {
                cout << "***** NOT WAttr " << RelativeName << "!!!!" << endl;
        }
}

double AxisG2::Speed2UserSpeed(double speed, double pos){

	double uspeed = speed;
	double p[5];
	int i = 2;
	double t = 0.00001 * speed;

	if ( lib_func_ok ) {
		p[0] = DirectFunc(pos - 2*t, userDirectFuncParams);
		p[1] = DirectFunc(pos - t, userDirectFuncParams);
		p[2] = DirectFunc(pos, userDirectFuncParams);
		p[3] = DirectFunc(pos + t, userDirectFuncParams);
		p[4] = DirectFunc(pos + 2*t, userDirectFuncParams);


		double firstDer = (   4.0 / 3.0 * (p[i + 1] - p[i - 1]) / (2.0 * t)
               		     - 1.0 / 3.0 * (p[i + 2] - p[i - 2]) / (4.0 * t) );

		//cout << "p0= " << p0 << endl;
		//cout << "p1= " << p1 << endl;
		//cout << "p1-p0= " << p1-p0 << endl;
		uspeed *= firstDer;
	};

	uspeed = fabs((*attr_UserScale_read) * uspeed);
	return uspeed;
}

bool AxisG2::with_microcode(){
	switch (controller->controller()){
		default:
			return false;
                        break;
                case Controller_ns::Yams:
                 	#ifdef _WITH_YAMSDRV_
                        #endif
			return true;
                        break;
 //N5N5
                case Controller_ns::N5:
                        #ifdef _WITH_N5DRV_
				return controller->drv()->with_microcode();
                        #endif
			return false;
                        break;
	}
	return false;
}

bool AxisG2::check_lsstroke(double v, double d){
	bool b1 = true;
	bool b2 = true;
	double s;
	double hws;
	double r_min, f_min;

	v = fabs(v);
	d = fabs(d);
	hws = axis->get_ls_tolerance();
	
	#ifdef _DBG_CHECK_LSSTROKE
		cout << "v        =" << v << endl;
		cout << "d        =" << d << endl;
	#endif

	if (d == 0.0) return false;
	s = v*v/(2*d);

	r_min = fmin(rLSStroke, hws);
	f_min = fmin(fLSStroke, hws);

	if (r_min < 0) r_min = nan("");
	if (f_min < 0) f_min = nan("");
	
	#ifdef _DBG_CHECK_LSSTROKE
		cout << "hws      =" << hws << endl;
		cout << "s        =" << s << endl;
		cout << "rLSStroke=" << rLSStroke << endl;
		cout << "fLSStroke=" << fLSStroke << endl;
		cout << "r_min    =" << r_min << endl;
		cout << "f_min    =" << f_min << endl;
	#endif

	if ( !isnan(r_min) ){
		if ( s > r_min ) b1 = false; else b1 = true;
	}
	if ( !isnan(f_min) ){
		if ( s > f_min ) b2 = false; else b2 = true;
	}

	#ifdef _DBG_CHECK_LSSTROKE
		cout << "!! " << __func__ << " ret= " << (b1 && b2?"True":"False") << endl;
	#endif

	return b1 && b2;
}

bool AxisG2::check_lsstroke_oninit(){
	#ifdef _DBG_CHECK_LSSTROKE
		cout << "!! " << __func__ << " !!" << endl;
	#endif
	return true;
}


/*----- PROTECTED REGION END -----*/	//	AxisG2::namespace_ending
} //	namespace
