/*----- PROTECTED REGION ID(AxisG2.h) ENABLED START -----*/
//=============================================================================
//
// file :        AxisG2.h
//
// description : Include file for the AxisG2 class
//
// project :     Axis
//
// This file is part of Tango device class.
// 
// Tango is free software: you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation, either version 3 of the License, or
// (at your option) any later version.
// 
// Tango is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
// 
// You should have received a copy of the GNU General Public License
// along with Tango.  If not, see <http://www.gnu.org/licenses/>.
// 
// $Author: abrami $
//
//
//=============================================================================
//                This file is generated by POGO
//        (Program Obviously used to Generate tango Object)
//=============================================================================


#ifndef AxisG2_H
#define AxisG2_H

#include <tango.h>

// MYCODE-START
#include "Utils.h"
#include "Axis_th.h"
#include <math.h>
#include <values.h>
#include <algorithm>
#include "AxisG2BriefLog.h"

#ifdef HAVE_SAFETYMANAGER
#include <SafetyManager.h>
#endif

#define DSTATUSMAX 128

#define _IF_MAX 10

#include "libaxisfuncs.h"

#include "History.h"

// MYCODE-END


/*----- PROTECTED REGION END -----*/	//	AxisG2.h

/**
 *  AxisG2 class description:
 *    This class realizes the initialisation and positioning functionalities for a single axis.
 */

namespace AxisG2_ns
{
/*----- PROTECTED REGION ID(AxisG2::Additional Class Declarations) ENABLED START -----*/

//	Additional Class Declarations

/*----- PROTECTED REGION END -----*/	//	AxisG2::Additional Class Declarations

class AxisG2 : public TANGO_BASE_CLASS
{

/*----- PROTECTED REGION ID(AxisG2::Data Members) ENABLED START -----*/

//	Add your own data members

// MYCODE-START
private:
	Controller_ns::ControllerType_t controller_type;
	Controller_ns::Controller *controller;
	Controller_ns::ControllerState_t ct;
	Axis_ns::Axis_th *axis;
	Axis_ns::AxisFSM_t FSMst;
	Tango::DevState __prevstate;
	string _FSMMsg;
	
	Tango::DevState __state;
	string 		__status;
	string 		__prevstatus;

	bool _conf_flag;
	string _ALARMMsg;
	double _recreate_tmo;
	struct timeval _last_create;
	int _ctrl_up_dwn;
	int _ctrl_to_close;
	Controller_ns::ControllerState_t __prev_ctrl_state;

        typedef struct _stat {
		float  current;
                float  mean;
                float  min;
                float  max;
        } stat_t;
        stat_t  update_stat;
	stat_t  statepos_stat;

	stat_t  chk_diff_on_run_stat;

	std::vector<string> DST;

	omni_mutex lock1;

	Axis_ns::chk_enc_t _chk_enc;
	Tango::DevState _chk_enc_onErr;
        Tango::DevState __enc_err_state;
        string __enc_err_status;

	bool axis_init_at_first_fsm;

	bool encoderDirection_defined; //used only for digital encoder

	AxisG2BriefLog_ns::AxisG2BriefLog *bf;

        Controller_ns::N5Drv  *n5d;


	bool cached_with_microcode;

#ifdef FERMI2DB
        string host_rw;
        long port_rw;
#endif

	#ifdef HAVE_SAFETYMANAGER
	SafetyManager* safety_manger;
	int _delay_safety_manger;
	#endif

        #define _PRTTRUE_ 4
        int prtTrue; // from N to 0, if 0 does not print log/msg etc...

	string _il_last;
	long   _il_count;

        History_ns::history* hist;

/*------------------------------*/
// User Funcs related stuff:
protected:
	F00_funcptr_t DirectFunc;
	F00_funcptr_t InverseFunc;
	bool lib_func_ok;

private:
	void* lib_handle;
        const char *dlsym_error;

protected:
	Tango::DevShort *attr_IsInitialised_old;

// MYCODE-END

/*----- PROTECTED REGION END -----*/	//	AxisG2::Data Members

//	Device property data members
public:
	//	Driver:	URI or TANGO device name of the motion controller which drives this axis
	//  
	//  <table class=mytable>
	//  <tr><td>DriverType   			<td> values
	//  <tr><td>GALILDMC2xxx, Yams, DMC2xxxPiezo. BCS	 <td><I> Example: </I> <B>ehf/yams/02 </B>
	//  <tr><td>N5				<td> <I> Example: </I> <B>http://xx.xx.xx.xx</B>
	//  <tr><td>SIMUL				<td> <I> Unused: </I> set to string
	//  </table>
	string	driver;
	//	DriverType:	This property states which type of controller is ``Driver``
	//      <BR>Current defined types are:
	//  <table>
	//  <tr><td><b><i>GALILDMC2xxx</b></i>     <td>  ... for bare Galil DMC2xxx controller
	//  <tr><td><b><i>Yams</b></i>                        <td> ... for Yams controller
	//  <tr><td><b><i>DMC2xxxPiezo</b></i>      <td> ... for Piezo on DMC2xxx controller
	//  <tr><td><b><i>BCS</b></i>                          <td> ... for BCS controller (temporary for upgrading)
	//  <tr><td><b><i> N5</b></i>                             <td> ... for Nanotec N5 controller
	//  <tr><td><b><i> SIMUL</b></i>                      <td> ... for a simulated axis
	//  </table>
	string	driverType;
	//	Channel:	Identification of the Axis on the motion controller (Driver).
	//  <table class=mytable>
	//  <tr><td>DriverType   		<td> values
	//  <tr><td>GALILDMC2xxx, Yams, DMC2xxxPiezo <td> It may be from  <I><B>A to H</B></I> (Galil terminology)
	//  <tr><td>BCS, N5, SIMUL		<td> <i><b>unused</b></i>, set to N
	//  </table>
	string	channel;
	//	EncoderType:	Type of Encoder connected to the axis:
	//  
	//  <table class=mytable>
	//  <tr><td>value   		<td> encoder type			<td colspan=6> supporting driver
	//  <tr><td>		<td>				<td> GALILDMC2xxx <td> Yams <td> DMC2xxxPiezo <td> BCS <td> N5 <td> SIMUL
	//  <tr><td><B> 0 </B>		<td> <B><I> no encoder</B></I>	<td>&check;	<td>&check;	<td>&check;	<td>&times;	<td>&check;	<td>&check;
	//  <tr><td><B> 1 </B>		<td> <B><I> incremental </B></I>	<td>&check;	<td>&check;	<td>&times;	<td>&times;	<td>&check;	<td>&times;
	//  <tr><td><B> 2 </B>		<td> <B><I> absolute</B></I>		<td>&check;	<td>&check;	<td>&times;	<td>&check;	<td>&times;	<td>&times;
	//  <tr><td><B> 3 </B>		<td> <B><I> semi-absolute</B></I>	<td>&check;	<td>&check;	<td>&times;	<td>&times;	<td>&times;	<td>&times;
	//  <tr><td><B> 4 </B>		<td> <B><I>analogic absolute</B></I>	<td>&check;	<td>&check;	<td>&times;	<td>&times;	<td>&times;	<td>&times;
	//  </table>
	Tango::DevLong	encoderType;
	//	EncoderPrecision:	Minimum increment that encoder may deliver.
	//  For digital encoder the value is 1.
	Tango::DevDouble	encoderPrecision;
	//	EncoderMotorRatio:	Number of Encoder increments/pulses for 1 Motor step. 
	//  
	//  EncoderMotorRatio (EMR) and EncoderMotorOffset (EMO)
	//  translate from motor value/coordinates to encoder ones.
	//  
	//  When no encoder is available for the Axis, this parameter must be set to 1.
	//  
	//  <I>Formula:</I> 
	//  _ _ e = EMR * m + EMO
	//  _ _ e : encoder value
	//  _ _ m : motor value
	Tango::DevDouble	encoderMotorRatio;
	//	EncoderMotorOffset:	See EncoderMotorRatio property description.
	//  
	//  Usually set to 0.
	Tango::DevDouble	encoderMotorOffset;
	//	PositionEncoderRatio:	PositionEncoderRatio (PER) and PositionEncoderOffset (PEO)
	//  translate from encoder value/coordinates to position ones.
	//  
	//  <I>Formula:</I> 
	//  _ _ p = PER * e + PEO
	//  _ _ p : position value
	//  _ _ e : encoder value
	Tango::DevDouble	positionEncoderRatio;
	//	PositionEncoderOffset:	See PositionEncoderRatio property description.
	Tango::DevDouble	positionEncoderOffset;
	//	MotorSmoothing:	Currently unimplemented
	Tango::DevDouble	motorSmoothing;
	//	MotorDirection:	Set this property to match <B><I>positive</I></B> motor movement (+ value/step)
	//  and activation of <I>positive</I> hardware limit switch: <B><I>Forward Limit Switch, FLS</I></B>
	//  
	//  <table class=mytable>
	//  <tr><td>DriverType   		<td> values		<td> description
	//  <tr><td rowspan=2>GALILDMC2xxx, Yams	<td>  <B>-2.0</B> 	<td> <I>``direct versus``</I>
	//  <tr> 			 <td>  <B>-2.5</B> 	<td> <I>``reverse versus``</I>
	//  <tr><td>DMC2xxxPiezo		<td> leave to -2.0	<td> unused
	//  <tr><td>BCS			<td> leave to -2.0	<td> unused
	//  <tr><td  rowspan=4>N5		<td> <B>1.0</B> 	<td> <I>``Specifies Servo motor``</I>
	//  <tr>			<td>  <B>-1.0</B>	<td> <I>``Specifies Servo motor  with reversed polarity``</I>
	//  <tr>			 <td>  <B>-2.0</B>	<td> <I>``Specifies Step motor, direct versus``</I>
	//  <tr>			  <td> <B>-2.5</B> 	<td> <I>``Specifies Step motor, reverse versus``</I>
	//  <tr><td>DMC2xxxPiezo		<td>  leave to -2.0	<td> unused
	//  <tr><td>SIMUL			<td>  leave to -2.0	<td> unused
	//  </table>
	//  
	//  (1) See Galil command reference MT
	Tango::DevDouble	motorDirection;
	//	MotorBrakeExtraTMO:	Extra time after brake on/off operation (sec).
	//  
	//  If axis has brake, MotorBrakeExtraTMO control the time
	//  software waits (block) for the brake to be settled.
	//  
	//  <i><b> Only for Yams DriverType </b></i>
	Tango::DevDouble	motorBrakeExtraTMO;
	//	MotorRawBrakeONTMO:	With <B><I>Raw mode commands</B></I>:
	//  time (sec) after which the brake (if configured) is automatically activated.
	//  
	//  <i><b> Only for Yams DriverType </b></i>
	Tango::DevDouble	motorRawBrakeONTMO;
	//	EncoderDirection:	<B><I>For EncoderType = 1,2,3</B></I>
	//  configures the encoder type and direction
	//  
	//  <table class=mytable>
	//  <tr><td>DriverType   			<td> values		<td> description
	//  <tr><td rowspan=4>GALILDMC2xxx, Yams<br>(1)	<td>  <B>0</B> 	<td> <I>Normal quadrature</I>
	//  <tr> 			 	<td>  <B>1</B> 	<td> <I>Normal pulse and direction</I>
	//  <tr> 			 	<td>  <B>2</B> 	<td> <I>Reversed quadrature </I>
	//  <tr> 			 	<td>  <B>3</B> 	<td> <I>Reversed pulse and direction</I> 
	//  <tr><td>DMC2xxxPiezo			<td> leave to 0		<td> unused
	//  <tr><td>BCS				<td> leave to 0		<td> unused
	//  <tr><td>N5	<br>(2)			<td> <B> number </B> 	<td> <I>Specifies ENCODER_RESOLUTION</I>
	//  <tr><td>DMC2xxxPiezo			<td>  leave to 0		<td> unused
	//  <tr><td>SIMUL				<td>  leave to 0		<td> unused
	//  </table>
	//  
	//  <I>Nornally used values: 0 or 2</I>
	//  
	//  (1) See Galil commmand reference CE
	//  (2) See Nanotec N5 Manual (Object 2052/00)
	Tango::DevLong	encoderDirection;
	//	EncoderExtras:	<B><I>For EncoderType = 3</B></I>
	//  here there are more configuration data.
	//  
	//  For Senc Encoders (semi-absolute), there are 3 parameters:
	//  
	//  _ <B><I>param0</B></I> ___ start point for signature generation/check, allowed values: <B>FLS</B> or <B>RLS</B>
	//  _ <B><I>param1</B></I> ___ value of encoder resolution, <I>usually 5 or 0.5 um</I>
	//  _ <B><I>param2</B></I> ___ value of encoder pitch, <I>usually 20 um</I>
	//  
	//  <I>See</I> : <A href=http://www.acu-rite.com>Senc Encoders</A>
	vector<string>	encoderExtras;
	//	AxisForwardLimit:	Currently unimplemented
	Tango::DevLong	axisForwardLimit;
	//	AxisBackwardLimit:	Currently unimplemented
	Tango::DevLong	axisBackwardLimit;
	//	InitType:	Initialisation type of the axis.
	//  
	//  <hr>Possible values for DriveType <b>GALILDMC2xxx, Yams, DMC2xxxPiezo</b>: 
	//  
	//   _ <B> 0</B> __ : no initialisation <I>(at run time <B>DefinePosition</B> command needed)</I>
	//   _ <B> 1</B> __ : initialisation on <B>home switch</B> <I>(deprecated)</I>
	//   _ <B> 2</B> __ : initialisation on <B>backward limit</B> 
	//   _ <B> 4</B> __ : initialisation on <B>forward limit</B>
	//   _ <B> 7</B> __  : goto <B>backward limit</B> and then search encoder <B>reference mark in forward direction</B>
	//   _ <B> 8</B> __  : goto <B>forward limit</B> and then search encoder <B>reference mark in backward direction</B>
	//   _ <B> 9</B> __  : initialisation on <B>home switch in forward direction</B>
	//  _ <B>10</B>__: initialisation on <B>home switch in backward direction</B>
	//  _ <B>11</B>__: initialisation on <B>absolute encoder</B> <I>(i.e. analogic absolute)</I>
	//  _ <B>12</B>__: initialisation on <B>semi-absolute encoder, forward direction</B> <I>(i.e. Senc encoder)</I>
	//  _ <B>13</B>__: initialisation on <B>semi-absolute encoder, backward direction</B> <I>(i.e. Senc encoder)</I>
	//  _ <B>14</B>__: initialisation on <B>encoder reference mark, positive rotation</B> <I>(for rotation stages)</I>
	//  _ <B>15</B>__: initialisation on <B>encoder reference mark, negative rotation</B> <I>(for rotation stages)</I>
	//  
	//  For ``absolute encoders`` at the end of the initialisation, the actual axis value is kept from the encoder.
	//  For the other encoders/InitType at the end of the initialisation, the actual axis value is kept from property <B><I>InitPosition</B></I>.
	//  
	//  <hr>Possible values for DriveType <b>BCS</b>:
	//  
	//   _ <B> 0</B> __ : no initialisation <I>(at run time <B>DefinePosition</B> command needed)</I>
	//  
	//  <hr>Possible values for DriveType <b>N5</b>:
	//  
	//   _ <B> 16</B> __ : initialisation on <B> CIA402 backward limit</B> 
	//   _ <B> 17</B> __ : initialisation on <B> CIA402 forward limit</B>
	//   _ <B> 18</B> __ : initialisation on <B> CIA402 backward limit</B> and then search encoder <B>reference mark in forward direction</B>
	//   _ <B> 19</B> __ : initialisation on <B> CIA402 forward limit</B> and then search encoder <B>reference mark in backward direction</B>
	//   _ <B> 20</B> __ : initialisation on <B> CAI402 encoder reference mark, positive rotation</B> <I>(for rotation stages)</I>
	//   _ <B> 21</B> __ : initialisation on <B> CIA402 encoder reference mark, negative rotation</B> <I>(for rotation stages)</I>
	//  
	//  <hr>Possible values for DriveType <b>SIMUL</b>:
	//  
	//   _ <B> 0</B> __ : no initialisation <I>(at run time <B>DefinePosition</B> command needed)</I>
	Tango::DevShort	initType;
	//	InitPosition:	Value used in the initialisation.
	//  <I>See</I> : InitType
	Tango::DevDouble	initPosition;
	//	MotoristMemo:	<I>Just a placeholder for comments/memos.</I>
	string	motoristMemo;
	//	FindSpeeds:	This property holds 2 parameters,
	//  which are the speeds (eng. units) used in the initialisation procedure:
	//  
	//  _ <B><I>param0</B></I> ___ coarse speed <I>(first phase of initialisation)</I>
	//  _ <B><I>param1</B></I> ___ fine speed <I>(second phase of initialisation)</I>
	vector<Tango::DevDouble>	findSpeeds;
	//	UserEncoderRatio:	Currently unimplemented
	Tango::DevDouble	userEncoderRatio;
	//	EncoderRippleOnStay:	<I><B>check_encoder() function parameter</B></I>
	//  Maximun encoder value displacement (absolute value in encoder units)
	//  before declaring the state set in the EncoderCheckOnError property.
	Tango::DevDouble	encoderRippleOnStay;
	//	EncoderCheckDelay:	<I><B>check_encoder() function parameter</B></I>
	//  Time delay (sec) before actually perform the encoder check.
	Tango::DevDouble	encoderCheckDelay;
	//	EncoderRippleOnRun:	<I><B>check_encoder() function parameter</B></I>
	//  While motor moving,
	//  if the difference between
	//   __ the motor value change (in encoder units)
	//  and
	//   __ the encoder value change (in encoder units)
	//  is greater than this property (in encoder units), then 
	//  the state is changed to that set in the EncoderCheckOnError property.
	Tango::DevDouble	encoderRippleOnRun;
	//	EncoderCheckOnError:	<I><B>check_encoder() function parameter</B></I>
	//  The state (status) value set when check_encoder() fails.
	string	encoderCheckOnError;
	//	CheckEncoderEnable:	<I><B>check_encoder() function parameter</B></I>
	//  Enable/disable the check_encoder() function.
	Tango::DevBoolean	checkEncoderEnable;
	//	EncoderCheckOnErrorStop:	<I><B>check_encoder() function parameter</B></I>
	//  Motion behavior when check_encoder() observe an error:
	//  if _ <B>true </B> __ then the motion stops
	//  if _ <B>false</B>__ then the motion keeps on
	Tango::DevBoolean	encoderCheckOnErrorStop;
	//	EncoderAnalogRatio:	EncoderAnalogRatio (EAR) and EncoderAnalogOffset (EAO)
	//  translate from analog read value to analog-encoder one.
	//  
	//  <I>Typically analog value is in Volt while analog-encoder is in milliVolt
	//  thus EAR=1000</I>
	//  
	//  <I>Formula:</I> 
	//  _ _ ae = EAR * av + EAO
	//  _ _ ae : encoder value
	//  _ _ av : analog value
	Tango::DevDouble	encoderAnalogRatio;
	//	EncoderAnalogOffset:	See EncoderAnalogRatio property description.
	//  
	//  Usually set to 0.
	Tango::DevDouble	encoderAnalogOffset;
	//	HWWriteEnable:	if _ <B>true </B> __ then any write/set operation is sent to the underling level and to the hardware
	//  if _ <B>false</B>__ then any write/set operation is blocked
	Tango::DevBoolean	hWWriteEnable;
	//	SafetyRules:	See <B><I>safetymanager</I></B> package.
	//  Mostly set <B>empty</B> (none).
	vector<string>	safetyRules;
	//	UserFuncLibrary:	Full path/name of the library containing user functions
	string	userFuncLibrary;
	//	UserDirectFuncName:	Name of the function to trasform Position into UserPosition
	string	userDirectFuncName;
	//	UserDirectFuncParams:	Array of parameters from x^0 param to x^N param
	vector<Tango::DevDouble>	userDirectFuncParams;
	//	UserInverseFuncName:	Name of the function to trasform Position into UserPosition
	string	userInverseFuncName;
	//	UserInverseFuncParams:	Array of parameters from x^0 param to x^N param
	vector<Tango::DevDouble>	userInverseFuncParams;
	//	RLSStroke:	
	Tango::DevDouble	rLSStroke;
	//	FLSStroke:	
	Tango::DevDouble	fLSStroke;
	//	FakeAxisInitEnable:	Enable FakeAxisInit
	Tango::DevBoolean	fakeAxisInitEnable;

	bool	mandatoryNotDefined;

//	Attribute data members
public:
	Tango::DevDouble	*attr_Position_read;
	Tango::DevBoolean	*attr_PositiveLimitSwitch_read;
	Tango::DevBoolean	*attr_NegativeLimitSwitch_read;
	Tango::DevBoolean	*attr_HomeSwitch_read;
	Tango::DevString	*attr_MotorStatus_read;
	Tango::DevDouble	*attr_EncoderPosition_read;
	Tango::DevLong	*attr_MotorPosition_read;
	Tango::DevDouble	*attr_UserPosition_read;
	Tango::DevDouble	*attr_UserScale_read;
	Tango::DevDouble	*attr_UserOffset_read;
	Tango::DevDouble	*attr_UserSpeed_read;
	Tango::DevDouble	*attr_Speed_read;
	Tango::DevDouble	*attr_Acceleration_read;
	Tango::DevDouble	*attr_Deceleration_read;
	Tango::DevDouble	*attr_MotionAccuracy_read;
	Tango::DevDouble	*attr_MotionPercent_read;
	Tango::DevDouble	*attr_MotionRetry_read;
	Tango::DevDouble	*attr_Backlash_read;
	Tango::DevDouble	*attr_BacklashDirection_read;
	Tango::DevDouble	*attr_Velocity_read;
	Tango::DevShort	*attr_IsInitialised_read;
	Tango::DevUShort	*attr_DeviceState_read;
	Tango::DevString	*attr_DeviceStatus_read;
	Tango::DevBoolean	*attr_IsMicrocodeOK_read;
	Tango::DevBoolean	*attr_CheckEncoder_read;
	Tango::DevBoolean	*attr_CheckEncoderHoldOn_read;
	Tango::DevDouble	*attr_StoredPosition4Fake_read;
	Tango::DevString	*attr_ExtStatus_read;
	Tango::DevString	*attr_History_read;

//	Constructors and destructors
public:
	/**
	 * Constructs a newly device object.
	 *
	 *	@param cl	Class.
	 *	@param s 	Device Name
	 */
	AxisG2(Tango::DeviceClass *cl,string &s);
	/**
	 * Constructs a newly device object.
	 *
	 *	@param cl	Class.
	 *	@param s 	Device Name
	 */
	AxisG2(Tango::DeviceClass *cl,const char *s);
	/**
	 * Constructs a newly device object.
	 *
	 *	@param cl	Class.
	 *	@param s 	Device name
	 *	@param d	Device description.
	 */
	AxisG2(Tango::DeviceClass *cl,const char *s,const char *d);
	/**
	 * The device object destructor.
	 */
	~AxisG2() {delete_device();};


//	Miscellaneous methods
public:
	/*
	 *	will be called at device destruction or at init command.
	 */
	void delete_device();
	/*
	 *	Initialize the device
	 */
	virtual void init_device();
	/*
	 *	Read the device properties from database
	 */
	void get_device_property();
	/*
	 *	Always executed method before execution command method.
	 */
	virtual void always_executed_hook();

	/*
	 *	Check if mandatory property has been set
	 */
	 void check_mandatory_property(Tango::DbDatum &class_prop, Tango::DbDatum &dev_prop);

//	Attribute methods
public:
	//--------------------------------------------------------
	/*
	 *	Method      : AxisG2::read_attr_hardware()
	 *	Description : Hardware acquisition for attributes.
	 */
	//--------------------------------------------------------
	virtual void read_attr_hardware(vector<long> &attr_list);
	//--------------------------------------------------------
	/*
	 *	Method      : AxisG2::write_attr_hardware()
	 *	Description : Hardware writing for attributes.
	 */
	//--------------------------------------------------------
	virtual void write_attr_hardware(vector<long> &attr_list);

/**
 *	Attribute Position related methods
 *	Description: Position of the axis (<I><B>plant coordinates/units</B></I>).
 *
 *	Data type:	Tango::DevDouble
 *	Attr type:	Scalar
 */
	virtual void read_Position(Tango::Attribute &attr);
	virtual void write_Position(Tango::WAttribute &attr);
	virtual bool is_Position_allowed(Tango::AttReqType type);
/**
 *	Attribute PositiveLimitSwitch related methods
 *	Description: Status of the forward/positive limit switch (<I><B>plant coordinates</B></I>).
 *
 *	Data type:	Tango::DevBoolean
 *	Attr type:	Scalar
 */
	virtual void read_PositiveLimitSwitch(Tango::Attribute &attr);
	virtual bool is_PositiveLimitSwitch_allowed(Tango::AttReqType type);
/**
 *	Attribute NegativeLimitSwitch related methods
 *	Description: Status of the backward/negative limit switch (<I><B>plant coordinates</B></I>).
 *
 *	Data type:	Tango::DevBoolean
 *	Attr type:	Scalar
 */
	virtual void read_NegativeLimitSwitch(Tango::Attribute &attr);
	virtual bool is_NegativeLimitSwitch_allowed(Tango::AttReqType type);
/**
 *	Attribute HomeSwitch related methods
 *	Description: Status of the home switch (<I><B>plant coordinates</B></I>).
 *
 *	Data type:	Tango::DevBoolean
 *	Attr type:	Scalar
 */
	virtual void read_HomeSwitch(Tango::Attribute &attr);
	virtual bool is_HomeSwitch_allowed(Tango::AttReqType type);
/**
 *	Attribute MotorStatus related methods
 *	Description: Status of the motor, <I>example: MOVIMG</I>.
 *
 *	Data type:	Tango::DevString
 *	Attr type:	Scalar
 */
	virtual void read_MotorStatus(Tango::Attribute &attr);
	virtual bool is_MotorStatus_allowed(Tango::AttReqType type);
/**
 *	Attribute EncoderPosition related methods
 *	Description: Position of the axis as reported by the encoder, in <B>encoder units</B> (<I><B>plant coordinates/units</B></I>).
 *
 *	Data type:	Tango::DevDouble
 *	Attr type:	Scalar
 */
	virtual void read_EncoderPosition(Tango::Attribute &attr);
	virtual bool is_EncoderPosition_allowed(Tango::AttReqType type);
/**
 *	Attribute MotorPosition related methods
 *	Description: Position of the axis as reported by the motor, in <B>motor steps</B> (<I><B>plant coordinates</B></I>).
 *
 *	Data type:	Tango::DevLong
 *	Attr type:	Scalar
 */
	virtual void read_MotorPosition(Tango::Attribute &attr);
	virtual void write_MotorPosition(Tango::WAttribute &attr);
	virtual bool is_MotorPosition_allowed(Tango::AttReqType type);
/**
 *	Attribute UserPosition related methods
 *	Description: Position of the axis (<I><B>user coordinates</B></I>).
 *
 *	Data type:	Tango::DevDouble
 *	Attr type:	Scalar
 */
	virtual void read_UserPosition(Tango::Attribute &attr);
	virtual void write_UserPosition(Tango::WAttribute &attr);
	virtual bool is_UserPosition_allowed(Tango::AttReqType type);
/**
 *	Attribute UserScale related methods
 *	Description: UserScale (US) and UserOffset (UO)
 *               translate position from <B><I>plant to user coordinates/units</I></B>.
 *               
 *               <I>Formula:</I> 
 *               _ _ up = US * pp + UO
 *               _ _ up : user position value
 *               _ _ pp : plant position value
 *
 *	Data type:	Tango::DevDouble
 *	Attr type:	Scalar
 */
	virtual void read_UserScale(Tango::Attribute &attr);
	virtual void write_UserScale(Tango::WAttribute &attr);
	virtual bool is_UserScale_allowed(Tango::AttReqType type);
/**
 *	Attribute UserOffset related methods
 *	Description: <I>See</I> : UserScale attribute description.
 *
 *	Data type:	Tango::DevDouble
 *	Attr type:	Scalar
 */
	virtual void read_UserOffset(Tango::Attribute &attr);
	virtual void write_UserOffset(Tango::WAttribute &attr);
	virtual bool is_UserOffset_allowed(Tango::AttReqType type);
/**
 *	Attribute UserSpeed related methods
 *	Description: Requested speed of the axis (<I><B>user coordinates/units</B></I>).
 *
 *	Data type:	Tango::DevDouble
 *	Attr type:	Scalar
 */
	virtual void read_UserSpeed(Tango::Attribute &attr);
	virtual void write_UserSpeed(Tango::WAttribute &attr);
	virtual bool is_UserSpeed_allowed(Tango::AttReqType type);
/**
 *	Attribute Speed related methods
 *	Description: Requested speed of the axis (<I><B>plant coordinates/units</B></I>).
 *
 *	Data type:	Tango::DevDouble
 *	Attr type:	Scalar
 */
	virtual void read_Speed(Tango::Attribute &attr);
	virtual void write_Speed(Tango::WAttribute &attr);
	virtual bool is_Speed_allowed(Tango::AttReqType type);
/**
 *	Attribute Acceleration related methods
 *	Description: Requested acceleration of the axis (<I><B>plant coordinates/units</B></I>).
 *
 *	Data type:	Tango::DevDouble
 *	Attr type:	Scalar
 */
	virtual void read_Acceleration(Tango::Attribute &attr);
	virtual void write_Acceleration(Tango::WAttribute &attr);
	virtual bool is_Acceleration_allowed(Tango::AttReqType type);
/**
 *	Attribute Deceleration related methods
 *	Description: Requested deceleration of the axis (<I><B>plant coordinates/units</B></I>).
 *
 *	Data type:	Tango::DevDouble
 *	Attr type:	Scalar
 */
	virtual void read_Deceleration(Tango::Attribute &attr);
	virtual void write_Deceleration(Tango::WAttribute &attr);
	virtual bool is_Deceleration_allowed(Tango::AttReqType type);
/**
 *	Attribute MotionAccuracy related methods
 *	Description: Minimun allowable displacement, i.e. maximum positioning error of the axis (<I><B>plant coordinates/units</B></I>).
 *
 *	Data type:	Tango::DevDouble
 *	Attr type:	Scalar
 */
	virtual void read_MotionAccuracy(Tango::Attribute &attr);
	virtual void write_MotionAccuracy(Tango::WAttribute &attr);
	virtual bool is_MotionAccuracy_allowed(Tango::AttReqType type);
/**
 *	Attribute MotionPercent related methods
 *	Description: Coefficient for successive approach positioning
 *
 *	Data type:	Tango::DevDouble
 *	Attr type:	Scalar
 */
	virtual void read_MotionPercent(Tango::Attribute &attr);
	virtual void write_MotionPercent(Tango::WAttribute &attr);
	virtual bool is_MotionPercent_allowed(Tango::AttReqType type);
/**
 *	Attribute MotionRetry related methods
 *	Description: Number of retries done by the controller closed control loop algorithm.
 *
 *	Data type:	Tango::DevDouble
 *	Attr type:	Scalar
 */
	virtual void read_MotionRetry(Tango::Attribute &attr);
	virtual void write_MotionRetry(Tango::WAttribute &attr);
	virtual bool is_MotionRetry_allowed(Tango::AttReqType type);
/**
 *	Attribute Backlash related methods
 *	Description: Value for the compensation for mechanical backlash by doing final move in the direction defined by BacklashDirection (<I><B>plant coordinates/units</B></I>).
 *
 *	Data type:	Tango::DevDouble
 *	Attr type:	Scalar
 */
	virtual void read_Backlash(Tango::Attribute &attr);
	virtual void write_Backlash(Tango::WAttribute &attr);
	virtual bool is_Backlash_allowed(Tango::AttReqType type);
/**
 *	Attribute BacklashDirection related methods
 *	Description: Direction of final move (for mechanical backlash compensation). 
 *               
 *               _ <B> 0</B> : no mechanical backlash compensation
 *               _ <B> 1</B> : final move direction = positive direction as defined in <I><B>plant coordinates/units</B></I>
 *               _<B>-1</B> : final move direction = negative direction as defined in <I><B>plant coordinates/units</B></I>
 *
 *	Data type:	Tango::DevDouble
 *	Attr type:	Scalar
 */
	virtual void read_BacklashDirection(Tango::Attribute &attr);
	virtual void write_BacklashDirection(Tango::WAttribute &attr);
	virtual bool is_BacklashDirection_allowed(Tango::AttReqType type);
/**
 *	Attribute Velocity related methods
 *	Description: Actual speed of the axis (<I><B>plant coordinates/units</B></I>),
 *               as retorted by the underneath controller.
 *
 *	Data type:	Tango::DevDouble
 *	Attr type:	Scalar
 */
	virtual void read_Velocity(Tango::Attribute &attr);
	virtual bool is_Velocity_allowed(Tango::AttReqType type);
/**
 *	Attribute IsInitialised related methods
 *	Description: Final state of the initialisation phase:
 *                
 *               _<B> 0 </B> : axis is not initialised
 *               _<B> 1 </B> : iaxis is initialized
 *
 *	Data type:	Tango::DevShort
 *	Attr type:	Scalar
 */
	virtual void read_IsInitialised(Tango::Attribute &attr);
	virtual bool is_IsInitialised_allowed(Tango::AttReqType type);
/**
 *	Attribute DeviceState related methods
 *	Description: Additional device state (numeric value).
 *               
 *               _<B> 0 </B> : UNKNOWN
 *               _<B> 1 </B> : ONLINE
 *               _<B> 2 </B> : OFFLINE
 *               _<B> 3 </B> : SERVICE
 *               _<B> 4 </B> : TEST
 *               
 *               <I>See</I> : DeviceStatus
 *
 *	Data type:	Tango::DevUShort
 *	Attr type:	Scalar
 */
	virtual void read_DeviceState(Tango::Attribute &attr);
	virtual void write_DeviceState(Tango::WAttribute &attr);
	virtual bool is_DeviceState_allowed(Tango::AttReqType type);
/**
 *	Attribute DeviceStatus related methods
 *	Description: Additional device status (string value).
 *               
 *               UNKNOWN, ONLINE, OFFLINE, SERVICE, TEST
 *
 *	Data type:	Tango::DevString
 *	Attr type:	Scalar
 */
	virtual void read_DeviceStatus(Tango::Attribute &attr);
	virtual bool is_DeviceStatus_allowed(Tango::AttReqType type);
/**
 *	Attribute IsMicrocodeOK related methods
 *	Description: <B>false</B> : micro code is not running on the underneath controller
 *                <B>true</B> : micro code is running on the underneath controller
 *
 *	Data type:	Tango::DevBoolean
 *	Attr type:	Scalar
 */
	virtual void read_IsMicrocodeOK(Tango::Attribute &attr);
	virtual bool is_IsMicrocodeOK_allowed(Tango::AttReqType type);
/**
 *	Attribute CheckEncoder related methods
 *	Description: <B>false</B> : deactivate the check controller functions.
 *                <B>true</B> : activate the check controller functions.
 *               This value may be modified only through the CheckEncoderEnable property or the relevant service function.
 *
 *	Data type:	Tango::DevBoolean
 *	Attr type:	Scalar
 */
	virtual void read_CheckEncoder(Tango::Attribute &attr);
	virtual bool is_CheckEncoder_allowed(Tango::AttReqType type);
/**
 *	Attribute CheckEncoderHoldOn related methods
 *	Description: <B>false</B> : the signalling status follows that of the check controller functions.
 *                <B>true</B> : the signalling status holds the first error/warning of the check controller functions.
 *
 *	Data type:	Tango::DevBoolean
 *	Attr type:	Scalar
 */
	virtual void read_CheckEncoderHoldOn(Tango::Attribute &attr);
	virtual void write_CheckEncoderHoldOn(Tango::WAttribute &attr);
	virtual bool is_CheckEncoderHoldOn_allowed(Tango::AttReqType type);
/**
 *	Attribute StoredPosition4Fake related methods
 *	Description: 
 *
 *	Data type:	Tango::DevDouble
 *	Attr type:	Scalar
 */
	virtual void read_StoredPosition4Fake(Tango::Attribute &attr);
	virtual bool is_StoredPosition4Fake_allowed(Tango::AttReqType type);
/**
 *	Attribute ExtStatus related methods
 *	Description: Inner states/values pertinent to all the functionalities.
 *
 *	Data type:	Tango::DevString
 *	Attr type:	Spectrum max = 100
 */
	virtual void read_ExtStatus(Tango::Attribute &attr);
	virtual bool is_ExtStatus_allowed(Tango::AttReqType type);
/**
 *	Attribute History related methods
 *	Description: 
 *
 *	Data type:	Tango::DevString
 *	Attr type:	Spectrum max = 2000
 */
	virtual void read_History(Tango::Attribute &attr);
	virtual bool is_History_allowed(Tango::AttReqType type);


	//--------------------------------------------------------
	/**
	 *	Method      : AxisG2::add_dynamic_attributes()
	 *	Description : Add dynamic attributes if any.
	 */
	//--------------------------------------------------------
	void add_dynamic_attributes();




//	Command related methods
public:
	/**
	 *	Command State related method
	 *	Description: This command gets the device state (stored in its <i>device_state</i> data member) and returns it to the caller.
	 *
	 *	@returns State Code
	 */
	virtual Tango::DevState dev_state();
	/**
	 *	Command Status related method
	 *	Description: This command gets the device status (stored in its <i>device_status</i> data member) and returns it to the caller.
	 *
	 *	@returns Status description
	 */
	virtual Tango::ConstDevString dev_status();
	/**
	 *	Command Forward related method
	 *	Description: Move the axis in the forward (positive) direction (<I><B>plant coordinates/units</B></I>).
	 *
	 */
	virtual void forward();
	virtual bool is_Forward_allowed(const CORBA::Any &any);
	/**
	 *	Command Stop related method
	 *	Description: Stop the actual movement.
	 *
	 */
	virtual void stop();
	virtual bool is_Stop_allowed(const CORBA::Any &any);
	/**
	 *	Command Backward related method
	 *	Description: Move the axis in the backward (negative) direction (<I><B>plant coordinates/units</B></I>).
	 *
	 */
	virtual void backward();
	virtual bool is_Backward_allowed(const CORBA::Any &any);
	/**
	 *	Command GoToRelativePosition related method
	 *	Description: Move the axis of the given displacement, relative positioning (<I><B>plant coordinates/units</B></I>).
	 *
	 *	@param argin Relative move in plant unit
	 */
	virtual void go_to_relative_position(Tango::DevDouble argin);
	virtual bool is_GoToRelativePosition_allowed(const CORBA::Any &any);
	/**
	 *	Command GoToPosition related method
	 *	Description: Move the axis of the given position, absolute positioning (<I><B>plant coordinates/units</B></I>).
	 *
	 *	@param argin Absolute position in plant units
	 */
	virtual void go_to_position(Tango::DevDouble argin);
	virtual bool is_GoToPosition_allowed(const CORBA::Any &any);
	/**
	 *	Command DefinePosition related method
	 *	Description: Set the value of the actual position (<I><B>plant coordinates/units</B></I>).
	 *
	 *	@param argin Actual position in plant units
	 *	@returns 
	 */
	virtual Tango::DevString define_position(Tango::DevDouble argin);
	virtual bool is_DefinePosition_allowed(const CORBA::Any &any);
	/**
	 *	Command GetMotionStatus related method
	 *	Description: Currently unimplemented
	 *
	 *	@returns 
	 */
	virtual Tango::DevLong get_motion_status();
	virtual bool is_GetMotionStatus_allowed(const CORBA::Any &any);
	/**
	 *	Command FindEdge related method
	 *	Description: Currently unimplemented
	 *
	 */
	virtual void find_edge();
	virtual bool is_FindEdge_allowed(const CORBA::Any &any);
	/**
	 *	Command FindIndex related method
	 *	Description: Currently unimplemented
	 *
	 */
	virtual void find_index();
	virtual bool is_FindIndex_allowed(const CORBA::Any &any);
	/**
	 *	Command FindHome related method
	 *	Description: Move to the home switch.
	 *
	 */
	virtual void find_home();
	virtual bool is_FindHome_allowed(const CORBA::Any &any);
	/**
	 *	Command GetErrorStatus related method
	 *	Description: Currently unimplemented
	 *
	 *	@returns 
	 */
	virtual Tango::DevLong get_error_status();
	virtual bool is_GetErrorStatus_allowed(const CORBA::Any &any);
	/**
	 *	Command DirectCmd related method
	 *	Description: Currently unimplemented
	 *
	 *	@param argin 
	 *	@returns 
	 */
	virtual Tango::DevString direct_cmd(Tango::DevString argin);
	virtual bool is_DirectCmd_allowed(const CORBA::Any &any);
	/**
	 *	Command AxisInit related method
	 *	Description: Start the axis initialisation.
	 *
	 */
	virtual void axis_init();
	virtual bool is_AxisInit_allowed(const CORBA::Any &any);
	/**
	 *	Command MotorOFF related method
	 *	Description: Switch off the power of the motor, and (if configured) do a brake on.
	 *
	 */
	virtual void motor_off();
	virtual bool is_MotorOFF_allowed(const CORBA::Any &any);
	/**
	 *	Command MotorON related method
	 *	Description: Switch on the power of the motor, and (if configured) do a brake off.
	 *
	 */
	virtual void motor_on();
	virtual bool is_MotorON_allowed(const CORBA::Any &any);
	/**
	 *	Command ReadHWConf related method
	 *	Description: Currently unimplemented
	 *
	 *	@returns 
	 */
	virtual Tango::DevVarStringArray *read_hwconf();
	virtual bool is_ReadHWConf_allowed(const CORBA::Any &any);
	/**
	 *	Command GetUserEncoderRatio related method
	 *	Description: Currently unimplemented
	 *
	 *	@returns 
	 */
	virtual Tango::DevDouble get_user_encoder_ratio();
	virtual bool is_GetUserEncoderRatio_allowed(const CORBA::Any &any);
	/**
	 *	Command Service related method
	 *	Description: Service command interface.
	 *
	 *	@param argin command
	 *	@returns 
	 */
	virtual Tango::DevString service(Tango::DevString argin);
	virtual bool is_Service_allowed(const CORBA::Any &any);
	/**
	 *	Command GetMotionHistory related method
	 *	Description: Return the last movements history.
	 *
	 *	@returns 
	 */
	virtual Tango::DevVarStringArray *get_motion_history();
	virtual bool is_GetMotionHistory_allowed(const CORBA::Any &any);
	/**
	 *	Command RestoreLastPosition related method
	 *	Description: May restore the last known position in case of loss of initialisation.
	 *               Axis must not have been moved ``externally``.
	 *
	 */
	virtual void restore_last_position();
	virtual bool is_RestoreLastPosition_allowed(const CORBA::Any &any);
	/**
	 *	Command AckCheckEnc related method
	 *	Description: Acknowledge the last check encoder alarm/state,
	 *               restore state if encoder alarm is not still active.
	 *
	 */
	virtual void ack_check_enc();
	virtual bool is_AckCheckEnc_allowed(const CORBA::Any &any);
	/**
	 *	Command RawAbsPos related method
	 *	Description: <B><I>Open loop movement: i.e. without encoder feedback</I></B>.
	 *               Move the axis of the given position, absolute positioning (<I><B>plant coordinates/units</B></I>).
	 *               Possible brake is hold off during the next MotorRawBrakeONTMO time.
	 *
	 *	@param argin Absolute move in plant unit
	 */
	virtual void raw_abs_pos(Tango::DevDouble argin);
	virtual bool is_RawAbsPos_allowed(const CORBA::Any &any);
	/**
	 *	Command RawRelPos related method
	 *	Description: <B><I>Open loop movement: i.e. without encoder feedback</I></B>.
	 *               Move the axis of the given displacement, relative positioning (<I><B>plant coordinates/units</B></I>).
	 *               Possible brake is hold off during the next MotorRawBrakeONTMO time.
	 *
	 *	@param argin Relative move in plant unit
	 */
	virtual void raw_rel_pos(Tango::DevDouble argin);
	virtual bool is_RawRelPos_allowed(const CORBA::Any &any);
	/**
	 *	Command UserRawAbsPos related method
	 *	Description: <B><I>Open loop movement: i.e. without encoder feedback</I></B>.
	 *               Absolute positioning (<I><B>user coordinates/units</B></I>).
	 *               <I>See</I> : RawAbsPos
	 *
	 *	@param argin Absolute move in user unit
	 */
	virtual void user_raw_abs_pos(Tango::DevDouble argin);
	virtual bool is_UserRawAbsPos_allowed(const CORBA::Any &any);
	/**
	 *	Command UserRawRelPos related method
	 *	Description: <B><I>Open loop movement: i.e. without encoder feedback</I></B>.
	 *               Relative positioning (<I><B>user coordinates/units</B></I>).
	 *               <I>See</I> : RawRelPos
	 *
	 *	@param argin Relative move in user unit
	 */
	virtual void user_raw_rel_pos(Tango::DevDouble argin);
	virtual bool is_UserRawRelPos_allowed(const CORBA::Any &any);
	/**
	 *	Command get_p4e related method
	 *	Description: Return position value (p) for given encoder (e),
	 *               NO motion, ONLY calculation
	 *
	 *	@param argin 
	 *	@returns 
	 */
	virtual Tango::DevDouble get_p4e(Tango::DevDouble argin);
	virtual bool is_get_p4e_allowed(const CORBA::Any &any);
	/**
	 *	Command get_e4p related method
	 *	Description: Return encoder value (e) for given position (p),
	 *               NO motion, ONLY calculation
	 *
	 *	@param argin 
	 *	@returns 
	 */
	virtual Tango::DevDouble get_e4p(Tango::DevDouble argin);
	virtual bool is_get_e4p_allowed(const CORBA::Any &any);
	/**
	 *	Command get_u4p related method
	 *	Description: Return user position value (u) for given position (p),
	 *               NO motion, ONLY calculation
	 *
	 *	@param argin 
	 *	@returns 
	 */
	virtual Tango::DevDouble get_u4p(Tango::DevDouble argin);
	virtual bool is_get_u4p_allowed(const CORBA::Any &any);
	/**
	 *	Command get_p4u related method
	 *	Description: Return position value (p) for given user position (u),
	 *               NO motion, ONLY calculation
	 *
	 *	@param argin 
	 *	@returns 
	 */
	virtual Tango::DevDouble get_p4u(Tango::DevDouble argin);
	virtual bool is_get_p4u_allowed(const CORBA::Any &any);
	/**
	 *	Command get_u4e related method
	 *	Description: Return user position value (u) for given encoder (e),
	 *               NO motion, ONLY calculation
	 *
	 *	@param argin 
	 *	@returns 
	 */
	virtual Tango::DevDouble get_u4e(Tango::DevDouble argin);
	virtual bool is_get_u4e_allowed(const CORBA::Any &any);
	/**
	 *	Command get_e4u related method
	 *	Description: Return encoder value (e) for given user position (u),
	 *               NO motion, ONLY calculation
	 *
	 *	@param argin 
	 *	@returns 
	 */
	virtual Tango::DevDouble get_e4u(Tango::DevDouble argin);
	virtual bool is_get_e4u_allowed(const CORBA::Any &any);
	/**
	 *	Command StorePosition4Fake related method
	 *	Description: Store actual position for subsequent FakeAxisInit
	 *
	 */
	virtual void store_position4_fake();
	virtual bool is_StorePosition4Fake_allowed(const CORBA::Any &any);
	/**
	 *	Command FakeAxisInit related method
	 *	Description: Do (if enabled) a fake initialization
	 *
	 */
	virtual void fake_axis_init();
	virtual bool is_FakeAxisInit_allowed(const CORBA::Any &any);


	//--------------------------------------------------------
	/**
	 *	Method      : AxisG2::add_dynamic_commands()
	 *	Description : Add dynamic commands if any.
	 */
	//--------------------------------------------------------
	void add_dynamic_commands();

/*----- PROTECTED REGION ID(AxisG2::Additional Method prototypes) ENABLED START -----*/

//	Additional Method prototypes

	// MYCODE-START
public:
	bool AxisCreate(bool withtmo);
	bool AxisConf();

        void ExtStatus(Tango::DevString *extstatusattr, int *riga, string msg);
	bool read_memorized_attribute(string attr_name, Tango::DbDatum & dbdatum);
	bool read_memorized_attribute(string attr_name, string attr_prop_name, Tango::DbDatum & dbdatum);
	bool put_memorized_attribute(string attr_name, Tango::DbDatum dbdatum);
	bool delete_memorized_attribute_property(string attr_name, Tango::DbDatum dbdatum);
	bool sethw_MotionAccuracy(double v);
	bool sethw_MotionPercent(double v);
	bool sethw_Backlash(double v);
	bool sethw_BacklashDirection(double v);
	bool sethw_MotionRetry(double v);
	bool check_MotionAccuracy(double v);
	bool check_Backlash(double v);

	bool configSencEnc(vector<string>  ee);

	void AxisStatePosition();	// CENTRAL FUNCTION

	Tango::DevState string2state(std::string state_str);

	bool RawPos(double v, bool rel);

        void UpdateRelative(string RelativeName, double value);

	double Speed2UserSpeed(double speed, double pos);

	bool with_microcode();

	bool check_lsstroke(double v, double d);
	bool check_lsstroke_oninit();

//SERVICE
        Tango::DevString _service(Tango::DevString argin);

	Tango::WAttribute* get_wattr_by_name(string att_name);

	Tango::Attribute* get_attr_by_name(string att_name);
	Tango::Attribute &rget_attr_by_name(string att_name);

	void INFOLOG(string x);
	void INFOLOG(bool once, string x);

	bool AInit() {if (axis != NULL) return axis->isinit(); else return false; };

	// MYCODE-END

/*----- PROTECTED REGION END -----*/	//	AxisG2::Additional Method prototypes
};

/*----- PROTECTED REGION ID(AxisG2::Additional Classes Definitions) ENABLED START -----*/

//	Additional Classes Definitions

/*----- PROTECTED REGION END -----*/	//	AxisG2::Additional Classes Definitions

}	//	End of namespace

#endif   //	AxisG2_H
