/*----- PROTECTED REGION ID(AxisG2Class.cpp) ENABLED START -----*/
__attribute__ ((unused)) static const char *__submodules__ = SUBMODULES;
//=============================================================================
//
// file :        AxisG2Class.cpp
//
// description : C++ source for the AxisG2Class.
//               A singleton class derived from DeviceClass.
//               It implements the command and attribute list
//               and all properties and methods required
//               by the AxisG2 once per process.
//
// project :     Axis
//
// This file is part of Tango device class.
// 
// Tango is free software: you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation, either version 3 of the License, or
// (at your option) any later version.
// 
// Tango is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
// 
// You should have received a copy of the GNU General Public License
// along with Tango.  If not, see <http://www.gnu.org/licenses/>.
// 
// $Author: abrami $
//
//
//=============================================================================
//                This file is generated by POGO
//        (Program Obviously used to Generate tango Object)
//=============================================================================


#include <AxisG2Class.h>

/*----- PROTECTED REGION END -----*/	//	AxisG2Class.cpp

//-------------------------------------------------------------------
/**
 *	Create AxisG2Class singleton and
 *	return it in a C function for Python usage
 */
//-------------------------------------------------------------------
extern "C" {
#ifdef _TG_WINDOWS_

__declspec(dllexport)

#endif

	Tango::DeviceClass *_create_AxisG2_class(const char *name) {
		return AxisG2_ns::AxisG2Class::init(name);
	}
}

namespace AxisG2_ns
{
//===================================================================
//	Initialize pointer for singleton pattern
//===================================================================
AxisG2Class *AxisG2Class::_instance = NULL;

//--------------------------------------------------------
/**
 * method : 		AxisG2Class::AxisG2Class(string &s)
 * description : 	constructor for the AxisG2Class
 *
 * @param s	The class name
 */
//--------------------------------------------------------
AxisG2Class::AxisG2Class(string &s):Tango::DeviceClass(s)
{
	cout2 << "Entering AxisG2Class constructor" << endl;
	set_default_property();
	write_class_property();

	/*----- PROTECTED REGION ID(AxisG2Class::constructor) ENABLED START -----*/

        // version tag

        string Release(RELEASE);
        set_cvs_tag(Release);

        string Repository(REPO);
        set_cvs_location(Repository);

        doc_url = REPO;
	
	/*----- PROTECTED REGION END -----*/	//	AxisG2Class::constructor

	cout2 << "Leaving AxisG2Class constructor" << endl;
}

//--------------------------------------------------------
/**
 * method : 		AxisG2Class::~AxisG2Class()
 * description : 	destructor for the AxisG2Class
 */
//--------------------------------------------------------
AxisG2Class::~AxisG2Class()
{
	/*----- PROTECTED REGION ID(AxisG2Class::destructor) ENABLED START -----*/
	
	/*----- PROTECTED REGION END -----*/	//	AxisG2Class::destructor

	_instance = NULL;
}


//--------------------------------------------------------
/**
 * method : 		AxisG2Class::init
 * description : 	Create the object if not already done.
 *                  Otherwise, just return a pointer to the object
 *
 * @param	name	The class name
 */
//--------------------------------------------------------
AxisG2Class *AxisG2Class::init(const char *name)
{
	if (_instance == NULL)
	{
		try
		{
			string s(name);
			_instance = new AxisG2Class(s);
		}
		catch (bad_alloc &)
		{
			throw;
		}
	}
	return _instance;
}

//--------------------------------------------------------
/**
 * method : 		AxisG2Class::instance
 * description : 	Check if object already created,
 *                  and return a pointer to the object
 */
//--------------------------------------------------------
AxisG2Class *AxisG2Class::instance()
{
	if (_instance == NULL)
	{
		cerr << "Class is not initialised !!" << endl;
		exit(-1);
	}
	return _instance;
}



//===================================================================
//	Command execution method calls
//===================================================================
//--------------------------------------------------------
/**
 * method : 		ForwardClass::execute()
 * description : 	method to trigger the execution of the command.
 *
 * @param	device	The device on which the command must be executed
 * @param	in_any	The command input data
 *
 *	returns The command output data (packed in the Any object)
 */
//--------------------------------------------------------
CORBA::Any *ForwardClass::execute(Tango::DeviceImpl *device, TANGO_UNUSED(const CORBA::Any &in_any))
{
	cout2 << "ForwardClass::execute(): arrived" << endl;
	((static_cast<AxisG2 *>(device))->forward());
	return new CORBA::Any();
}

//--------------------------------------------------------
/**
 * method : 		StopClass::execute()
 * description : 	method to trigger the execution of the command.
 *
 * @param	device	The device on which the command must be executed
 * @param	in_any	The command input data
 *
 *	returns The command output data (packed in the Any object)
 */
//--------------------------------------------------------
CORBA::Any *StopClass::execute(Tango::DeviceImpl *device, TANGO_UNUSED(const CORBA::Any &in_any))
{
	cout2 << "StopClass::execute(): arrived" << endl;
	((static_cast<AxisG2 *>(device))->stop());
	return new CORBA::Any();
}

//--------------------------------------------------------
/**
 * method : 		BackwardClass::execute()
 * description : 	method to trigger the execution of the command.
 *
 * @param	device	The device on which the command must be executed
 * @param	in_any	The command input data
 *
 *	returns The command output data (packed in the Any object)
 */
//--------------------------------------------------------
CORBA::Any *BackwardClass::execute(Tango::DeviceImpl *device, TANGO_UNUSED(const CORBA::Any &in_any))
{
	cout2 << "BackwardClass::execute(): arrived" << endl;
	((static_cast<AxisG2 *>(device))->backward());
	return new CORBA::Any();
}

//--------------------------------------------------------
/**
 * method : 		GoToRelativePositionClass::execute()
 * description : 	method to trigger the execution of the command.
 *
 * @param	device	The device on which the command must be executed
 * @param	in_any	The command input data
 *
 *	returns The command output data (packed in the Any object)
 */
//--------------------------------------------------------
CORBA::Any *GoToRelativePositionClass::execute(Tango::DeviceImpl *device, const CORBA::Any &in_any)
{
	cout2 << "GoToRelativePositionClass::execute(): arrived" << endl;
	Tango::DevDouble argin;
	extract(in_any, argin);
	((static_cast<AxisG2 *>(device))->go_to_relative_position(argin));
	return new CORBA::Any();
}

//--------------------------------------------------------
/**
 * method : 		GoToPositionClass::execute()
 * description : 	method to trigger the execution of the command.
 *
 * @param	device	The device on which the command must be executed
 * @param	in_any	The command input data
 *
 *	returns The command output data (packed in the Any object)
 */
//--------------------------------------------------------
CORBA::Any *GoToPositionClass::execute(Tango::DeviceImpl *device, const CORBA::Any &in_any)
{
	cout2 << "GoToPositionClass::execute(): arrived" << endl;
	Tango::DevDouble argin;
	extract(in_any, argin);
	((static_cast<AxisG2 *>(device))->go_to_position(argin));
	return new CORBA::Any();
}

//--------------------------------------------------------
/**
 * method : 		DefinePositionClass::execute()
 * description : 	method to trigger the execution of the command.
 *
 * @param	device	The device on which the command must be executed
 * @param	in_any	The command input data
 *
 *	returns The command output data (packed in the Any object)
 */
//--------------------------------------------------------
CORBA::Any *DefinePositionClass::execute(Tango::DeviceImpl *device, const CORBA::Any &in_any)
{
	cout2 << "DefinePositionClass::execute(): arrived" << endl;
	Tango::DevDouble argin;
	extract(in_any, argin);
	return insert((static_cast<AxisG2 *>(device))->define_position(argin));
}

//--------------------------------------------------------
/**
 * method : 		GetMotionStatusClass::execute()
 * description : 	method to trigger the execution of the command.
 *
 * @param	device	The device on which the command must be executed
 * @param	in_any	The command input data
 *
 *	returns The command output data (packed in the Any object)
 */
//--------------------------------------------------------
CORBA::Any *GetMotionStatusClass::execute(Tango::DeviceImpl *device, TANGO_UNUSED(const CORBA::Any &in_any))
{
	cout2 << "GetMotionStatusClass::execute(): arrived" << endl;
	return insert((static_cast<AxisG2 *>(device))->get_motion_status());
}

//--------------------------------------------------------
/**
 * method : 		FindEdgeClass::execute()
 * description : 	method to trigger the execution of the command.
 *
 * @param	device	The device on which the command must be executed
 * @param	in_any	The command input data
 *
 *	returns The command output data (packed in the Any object)
 */
//--------------------------------------------------------
CORBA::Any *FindEdgeClass::execute(Tango::DeviceImpl *device, TANGO_UNUSED(const CORBA::Any &in_any))
{
	cout2 << "FindEdgeClass::execute(): arrived" << endl;
	((static_cast<AxisG2 *>(device))->find_edge());
	return new CORBA::Any();
}

//--------------------------------------------------------
/**
 * method : 		FindIndexClass::execute()
 * description : 	method to trigger the execution of the command.
 *
 * @param	device	The device on which the command must be executed
 * @param	in_any	The command input data
 *
 *	returns The command output data (packed in the Any object)
 */
//--------------------------------------------------------
CORBA::Any *FindIndexClass::execute(Tango::DeviceImpl *device, TANGO_UNUSED(const CORBA::Any &in_any))
{
	cout2 << "FindIndexClass::execute(): arrived" << endl;
	((static_cast<AxisG2 *>(device))->find_index());
	return new CORBA::Any();
}

//--------------------------------------------------------
/**
 * method : 		FindHomeClass::execute()
 * description : 	method to trigger the execution of the command.
 *
 * @param	device	The device on which the command must be executed
 * @param	in_any	The command input data
 *
 *	returns The command output data (packed in the Any object)
 */
//--------------------------------------------------------
CORBA::Any *FindHomeClass::execute(Tango::DeviceImpl *device, TANGO_UNUSED(const CORBA::Any &in_any))
{
	cout2 << "FindHomeClass::execute(): arrived" << endl;
	((static_cast<AxisG2 *>(device))->find_home());
	return new CORBA::Any();
}

//--------------------------------------------------------
/**
 * method : 		GetErrorStatusClass::execute()
 * description : 	method to trigger the execution of the command.
 *
 * @param	device	The device on which the command must be executed
 * @param	in_any	The command input data
 *
 *	returns The command output data (packed in the Any object)
 */
//--------------------------------------------------------
CORBA::Any *GetErrorStatusClass::execute(Tango::DeviceImpl *device, TANGO_UNUSED(const CORBA::Any &in_any))
{
	cout2 << "GetErrorStatusClass::execute(): arrived" << endl;
	return insert((static_cast<AxisG2 *>(device))->get_error_status());
}

//--------------------------------------------------------
/**
 * method : 		DirectCmdClass::execute()
 * description : 	method to trigger the execution of the command.
 *
 * @param	device	The device on which the command must be executed
 * @param	in_any	The command input data
 *
 *	returns The command output data (packed in the Any object)
 */
//--------------------------------------------------------
CORBA::Any *DirectCmdClass::execute(Tango::DeviceImpl *device, const CORBA::Any &in_any)
{
	cout2 << "DirectCmdClass::execute(): arrived" << endl;
	Tango::DevString argin;
	extract(in_any, argin);
	return insert((static_cast<AxisG2 *>(device))->direct_cmd(argin));
}

//--------------------------------------------------------
/**
 * method : 		AxisInitClass::execute()
 * description : 	method to trigger the execution of the command.
 *
 * @param	device	The device on which the command must be executed
 * @param	in_any	The command input data
 *
 *	returns The command output data (packed in the Any object)
 */
//--------------------------------------------------------
CORBA::Any *AxisInitClass::execute(Tango::DeviceImpl *device, TANGO_UNUSED(const CORBA::Any &in_any))
{
	cout2 << "AxisInitClass::execute(): arrived" << endl;
	((static_cast<AxisG2 *>(device))->axis_init());
	return new CORBA::Any();
}

//--------------------------------------------------------
/**
 * method : 		MotorOFFClass::execute()
 * description : 	method to trigger the execution of the command.
 *
 * @param	device	The device on which the command must be executed
 * @param	in_any	The command input data
 *
 *	returns The command output data (packed in the Any object)
 */
//--------------------------------------------------------
CORBA::Any *MotorOFFClass::execute(Tango::DeviceImpl *device, TANGO_UNUSED(const CORBA::Any &in_any))
{
	cout2 << "MotorOFFClass::execute(): arrived" << endl;
	((static_cast<AxisG2 *>(device))->motor_off());
	return new CORBA::Any();
}

//--------------------------------------------------------
/**
 * method : 		MotorONClass::execute()
 * description : 	method to trigger the execution of the command.
 *
 * @param	device	The device on which the command must be executed
 * @param	in_any	The command input data
 *
 *	returns The command output data (packed in the Any object)
 */
//--------------------------------------------------------
CORBA::Any *MotorONClass::execute(Tango::DeviceImpl *device, TANGO_UNUSED(const CORBA::Any &in_any))
{
	cout2 << "MotorONClass::execute(): arrived" << endl;
	((static_cast<AxisG2 *>(device))->motor_on());
	return new CORBA::Any();
}

//--------------------------------------------------------
/**
 * method : 		ReadHWConfClass::execute()
 * description : 	method to trigger the execution of the command.
 *
 * @param	device	The device on which the command must be executed
 * @param	in_any	The command input data
 *
 *	returns The command output data (packed in the Any object)
 */
//--------------------------------------------------------
CORBA::Any *ReadHWConfClass::execute(Tango::DeviceImpl *device, TANGO_UNUSED(const CORBA::Any &in_any))
{
	cout2 << "ReadHWConfClass::execute(): arrived" << endl;
	return insert((static_cast<AxisG2 *>(device))->read_hwconf());
}

//--------------------------------------------------------
/**
 * method : 		GetUserEncoderRatioClass::execute()
 * description : 	method to trigger the execution of the command.
 *
 * @param	device	The device on which the command must be executed
 * @param	in_any	The command input data
 *
 *	returns The command output data (packed in the Any object)
 */
//--------------------------------------------------------
CORBA::Any *GetUserEncoderRatioClass::execute(Tango::DeviceImpl *device, TANGO_UNUSED(const CORBA::Any &in_any))
{
	cout2 << "GetUserEncoderRatioClass::execute(): arrived" << endl;
	return insert((static_cast<AxisG2 *>(device))->get_user_encoder_ratio());
}

//--------------------------------------------------------
/**
 * method : 		ServiceClass::execute()
 * description : 	method to trigger the execution of the command.
 *
 * @param	device	The device on which the command must be executed
 * @param	in_any	The command input data
 *
 *	returns The command output data (packed in the Any object)
 */
//--------------------------------------------------------
CORBA::Any *ServiceClass::execute(Tango::DeviceImpl *device, const CORBA::Any &in_any)
{
	cout2 << "ServiceClass::execute(): arrived" << endl;
	Tango::DevString argin;
	extract(in_any, argin);
	return insert((static_cast<AxisG2 *>(device))->service(argin));
}

//--------------------------------------------------------
/**
 * method : 		GetMotionHistoryClass::execute()
 * description : 	method to trigger the execution of the command.
 *
 * @param	device	The device on which the command must be executed
 * @param	in_any	The command input data
 *
 *	returns The command output data (packed in the Any object)
 */
//--------------------------------------------------------
CORBA::Any *GetMotionHistoryClass::execute(Tango::DeviceImpl *device, TANGO_UNUSED(const CORBA::Any &in_any))
{
	cout2 << "GetMotionHistoryClass::execute(): arrived" << endl;
	return insert((static_cast<AxisG2 *>(device))->get_motion_history());
}

//--------------------------------------------------------
/**
 * method : 		RestoreLastPositionClass::execute()
 * description : 	method to trigger the execution of the command.
 *
 * @param	device	The device on which the command must be executed
 * @param	in_any	The command input data
 *
 *	returns The command output data (packed in the Any object)
 */
//--------------------------------------------------------
CORBA::Any *RestoreLastPositionClass::execute(Tango::DeviceImpl *device, TANGO_UNUSED(const CORBA::Any &in_any))
{
	cout2 << "RestoreLastPositionClass::execute(): arrived" << endl;
	((static_cast<AxisG2 *>(device))->restore_last_position());
	return new CORBA::Any();
}

//--------------------------------------------------------
/**
 * method : 		AckCheckEncClass::execute()
 * description : 	method to trigger the execution of the command.
 *
 * @param	device	The device on which the command must be executed
 * @param	in_any	The command input data
 *
 *	returns The command output data (packed in the Any object)
 */
//--------------------------------------------------------
CORBA::Any *AckCheckEncClass::execute(Tango::DeviceImpl *device, TANGO_UNUSED(const CORBA::Any &in_any))
{
	cout2 << "AckCheckEncClass::execute(): arrived" << endl;
	((static_cast<AxisG2 *>(device))->ack_check_enc());
	return new CORBA::Any();
}

//--------------------------------------------------------
/**
 * method : 		RawAbsPosClass::execute()
 * description : 	method to trigger the execution of the command.
 *
 * @param	device	The device on which the command must be executed
 * @param	in_any	The command input data
 *
 *	returns The command output data (packed in the Any object)
 */
//--------------------------------------------------------
CORBA::Any *RawAbsPosClass::execute(Tango::DeviceImpl *device, const CORBA::Any &in_any)
{
	cout2 << "RawAbsPosClass::execute(): arrived" << endl;
	Tango::DevDouble argin;
	extract(in_any, argin);
	((static_cast<AxisG2 *>(device))->raw_abs_pos(argin));
	return new CORBA::Any();
}

//--------------------------------------------------------
/**
 * method : 		RawRelPosClass::execute()
 * description : 	method to trigger the execution of the command.
 *
 * @param	device	The device on which the command must be executed
 * @param	in_any	The command input data
 *
 *	returns The command output data (packed in the Any object)
 */
//--------------------------------------------------------
CORBA::Any *RawRelPosClass::execute(Tango::DeviceImpl *device, const CORBA::Any &in_any)
{
	cout2 << "RawRelPosClass::execute(): arrived" << endl;
	Tango::DevDouble argin;
	extract(in_any, argin);
	((static_cast<AxisG2 *>(device))->raw_rel_pos(argin));
	return new CORBA::Any();
}

//--------------------------------------------------------
/**
 * method : 		UserRawAbsPosClass::execute()
 * description : 	method to trigger the execution of the command.
 *
 * @param	device	The device on which the command must be executed
 * @param	in_any	The command input data
 *
 *	returns The command output data (packed in the Any object)
 */
//--------------------------------------------------------
CORBA::Any *UserRawAbsPosClass::execute(Tango::DeviceImpl *device, const CORBA::Any &in_any)
{
	cout2 << "UserRawAbsPosClass::execute(): arrived" << endl;
	Tango::DevDouble argin;
	extract(in_any, argin);
	((static_cast<AxisG2 *>(device))->user_raw_abs_pos(argin));
	return new CORBA::Any();
}

//--------------------------------------------------------
/**
 * method : 		UserRawRelPosClass::execute()
 * description : 	method to trigger the execution of the command.
 *
 * @param	device	The device on which the command must be executed
 * @param	in_any	The command input data
 *
 *	returns The command output data (packed in the Any object)
 */
//--------------------------------------------------------
CORBA::Any *UserRawRelPosClass::execute(Tango::DeviceImpl *device, const CORBA::Any &in_any)
{
	cout2 << "UserRawRelPosClass::execute(): arrived" << endl;
	Tango::DevDouble argin;
	extract(in_any, argin);
	((static_cast<AxisG2 *>(device))->user_raw_rel_pos(argin));
	return new CORBA::Any();
}

//--------------------------------------------------------
/**
 * method : 		get_p4eClass::execute()
 * description : 	method to trigger the execution of the command.
 *
 * @param	device	The device on which the command must be executed
 * @param	in_any	The command input data
 *
 *	returns The command output data (packed in the Any object)
 */
//--------------------------------------------------------
CORBA::Any *get_p4eClass::execute(Tango::DeviceImpl *device, const CORBA::Any &in_any)
{
	cout2 << "get_p4eClass::execute(): arrived" << endl;
	Tango::DevDouble argin;
	extract(in_any, argin);
	return insert((static_cast<AxisG2 *>(device))->get_p4e(argin));
}

//--------------------------------------------------------
/**
 * method : 		get_e4pClass::execute()
 * description : 	method to trigger the execution of the command.
 *
 * @param	device	The device on which the command must be executed
 * @param	in_any	The command input data
 *
 *	returns The command output data (packed in the Any object)
 */
//--------------------------------------------------------
CORBA::Any *get_e4pClass::execute(Tango::DeviceImpl *device, const CORBA::Any &in_any)
{
	cout2 << "get_e4pClass::execute(): arrived" << endl;
	Tango::DevDouble argin;
	extract(in_any, argin);
	return insert((static_cast<AxisG2 *>(device))->get_e4p(argin));
}

//--------------------------------------------------------
/**
 * method : 		get_u4pClass::execute()
 * description : 	method to trigger the execution of the command.
 *
 * @param	device	The device on which the command must be executed
 * @param	in_any	The command input data
 *
 *	returns The command output data (packed in the Any object)
 */
//--------------------------------------------------------
CORBA::Any *get_u4pClass::execute(Tango::DeviceImpl *device, const CORBA::Any &in_any)
{
	cout2 << "get_u4pClass::execute(): arrived" << endl;
	Tango::DevDouble argin;
	extract(in_any, argin);
	return insert((static_cast<AxisG2 *>(device))->get_u4p(argin));
}

//--------------------------------------------------------
/**
 * method : 		get_p4uClass::execute()
 * description : 	method to trigger the execution of the command.
 *
 * @param	device	The device on which the command must be executed
 * @param	in_any	The command input data
 *
 *	returns The command output data (packed in the Any object)
 */
//--------------------------------------------------------
CORBA::Any *get_p4uClass::execute(Tango::DeviceImpl *device, const CORBA::Any &in_any)
{
	cout2 << "get_p4uClass::execute(): arrived" << endl;
	Tango::DevDouble argin;
	extract(in_any, argin);
	return insert((static_cast<AxisG2 *>(device))->get_p4u(argin));
}

//--------------------------------------------------------
/**
 * method : 		get_u4eClass::execute()
 * description : 	method to trigger the execution of the command.
 *
 * @param	device	The device on which the command must be executed
 * @param	in_any	The command input data
 *
 *	returns The command output data (packed in the Any object)
 */
//--------------------------------------------------------
CORBA::Any *get_u4eClass::execute(Tango::DeviceImpl *device, const CORBA::Any &in_any)
{
	cout2 << "get_u4eClass::execute(): arrived" << endl;
	Tango::DevDouble argin;
	extract(in_any, argin);
	return insert((static_cast<AxisG2 *>(device))->get_u4e(argin));
}

//--------------------------------------------------------
/**
 * method : 		get_e4uClass::execute()
 * description : 	method to trigger the execution of the command.
 *
 * @param	device	The device on which the command must be executed
 * @param	in_any	The command input data
 *
 *	returns The command output data (packed in the Any object)
 */
//--------------------------------------------------------
CORBA::Any *get_e4uClass::execute(Tango::DeviceImpl *device, const CORBA::Any &in_any)
{
	cout2 << "get_e4uClass::execute(): arrived" << endl;
	Tango::DevDouble argin;
	extract(in_any, argin);
	return insert((static_cast<AxisG2 *>(device))->get_e4u(argin));
}

//--------------------------------------------------------
/**
 * method : 		StorePosition4FakeClass::execute()
 * description : 	method to trigger the execution of the command.
 *
 * @param	device	The device on which the command must be executed
 * @param	in_any	The command input data
 *
 *	returns The command output data (packed in the Any object)
 */
//--------------------------------------------------------
CORBA::Any *StorePosition4FakeClass::execute(Tango::DeviceImpl *device, TANGO_UNUSED(const CORBA::Any &in_any))
{
	cout2 << "StorePosition4FakeClass::execute(): arrived" << endl;
	((static_cast<AxisG2 *>(device))->store_position4_fake());
	return new CORBA::Any();
}

//--------------------------------------------------------
/**
 * method : 		FakeAxisInitClass::execute()
 * description : 	method to trigger the execution of the command.
 *
 * @param	device	The device on which the command must be executed
 * @param	in_any	The command input data
 *
 *	returns The command output data (packed in the Any object)
 */
//--------------------------------------------------------
CORBA::Any *FakeAxisInitClass::execute(Tango::DeviceImpl *device, TANGO_UNUSED(const CORBA::Any &in_any))
{
	cout2 << "FakeAxisInitClass::execute(): arrived" << endl;
	((static_cast<AxisG2 *>(device))->fake_axis_init());
	return new CORBA::Any();
}


//===================================================================
//	Properties management
//===================================================================
//--------------------------------------------------------
/**
 *	Method      : AxisG2Class::get_class_property()
 *	Description : Get the class property for specified name.
 */
//--------------------------------------------------------
Tango::DbDatum AxisG2Class::get_class_property(string &prop_name)
{
	for (unsigned int i=0 ; i<cl_prop.size() ; i++)
		if (cl_prop[i].name == prop_name)
			return cl_prop[i];
	//	if not found, returns  an empty DbDatum
	return Tango::DbDatum(prop_name);
}

//--------------------------------------------------------
/**
 *	Method      : AxisG2Class::get_default_device_property()
 *	Description : Return the default value for device property.
 */
//--------------------------------------------------------
Tango::DbDatum AxisG2Class::get_default_device_property(string &prop_name)
{
	for (unsigned int i=0 ; i<dev_def_prop.size() ; i++)
		if (dev_def_prop[i].name == prop_name)
			return dev_def_prop[i];
	//	if not found, return  an empty DbDatum
	return Tango::DbDatum(prop_name);
}

//--------------------------------------------------------
/**
 *	Method      : AxisG2Class::get_default_class_property()
 *	Description : Return the default value for class property.
 */
//--------------------------------------------------------
Tango::DbDatum AxisG2Class::get_default_class_property(string &prop_name)
{
	for (unsigned int i=0 ; i<cl_def_prop.size() ; i++)
		if (cl_def_prop[i].name == prop_name)
			return cl_def_prop[i];
	//	if not found, return  an empty DbDatum
	return Tango::DbDatum(prop_name);
}


//--------------------------------------------------------
/**
 *	Method      : AxisG2Class::set_default_property()
 *	Description : Set default property (class and device) for wizard.
 *                For each property, add to wizard property name and description.
 *                If default value has been set, add it to wizard property and
 *                store it in a DbDatum.
 */
//--------------------------------------------------------
void AxisG2Class::set_default_property()
{
	string	prop_name;
	string	prop_desc;
	string	prop_def;
	vector<string>	vect_data;

	//	Set Default Class Properties

	//	Set Default device Properties
	prop_name = "Driver";
	prop_desc = "URI or TANGO device name of the motion controller which drives this axis\n\n<table class=mytable>\n<tr><td>DriverType   			<td> values\n<tr><td>GALILDMC2xxx, Yams, DMC2xxxPiezo. BCS	 <td><I> Example: </I> <B>ehf/yams/02 </B>\n<tr><td>N5				<td> <I> Example: </I> <B>http://xx.xx.xx.xx</B>\n<tr><td>SIMUL				<td> <I> Unused: </I> set to string\n</table>";
	prop_def  = "";
	vect_data.clear();
	if (prop_def.length()>0)
	{
		Tango::DbDatum	data(prop_name);
		data << vect_data ;
		dev_def_prop.push_back(data);
		add_wiz_dev_prop(prop_name, prop_desc,  prop_def);
	}
	else
		add_wiz_dev_prop(prop_name, prop_desc);
	prop_name = "DriverType";
	prop_desc = "This property states which type of controller is ``Driver``\n    <BR>Current defined types are:\n<table>\n<tr><td><b><i>GALILDMC2xxx</b></i>     <td>  ... for bare Galil DMC2xxx controller\n<tr><td><b><i>Yams</b></i>                        <td> ... for Yams controller\n<tr><td><b><i>DMC2xxxPiezo</b></i>      <td> ... for Piezo on DMC2xxx controller\n<tr><td><b><i>BCS</b></i>                          <td> ... for BCS controller (temporary for upgrading)\n<tr><td><b><i> N5</b></i>                             <td> ... for Nanotec N5 controller\n<tr><td><b><i> SIMUL</b></i>                      <td> ... for a simulated axis\n</table>";
	prop_def  = "Yams";
	vect_data.clear();
	vect_data.push_back("Yams");
	if (prop_def.length()>0)
	{
		Tango::DbDatum	data(prop_name);
		data << vect_data ;
		dev_def_prop.push_back(data);
		add_wiz_dev_prop(prop_name, prop_desc,  prop_def);
	}
	else
		add_wiz_dev_prop(prop_name, prop_desc);
	prop_name = "Channel";
	prop_desc = "Identification of the Axis on the motion controller (Driver).\n<table class=mytable>\n<tr><td>DriverType   		<td> values\n<tr><td>GALILDMC2xxx, Yams, DMC2xxxPiezo <td> It may be from  <I><B>A to H</B></I> (Galil terminology)\n<tr><td>BCS, N5, SIMUL		<td> <i><b>unused</b></i>, set to N\n</table>";
	prop_def  = "";
	vect_data.clear();
	if (prop_def.length()>0)
	{
		Tango::DbDatum	data(prop_name);
		data << vect_data ;
		dev_def_prop.push_back(data);
		add_wiz_dev_prop(prop_name, prop_desc,  prop_def);
	}
	else
		add_wiz_dev_prop(prop_name, prop_desc);
	prop_name = "EncoderType";
	prop_desc = "Type of Encoder connected to the axis:\n\n<table class=mytable>\n<tr><td>value   		<td> encoder type			<td colspan=6> supporting driver\n<tr><td>		<td>				<td> GALILDMC2xxx <td> Yams <td> DMC2xxxPiezo <td> BCS <td> N5 <td> SIMUL\n<tr><td><B> 0 </B>		<td> <B><I> no encoder</B></I>	<td>&check;	<td>&check;	<td>&check;	<td>&times;	<td>&check;	<td>&check;\n<tr><td><B> 1 </B>		<td> <B><I> incremental </B></I>	<td>&check;	<td>&check;	<td>&times;	<td>&times;	<td>&check;	<td>&times;\n<tr><td><B> 2 </B>		<td> <B><I> absolute</B></I>		<td>&check;	<td>&check;	<td>&times;	<td>&check;	<td>&times;	<td>&times;\n<tr><td><B> 3 </B>		<td> <B><I> semi-absolute</B></I>	<td>&check;	<td>&check;	<td>&times;	<td>&times;	<td>&times;	<td>&times;\n<tr><td><B> 4 </B>		<td> <B><I>analogic absolute</B></I>	<td>&check;	<td>&check;	<td>&times;	<td>&times;	<td>&times;	<td>&times;\n</table>";
	prop_def  = "";
	vect_data.clear();
	if (prop_def.length()>0)
	{
		Tango::DbDatum	data(prop_name);
		data << vect_data ;
		dev_def_prop.push_back(data);
		add_wiz_dev_prop(prop_name, prop_desc,  prop_def);
	}
	else
		add_wiz_dev_prop(prop_name, prop_desc);
	prop_name = "EncoderPrecision";
	prop_desc = "Minimum increment that encoder may deliver.\nFor digital encoder the value is 1.";
	prop_def  = "1";
	vect_data.clear();
	vect_data.push_back("1");
	if (prop_def.length()>0)
	{
		Tango::DbDatum	data(prop_name);
		data << vect_data ;
		dev_def_prop.push_back(data);
		add_wiz_dev_prop(prop_name, prop_desc,  prop_def);
	}
	else
		add_wiz_dev_prop(prop_name, prop_desc);
	prop_name = "EncoderMotorRatio";
	prop_desc = "Number of Encoder increments/pulses for 1 Motor step. \n\nEncoderMotorRatio (EMR) and EncoderMotorOffset (EMO)\ntranslate from motor value/coordinates to encoder ones.\n\nWhen no encoder is available for the Axis, this parameter must be set to 1.\n\n<I>Formula:</I> \n_ _ e = EMR * m + EMO\n_ _ e : encoder value\n_ _ m : motor value";
	prop_def  = "";
	vect_data.clear();
	if (prop_def.length()>0)
	{
		Tango::DbDatum	data(prop_name);
		data << vect_data ;
		dev_def_prop.push_back(data);
		add_wiz_dev_prop(prop_name, prop_desc,  prop_def);
	}
	else
		add_wiz_dev_prop(prop_name, prop_desc);
	prop_name = "EncoderMotorOffset";
	prop_desc = "See EncoderMotorRatio property description.\n\nUsually set to 0.";
	prop_def  = "0";
	vect_data.clear();
	vect_data.push_back("0");
	if (prop_def.length()>0)
	{
		Tango::DbDatum	data(prop_name);
		data << vect_data ;
		dev_def_prop.push_back(data);
		add_wiz_dev_prop(prop_name, prop_desc,  prop_def);
	}
	else
		add_wiz_dev_prop(prop_name, prop_desc);
	prop_name = "PositionEncoderRatio";
	prop_desc = "PositionEncoderRatio (PER) and PositionEncoderOffset (PEO)\ntranslate from encoder value/coordinates to position ones.\n\n<I>Formula:</I> \n_ _ p = PER * e + PEO\n_ _ p : position value\n_ _ e : encoder value";
	prop_def  = "";
	vect_data.clear();
	if (prop_def.length()>0)
	{
		Tango::DbDatum	data(prop_name);
		data << vect_data ;
		dev_def_prop.push_back(data);
		add_wiz_dev_prop(prop_name, prop_desc,  prop_def);
	}
	else
		add_wiz_dev_prop(prop_name, prop_desc);
	prop_name = "PositionEncoderOffset";
	prop_desc = "See PositionEncoderRatio property description.";
	prop_def  = "0";
	vect_data.clear();
	vect_data.push_back("0");
	if (prop_def.length()>0)
	{
		Tango::DbDatum	data(prop_name);
		data << vect_data ;
		dev_def_prop.push_back(data);
		add_wiz_dev_prop(prop_name, prop_desc,  prop_def);
	}
	else
		add_wiz_dev_prop(prop_name, prop_desc);
	prop_name = "MotorSmoothing";
	prop_desc = "Currently unimplemented";
	prop_def  = "";
	vect_data.clear();
	if (prop_def.length()>0)
	{
		Tango::DbDatum	data(prop_name);
		data << vect_data ;
		dev_def_prop.push_back(data);
		add_wiz_dev_prop(prop_name, prop_desc,  prop_def);
	}
	else
		add_wiz_dev_prop(prop_name, prop_desc);
	prop_name = "MotorDirection";
	prop_desc = "Set this property to match <B><I>positive</I></B> motor movement (+ value/step)\nand activation of <I>positive</I> hardware limit switch: <B><I>Forward Limit Switch, FLS</I></B>\n\n<table class=mytable>\n<tr><td>DriverType   		<td> values		<td> description\n<tr><td rowspan=2>GALILDMC2xxx, Yams	<td>  <B>-2.0</B> 	<td> <I>``direct versus``</I>\n<tr> 			 <td>  <B>-2.5</B> 	<td> <I>``reverse versus``</I>\n<tr><td>DMC2xxxPiezo		<td> leave to -2.0	<td> unused\n<tr><td>BCS			<td> leave to -2.0	<td> unused\n<tr><td  rowspan=4>N5		<td> <B>1.0</B> 	<td> <I>``Specifies Servo motor``</I>\n<tr>			<td>  <B>-1.0</B>	<td> <I>``Specifies Servo motor  with reversed polarity``</I>\n<tr>			 <td>  <B>-2.0</B>	<td> <I>``Specifies Step motor, direct versus``</I>\n<tr>			  <td> <B>-2.5</B> 	<td> <I>``Specifies Step motor, reverse versus``</I>\n<tr><td>DMC2xxxPiezo		<td>  leave to -2.0	<td> unused\n<tr><td>SIMUL			<td>  leave to -2.0	<td> unused\n</table>\n\n(1) See Galil command reference MT";
	prop_def  = "";
	vect_data.clear();
	if (prop_def.length()>0)
	{
		Tango::DbDatum	data(prop_name);
		data << vect_data ;
		dev_def_prop.push_back(data);
		add_wiz_dev_prop(prop_name, prop_desc,  prop_def);
	}
	else
		add_wiz_dev_prop(prop_name, prop_desc);
	prop_name = "MotorBrakeExtraTMO";
	prop_desc = "Extra time after brake on/off operation (sec).\n\nIf axis has brake, MotorBrakeExtraTMO control the time\nsoftware waits (block) for the brake to be settled.\n\n<i><b> Only for Yams DriverType </b></i>";
	prop_def  = "1";
	vect_data.clear();
	vect_data.push_back("1");
	if (prop_def.length()>0)
	{
		Tango::DbDatum	data(prop_name);
		data << vect_data ;
		dev_def_prop.push_back(data);
		add_wiz_dev_prop(prop_name, prop_desc,  prop_def);
	}
	else
		add_wiz_dev_prop(prop_name, prop_desc);
	prop_name = "MotorRawBrakeONTMO";
	prop_desc = "With <B><I>Raw mode commands</B></I>:\ntime (sec) after which the brake (if configured) is automatically activated.\n\n<i><b> Only for Yams DriverType </b></i>";
	prop_def  = "10";
	vect_data.clear();
	vect_data.push_back("10");
	if (prop_def.length()>0)
	{
		Tango::DbDatum	data(prop_name);
		data << vect_data ;
		dev_def_prop.push_back(data);
		add_wiz_dev_prop(prop_name, prop_desc,  prop_def);
	}
	else
		add_wiz_dev_prop(prop_name, prop_desc);
	prop_name = "EncoderDirection";
	prop_desc = "<B><I>For EncoderType = 1,2,3</B></I>\nconfigures the encoder type and direction\n\n<table class=mytable>\n<tr><td>DriverType   			<td> values		<td> description\n<tr><td rowspan=4>GALILDMC2xxx, Yams<br>(1)	<td>  <B>0</B> 	<td> <I>Normal quadrature</I>\n<tr> 			 	<td>  <B>1</B> 	<td> <I>Normal pulse and direction</I>\n<tr> 			 	<td>  <B>2</B> 	<td> <I>Reversed quadrature </I>\n<tr> 			 	<td>  <B>3</B> 	<td> <I>Reversed pulse and direction</I> \n<tr><td>DMC2xxxPiezo			<td> leave to 0		<td> unused\n<tr><td>BCS				<td> leave to 0		<td> unused\n<tr><td>N5	<br>(2)			<td> <B> number </B> 	<td> <I>Specifies ENCODER_RESOLUTION</I>\n<tr><td>DMC2xxxPiezo			<td>  leave to 0		<td> unused\n<tr><td>SIMUL				<td>  leave to 0		<td> unused\n</table>\n\n<I>Nornally used values: 0 or 2</I>\n\n(1) See Galil commmand reference CE\n(2) See Nanotec N5 Manual (Object 2052/00)";
	prop_def  = "";
	vect_data.clear();
	if (prop_def.length()>0)
	{
		Tango::DbDatum	data(prop_name);
		data << vect_data ;
		dev_def_prop.push_back(data);
		add_wiz_dev_prop(prop_name, prop_desc,  prop_def);
	}
	else
		add_wiz_dev_prop(prop_name, prop_desc);
	prop_name = "EncoderExtras";
	prop_desc = "<B><I>For EncoderType = 3</B></I>\nhere there are more configuration data.\n\nFor Senc Encoders (semi-absolute), there are 3 parameters:\n\n_ <B><I>param0</B></I> ___ start point for signature generation/check, allowed values: <B>FLS</B> or <B>RLS</B>\n_ <B><I>param1</B></I> ___ value of encoder resolution, <I>usually 5 or 0.5 um</I>\n_ <B><I>param2</B></I> ___ value of encoder pitch, <I>usually 20 um</I>\n\n<I>See</I> : <A href=http://www.acu-rite.com>Senc Encoders</A>";
	prop_def  = "";
	vect_data.clear();
	if (prop_def.length()>0)
	{
		Tango::DbDatum	data(prop_name);
		data << vect_data ;
		dev_def_prop.push_back(data);
		add_wiz_dev_prop(prop_name, prop_desc,  prop_def);
	}
	else
		add_wiz_dev_prop(prop_name, prop_desc);
	prop_name = "AxisForwardLimit";
	prop_desc = "Currently unimplemented";
	prop_def  = "";
	vect_data.clear();
	if (prop_def.length()>0)
	{
		Tango::DbDatum	data(prop_name);
		data << vect_data ;
		dev_def_prop.push_back(data);
		add_wiz_dev_prop(prop_name, prop_desc,  prop_def);
	}
	else
		add_wiz_dev_prop(prop_name, prop_desc);
	prop_name = "AxisBackwardLimit";
	prop_desc = "Currently unimplemented";
	prop_def  = "";
	vect_data.clear();
	if (prop_def.length()>0)
	{
		Tango::DbDatum	data(prop_name);
		data << vect_data ;
		dev_def_prop.push_back(data);
		add_wiz_dev_prop(prop_name, prop_desc,  prop_def);
	}
	else
		add_wiz_dev_prop(prop_name, prop_desc);
	prop_name = "InitType";
	prop_desc = "Initialisation type of the axis.\n\n<hr>Possible values for DriveType <b>GALILDMC2xxx, Yams, DMC2xxxPiezo</b>: \n\n _ <B> 0</B> __ : no initialisation <I>(at run time <B>DefinePosition</B> command needed)</I>\n _ <B> 1</B> __ : initialisation on <B>home switch</B> <I>(deprecated)</I>\n _ <B> 2</B> __ : initialisation on <B>backward limit</B> \n _ <B> 4</B> __ : initialisation on <B>forward limit</B>\n _ <B> 7</B> __  : goto <B>backward limit</B> and then search encoder <B>reference mark in forward direction</B>\n _ <B> 8</B> __  : goto <B>forward limit</B> and then search encoder <B>reference mark in backward direction</B>\n _ <B> 9</B> __  : initialisation on <B>home switch in forward direction</B>\n_ <B>10</B>__: initialisation on <B>home switch in backward direction</B>\n_ <B>11</B>__: initialisation on <B>absolute encoder</B> <I>(i.e. analogic absolute)</I>\n_ <B>12</B>__: initialisation on <B>semi-absolute encoder, forward direction</B> <I>(i.e. Senc encoder)</I>\n_ <B>13</B>__: initialisation on <B>semi-absolute encoder, backward direction</B> <I>(i.e. Senc encoder)</I>\n_ <B>14</B>__: initialisation on <B>encoder reference mark, positive rotation</B> <I>(for rotation stages)</I>\n_ <B>15</B>__: initialisation on <B>encoder reference mark, negative rotation</B> <I>(for rotation stages)</I>\n\nFor ``absolute encoders`` at the end of the initialisation, the actual axis value is kept from the encoder.\nFor the other encoders/InitType at the end of the initialisation, the actual axis value is kept from property <B><I>InitPosition</B></I>.\n\n<hr>Possible values for DriveType <b>BCS</b>:\n\n _ <B> 0</B> __ : no initialisation <I>(at run time <B>DefinePosition</B> command needed)</I>\n\n<hr>Possible values for DriveType <b>N5</b>:\n\n _ <B> 16</B> __ : initialisation on <B> CIA402 backward limit</B> \n _ <B> 17</B> __ : initialisation on <B> CIA402 forward limit</B>\n _ <B> 18</B> __ : initialisation on <B> CIA402 backward limit</B> and then search encoder <B>reference mark in forward direction</B>\n _ <B> 19</B> __ : initialisation on <B> CIA402 forward limit</B> and then search encoder <B>reference mark in backward direction</B>\n _ <B> 20</B> __ : initialisation on <B> CAI402 encoder reference mark, positive rotation</B> <I>(for rotation stages)</I>\n _ <B> 21</B> __ : initialisation on <B> CIA402 encoder reference mark, negative rotation</B> <I>(for rotation stages)</I>\n\n<hr>Possible values for DriveType <b>SIMUL</b>:\n\n _ <B> 0</B> __ : no initialisation <I>(at run time <B>DefinePosition</B> command needed)</I>";
	prop_def  = "";
	vect_data.clear();
	if (prop_def.length()>0)
	{
		Tango::DbDatum	data(prop_name);
		data << vect_data ;
		dev_def_prop.push_back(data);
		add_wiz_dev_prop(prop_name, prop_desc,  prop_def);
	}
	else
		add_wiz_dev_prop(prop_name, prop_desc);
	prop_name = "InitPosition";
	prop_desc = "Value used in the initialisation.\n<I>See</I> : InitType";
	prop_def  = "0";
	vect_data.clear();
	vect_data.push_back("0");
	if (prop_def.length()>0)
	{
		Tango::DbDatum	data(prop_name);
		data << vect_data ;
		dev_def_prop.push_back(data);
		add_wiz_dev_prop(prop_name, prop_desc,  prop_def);
	}
	else
		add_wiz_dev_prop(prop_name, prop_desc);
	prop_name = "MotoristMemo";
	prop_desc = "<I>Just a placeholder for comments/memos.</I>";
	prop_def  = "";
	vect_data.clear();
	if (prop_def.length()>0)
	{
		Tango::DbDatum	data(prop_name);
		data << vect_data ;
		dev_def_prop.push_back(data);
		add_wiz_dev_prop(prop_name, prop_desc,  prop_def);
	}
	else
		add_wiz_dev_prop(prop_name, prop_desc);
	prop_name = "FindSpeeds";
	prop_desc = "This property holds 2 parameters,\nwhich are the speeds (eng. units) used in the initialisation procedure:\n\n_ <B><I>param0</B></I> ___ coarse speed <I>(first phase of initialisation)</I>\n_ <B><I>param1</B></I> ___ fine speed <I>(second phase of initialisation)</I>";
	prop_def  = "";
	vect_data.clear();
	if (prop_def.length()>0)
	{
		Tango::DbDatum	data(prop_name);
		data << vect_data ;
		dev_def_prop.push_back(data);
		add_wiz_dev_prop(prop_name, prop_desc,  prop_def);
	}
	else
		add_wiz_dev_prop(prop_name, prop_desc);
	prop_name = "UserEncoderRatio";
	prop_desc = "Currently unimplemented";
	prop_def  = "";
	vect_data.clear();
	if (prop_def.length()>0)
	{
		Tango::DbDatum	data(prop_name);
		data << vect_data ;
		dev_def_prop.push_back(data);
		add_wiz_dev_prop(prop_name, prop_desc,  prop_def);
	}
	else
		add_wiz_dev_prop(prop_name, prop_desc);
	prop_name = "EncoderRippleOnStay";
	prop_desc = "<I><B>check_encoder() function parameter</B></I>\nMaximun encoder value displacement (absolute value in encoder units)\nbefore declaring the state set in the EncoderCheckOnError property.";
	prop_def  = "2";
	vect_data.clear();
	vect_data.push_back("2");
	if (prop_def.length()>0)
	{
		Tango::DbDatum	data(prop_name);
		data << vect_data ;
		dev_def_prop.push_back(data);
		add_wiz_dev_prop(prop_name, prop_desc,  prop_def);
	}
	else
		add_wiz_dev_prop(prop_name, prop_desc);
	prop_name = "EncoderCheckDelay";
	prop_desc = "<I><B>check_encoder() function parameter</B></I>\nTime delay (sec) before actually perform the encoder check.";
	prop_def  = "1";
	vect_data.clear();
	vect_data.push_back("1");
	if (prop_def.length()>0)
	{
		Tango::DbDatum	data(prop_name);
		data << vect_data ;
		dev_def_prop.push_back(data);
		add_wiz_dev_prop(prop_name, prop_desc,  prop_def);
	}
	else
		add_wiz_dev_prop(prop_name, prop_desc);
	prop_name = "EncoderRippleOnRun";
	prop_desc = "<I><B>check_encoder() function parameter</B></I>\nWhile motor moving,\nif the difference between\n __ the motor value change (in encoder units)\nand\n __ the encoder value change (in encoder units)\nis greater than this property (in encoder units), then \nthe state is changed to that set in the EncoderCheckOnError property.";
	prop_def  = "2";
	vect_data.clear();
	vect_data.push_back("2");
	if (prop_def.length()>0)
	{
		Tango::DbDatum	data(prop_name);
		data << vect_data ;
		dev_def_prop.push_back(data);
		add_wiz_dev_prop(prop_name, prop_desc,  prop_def);
	}
	else
		add_wiz_dev_prop(prop_name, prop_desc);
	prop_name = "EncoderCheckOnError";
	prop_desc = "<I><B>check_encoder() function parameter</B></I>\nThe state (status) value set when check_encoder() fails.";
	prop_def  = "ALARM";
	vect_data.clear();
	vect_data.push_back("ALARM");
	if (prop_def.length()>0)
	{
		Tango::DbDatum	data(prop_name);
		data << vect_data ;
		dev_def_prop.push_back(data);
		add_wiz_dev_prop(prop_name, prop_desc,  prop_def);
	}
	else
		add_wiz_dev_prop(prop_name, prop_desc);
	prop_name = "CheckEncoderEnable";
	prop_desc = "<I><B>check_encoder() function parameter</B></I>\nEnable/disable the check_encoder() function.";
	prop_def  = "true";
	vect_data.clear();
	vect_data.push_back("true");
	if (prop_def.length()>0)
	{
		Tango::DbDatum	data(prop_name);
		data << vect_data ;
		dev_def_prop.push_back(data);
		add_wiz_dev_prop(prop_name, prop_desc,  prop_def);
	}
	else
		add_wiz_dev_prop(prop_name, prop_desc);
	prop_name = "EncoderCheckOnErrorStop";
	prop_desc = "<I><B>check_encoder() function parameter</B></I>\nMotion behavior when check_encoder() observe an error:\nif _ <B>true </B> __ then the motion stops\nif _ <B>false</B>__ then the motion keeps on";
	prop_def  = "true";
	vect_data.clear();
	vect_data.push_back("true");
	if (prop_def.length()>0)
	{
		Tango::DbDatum	data(prop_name);
		data << vect_data ;
		dev_def_prop.push_back(data);
		add_wiz_dev_prop(prop_name, prop_desc,  prop_def);
	}
	else
		add_wiz_dev_prop(prop_name, prop_desc);
	prop_name = "EncoderAnalogRatio";
	prop_desc = "EncoderAnalogRatio (EAR) and EncoderAnalogOffset (EAO)\ntranslate from analog read value to analog-encoder one.\n\n<I>Typically analog value is in Volt while analog-encoder is in milliVolt\nthus EAR=1000</I>\n\n<I>Formula:</I> \n_ _ ae = EAR * av + EAO\n_ _ ae : encoder value\n_ _ av : analog value";
	prop_def  = "1";
	vect_data.clear();
	vect_data.push_back("1");
	if (prop_def.length()>0)
	{
		Tango::DbDatum	data(prop_name);
		data << vect_data ;
		dev_def_prop.push_back(data);
		add_wiz_dev_prop(prop_name, prop_desc,  prop_def);
	}
	else
		add_wiz_dev_prop(prop_name, prop_desc);
	prop_name = "EncoderAnalogOffset";
	prop_desc = "See EncoderAnalogRatio property description.\n\nUsually set to 0.";
	prop_def  = "0";
	vect_data.clear();
	vect_data.push_back("0");
	if (prop_def.length()>0)
	{
		Tango::DbDatum	data(prop_name);
		data << vect_data ;
		dev_def_prop.push_back(data);
		add_wiz_dev_prop(prop_name, prop_desc,  prop_def);
	}
	else
		add_wiz_dev_prop(prop_name, prop_desc);
	prop_name = "HWWriteEnable";
	prop_desc = "if _ <B>true </B> __ then any write/set operation is sent to the underling level and to the hardware\nif _ <B>false</B>__ then any write/set operation is blocked";
	prop_def  = "true";
	vect_data.clear();
	vect_data.push_back("true");
	if (prop_def.length()>0)
	{
		Tango::DbDatum	data(prop_name);
		data << vect_data ;
		dev_def_prop.push_back(data);
		add_wiz_dev_prop(prop_name, prop_desc,  prop_def);
	}
	else
		add_wiz_dev_prop(prop_name, prop_desc);
	prop_name = "SafetyRules";
	prop_desc = "See <B><I>safetymanager</I></B> package.\nMostly set <B>empty</B> (none).";
	prop_def  = "";
	vect_data.clear();
	if (prop_def.length()>0)
	{
		Tango::DbDatum	data(prop_name);
		data << vect_data ;
		dev_def_prop.push_back(data);
		add_wiz_dev_prop(prop_name, prop_desc,  prop_def);
	}
	else
		add_wiz_dev_prop(prop_name, prop_desc);
	prop_name = "UserFuncLibrary";
	prop_desc = "Full path/name of the library containing user functions";
	prop_def  = "None";
	vect_data.clear();
	vect_data.push_back("None");
	if (prop_def.length()>0)
	{
		Tango::DbDatum	data(prop_name);
		data << vect_data ;
		dev_def_prop.push_back(data);
		add_wiz_dev_prop(prop_name, prop_desc,  prop_def);
	}
	else
		add_wiz_dev_prop(prop_name, prop_desc);
	prop_name = "UserDirectFuncName";
	prop_desc = "Name of the function to trasform Position into UserPosition";
	prop_def  = "None";
	vect_data.clear();
	vect_data.push_back("None");
	if (prop_def.length()>0)
	{
		Tango::DbDatum	data(prop_name);
		data << vect_data ;
		dev_def_prop.push_back(data);
		add_wiz_dev_prop(prop_name, prop_desc,  prop_def);
	}
	else
		add_wiz_dev_prop(prop_name, prop_desc);
	prop_name = "UserDirectFuncParams";
	prop_desc = "Array of parameters from x^0 param to x^N param";
	prop_def  = "";
	vect_data.clear();
	if (prop_def.length()>0)
	{
		Tango::DbDatum	data(prop_name);
		data << vect_data ;
		dev_def_prop.push_back(data);
		add_wiz_dev_prop(prop_name, prop_desc,  prop_def);
	}
	else
		add_wiz_dev_prop(prop_name, prop_desc);
	prop_name = "UserInverseFuncName";
	prop_desc = "Name of the function to trasform Position into UserPosition";
	prop_def  = "None";
	vect_data.clear();
	vect_data.push_back("None");
	if (prop_def.length()>0)
	{
		Tango::DbDatum	data(prop_name);
		data << vect_data ;
		dev_def_prop.push_back(data);
		add_wiz_dev_prop(prop_name, prop_desc,  prop_def);
	}
	else
		add_wiz_dev_prop(prop_name, prop_desc);
	prop_name = "UserInverseFuncParams";
	prop_desc = "Array of parameters from x^0 param to x^N param";
	prop_def  = "";
	vect_data.clear();
	if (prop_def.length()>0)
	{
		Tango::DbDatum	data(prop_name);
		data << vect_data ;
		dev_def_prop.push_back(data);
		add_wiz_dev_prop(prop_name, prop_desc,  prop_def);
	}
	else
		add_wiz_dev_prop(prop_name, prop_desc);
	prop_name = "RLSStroke";
	prop_desc = "";
	prop_def  = "";
	vect_data.clear();
	if (prop_def.length()>0)
	{
		Tango::DbDatum	data(prop_name);
		data << vect_data ;
		dev_def_prop.push_back(data);
		add_wiz_dev_prop(prop_name, prop_desc,  prop_def);
	}
	else
		add_wiz_dev_prop(prop_name, prop_desc);
	prop_name = "FLSStroke";
	prop_desc = "";
	prop_def  = "";
	vect_data.clear();
	if (prop_def.length()>0)
	{
		Tango::DbDatum	data(prop_name);
		data << vect_data ;
		dev_def_prop.push_back(data);
		add_wiz_dev_prop(prop_name, prop_desc,  prop_def);
	}
	else
		add_wiz_dev_prop(prop_name, prop_desc);
	prop_name = "FakeAxisInitEnable";
	prop_desc = "Enable FakeAxisInit";
	prop_def  = "false";
	vect_data.clear();
	vect_data.push_back("false");
	if (prop_def.length()>0)
	{
		Tango::DbDatum	data(prop_name);
		data << vect_data ;
		dev_def_prop.push_back(data);
		add_wiz_dev_prop(prop_name, prop_desc,  prop_def);
	}
	else
		add_wiz_dev_prop(prop_name, prop_desc);
}

//--------------------------------------------------------
/**
 *	Method      : AxisG2Class::write_class_property()
 *	Description : Set class description fields as property in database
 */
//--------------------------------------------------------
void AxisG2Class::write_class_property()
{
	//	First time, check if database used
	if (Tango::Util::_UseDb == false)
		return;

	Tango::DbData	data;
	string	classname = get_name();
	string	header;
	string::size_type	start, end;

	//	Put title
	Tango::DbDatum	title("ProjectTitle");
	string	str_title("Axis Generation Two");
	title << str_title;
	data.push_back(title);

	//	Put Description
	Tango::DbDatum	description("Description");
	vector<string>	str_desc;
	str_desc.push_back("This class realizes the initialisation and positioning functionalities for a single axis.");
	description << str_desc;
	data.push_back(description);

	//  Put inheritance
	Tango::DbDatum	inher_datum("InheritedFrom");
	vector<string> inheritance;
	inheritance.push_back("TANGO_BASE_CLASS");
	inher_datum << inheritance;
	data.push_back(inher_datum);

	//	Call database and and values
	get_db_class()->put_property(data);
}

//===================================================================
//	Factory methods
//===================================================================

//--------------------------------------------------------
/**
 *	Method      : AxisG2Class::device_factory()
 *	Description : Create the device object(s)
 *                and store them in the device list
 */
//--------------------------------------------------------
void AxisG2Class::device_factory(const Tango::DevVarStringArray *devlist_ptr)
{
	/*----- PROTECTED REGION ID(AxisG2Class::device_factory_before) ENABLED START -----*/
	
	//	Add your own code
	
	/*----- PROTECTED REGION END -----*/	//	AxisG2Class::device_factory_before

	//	Create devices and add it into the device list
	for (unsigned long i=0 ; i<devlist_ptr->length() ; i++)
	{
		cout4 << "Device name : " << (*devlist_ptr)[i].in() << endl;
		device_list.push_back(new AxisG2(this, (*devlist_ptr)[i]));
	}

	//	Manage dynamic attributes if any
	erase_dynamic_attributes(devlist_ptr, get_class_attr()->get_attr_list());

	//	Export devices to the outside world
	for (unsigned long i=1 ; i<=devlist_ptr->length() ; i++)
	{
		//	Add dynamic attributes if any
		AxisG2 *dev = static_cast<AxisG2 *>(device_list[device_list.size()-i]);
		dev->add_dynamic_attributes();

		//	Check before if database used.
		if ((Tango::Util::_UseDb == true) && (Tango::Util::_FileDb == false))
			export_device(dev);
		else
			export_device(dev, dev->get_name().c_str());
	}

	/*----- PROTECTED REGION ID(AxisG2Class::device_factory_after) ENABLED START -----*/
	
	//	Add your own code
	
	/*----- PROTECTED REGION END -----*/	//	AxisG2Class::device_factory_after
}
//--------------------------------------------------------
/**
 *	Method      : AxisG2Class::attribute_factory()
 *	Description : Create the attribute object(s)
 *                and store them in the attribute list
 */
//--------------------------------------------------------
void AxisG2Class::attribute_factory(vector<Tango::Attr *> &att_list)
{
	/*----- PROTECTED REGION ID(AxisG2Class::attribute_factory_before) ENABLED START -----*/
	
	//	Add your own code
	
	/*----- PROTECTED REGION END -----*/	//	AxisG2Class::attribute_factory_before
	//	Attribute : Position
	PositionAttrib	*position = new PositionAttrib();
	Tango::UserDefaultAttrProp	position_prop;
	position_prop.set_description("Position of the axis (<I><B>plant coordinates/units</B></I>).");
	position_prop.set_label("Position");
	position_prop.set_unit("AxisUnits");
	//	standard_unit	not set for Position
	//	display_unit	not set for Position
	//	format	not set for Position
	//	max_value	not set for Position
	//	min_value	not set for Position
	//	max_alarm	not set for Position
	//	min_alarm	not set for Position
	//	max_warning	not set for Position
	//	min_warning	not set for Position
	//	delta_t	not set for Position
	//	delta_val	not set for Position
	
	position->set_default_properties(position_prop);
	position->set_polling_period(500);
	position->set_disp_level(Tango::OPERATOR);
	position->set_memorized();
	position->set_memorized_init(false);
	att_list.push_back(position);

	//	Attribute : PositiveLimitSwitch
	PositiveLimitSwitchAttrib	*positivelimitswitch = new PositiveLimitSwitchAttrib();
	Tango::UserDefaultAttrProp	positivelimitswitch_prop;
	positivelimitswitch_prop.set_description("Status of the forward/positive limit switch (<I><B>plant coordinates</B></I>).");
	positivelimitswitch_prop.set_label("Axis +Limit");
	//	unit	not set for PositiveLimitSwitch
	//	standard_unit	not set for PositiveLimitSwitch
	//	display_unit	not set for PositiveLimitSwitch
	//	format	not set for PositiveLimitSwitch
	//	max_value	not set for PositiveLimitSwitch
	//	min_value	not set for PositiveLimitSwitch
	//	max_alarm	not set for PositiveLimitSwitch
	//	min_alarm	not set for PositiveLimitSwitch
	//	max_warning	not set for PositiveLimitSwitch
	//	min_warning	not set for PositiveLimitSwitch
	//	delta_t	not set for PositiveLimitSwitch
	//	delta_val	not set for PositiveLimitSwitch
	
	positivelimitswitch->set_default_properties(positivelimitswitch_prop);
	//	Not Polled
	positivelimitswitch->set_disp_level(Tango::OPERATOR);
	//	Not Memorized
	att_list.push_back(positivelimitswitch);

	//	Attribute : NegativeLimitSwitch
	NegativeLimitSwitchAttrib	*negativelimitswitch = new NegativeLimitSwitchAttrib();
	Tango::UserDefaultAttrProp	negativelimitswitch_prop;
	negativelimitswitch_prop.set_description("Status of the backward/negative limit switch (<I><B>plant coordinates</B></I>).");
	negativelimitswitch_prop.set_label("Axis -Limit");
	//	unit	not set for NegativeLimitSwitch
	//	standard_unit	not set for NegativeLimitSwitch
	//	display_unit	not set for NegativeLimitSwitch
	//	format	not set for NegativeLimitSwitch
	//	max_value	not set for NegativeLimitSwitch
	//	min_value	not set for NegativeLimitSwitch
	//	max_alarm	not set for NegativeLimitSwitch
	//	min_alarm	not set for NegativeLimitSwitch
	//	max_warning	not set for NegativeLimitSwitch
	//	min_warning	not set for NegativeLimitSwitch
	//	delta_t	not set for NegativeLimitSwitch
	//	delta_val	not set for NegativeLimitSwitch
	
	negativelimitswitch->set_default_properties(negativelimitswitch_prop);
	//	Not Polled
	negativelimitswitch->set_disp_level(Tango::OPERATOR);
	//	Not Memorized
	att_list.push_back(negativelimitswitch);

	//	Attribute : HomeSwitch
	HomeSwitchAttrib	*homeswitch = new HomeSwitchAttrib();
	Tango::UserDefaultAttrProp	homeswitch_prop;
	homeswitch_prop.set_description("Status of the home switch (<I><B>plant coordinates</B></I>).");
	homeswitch_prop.set_label("Home Switch");
	//	unit	not set for HomeSwitch
	//	standard_unit	not set for HomeSwitch
	//	display_unit	not set for HomeSwitch
	//	format	not set for HomeSwitch
	//	max_value	not set for HomeSwitch
	//	min_value	not set for HomeSwitch
	//	max_alarm	not set for HomeSwitch
	//	min_alarm	not set for HomeSwitch
	//	max_warning	not set for HomeSwitch
	//	min_warning	not set for HomeSwitch
	//	delta_t	not set for HomeSwitch
	//	delta_val	not set for HomeSwitch
	
	homeswitch->set_default_properties(homeswitch_prop);
	//	Not Polled
	homeswitch->set_disp_level(Tango::OPERATOR);
	//	Not Memorized
	att_list.push_back(homeswitch);

	//	Attribute : MotorStatus
	MotorStatusAttrib	*motorstatus = new MotorStatusAttrib();
	Tango::UserDefaultAttrProp	motorstatus_prop;
	motorstatus_prop.set_description("Status of the motor, <I>example: MOVIMG</I>.");
	motorstatus_prop.set_label("Motor Status");
	//	unit	not set for MotorStatus
	//	standard_unit	not set for MotorStatus
	//	display_unit	not set for MotorStatus
	motorstatus_prop.set_format("%s");
	//	max_value	not set for MotorStatus
	//	min_value	not set for MotorStatus
	//	max_alarm	not set for MotorStatus
	//	min_alarm	not set for MotorStatus
	//	max_warning	not set for MotorStatus
	//	min_warning	not set for MotorStatus
	//	delta_t	not set for MotorStatus
	//	delta_val	not set for MotorStatus
	
	motorstatus->set_default_properties(motorstatus_prop);
	//	Not Polled
	motorstatus->set_disp_level(Tango::OPERATOR);
	//	Not Memorized
	att_list.push_back(motorstatus);

	//	Attribute : EncoderPosition
	EncoderPositionAttrib	*encoderposition = new EncoderPositionAttrib();
	Tango::UserDefaultAttrProp	encoderposition_prop;
	encoderposition_prop.set_description("Position of the axis as reported by the encoder, in <B>encoder units</B> (<I><B>plant coordinates/units</B></I>).");
	encoderposition_prop.set_label("Encoder position");
	encoderposition_prop.set_unit("EncoderUnits");
	//	standard_unit	not set for EncoderPosition
	//	display_unit	not set for EncoderPosition
	//	format	not set for EncoderPosition
	//	max_value	not set for EncoderPosition
	//	min_value	not set for EncoderPosition
	//	max_alarm	not set for EncoderPosition
	//	min_alarm	not set for EncoderPosition
	//	max_warning	not set for EncoderPosition
	//	min_warning	not set for EncoderPosition
	//	delta_t	not set for EncoderPosition
	//	delta_val	not set for EncoderPosition
	
	encoderposition->set_default_properties(encoderposition_prop);
	//	Not Polled
	encoderposition->set_disp_level(Tango::EXPERT);
	//	Not Memorized
	att_list.push_back(encoderposition);

	//	Attribute : MotorPosition
	MotorPositionAttrib	*motorposition = new MotorPositionAttrib();
	Tango::UserDefaultAttrProp	motorposition_prop;
	motorposition_prop.set_description("Position of the axis as reported by the motor, in <B>motor steps</B> (<I><B>plant coordinates</B></I>).");
	motorposition_prop.set_label("Motor position");
	motorposition_prop.set_unit("steps");
	motorposition_prop.set_standard_unit("steps");
	motorposition_prop.set_display_unit("steps");
	motorposition_prop.set_format("%10d");
	//	max_value	not set for MotorPosition
	//	min_value	not set for MotorPosition
	//	max_alarm	not set for MotorPosition
	//	min_alarm	not set for MotorPosition
	//	max_warning	not set for MotorPosition
	//	min_warning	not set for MotorPosition
	//	delta_t	not set for MotorPosition
	//	delta_val	not set for MotorPosition
	
	motorposition->set_default_properties(motorposition_prop);
	//	Not Polled
	motorposition->set_disp_level(Tango::EXPERT);
	motorposition->set_memorized();
	motorposition->set_memorized_init(false);
	att_list.push_back(motorposition);

	//	Attribute : UserPosition
	UserPositionAttrib	*userposition = new UserPositionAttrib();
	Tango::UserDefaultAttrProp	userposition_prop;
	userposition_prop.set_description("Position of the axis (<I><B>user coordinates</B></I>).");
	userposition_prop.set_label("User position");
	userposition_prop.set_unit("UserUnits");
	//	standard_unit	not set for UserPosition
	//	display_unit	not set for UserPosition
	//	format	not set for UserPosition
	//	max_value	not set for UserPosition
	//	min_value	not set for UserPosition
	//	max_alarm	not set for UserPosition
	//	min_alarm	not set for UserPosition
	//	max_warning	not set for UserPosition
	//	min_warning	not set for UserPosition
	//	delta_t	not set for UserPosition
	//	delta_val	not set for UserPosition
	
	userposition->set_default_properties(userposition_prop);
	//	Not Polled
	userposition->set_disp_level(Tango::OPERATOR);
	userposition->set_memorized();
	userposition->set_memorized_init(false);
	att_list.push_back(userposition);

	//	Attribute : UserScale
	UserScaleAttrib	*userscale = new UserScaleAttrib();
	Tango::UserDefaultAttrProp	userscale_prop;
	userscale_prop.set_description("UserScale (US) and UserOffset (UO)\ntranslate position from <B><I>plant to user coordinates/units</I></B>.\n\n<I>Formula:</I> \n_ _ up = US * pp + UO\n_ _ up : user position value\n_ _ pp : plant position value");
	userscale_prop.set_label("User Scale");
	userscale_prop.set_unit("UserUnits");
	//	standard_unit	not set for UserScale
	//	display_unit	not set for UserScale
	//	format	not set for UserScale
	//	max_value	not set for UserScale
	//	min_value	not set for UserScale
	//	max_alarm	not set for UserScale
	//	min_alarm	not set for UserScale
	//	max_warning	not set for UserScale
	//	min_warning	not set for UserScale
	//	delta_t	not set for UserScale
	//	delta_val	not set for UserScale
	
	userscale->set_default_properties(userscale_prop);
	//	Not Polled
	userscale->set_disp_level(Tango::EXPERT);
	userscale->set_memorized();
	userscale->set_memorized_init(true);
	att_list.push_back(userscale);

	//	Attribute : UserOffset
	UserOffsetAttrib	*useroffset = new UserOffsetAttrib();
	Tango::UserDefaultAttrProp	useroffset_prop;
	useroffset_prop.set_description("<I>See</I> : UserScale attribute description.");
	useroffset_prop.set_label("User Offset");
	useroffset_prop.set_unit("UserUnits");
	//	standard_unit	not set for UserOffset
	//	display_unit	not set for UserOffset
	//	format	not set for UserOffset
	//	max_value	not set for UserOffset
	//	min_value	not set for UserOffset
	//	max_alarm	not set for UserOffset
	//	min_alarm	not set for UserOffset
	//	max_warning	not set for UserOffset
	//	min_warning	not set for UserOffset
	//	delta_t	not set for UserOffset
	//	delta_val	not set for UserOffset
	
	useroffset->set_default_properties(useroffset_prop);
	//	Not Polled
	useroffset->set_disp_level(Tango::EXPERT);
	useroffset->set_memorized();
	useroffset->set_memorized_init(true);
	att_list.push_back(useroffset);

	//	Attribute : UserSpeed
	UserSpeedAttrib	*userspeed = new UserSpeedAttrib();
	Tango::UserDefaultAttrProp	userspeed_prop;
	userspeed_prop.set_description("Requested speed of the axis (<I><B>user coordinates/units</B></I>).");
	userspeed_prop.set_label("User Speed");
	userspeed_prop.set_unit("UserUnits/sec");
	//	standard_unit	not set for UserSpeed
	//	display_unit	not set for UserSpeed
	//	format	not set for UserSpeed
	//	max_value	not set for UserSpeed
	userspeed_prop.set_min_value("1e-38");
	//	max_alarm	not set for UserSpeed
	//	min_alarm	not set for UserSpeed
	//	max_warning	not set for UserSpeed
	//	min_warning	not set for UserSpeed
	//	delta_t	not set for UserSpeed
	//	delta_val	not set for UserSpeed
	
	userspeed->set_default_properties(userspeed_prop);
	//	Not Polled
	userspeed->set_disp_level(Tango::EXPERT);
	userspeed->set_memorized();
	userspeed->set_memorized_init(false);
	att_list.push_back(userspeed);

	//	Attribute : Speed
	SpeedAttrib	*speed = new SpeedAttrib();
	Tango::UserDefaultAttrProp	speed_prop;
	speed_prop.set_description("Requested speed of the axis (<I><B>plant coordinates/units</B></I>).");
	speed_prop.set_label("Speed");
	speed_prop.set_unit("AxisUnits/sec");
	//	standard_unit	not set for Speed
	//	display_unit	not set for Speed
	//	format	not set for Speed
	//	max_value	not set for Speed
	speed_prop.set_min_value("1e-38");
	//	max_alarm	not set for Speed
	//	min_alarm	not set for Speed
	//	max_warning	not set for Speed
	//	min_warning	not set for Speed
	//	delta_t	not set for Speed
	//	delta_val	not set for Speed
	
	speed->set_default_properties(speed_prop);
	//	Not Polled
	speed->set_disp_level(Tango::EXPERT);
	speed->set_memorized();
	speed->set_memorized_init(true);
	att_list.push_back(speed);

	//	Attribute : Acceleration
	AccelerationAttrib	*acceleration = new AccelerationAttrib();
	Tango::UserDefaultAttrProp	acceleration_prop;
	acceleration_prop.set_description("Requested acceleration of the axis (<I><B>plant coordinates/units</B></I>).");
	acceleration_prop.set_label("Acceleration");
	acceleration_prop.set_unit("AxisUnits/sec2");
	//	standard_unit	not set for Acceleration
	//	display_unit	not set for Acceleration
	//	format	not set for Acceleration
	//	max_value	not set for Acceleration
	//	min_value	not set for Acceleration
	//	max_alarm	not set for Acceleration
	//	min_alarm	not set for Acceleration
	//	max_warning	not set for Acceleration
	//	min_warning	not set for Acceleration
	//	delta_t	not set for Acceleration
	//	delta_val	not set for Acceleration
	
	acceleration->set_default_properties(acceleration_prop);
	//	Not Polled
	acceleration->set_disp_level(Tango::EXPERT);
	acceleration->set_memorized();
	acceleration->set_memorized_init(true);
	att_list.push_back(acceleration);

	//	Attribute : Deceleration
	DecelerationAttrib	*deceleration = new DecelerationAttrib();
	Tango::UserDefaultAttrProp	deceleration_prop;
	deceleration_prop.set_description("Requested deceleration of the axis (<I><B>plant coordinates/units</B></I>).");
	deceleration_prop.set_label("Deceleration");
	deceleration_prop.set_unit("AxisUnits/sec2");
	//	standard_unit	not set for Deceleration
	//	display_unit	not set for Deceleration
	//	format	not set for Deceleration
	//	max_value	not set for Deceleration
	//	min_value	not set for Deceleration
	//	max_alarm	not set for Deceleration
	//	min_alarm	not set for Deceleration
	//	max_warning	not set for Deceleration
	//	min_warning	not set for Deceleration
	//	delta_t	not set for Deceleration
	//	delta_val	not set for Deceleration
	
	deceleration->set_default_properties(deceleration_prop);
	//	Not Polled
	deceleration->set_disp_level(Tango::EXPERT);
	deceleration->set_memorized();
	deceleration->set_memorized_init(true);
	att_list.push_back(deceleration);

	//	Attribute : MotionAccuracy
	MotionAccuracyAttrib	*motionaccuracy = new MotionAccuracyAttrib();
	Tango::UserDefaultAttrProp	motionaccuracy_prop;
	motionaccuracy_prop.set_description("Minimun allowable displacement, i.e. maximum positioning error of the axis (<I><B>plant coordinates/units</B></I>).");
	motionaccuracy_prop.set_label("Motion Accuracy");
	motionaccuracy_prop.set_unit("AxisUnits");
	//	standard_unit	not set for MotionAccuracy
	//	display_unit	not set for MotionAccuracy
	//	format	not set for MotionAccuracy
	//	max_value	not set for MotionAccuracy
	//	min_value	not set for MotionAccuracy
	//	max_alarm	not set for MotionAccuracy
	//	min_alarm	not set for MotionAccuracy
	//	max_warning	not set for MotionAccuracy
	//	min_warning	not set for MotionAccuracy
	//	delta_t	not set for MotionAccuracy
	//	delta_val	not set for MotionAccuracy
	
	motionaccuracy->set_default_properties(motionaccuracy_prop);
	//	Not Polled
	motionaccuracy->set_disp_level(Tango::EXPERT);
	motionaccuracy->set_memorized();
	motionaccuracy->set_memorized_init(true);
	att_list.push_back(motionaccuracy);

	//	Attribute : MotionPercent
	MotionPercentAttrib	*motionpercent = new MotionPercentAttrib();
	Tango::UserDefaultAttrProp	motionpercent_prop;
	motionpercent_prop.set_description("Coefficient for successive approach positioning");
	motionpercent_prop.set_label("Positioning Percent");
	//	unit	not set for MotionPercent
	//	standard_unit	not set for MotionPercent
	//	display_unit	not set for MotionPercent
	//	format	not set for MotionPercent
	//	max_value	not set for MotionPercent
	//	min_value	not set for MotionPercent
	//	max_alarm	not set for MotionPercent
	//	min_alarm	not set for MotionPercent
	//	max_warning	not set for MotionPercent
	//	min_warning	not set for MotionPercent
	//	delta_t	not set for MotionPercent
	//	delta_val	not set for MotionPercent
	
	motionpercent->set_default_properties(motionpercent_prop);
	//	Not Polled
	motionpercent->set_disp_level(Tango::EXPERT);
	motionpercent->set_memorized();
	motionpercent->set_memorized_init(false);
	att_list.push_back(motionpercent);

	//	Attribute : MotionRetry
	MotionRetryAttrib	*motionretry = new MotionRetryAttrib();
	Tango::UserDefaultAttrProp	motionretry_prop;
	motionretry_prop.set_description("Number of retries done by the controller closed control loop algorithm.");
	motionretry_prop.set_label("Number of retries");
	//	unit	not set for MotionRetry
	//	standard_unit	not set for MotionRetry
	//	display_unit	not set for MotionRetry
	//	format	not set for MotionRetry
	//	max_value	not set for MotionRetry
	//	min_value	not set for MotionRetry
	//	max_alarm	not set for MotionRetry
	//	min_alarm	not set for MotionRetry
	//	max_warning	not set for MotionRetry
	//	min_warning	not set for MotionRetry
	//	delta_t	not set for MotionRetry
	//	delta_val	not set for MotionRetry
	
	motionretry->set_default_properties(motionretry_prop);
	//	Not Polled
	motionretry->set_disp_level(Tango::EXPERT);
	motionretry->set_memorized();
	motionretry->set_memorized_init(false);
	att_list.push_back(motionretry);

	//	Attribute : Backlash
	BacklashAttrib	*backlash = new BacklashAttrib();
	Tango::UserDefaultAttrProp	backlash_prop;
	backlash_prop.set_description("Value for the compensation for mechanical backlash by doing final move in the direction defined by BacklashDirection (<I><B>plant coordinates/units</B></I>).");
	backlash_prop.set_label("Backlash");
	backlash_prop.set_unit("AxisUnits");
	//	standard_unit	not set for Backlash
	//	display_unit	not set for Backlash
	//	format	not set for Backlash
	//	max_value	not set for Backlash
	//	min_value	not set for Backlash
	//	max_alarm	not set for Backlash
	//	min_alarm	not set for Backlash
	//	max_warning	not set for Backlash
	//	min_warning	not set for Backlash
	//	delta_t	not set for Backlash
	//	delta_val	not set for Backlash
	
	backlash->set_default_properties(backlash_prop);
	//	Not Polled
	backlash->set_disp_level(Tango::EXPERT);
	backlash->set_memorized();
	backlash->set_memorized_init(false);
	att_list.push_back(backlash);

	//	Attribute : BacklashDirection
	BacklashDirectionAttrib	*backlashdirection = new BacklashDirectionAttrib();
	Tango::UserDefaultAttrProp	backlashdirection_prop;
	backlashdirection_prop.set_description("Direction of final move (for mechanical backlash compensation). \n\n_ <B> 0</B> : no mechanical backlash compensation\n_ <B> 1</B> : final move direction = positive direction as defined in <I><B>plant coordinates/units</B></I>\n_<B>-1</B> : final move direction = negative direction as defined in <I><B>plant coordinates/units</B></I>");
	backlashdirection_prop.set_label("BacklashDirection/OFF");
	//	unit	not set for BacklashDirection
	//	standard_unit	not set for BacklashDirection
	//	display_unit	not set for BacklashDirection
	//	format	not set for BacklashDirection
	//	max_value	not set for BacklashDirection
	//	min_value	not set for BacklashDirection
	//	max_alarm	not set for BacklashDirection
	//	min_alarm	not set for BacklashDirection
	//	max_warning	not set for BacklashDirection
	//	min_warning	not set for BacklashDirection
	//	delta_t	not set for BacklashDirection
	//	delta_val	not set for BacklashDirection
	
	backlashdirection->set_default_properties(backlashdirection_prop);
	//	Not Polled
	backlashdirection->set_disp_level(Tango::EXPERT);
	backlashdirection->set_memorized();
	backlashdirection->set_memorized_init(false);
	att_list.push_back(backlashdirection);

	//	Attribute : Velocity
	VelocityAttrib	*velocity = new VelocityAttrib();
	Tango::UserDefaultAttrProp	velocity_prop;
	velocity_prop.set_description("Actual speed of the axis (<I><B>plant coordinates/units</B></I>),\nas retorted by the underneath controller.");
	velocity_prop.set_label("Velocity");
	velocity_prop.set_unit("AxisUnits/sec");
	//	standard_unit	not set for Velocity
	//	display_unit	not set for Velocity
	//	format	not set for Velocity
	//	max_value	not set for Velocity
	//	min_value	not set for Velocity
	//	max_alarm	not set for Velocity
	//	min_alarm	not set for Velocity
	//	max_warning	not set for Velocity
	//	min_warning	not set for Velocity
	//	delta_t	not set for Velocity
	//	delta_val	not set for Velocity
	
	velocity->set_default_properties(velocity_prop);
	//	Not Polled
	velocity->set_disp_level(Tango::OPERATOR);
	//	Not Memorized
	att_list.push_back(velocity);

	//	Attribute : IsInitialised
	IsInitialisedAttrib	*isinitialised = new IsInitialisedAttrib();
	Tango::UserDefaultAttrProp	isinitialised_prop;
	isinitialised_prop.set_description("Final state of the initialisation phase:\n \n_<B> 0 </B> : axis is not initialised\n_<B> 1 </B> : iaxis is initialized");
	isinitialised_prop.set_label("IsInitialised");
	//	unit	not set for IsInitialised
	//	standard_unit	not set for IsInitialised
	//	display_unit	not set for IsInitialised
	//	format	not set for IsInitialised
	//	max_value	not set for IsInitialised
	//	min_value	not set for IsInitialised
	//	max_alarm	not set for IsInitialised
	//	min_alarm	not set for IsInitialised
	//	max_warning	not set for IsInitialised
	//	min_warning	not set for IsInitialised
	//	delta_t	not set for IsInitialised
	//	delta_val	not set for IsInitialised
	
	isinitialised->set_default_properties(isinitialised_prop);
	//	Not Polled
	isinitialised->set_disp_level(Tango::EXPERT);
	//	Not Memorized
	att_list.push_back(isinitialised);

	//	Attribute : DeviceState
	DeviceStateAttrib	*devicestate = new DeviceStateAttrib();
	Tango::UserDefaultAttrProp	devicestate_prop;
	devicestate_prop.set_description("Additional device state (numeric value).\n\n_<B> 0 </B> : UNKNOWN\n_<B> 1 </B> : ONLINE\n_<B> 2 </B> : OFFLINE\n_<B> 3 </B> : SERVICE\n_<B> 4 </B> : TEST\n\n<I>See</I> : DeviceStatus");
	devicestate_prop.set_label("Device State");
	devicestate_prop.set_unit("-");
	devicestate_prop.set_standard_unit("-");
	devicestate_prop.set_display_unit("-");
	devicestate_prop.set_format("%02d");
	devicestate_prop.set_max_value("4");
	devicestate_prop.set_min_value("0");
	//	max_alarm	not set for DeviceState
	//	min_alarm	not set for DeviceState
	//	max_warning	not set for DeviceState
	//	min_warning	not set for DeviceState
	//	delta_t	not set for DeviceState
	//	delta_val	not set for DeviceState
	
	devicestate->set_default_properties(devicestate_prop);
	//	Not Polled
	devicestate->set_disp_level(Tango::EXPERT);
	devicestate->set_memorized();
	devicestate->set_memorized_init(true);
	att_list.push_back(devicestate);

	//	Attribute : DeviceStatus
	DeviceStatusAttrib	*devicestatus = new DeviceStatusAttrib();
	Tango::UserDefaultAttrProp	devicestatus_prop;
	devicestatus_prop.set_description("Additional device status (string value).\n\nUNKNOWN, ONLINE, OFFLINE, SERVICE, TEST");
	devicestatus_prop.set_label("Device Status");
	devicestatus_prop.set_unit("-");
	devicestatus_prop.set_standard_unit("-");
	devicestatus_prop.set_display_unit("-");
	devicestatus_prop.set_format("%s");
	//	max_value	not set for DeviceStatus
	//	min_value	not set for DeviceStatus
	//	max_alarm	not set for DeviceStatus
	//	min_alarm	not set for DeviceStatus
	//	max_warning	not set for DeviceStatus
	//	min_warning	not set for DeviceStatus
	//	delta_t	not set for DeviceStatus
	//	delta_val	not set for DeviceStatus
	
	devicestatus->set_default_properties(devicestatus_prop);
	//	Not Polled
	devicestatus->set_disp_level(Tango::OPERATOR);
	//	Not Memorized
	att_list.push_back(devicestatus);

	//	Attribute : IsMicrocodeOK
	IsMicrocodeOKAttrib	*ismicrocodeok = new IsMicrocodeOKAttrib();
	Tango::UserDefaultAttrProp	ismicrocodeok_prop;
	ismicrocodeok_prop.set_description("<B>false</B> : micro code is not running on the underneath controller\n <B>true</B> : micro code is running on the underneath controller");
	ismicrocodeok_prop.set_label("IsMicroCodeOK");
	ismicrocodeok_prop.set_unit("-");
	ismicrocodeok_prop.set_standard_unit("-");
	ismicrocodeok_prop.set_display_unit("-");
	//	format	not set for IsMicrocodeOK
	//	max_value	not set for IsMicrocodeOK
	//	min_value	not set for IsMicrocodeOK
	//	max_alarm	not set for IsMicrocodeOK
	//	min_alarm	not set for IsMicrocodeOK
	//	max_warning	not set for IsMicrocodeOK
	//	min_warning	not set for IsMicrocodeOK
	//	delta_t	not set for IsMicrocodeOK
	//	delta_val	not set for IsMicrocodeOK
	
	ismicrocodeok->set_default_properties(ismicrocodeok_prop);
	ismicrocodeok->set_polling_period(5000);
	ismicrocodeok->set_disp_level(Tango::EXPERT);
	//	Not Memorized
	att_list.push_back(ismicrocodeok);

	//	Attribute : CheckEncoder
	CheckEncoderAttrib	*checkencoder = new CheckEncoderAttrib();
	Tango::UserDefaultAttrProp	checkencoder_prop;
	checkencoder_prop.set_description("<B>false</B> : deactivate the check controller functions.\n <B>true</B> : activate the check controller functions.\nThis value may be modified only through the CheckEncoderEnable property or the relevant service function.");
	checkencoder_prop.set_label("Check Encoder Enable");
	//	unit	not set for CheckEncoder
	//	standard_unit	not set for CheckEncoder
	//	display_unit	not set for CheckEncoder
	//	format	not set for CheckEncoder
	//	max_value	not set for CheckEncoder
	//	min_value	not set for CheckEncoder
	//	max_alarm	not set for CheckEncoder
	//	min_alarm	not set for CheckEncoder
	//	max_warning	not set for CheckEncoder
	//	min_warning	not set for CheckEncoder
	//	delta_t	not set for CheckEncoder
	//	delta_val	not set for CheckEncoder
	
	checkencoder->set_default_properties(checkencoder_prop);
	//	Not Polled
	checkencoder->set_disp_level(Tango::EXPERT);
	//	Not Memorized
	att_list.push_back(checkencoder);

	//	Attribute : CheckEncoderHoldOn
	CheckEncoderHoldOnAttrib	*checkencoderholdon = new CheckEncoderHoldOnAttrib();
	Tango::UserDefaultAttrProp	checkencoderholdon_prop;
	checkencoderholdon_prop.set_description("<B>false</B> : the signalling status follows that of the check controller functions.\n <B>true</B> : the signalling status holds the first error/warning of the check controller functions.");
	checkencoderholdon_prop.set_label("Check Encoder Hold On");
	//	unit	not set for CheckEncoderHoldOn
	//	standard_unit	not set for CheckEncoderHoldOn
	//	display_unit	not set for CheckEncoderHoldOn
	//	format	not set for CheckEncoderHoldOn
	//	max_value	not set for CheckEncoderHoldOn
	//	min_value	not set for CheckEncoderHoldOn
	//	max_alarm	not set for CheckEncoderHoldOn
	//	min_alarm	not set for CheckEncoderHoldOn
	//	max_warning	not set for CheckEncoderHoldOn
	//	min_warning	not set for CheckEncoderHoldOn
	//	delta_t	not set for CheckEncoderHoldOn
	//	delta_val	not set for CheckEncoderHoldOn
	
	checkencoderholdon->set_default_properties(checkencoderholdon_prop);
	//	Not Polled
	checkencoderholdon->set_disp_level(Tango::EXPERT);
	checkencoderholdon->set_memorized();
	checkencoderholdon->set_memorized_init(true);
	att_list.push_back(checkencoderholdon);

	//	Attribute : StoredPosition4Fake
	StoredPosition4FakeAttrib	*storedposition4fake = new StoredPosition4FakeAttrib();
	Tango::UserDefaultAttrProp	storedposition4fake_prop;
	//	description	not set for StoredPosition4Fake
	//	label	not set for StoredPosition4Fake
	//	unit	not set for StoredPosition4Fake
	//	standard_unit	not set for StoredPosition4Fake
	//	display_unit	not set for StoredPosition4Fake
	//	format	not set for StoredPosition4Fake
	//	max_value	not set for StoredPosition4Fake
	//	min_value	not set for StoredPosition4Fake
	//	max_alarm	not set for StoredPosition4Fake
	//	min_alarm	not set for StoredPosition4Fake
	//	max_warning	not set for StoredPosition4Fake
	//	min_warning	not set for StoredPosition4Fake
	//	delta_t	not set for StoredPosition4Fake
	//	delta_val	not set for StoredPosition4Fake
	
	storedposition4fake->set_default_properties(storedposition4fake_prop);
	//	Not Polled
	storedposition4fake->set_disp_level(Tango::EXPERT);
	//	Not Memorized
	att_list.push_back(storedposition4fake);

	//	Attribute : ExtStatus
	ExtStatusAttrib	*extstatus = new ExtStatusAttrib();
	Tango::UserDefaultAttrProp	extstatus_prop;
	extstatus_prop.set_description("Inner states/values pertinent to all the functionalities.");
	//	label	not set for ExtStatus
	//	unit	not set for ExtStatus
	//	standard_unit	not set for ExtStatus
	//	display_unit	not set for ExtStatus
	//	format	not set for ExtStatus
	//	max_value	not set for ExtStatus
	//	min_value	not set for ExtStatus
	//	max_alarm	not set for ExtStatus
	//	min_alarm	not set for ExtStatus
	//	max_warning	not set for ExtStatus
	//	min_warning	not set for ExtStatus
	//	delta_t	not set for ExtStatus
	//	delta_val	not set for ExtStatus
	
	extstatus->set_default_properties(extstatus_prop);
	//	Not Polled
	extstatus->set_disp_level(Tango::EXPERT);
	//	Not Memorized
	att_list.push_back(extstatus);

	//	Attribute : History
	HistoryAttrib	*history = new HistoryAttrib();
	Tango::UserDefaultAttrProp	history_prop;
	//	description	not set for History
	//	label	not set for History
	//	unit	not set for History
	//	standard_unit	not set for History
	//	display_unit	not set for History
	//	format	not set for History
	//	max_value	not set for History
	//	min_value	not set for History
	//	max_alarm	not set for History
	//	min_alarm	not set for History
	//	max_warning	not set for History
	//	min_warning	not set for History
	//	delta_t	not set for History
	//	delta_val	not set for History
	
	history->set_default_properties(history_prop);
	//	Not Polled
	history->set_disp_level(Tango::EXPERT);
	//	Not Memorized
	att_list.push_back(history);


	//	Create a list of static attributes
	create_static_attribute_list(get_class_attr()->get_attr_list());
	/*----- PROTECTED REGION ID(AxisG2Class::attribute_factory_after) ENABLED START -----*/
	
	//	Add your own code
	
	/*----- PROTECTED REGION END -----*/	//	AxisG2Class::attribute_factory_after
}
//--------------------------------------------------------
/**
 *	Method      : AxisG2Class::pipe_factory()
 *	Description : Create the pipe object(s)
 *                and store them in the pipe list
 */
//--------------------------------------------------------
void AxisG2Class::pipe_factory()
{
	/*----- PROTECTED REGION ID(AxisG2Class::pipe_factory_before) ENABLED START -----*/
	
	//	Add your own code
	
	/*----- PROTECTED REGION END -----*/	//	AxisG2Class::pipe_factory_before
	/*----- PROTECTED REGION ID(AxisG2Class::pipe_factory_after) ENABLED START -----*/
	
	//	Add your own code
	
	/*----- PROTECTED REGION END -----*/	//	AxisG2Class::pipe_factory_after
}
//--------------------------------------------------------
/**
 *	Method      : AxisG2Class::command_factory()
 *	Description : Create the command object(s)
 *                and store them in the command list
 */
//--------------------------------------------------------
void AxisG2Class::command_factory()
{
	/*----- PROTECTED REGION ID(AxisG2Class::command_factory_before) ENABLED START -----*/
	
	//	Add your own code
	
	/*----- PROTECTED REGION END -----*/	//	AxisG2Class::command_factory_before


	//	Command Forward
	ForwardClass	*pForwardCmd =
		new ForwardClass("Forward",
			Tango::DEV_VOID, Tango::DEV_VOID,
			"",
			"",
			Tango::OPERATOR);
	command_list.push_back(pForwardCmd);

	//	Command Stop
	StopClass	*pStopCmd =
		new StopClass("Stop",
			Tango::DEV_VOID, Tango::DEV_VOID,
			"",
			"",
			Tango::OPERATOR);
	command_list.push_back(pStopCmd);

	//	Command Backward
	BackwardClass	*pBackwardCmd =
		new BackwardClass("Backward",
			Tango::DEV_VOID, Tango::DEV_VOID,
			"",
			"",
			Tango::OPERATOR);
	command_list.push_back(pBackwardCmd);

	//	Command GoToRelativePosition
	GoToRelativePositionClass	*pGoToRelativePositionCmd =
		new GoToRelativePositionClass("GoToRelativePosition",
			Tango::DEV_DOUBLE, Tango::DEV_VOID,
			"Relative move in plant unit",
			"",
			Tango::OPERATOR);
	command_list.push_back(pGoToRelativePositionCmd);

	//	Command GoToPosition
	GoToPositionClass	*pGoToPositionCmd =
		new GoToPositionClass("GoToPosition",
			Tango::DEV_DOUBLE, Tango::DEV_VOID,
			"Absolute position in plant units",
			"",
			Tango::OPERATOR);
	command_list.push_back(pGoToPositionCmd);

	//	Command DefinePosition
	DefinePositionClass	*pDefinePositionCmd =
		new DefinePositionClass("DefinePosition",
			Tango::DEV_DOUBLE, Tango::DEV_STRING,
			"Actual position in plant units",
			"",
			Tango::OPERATOR);
	command_list.push_back(pDefinePositionCmd);

	//	Command GetMotionStatus
	GetMotionStatusClass	*pGetMotionStatusCmd =
		new GetMotionStatusClass("GetMotionStatus",
			Tango::DEV_VOID, Tango::DEV_LONG,
			"",
			"",
			Tango::EXPERT);
	command_list.push_back(pGetMotionStatusCmd);

	//	Command FindEdge
	FindEdgeClass	*pFindEdgeCmd =
		new FindEdgeClass("FindEdge",
			Tango::DEV_VOID, Tango::DEV_VOID,
			"",
			"",
			Tango::EXPERT);
	command_list.push_back(pFindEdgeCmd);

	//	Command FindIndex
	FindIndexClass	*pFindIndexCmd =
		new FindIndexClass("FindIndex",
			Tango::DEV_VOID, Tango::DEV_VOID,
			"",
			"",
			Tango::EXPERT);
	command_list.push_back(pFindIndexCmd);

	//	Command FindHome
	FindHomeClass	*pFindHomeCmd =
		new FindHomeClass("FindHome",
			Tango::DEV_VOID, Tango::DEV_VOID,
			"",
			"",
			Tango::EXPERT);
	command_list.push_back(pFindHomeCmd);

	//	Command GetErrorStatus
	GetErrorStatusClass	*pGetErrorStatusCmd =
		new GetErrorStatusClass("GetErrorStatus",
			Tango::DEV_VOID, Tango::DEV_LONG,
			"",
			"",
			Tango::EXPERT);
	command_list.push_back(pGetErrorStatusCmd);

	//	Command DirectCmd
	DirectCmdClass	*pDirectCmdCmd =
		new DirectCmdClass("DirectCmd",
			Tango::DEV_STRING, Tango::DEV_STRING,
			"",
			"",
			Tango::EXPERT);
	command_list.push_back(pDirectCmdCmd);

	//	Command AxisInit
	AxisInitClass	*pAxisInitCmd =
		new AxisInitClass("AxisInit",
			Tango::DEV_VOID, Tango::DEV_VOID,
			"",
			"",
			Tango::EXPERT);
	command_list.push_back(pAxisInitCmd);

	//	Command MotorOFF
	MotorOFFClass	*pMotorOFFCmd =
		new MotorOFFClass("MotorOFF",
			Tango::DEV_VOID, Tango::DEV_VOID,
			"",
			"",
			Tango::EXPERT);
	command_list.push_back(pMotorOFFCmd);

	//	Command MotorON
	MotorONClass	*pMotorONCmd =
		new MotorONClass("MotorON",
			Tango::DEV_VOID, Tango::DEV_VOID,
			"",
			"",
			Tango::EXPERT);
	command_list.push_back(pMotorONCmd);

	//	Command ReadHWConf
	ReadHWConfClass	*pReadHWConfCmd =
		new ReadHWConfClass("ReadHWConf",
			Tango::DEV_VOID, Tango::DEVVAR_STRINGARRAY,
			"",
			"",
			Tango::EXPERT);
	command_list.push_back(pReadHWConfCmd);

	//	Command GetUserEncoderRatio
	GetUserEncoderRatioClass	*pGetUserEncoderRatioCmd =
		new GetUserEncoderRatioClass("GetUserEncoderRatio",
			Tango::DEV_VOID, Tango::DEV_DOUBLE,
			"",
			"",
			Tango::OPERATOR);
	command_list.push_back(pGetUserEncoderRatioCmd);

	//	Command Service
	ServiceClass	*pServiceCmd =
		new ServiceClass("Service",
			Tango::DEV_STRING, Tango::DEV_STRING,
			"command",
			"",
			Tango::EXPERT);
	command_list.push_back(pServiceCmd);

	//	Command GetMotionHistory
	GetMotionHistoryClass	*pGetMotionHistoryCmd =
		new GetMotionHistoryClass("GetMotionHistory",
			Tango::DEV_VOID, Tango::DEVVAR_STRINGARRAY,
			"",
			"",
			Tango::OPERATOR);
	command_list.push_back(pGetMotionHistoryCmd);

	//	Command RestoreLastPosition
	RestoreLastPositionClass	*pRestoreLastPositionCmd =
		new RestoreLastPositionClass("RestoreLastPosition",
			Tango::DEV_VOID, Tango::DEV_VOID,
			"",
			"",
			Tango::EXPERT);
	command_list.push_back(pRestoreLastPositionCmd);

	//	Command AckCheckEnc
	AckCheckEncClass	*pAckCheckEncCmd =
		new AckCheckEncClass("AckCheckEnc",
			Tango::DEV_VOID, Tango::DEV_VOID,
			"",
			"",
			Tango::EXPERT);
	command_list.push_back(pAckCheckEncCmd);

	//	Command RawAbsPos
	RawAbsPosClass	*pRawAbsPosCmd =
		new RawAbsPosClass("RawAbsPos",
			Tango::DEV_DOUBLE, Tango::DEV_VOID,
			"Absolute move in plant unit",
			"",
			Tango::OPERATOR);
	command_list.push_back(pRawAbsPosCmd);

	//	Command RawRelPos
	RawRelPosClass	*pRawRelPosCmd =
		new RawRelPosClass("RawRelPos",
			Tango::DEV_DOUBLE, Tango::DEV_VOID,
			"Relative move in plant unit",
			"",
			Tango::OPERATOR);
	command_list.push_back(pRawRelPosCmd);

	//	Command UserRawAbsPos
	UserRawAbsPosClass	*pUserRawAbsPosCmd =
		new UserRawAbsPosClass("UserRawAbsPos",
			Tango::DEV_DOUBLE, Tango::DEV_VOID,
			"Absolute move in user unit",
			"",
			Tango::OPERATOR);
	command_list.push_back(pUserRawAbsPosCmd);

	//	Command UserRawRelPos
	UserRawRelPosClass	*pUserRawRelPosCmd =
		new UserRawRelPosClass("UserRawRelPos",
			Tango::DEV_DOUBLE, Tango::DEV_VOID,
			"Relative move in user unit",
			"",
			Tango::OPERATOR);
	command_list.push_back(pUserRawRelPosCmd);

	//	Command get_p4e
	get_p4eClass	*pget_p4eCmd =
		new get_p4eClass("get_p4e",
			Tango::DEV_DOUBLE, Tango::DEV_DOUBLE,
			"",
			"",
			Tango::EXPERT);
	command_list.push_back(pget_p4eCmd);

	//	Command get_e4p
	get_e4pClass	*pget_e4pCmd =
		new get_e4pClass("get_e4p",
			Tango::DEV_DOUBLE, Tango::DEV_DOUBLE,
			"",
			"",
			Tango::EXPERT);
	command_list.push_back(pget_e4pCmd);

	//	Command get_u4p
	get_u4pClass	*pget_u4pCmd =
		new get_u4pClass("get_u4p",
			Tango::DEV_DOUBLE, Tango::DEV_DOUBLE,
			"",
			"",
			Tango::EXPERT);
	command_list.push_back(pget_u4pCmd);

	//	Command get_p4u
	get_p4uClass	*pget_p4uCmd =
		new get_p4uClass("get_p4u",
			Tango::DEV_DOUBLE, Tango::DEV_DOUBLE,
			"",
			"",
			Tango::EXPERT);
	command_list.push_back(pget_p4uCmd);

	//	Command get_u4e
	get_u4eClass	*pget_u4eCmd =
		new get_u4eClass("get_u4e",
			Tango::DEV_DOUBLE, Tango::DEV_DOUBLE,
			"",
			"",
			Tango::EXPERT);
	command_list.push_back(pget_u4eCmd);

	//	Command get_e4u
	get_e4uClass	*pget_e4uCmd =
		new get_e4uClass("get_e4u",
			Tango::DEV_DOUBLE, Tango::DEV_DOUBLE,
			"",
			"",
			Tango::EXPERT);
	command_list.push_back(pget_e4uCmd);

	//	Command StorePosition4Fake
	StorePosition4FakeClass	*pStorePosition4FakeCmd =
		new StorePosition4FakeClass("StorePosition4Fake",
			Tango::DEV_VOID, Tango::DEV_VOID,
			"",
			"",
			Tango::EXPERT);
	command_list.push_back(pStorePosition4FakeCmd);

	//	Command FakeAxisInit
	FakeAxisInitClass	*pFakeAxisInitCmd =
		new FakeAxisInitClass("FakeAxisInit",
			Tango::DEV_VOID, Tango::DEV_VOID,
			"",
			"",
			Tango::EXPERT);
	command_list.push_back(pFakeAxisInitCmd);

	/*----- PROTECTED REGION ID(AxisG2Class::command_factory_after) ENABLED START -----*/
	
	//	Add your own code
	
	/*----- PROTECTED REGION END -----*/	//	AxisG2Class::command_factory_after
}

//===================================================================
//	Dynamic attributes related methods
//===================================================================

//--------------------------------------------------------
/**
 * method : 		AxisG2Class::create_static_attribute_list
 * description : 	Create the a list of static attributes
 *
 * @param	att_list	the ceated attribute list
 */
//--------------------------------------------------------
void AxisG2Class::create_static_attribute_list(vector<Tango::Attr *> &att_list)
{
	for (unsigned long i=0 ; i<att_list.size() ; i++)
	{
		string att_name(att_list[i]->get_name());
		transform(att_name.begin(), att_name.end(), att_name.begin(), ::tolower);
		defaultAttList.push_back(att_name);
	}

	cout2 << defaultAttList.size() << " attributes in default list" << endl;

	/*----- PROTECTED REGION ID(AxisG2Class::create_static_att_list) ENABLED START -----*/
	
	/*----- PROTECTED REGION END -----*/	//	AxisG2Class::create_static_att_list
}


//--------------------------------------------------------
/**
 * method : 		AxisG2Class::erase_dynamic_attributes
 * description : 	delete the dynamic attributes if any.
 *
 * @param	devlist_ptr	the device list pointer
 * @param	list of all attributes
 */
//--------------------------------------------------------
void AxisG2Class::erase_dynamic_attributes(const Tango::DevVarStringArray *devlist_ptr, vector<Tango::Attr *> &att_list)
{
	Tango::Util *tg = Tango::Util::instance();

	for (unsigned long i=0 ; i<devlist_ptr->length() ; i++)
	{
		Tango::DeviceImpl *dev_impl = tg->get_device_by_name(((string)(*devlist_ptr)[i]).c_str());
		AxisG2 *dev = static_cast<AxisG2 *> (dev_impl);

		vector<Tango::Attribute *> &dev_att_list = dev->get_device_attr()->get_attribute_list();
		vector<Tango::Attribute *>::iterator ite_att;
		for (ite_att=dev_att_list.begin() ; ite_att != dev_att_list.end() ; ++ite_att)
		{
			string att_name((*ite_att)->get_name_lower());
			if ((att_name == "state") || (att_name == "status"))
				continue;
			vector<string>::iterator ite_str = find(defaultAttList.begin(), defaultAttList.end(), att_name);
			if (ite_str == defaultAttList.end())
			{
				cout2 << att_name << " is a UNWANTED dynamic attribute for device " << (*devlist_ptr)[i] << endl;
				Tango::Attribute &att = dev->get_device_attr()->get_attr_by_name(att_name.c_str());
				dev->remove_attribute(att_list[att.get_attr_idx()], true, false);
				--ite_att;
			}
		}
	}
	/*----- PROTECTED REGION ID(AxisG2Class::erase_dynamic_attributes) ENABLED START -----*/
	
	/*----- PROTECTED REGION END -----*/	//	AxisG2Class::erase_dynamic_attributes
}

//--------------------------------------------------------
/**
 *	Method      : AxisG2Class::get_attr_object_by_name()
 *	Description : returns Tango::Attr * object found by name
 */
//--------------------------------------------------------
Tango::Attr *AxisG2Class::get_attr_object_by_name(vector<Tango::Attr *> &att_list, string attname)
{
	vector<Tango::Attr *>::iterator it;
	for (it=att_list.begin() ; it<att_list.end() ; ++it)
		if ((*it)->get_name()==attname)
			return (*it);
	//	Attr does not exist
	return NULL;
}


/*----- PROTECTED REGION ID(AxisG2Class::Additional Methods) ENABLED START -----*/

/*----- PROTECTED REGION END -----*/	//	AxisG2Class::Additional Methods
} //	namespace
