/*----- PROTECTED REGION ID(AxisG2Class.h) ENABLED START -----*/
//=============================================================================
//
// file :        AxisG2Class.h
//
// description : Include for the AxisG2 root class.
//               This class is the singleton class for
//                the AxisG2 device class.
//               It contains all properties and methods which the 
//               AxisG2 requires only once e.g. the commands.
//
// project :     Axis
//
// This file is part of Tango device class.
// 
// Tango is free software: you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation, either version 3 of the License, or
// (at your option) any later version.
// 
// Tango is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
// 
// You should have received a copy of the GNU General Public License
// along with Tango.  If not, see <http://www.gnu.org/licenses/>.
// 
// $Author: abrami $
//
//
//=============================================================================
//                This file is generated by POGO
//        (Program Obviously used to Generate tango Object)
//=============================================================================


#ifndef AxisG2Class_H
#define AxisG2Class_H

#include <tango.h>
#include <AxisG2.h>


/*----- PROTECTED REGION END -----*/	//	AxisG2Class.h


namespace AxisG2_ns
{
/*----- PROTECTED REGION ID(AxisG2Class::classes for dynamic creation) ENABLED START -----*/


/*----- PROTECTED REGION END -----*/	//	AxisG2Class::classes for dynamic creation

//=========================================
//	Define classes for attributes
//=========================================
//	Attribute Position class definition
class PositionAttrib: public Tango::Attr
{
public:
	PositionAttrib():Attr("Position",
			Tango::DEV_DOUBLE, Tango::READ_WRITE) {};
	~PositionAttrib() {};
	virtual void read(Tango::DeviceImpl *dev,Tango::Attribute &att)
		{(static_cast<AxisG2 *>(dev))->read_Position(att);}
	virtual void write(Tango::DeviceImpl *dev,Tango::WAttribute &att)
		{(static_cast<AxisG2 *>(dev))->write_Position(att);}
	virtual bool is_allowed(Tango::DeviceImpl *dev,Tango::AttReqType ty)
		{return (static_cast<AxisG2 *>(dev))->is_Position_allowed(ty);}
};

//	Attribute PositiveLimitSwitch class definition
class PositiveLimitSwitchAttrib: public Tango::Attr
{
public:
	PositiveLimitSwitchAttrib():Attr("PositiveLimitSwitch",
			Tango::DEV_BOOLEAN, Tango::READ) {};
	~PositiveLimitSwitchAttrib() {};
	virtual void read(Tango::DeviceImpl *dev,Tango::Attribute &att)
		{(static_cast<AxisG2 *>(dev))->read_PositiveLimitSwitch(att);}
	virtual bool is_allowed(Tango::DeviceImpl *dev,Tango::AttReqType ty)
		{return (static_cast<AxisG2 *>(dev))->is_PositiveLimitSwitch_allowed(ty);}
};

//	Attribute NegativeLimitSwitch class definition
class NegativeLimitSwitchAttrib: public Tango::Attr
{
public:
	NegativeLimitSwitchAttrib():Attr("NegativeLimitSwitch",
			Tango::DEV_BOOLEAN, Tango::READ) {};
	~NegativeLimitSwitchAttrib() {};
	virtual void read(Tango::DeviceImpl *dev,Tango::Attribute &att)
		{(static_cast<AxisG2 *>(dev))->read_NegativeLimitSwitch(att);}
	virtual bool is_allowed(Tango::DeviceImpl *dev,Tango::AttReqType ty)
		{return (static_cast<AxisG2 *>(dev))->is_NegativeLimitSwitch_allowed(ty);}
};

//	Attribute HomeSwitch class definition
class HomeSwitchAttrib: public Tango::Attr
{
public:
	HomeSwitchAttrib():Attr("HomeSwitch",
			Tango::DEV_BOOLEAN, Tango::READ) {};
	~HomeSwitchAttrib() {};
	virtual void read(Tango::DeviceImpl *dev,Tango::Attribute &att)
		{(static_cast<AxisG2 *>(dev))->read_HomeSwitch(att);}
	virtual bool is_allowed(Tango::DeviceImpl *dev,Tango::AttReqType ty)
		{return (static_cast<AxisG2 *>(dev))->is_HomeSwitch_allowed(ty);}
};

//	Attribute MotorStatus class definition
class MotorStatusAttrib: public Tango::Attr
{
public:
	MotorStatusAttrib():Attr("MotorStatus",
			Tango::DEV_STRING, Tango::READ) {};
	~MotorStatusAttrib() {};
	virtual void read(Tango::DeviceImpl *dev,Tango::Attribute &att)
		{(static_cast<AxisG2 *>(dev))->read_MotorStatus(att);}
	virtual bool is_allowed(Tango::DeviceImpl *dev,Tango::AttReqType ty)
		{return (static_cast<AxisG2 *>(dev))->is_MotorStatus_allowed(ty);}
};

//	Attribute EncoderPosition class definition
class EncoderPositionAttrib: public Tango::Attr
{
public:
	EncoderPositionAttrib():Attr("EncoderPosition",
			Tango::DEV_DOUBLE, Tango::READ) {};
	~EncoderPositionAttrib() {};
	virtual void read(Tango::DeviceImpl *dev,Tango::Attribute &att)
		{(static_cast<AxisG2 *>(dev))->read_EncoderPosition(att);}
	virtual bool is_allowed(Tango::DeviceImpl *dev,Tango::AttReqType ty)
		{return (static_cast<AxisG2 *>(dev))->is_EncoderPosition_allowed(ty);}
};

//	Attribute MotorPosition class definition
class MotorPositionAttrib: public Tango::Attr
{
public:
	MotorPositionAttrib():Attr("MotorPosition",
			Tango::DEV_LONG, Tango::READ_WRITE) {};
	~MotorPositionAttrib() {};
	virtual void read(Tango::DeviceImpl *dev,Tango::Attribute &att)
		{(static_cast<AxisG2 *>(dev))->read_MotorPosition(att);}
	virtual void write(Tango::DeviceImpl *dev,Tango::WAttribute &att)
		{(static_cast<AxisG2 *>(dev))->write_MotorPosition(att);}
	virtual bool is_allowed(Tango::DeviceImpl *dev,Tango::AttReqType ty)
		{return (static_cast<AxisG2 *>(dev))->is_MotorPosition_allowed(ty);}
};

//	Attribute UserPosition class definition
class UserPositionAttrib: public Tango::Attr
{
public:
	UserPositionAttrib():Attr("UserPosition",
			Tango::DEV_DOUBLE, Tango::READ_WRITE) {};
	~UserPositionAttrib() {};
	virtual void read(Tango::DeviceImpl *dev,Tango::Attribute &att)
		{(static_cast<AxisG2 *>(dev))->read_UserPosition(att);}
	virtual void write(Tango::DeviceImpl *dev,Tango::WAttribute &att)
		{(static_cast<AxisG2 *>(dev))->write_UserPosition(att);}
	virtual bool is_allowed(Tango::DeviceImpl *dev,Tango::AttReqType ty)
		{return (static_cast<AxisG2 *>(dev))->is_UserPosition_allowed(ty);}
};

//	Attribute UserScale class definition
class UserScaleAttrib: public Tango::Attr
{
public:
	UserScaleAttrib():Attr("UserScale",
			Tango::DEV_DOUBLE, Tango::READ_WRITE) {};
	~UserScaleAttrib() {};
	virtual void read(Tango::DeviceImpl *dev,Tango::Attribute &att)
		{(static_cast<AxisG2 *>(dev))->read_UserScale(att);}
	virtual void write(Tango::DeviceImpl *dev,Tango::WAttribute &att)
		{(static_cast<AxisG2 *>(dev))->write_UserScale(att);}
	virtual bool is_allowed(Tango::DeviceImpl *dev,Tango::AttReqType ty)
		{return (static_cast<AxisG2 *>(dev))->is_UserScale_allowed(ty);}
};

//	Attribute UserOffset class definition
class UserOffsetAttrib: public Tango::Attr
{
public:
	UserOffsetAttrib():Attr("UserOffset",
			Tango::DEV_DOUBLE, Tango::READ_WRITE) {};
	~UserOffsetAttrib() {};
	virtual void read(Tango::DeviceImpl *dev,Tango::Attribute &att)
		{(static_cast<AxisG2 *>(dev))->read_UserOffset(att);}
	virtual void write(Tango::DeviceImpl *dev,Tango::WAttribute &att)
		{(static_cast<AxisG2 *>(dev))->write_UserOffset(att);}
	virtual bool is_allowed(Tango::DeviceImpl *dev,Tango::AttReqType ty)
		{return (static_cast<AxisG2 *>(dev))->is_UserOffset_allowed(ty);}
};

//	Attribute UserSpeed class definition
class UserSpeedAttrib: public Tango::Attr
{
public:
	UserSpeedAttrib():Attr("UserSpeed",
			Tango::DEV_DOUBLE, Tango::READ_WRITE) {};
	~UserSpeedAttrib() {};
	virtual void read(Tango::DeviceImpl *dev,Tango::Attribute &att)
		{(static_cast<AxisG2 *>(dev))->read_UserSpeed(att);}
	virtual void write(Tango::DeviceImpl *dev,Tango::WAttribute &att)
		{(static_cast<AxisG2 *>(dev))->write_UserSpeed(att);}
	virtual bool is_allowed(Tango::DeviceImpl *dev,Tango::AttReqType ty)
		{return (static_cast<AxisG2 *>(dev))->is_UserSpeed_allowed(ty);}
};

//	Attribute Speed class definition
class SpeedAttrib: public Tango::Attr
{
public:
	SpeedAttrib():Attr("Speed",
			Tango::DEV_DOUBLE, Tango::READ_WRITE) {};
	~SpeedAttrib() {};
	virtual void read(Tango::DeviceImpl *dev,Tango::Attribute &att)
		{(static_cast<AxisG2 *>(dev))->read_Speed(att);}
	virtual void write(Tango::DeviceImpl *dev,Tango::WAttribute &att)
		{(static_cast<AxisG2 *>(dev))->write_Speed(att);}
	virtual bool is_allowed(Tango::DeviceImpl *dev,Tango::AttReqType ty)
		{return (static_cast<AxisG2 *>(dev))->is_Speed_allowed(ty);}
};

//	Attribute Acceleration class definition
class AccelerationAttrib: public Tango::Attr
{
public:
	AccelerationAttrib():Attr("Acceleration",
			Tango::DEV_DOUBLE, Tango::READ_WRITE) {};
	~AccelerationAttrib() {};
	virtual void read(Tango::DeviceImpl *dev,Tango::Attribute &att)
		{(static_cast<AxisG2 *>(dev))->read_Acceleration(att);}
	virtual void write(Tango::DeviceImpl *dev,Tango::WAttribute &att)
		{(static_cast<AxisG2 *>(dev))->write_Acceleration(att);}
	virtual bool is_allowed(Tango::DeviceImpl *dev,Tango::AttReqType ty)
		{return (static_cast<AxisG2 *>(dev))->is_Acceleration_allowed(ty);}
};

//	Attribute Deceleration class definition
class DecelerationAttrib: public Tango::Attr
{
public:
	DecelerationAttrib():Attr("Deceleration",
			Tango::DEV_DOUBLE, Tango::READ_WRITE) {};
	~DecelerationAttrib() {};
	virtual void read(Tango::DeviceImpl *dev,Tango::Attribute &att)
		{(static_cast<AxisG2 *>(dev))->read_Deceleration(att);}
	virtual void write(Tango::DeviceImpl *dev,Tango::WAttribute &att)
		{(static_cast<AxisG2 *>(dev))->write_Deceleration(att);}
	virtual bool is_allowed(Tango::DeviceImpl *dev,Tango::AttReqType ty)
		{return (static_cast<AxisG2 *>(dev))->is_Deceleration_allowed(ty);}
};

//	Attribute MotionAccuracy class definition
class MotionAccuracyAttrib: public Tango::Attr
{
public:
	MotionAccuracyAttrib():Attr("MotionAccuracy",
			Tango::DEV_DOUBLE, Tango::READ_WRITE) {};
	~MotionAccuracyAttrib() {};
	virtual void read(Tango::DeviceImpl *dev,Tango::Attribute &att)
		{(static_cast<AxisG2 *>(dev))->read_MotionAccuracy(att);}
	virtual void write(Tango::DeviceImpl *dev,Tango::WAttribute &att)
		{(static_cast<AxisG2 *>(dev))->write_MotionAccuracy(att);}
	virtual bool is_allowed(Tango::DeviceImpl *dev,Tango::AttReqType ty)
		{return (static_cast<AxisG2 *>(dev))->is_MotionAccuracy_allowed(ty);}
};

//	Attribute MotionPercent class definition
class MotionPercentAttrib: public Tango::Attr
{
public:
	MotionPercentAttrib():Attr("MotionPercent",
			Tango::DEV_DOUBLE, Tango::READ_WRITE) {};
	~MotionPercentAttrib() {};
	virtual void read(Tango::DeviceImpl *dev,Tango::Attribute &att)
		{(static_cast<AxisG2 *>(dev))->read_MotionPercent(att);}
	virtual void write(Tango::DeviceImpl *dev,Tango::WAttribute &att)
		{(static_cast<AxisG2 *>(dev))->write_MotionPercent(att);}
	virtual bool is_allowed(Tango::DeviceImpl *dev,Tango::AttReqType ty)
		{return (static_cast<AxisG2 *>(dev))->is_MotionPercent_allowed(ty);}
};

//	Attribute MotionRetry class definition
class MotionRetryAttrib: public Tango::Attr
{
public:
	MotionRetryAttrib():Attr("MotionRetry",
			Tango::DEV_DOUBLE, Tango::READ_WRITE) {};
	~MotionRetryAttrib() {};
	virtual void read(Tango::DeviceImpl *dev,Tango::Attribute &att)
		{(static_cast<AxisG2 *>(dev))->read_MotionRetry(att);}
	virtual void write(Tango::DeviceImpl *dev,Tango::WAttribute &att)
		{(static_cast<AxisG2 *>(dev))->write_MotionRetry(att);}
	virtual bool is_allowed(Tango::DeviceImpl *dev,Tango::AttReqType ty)
		{return (static_cast<AxisG2 *>(dev))->is_MotionRetry_allowed(ty);}
};

//	Attribute Backlash class definition
class BacklashAttrib: public Tango::Attr
{
public:
	BacklashAttrib():Attr("Backlash",
			Tango::DEV_DOUBLE, Tango::READ_WRITE) {};
	~BacklashAttrib() {};
	virtual void read(Tango::DeviceImpl *dev,Tango::Attribute &att)
		{(static_cast<AxisG2 *>(dev))->read_Backlash(att);}
	virtual void write(Tango::DeviceImpl *dev,Tango::WAttribute &att)
		{(static_cast<AxisG2 *>(dev))->write_Backlash(att);}
	virtual bool is_allowed(Tango::DeviceImpl *dev,Tango::AttReqType ty)
		{return (static_cast<AxisG2 *>(dev))->is_Backlash_allowed(ty);}
};

//	Attribute BacklashDirection class definition
class BacklashDirectionAttrib: public Tango::Attr
{
public:
	BacklashDirectionAttrib():Attr("BacklashDirection",
			Tango::DEV_DOUBLE, Tango::READ_WRITE) {};
	~BacklashDirectionAttrib() {};
	virtual void read(Tango::DeviceImpl *dev,Tango::Attribute &att)
		{(static_cast<AxisG2 *>(dev))->read_BacklashDirection(att);}
	virtual void write(Tango::DeviceImpl *dev,Tango::WAttribute &att)
		{(static_cast<AxisG2 *>(dev))->write_BacklashDirection(att);}
	virtual bool is_allowed(Tango::DeviceImpl *dev,Tango::AttReqType ty)
		{return (static_cast<AxisG2 *>(dev))->is_BacklashDirection_allowed(ty);}
};

//	Attribute Velocity class definition
class VelocityAttrib: public Tango::Attr
{
public:
	VelocityAttrib():Attr("Velocity",
			Tango::DEV_DOUBLE, Tango::READ) {};
	~VelocityAttrib() {};
	virtual void read(Tango::DeviceImpl *dev,Tango::Attribute &att)
		{(static_cast<AxisG2 *>(dev))->read_Velocity(att);}
	virtual bool is_allowed(Tango::DeviceImpl *dev,Tango::AttReqType ty)
		{return (static_cast<AxisG2 *>(dev))->is_Velocity_allowed(ty);}
};

//	Attribute IsInitialised class definition
class IsInitialisedAttrib: public Tango::Attr
{
public:
	IsInitialisedAttrib():Attr("IsInitialised",
			Tango::DEV_SHORT, Tango::READ) {};
	~IsInitialisedAttrib() {};
	virtual void read(Tango::DeviceImpl *dev,Tango::Attribute &att)
		{(static_cast<AxisG2 *>(dev))->read_IsInitialised(att);}
	virtual bool is_allowed(Tango::DeviceImpl *dev,Tango::AttReqType ty)
		{return (static_cast<AxisG2 *>(dev))->is_IsInitialised_allowed(ty);}
};

//	Attribute DeviceState class definition
class DeviceStateAttrib: public Tango::Attr
{
public:
	DeviceStateAttrib():Attr("DeviceState",
			Tango::DEV_USHORT, Tango::READ_WRITE) {};
	~DeviceStateAttrib() {};
	virtual void read(Tango::DeviceImpl *dev,Tango::Attribute &att)
		{(static_cast<AxisG2 *>(dev))->read_DeviceState(att);}
	virtual void write(Tango::DeviceImpl *dev,Tango::WAttribute &att)
		{(static_cast<AxisG2 *>(dev))->write_DeviceState(att);}
	virtual bool is_allowed(Tango::DeviceImpl *dev,Tango::AttReqType ty)
		{return (static_cast<AxisG2 *>(dev))->is_DeviceState_allowed(ty);}
};

//	Attribute DeviceStatus class definition
class DeviceStatusAttrib: public Tango::Attr
{
public:
	DeviceStatusAttrib():Attr("DeviceStatus",
			Tango::DEV_STRING, Tango::READ) {};
	~DeviceStatusAttrib() {};
	virtual void read(Tango::DeviceImpl *dev,Tango::Attribute &att)
		{(static_cast<AxisG2 *>(dev))->read_DeviceStatus(att);}
	virtual bool is_allowed(Tango::DeviceImpl *dev,Tango::AttReqType ty)
		{return (static_cast<AxisG2 *>(dev))->is_DeviceStatus_allowed(ty);}
};

//	Attribute IsMicrocodeOK class definition
class IsMicrocodeOKAttrib: public Tango::Attr
{
public:
	IsMicrocodeOKAttrib():Attr("IsMicrocodeOK",
			Tango::DEV_BOOLEAN, Tango::READ) {};
	~IsMicrocodeOKAttrib() {};
	virtual void read(Tango::DeviceImpl *dev,Tango::Attribute &att)
		{(static_cast<AxisG2 *>(dev))->read_IsMicrocodeOK(att);}
	virtual bool is_allowed(Tango::DeviceImpl *dev,Tango::AttReqType ty)
		{return (static_cast<AxisG2 *>(dev))->is_IsMicrocodeOK_allowed(ty);}
};

//	Attribute CheckEncoder class definition
class CheckEncoderAttrib: public Tango::Attr
{
public:
	CheckEncoderAttrib():Attr("CheckEncoder",
			Tango::DEV_BOOLEAN, Tango::READ) {};
	~CheckEncoderAttrib() {};
	virtual void read(Tango::DeviceImpl *dev,Tango::Attribute &att)
		{(static_cast<AxisG2 *>(dev))->read_CheckEncoder(att);}
	virtual bool is_allowed(Tango::DeviceImpl *dev,Tango::AttReqType ty)
		{return (static_cast<AxisG2 *>(dev))->is_CheckEncoder_allowed(ty);}
};

//	Attribute CheckEncoderHoldOn class definition
class CheckEncoderHoldOnAttrib: public Tango::Attr
{
public:
	CheckEncoderHoldOnAttrib():Attr("CheckEncoderHoldOn",
			Tango::DEV_BOOLEAN, Tango::READ_WRITE) {};
	~CheckEncoderHoldOnAttrib() {};
	virtual void read(Tango::DeviceImpl *dev,Tango::Attribute &att)
		{(static_cast<AxisG2 *>(dev))->read_CheckEncoderHoldOn(att);}
	virtual void write(Tango::DeviceImpl *dev,Tango::WAttribute &att)
		{(static_cast<AxisG2 *>(dev))->write_CheckEncoderHoldOn(att);}
	virtual bool is_allowed(Tango::DeviceImpl *dev,Tango::AttReqType ty)
		{return (static_cast<AxisG2 *>(dev))->is_CheckEncoderHoldOn_allowed(ty);}
};

//	Attribute StoredPosition4Fake class definition
class StoredPosition4FakeAttrib: public Tango::Attr
{
public:
	StoredPosition4FakeAttrib():Attr("StoredPosition4Fake",
			Tango::DEV_DOUBLE, Tango::READ) {};
	~StoredPosition4FakeAttrib() {};
	virtual void read(Tango::DeviceImpl *dev,Tango::Attribute &att)
		{(static_cast<AxisG2 *>(dev))->read_StoredPosition4Fake(att);}
	virtual bool is_allowed(Tango::DeviceImpl *dev,Tango::AttReqType ty)
		{return (static_cast<AxisG2 *>(dev))->is_StoredPosition4Fake_allowed(ty);}
};

//	Attribute ExtStatus class definition
class ExtStatusAttrib: public Tango::SpectrumAttr
{
public:
	ExtStatusAttrib():SpectrumAttr("ExtStatus",
			Tango::DEV_STRING, Tango::READ, 100) {};
	~ExtStatusAttrib() {};
	virtual void read(Tango::DeviceImpl *dev,Tango::Attribute &att)
		{(static_cast<AxisG2 *>(dev))->read_ExtStatus(att);}
	virtual bool is_allowed(Tango::DeviceImpl *dev,Tango::AttReqType ty)
		{return (static_cast<AxisG2 *>(dev))->is_ExtStatus_allowed(ty);}
};

//	Attribute History class definition
class HistoryAttrib: public Tango::SpectrumAttr
{
public:
	HistoryAttrib():SpectrumAttr("History",
			Tango::DEV_STRING, Tango::READ, 2000) {};
	~HistoryAttrib() {};
	virtual void read(Tango::DeviceImpl *dev,Tango::Attribute &att)
		{(static_cast<AxisG2 *>(dev))->read_History(att);}
	virtual bool is_allowed(Tango::DeviceImpl *dev,Tango::AttReqType ty)
		{return (static_cast<AxisG2 *>(dev))->is_History_allowed(ty);}
};


//=========================================
//	Define classes for commands
//=========================================
//	Command Forward class definition
class ForwardClass : public Tango::Command
{
public:
	ForwardClass(const char   *name,
	               Tango::CmdArgType in,
				   Tango::CmdArgType out,
				   const char        *in_desc,
				   const char        *out_desc,
				   Tango::DispLevel  level)
	:Command(name,in,out,in_desc,out_desc, level)	{};

	ForwardClass(const char   *name,
	               Tango::CmdArgType in,
				   Tango::CmdArgType out)
	:Command(name,in,out)	{};
	~ForwardClass() {};
	
	virtual CORBA::Any *execute (Tango::DeviceImpl *dev, const CORBA::Any &any);
	virtual bool is_allowed (Tango::DeviceImpl *dev, const CORBA::Any &any)
	{return (static_cast<AxisG2 *>(dev))->is_Forward_allowed(any);}
};

//	Command Stop class definition
class StopClass : public Tango::Command
{
public:
	StopClass(const char   *name,
	               Tango::CmdArgType in,
				   Tango::CmdArgType out,
				   const char        *in_desc,
				   const char        *out_desc,
				   Tango::DispLevel  level)
	:Command(name,in,out,in_desc,out_desc, level)	{};

	StopClass(const char   *name,
	               Tango::CmdArgType in,
				   Tango::CmdArgType out)
	:Command(name,in,out)	{};
	~StopClass() {};
	
	virtual CORBA::Any *execute (Tango::DeviceImpl *dev, const CORBA::Any &any);
	virtual bool is_allowed (Tango::DeviceImpl *dev, const CORBA::Any &any)
	{return (static_cast<AxisG2 *>(dev))->is_Stop_allowed(any);}
};

//	Command Backward class definition
class BackwardClass : public Tango::Command
{
public:
	BackwardClass(const char   *name,
	               Tango::CmdArgType in,
				   Tango::CmdArgType out,
				   const char        *in_desc,
				   const char        *out_desc,
				   Tango::DispLevel  level)
	:Command(name,in,out,in_desc,out_desc, level)	{};

	BackwardClass(const char   *name,
	               Tango::CmdArgType in,
				   Tango::CmdArgType out)
	:Command(name,in,out)	{};
	~BackwardClass() {};
	
	virtual CORBA::Any *execute (Tango::DeviceImpl *dev, const CORBA::Any &any);
	virtual bool is_allowed (Tango::DeviceImpl *dev, const CORBA::Any &any)
	{return (static_cast<AxisG2 *>(dev))->is_Backward_allowed(any);}
};

//	Command GoToRelativePosition class definition
class GoToRelativePositionClass : public Tango::Command
{
public:
	GoToRelativePositionClass(const char   *name,
	               Tango::CmdArgType in,
				   Tango::CmdArgType out,
				   const char        *in_desc,
				   const char        *out_desc,
				   Tango::DispLevel  level)
	:Command(name,in,out,in_desc,out_desc, level)	{};

	GoToRelativePositionClass(const char   *name,
	               Tango::CmdArgType in,
				   Tango::CmdArgType out)
	:Command(name,in,out)	{};
	~GoToRelativePositionClass() {};
	
	virtual CORBA::Any *execute (Tango::DeviceImpl *dev, const CORBA::Any &any);
	virtual bool is_allowed (Tango::DeviceImpl *dev, const CORBA::Any &any)
	{return (static_cast<AxisG2 *>(dev))->is_GoToRelativePosition_allowed(any);}
};

//	Command GoToPosition class definition
class GoToPositionClass : public Tango::Command
{
public:
	GoToPositionClass(const char   *name,
	               Tango::CmdArgType in,
				   Tango::CmdArgType out,
				   const char        *in_desc,
				   const char        *out_desc,
				   Tango::DispLevel  level)
	:Command(name,in,out,in_desc,out_desc, level)	{};

	GoToPositionClass(const char   *name,
	               Tango::CmdArgType in,
				   Tango::CmdArgType out)
	:Command(name,in,out)	{};
	~GoToPositionClass() {};
	
	virtual CORBA::Any *execute (Tango::DeviceImpl *dev, const CORBA::Any &any);
	virtual bool is_allowed (Tango::DeviceImpl *dev, const CORBA::Any &any)
	{return (static_cast<AxisG2 *>(dev))->is_GoToPosition_allowed(any);}
};

//	Command DefinePosition class definition
class DefinePositionClass : public Tango::Command
{
public:
	DefinePositionClass(const char   *name,
	               Tango::CmdArgType in,
				   Tango::CmdArgType out,
				   const char        *in_desc,
				   const char        *out_desc,
				   Tango::DispLevel  level)
	:Command(name,in,out,in_desc,out_desc, level)	{};

	DefinePositionClass(const char   *name,
	               Tango::CmdArgType in,
				   Tango::CmdArgType out)
	:Command(name,in,out)	{};
	~DefinePositionClass() {};
	
	virtual CORBA::Any *execute (Tango::DeviceImpl *dev, const CORBA::Any &any);
	virtual bool is_allowed (Tango::DeviceImpl *dev, const CORBA::Any &any)
	{return (static_cast<AxisG2 *>(dev))->is_DefinePosition_allowed(any);}
};

//	Command GetMotionStatus class definition
class GetMotionStatusClass : public Tango::Command
{
public:
	GetMotionStatusClass(const char   *name,
	               Tango::CmdArgType in,
				   Tango::CmdArgType out,
				   const char        *in_desc,
				   const char        *out_desc,
				   Tango::DispLevel  level)
	:Command(name,in,out,in_desc,out_desc, level)	{};

	GetMotionStatusClass(const char   *name,
	               Tango::CmdArgType in,
				   Tango::CmdArgType out)
	:Command(name,in,out)	{};
	~GetMotionStatusClass() {};
	
	virtual CORBA::Any *execute (Tango::DeviceImpl *dev, const CORBA::Any &any);
	virtual bool is_allowed (Tango::DeviceImpl *dev, const CORBA::Any &any)
	{return (static_cast<AxisG2 *>(dev))->is_GetMotionStatus_allowed(any);}
};

//	Command FindEdge class definition
class FindEdgeClass : public Tango::Command
{
public:
	FindEdgeClass(const char   *name,
	               Tango::CmdArgType in,
				   Tango::CmdArgType out,
				   const char        *in_desc,
				   const char        *out_desc,
				   Tango::DispLevel  level)
	:Command(name,in,out,in_desc,out_desc, level)	{};

	FindEdgeClass(const char   *name,
	               Tango::CmdArgType in,
				   Tango::CmdArgType out)
	:Command(name,in,out)	{};
	~FindEdgeClass() {};
	
	virtual CORBA::Any *execute (Tango::DeviceImpl *dev, const CORBA::Any &any);
	virtual bool is_allowed (Tango::DeviceImpl *dev, const CORBA::Any &any)
	{return (static_cast<AxisG2 *>(dev))->is_FindEdge_allowed(any);}
};

//	Command FindIndex class definition
class FindIndexClass : public Tango::Command
{
public:
	FindIndexClass(const char   *name,
	               Tango::CmdArgType in,
				   Tango::CmdArgType out,
				   const char        *in_desc,
				   const char        *out_desc,
				   Tango::DispLevel  level)
	:Command(name,in,out,in_desc,out_desc, level)	{};

	FindIndexClass(const char   *name,
	               Tango::CmdArgType in,
				   Tango::CmdArgType out)
	:Command(name,in,out)	{};
	~FindIndexClass() {};
	
	virtual CORBA::Any *execute (Tango::DeviceImpl *dev, const CORBA::Any &any);
	virtual bool is_allowed (Tango::DeviceImpl *dev, const CORBA::Any &any)
	{return (static_cast<AxisG2 *>(dev))->is_FindIndex_allowed(any);}
};

//	Command FindHome class definition
class FindHomeClass : public Tango::Command
{
public:
	FindHomeClass(const char   *name,
	               Tango::CmdArgType in,
				   Tango::CmdArgType out,
				   const char        *in_desc,
				   const char        *out_desc,
				   Tango::DispLevel  level)
	:Command(name,in,out,in_desc,out_desc, level)	{};

	FindHomeClass(const char   *name,
	               Tango::CmdArgType in,
				   Tango::CmdArgType out)
	:Command(name,in,out)	{};
	~FindHomeClass() {};
	
	virtual CORBA::Any *execute (Tango::DeviceImpl *dev, const CORBA::Any &any);
	virtual bool is_allowed (Tango::DeviceImpl *dev, const CORBA::Any &any)
	{return (static_cast<AxisG2 *>(dev))->is_FindHome_allowed(any);}
};

//	Command GetErrorStatus class definition
class GetErrorStatusClass : public Tango::Command
{
public:
	GetErrorStatusClass(const char   *name,
	               Tango::CmdArgType in,
				   Tango::CmdArgType out,
				   const char        *in_desc,
				   const char        *out_desc,
				   Tango::DispLevel  level)
	:Command(name,in,out,in_desc,out_desc, level)	{};

	GetErrorStatusClass(const char   *name,
	               Tango::CmdArgType in,
				   Tango::CmdArgType out)
	:Command(name,in,out)	{};
	~GetErrorStatusClass() {};
	
	virtual CORBA::Any *execute (Tango::DeviceImpl *dev, const CORBA::Any &any);
	virtual bool is_allowed (Tango::DeviceImpl *dev, const CORBA::Any &any)
	{return (static_cast<AxisG2 *>(dev))->is_GetErrorStatus_allowed(any);}
};

//	Command DirectCmd class definition
class DirectCmdClass : public Tango::Command
{
public:
	DirectCmdClass(const char   *name,
	               Tango::CmdArgType in,
				   Tango::CmdArgType out,
				   const char        *in_desc,
				   const char        *out_desc,
				   Tango::DispLevel  level)
	:Command(name,in,out,in_desc,out_desc, level)	{};

	DirectCmdClass(const char   *name,
	               Tango::CmdArgType in,
				   Tango::CmdArgType out)
	:Command(name,in,out)	{};
	~DirectCmdClass() {};
	
	virtual CORBA::Any *execute (Tango::DeviceImpl *dev, const CORBA::Any &any);
	virtual bool is_allowed (Tango::DeviceImpl *dev, const CORBA::Any &any)
	{return (static_cast<AxisG2 *>(dev))->is_DirectCmd_allowed(any);}
};

//	Command AxisInit class definition
class AxisInitClass : public Tango::Command
{
public:
	AxisInitClass(const char   *name,
	               Tango::CmdArgType in,
				   Tango::CmdArgType out,
				   const char        *in_desc,
				   const char        *out_desc,
				   Tango::DispLevel  level)
	:Command(name,in,out,in_desc,out_desc, level)	{};

	AxisInitClass(const char   *name,
	               Tango::CmdArgType in,
				   Tango::CmdArgType out)
	:Command(name,in,out)	{};
	~AxisInitClass() {};
	
	virtual CORBA::Any *execute (Tango::DeviceImpl *dev, const CORBA::Any &any);
	virtual bool is_allowed (Tango::DeviceImpl *dev, const CORBA::Any &any)
	{return (static_cast<AxisG2 *>(dev))->is_AxisInit_allowed(any);}
};

//	Command MotorOFF class definition
class MotorOFFClass : public Tango::Command
{
public:
	MotorOFFClass(const char   *name,
	               Tango::CmdArgType in,
				   Tango::CmdArgType out,
				   const char        *in_desc,
				   const char        *out_desc,
				   Tango::DispLevel  level)
	:Command(name,in,out,in_desc,out_desc, level)	{};

	MotorOFFClass(const char   *name,
	               Tango::CmdArgType in,
				   Tango::CmdArgType out)
	:Command(name,in,out)	{};
	~MotorOFFClass() {};
	
	virtual CORBA::Any *execute (Tango::DeviceImpl *dev, const CORBA::Any &any);
	virtual bool is_allowed (Tango::DeviceImpl *dev, const CORBA::Any &any)
	{return (static_cast<AxisG2 *>(dev))->is_MotorOFF_allowed(any);}
};

//	Command MotorON class definition
class MotorONClass : public Tango::Command
{
public:
	MotorONClass(const char   *name,
	               Tango::CmdArgType in,
				   Tango::CmdArgType out,
				   const char        *in_desc,
				   const char        *out_desc,
				   Tango::DispLevel  level)
	:Command(name,in,out,in_desc,out_desc, level)	{};

	MotorONClass(const char   *name,
	               Tango::CmdArgType in,
				   Tango::CmdArgType out)
	:Command(name,in,out)	{};
	~MotorONClass() {};
	
	virtual CORBA::Any *execute (Tango::DeviceImpl *dev, const CORBA::Any &any);
	virtual bool is_allowed (Tango::DeviceImpl *dev, const CORBA::Any &any)
	{return (static_cast<AxisG2 *>(dev))->is_MotorON_allowed(any);}
};

//	Command ReadHWConf class definition
class ReadHWConfClass : public Tango::Command
{
public:
	ReadHWConfClass(const char   *name,
	               Tango::CmdArgType in,
				   Tango::CmdArgType out,
				   const char        *in_desc,
				   const char        *out_desc,
				   Tango::DispLevel  level)
	:Command(name,in,out,in_desc,out_desc, level)	{};

	ReadHWConfClass(const char   *name,
	               Tango::CmdArgType in,
				   Tango::CmdArgType out)
	:Command(name,in,out)	{};
	~ReadHWConfClass() {};
	
	virtual CORBA::Any *execute (Tango::DeviceImpl *dev, const CORBA::Any &any);
	virtual bool is_allowed (Tango::DeviceImpl *dev, const CORBA::Any &any)
	{return (static_cast<AxisG2 *>(dev))->is_ReadHWConf_allowed(any);}
};

//	Command GetUserEncoderRatio class definition
class GetUserEncoderRatioClass : public Tango::Command
{
public:
	GetUserEncoderRatioClass(const char   *name,
	               Tango::CmdArgType in,
				   Tango::CmdArgType out,
				   const char        *in_desc,
				   const char        *out_desc,
				   Tango::DispLevel  level)
	:Command(name,in,out,in_desc,out_desc, level)	{};

	GetUserEncoderRatioClass(const char   *name,
	               Tango::CmdArgType in,
				   Tango::CmdArgType out)
	:Command(name,in,out)	{};
	~GetUserEncoderRatioClass() {};
	
	virtual CORBA::Any *execute (Tango::DeviceImpl *dev, const CORBA::Any &any);
	virtual bool is_allowed (Tango::DeviceImpl *dev, const CORBA::Any &any)
	{return (static_cast<AxisG2 *>(dev))->is_GetUserEncoderRatio_allowed(any);}
};

//	Command Service class definition
class ServiceClass : public Tango::Command
{
public:
	ServiceClass(const char   *name,
	               Tango::CmdArgType in,
				   Tango::CmdArgType out,
				   const char        *in_desc,
				   const char        *out_desc,
				   Tango::DispLevel  level)
	:Command(name,in,out,in_desc,out_desc, level)	{};

	ServiceClass(const char   *name,
	               Tango::CmdArgType in,
				   Tango::CmdArgType out)
	:Command(name,in,out)	{};
	~ServiceClass() {};
	
	virtual CORBA::Any *execute (Tango::DeviceImpl *dev, const CORBA::Any &any);
	virtual bool is_allowed (Tango::DeviceImpl *dev, const CORBA::Any &any)
	{return (static_cast<AxisG2 *>(dev))->is_Service_allowed(any);}
};

//	Command GetMotionHistory class definition
class GetMotionHistoryClass : public Tango::Command
{
public:
	GetMotionHistoryClass(const char   *name,
	               Tango::CmdArgType in,
				   Tango::CmdArgType out,
				   const char        *in_desc,
				   const char        *out_desc,
				   Tango::DispLevel  level)
	:Command(name,in,out,in_desc,out_desc, level)	{};

	GetMotionHistoryClass(const char   *name,
	               Tango::CmdArgType in,
				   Tango::CmdArgType out)
	:Command(name,in,out)	{};
	~GetMotionHistoryClass() {};
	
	virtual CORBA::Any *execute (Tango::DeviceImpl *dev, const CORBA::Any &any);
	virtual bool is_allowed (Tango::DeviceImpl *dev, const CORBA::Any &any)
	{return (static_cast<AxisG2 *>(dev))->is_GetMotionHistory_allowed(any);}
};

//	Command RestoreLastPosition class definition
class RestoreLastPositionClass : public Tango::Command
{
public:
	RestoreLastPositionClass(const char   *name,
	               Tango::CmdArgType in,
				   Tango::CmdArgType out,
				   const char        *in_desc,
				   const char        *out_desc,
				   Tango::DispLevel  level)
	:Command(name,in,out,in_desc,out_desc, level)	{};

	RestoreLastPositionClass(const char   *name,
	               Tango::CmdArgType in,
				   Tango::CmdArgType out)
	:Command(name,in,out)	{};
	~RestoreLastPositionClass() {};
	
	virtual CORBA::Any *execute (Tango::DeviceImpl *dev, const CORBA::Any &any);
	virtual bool is_allowed (Tango::DeviceImpl *dev, const CORBA::Any &any)
	{return (static_cast<AxisG2 *>(dev))->is_RestoreLastPosition_allowed(any);}
};

//	Command AckCheckEnc class definition
class AckCheckEncClass : public Tango::Command
{
public:
	AckCheckEncClass(const char   *name,
	               Tango::CmdArgType in,
				   Tango::CmdArgType out,
				   const char        *in_desc,
				   const char        *out_desc,
				   Tango::DispLevel  level)
	:Command(name,in,out,in_desc,out_desc, level)	{};

	AckCheckEncClass(const char   *name,
	               Tango::CmdArgType in,
				   Tango::CmdArgType out)
	:Command(name,in,out)	{};
	~AckCheckEncClass() {};
	
	virtual CORBA::Any *execute (Tango::DeviceImpl *dev, const CORBA::Any &any);
	virtual bool is_allowed (Tango::DeviceImpl *dev, const CORBA::Any &any)
	{return (static_cast<AxisG2 *>(dev))->is_AckCheckEnc_allowed(any);}
};

//	Command RawAbsPos class definition
class RawAbsPosClass : public Tango::Command
{
public:
	RawAbsPosClass(const char   *name,
	               Tango::CmdArgType in,
				   Tango::CmdArgType out,
				   const char        *in_desc,
				   const char        *out_desc,
				   Tango::DispLevel  level)
	:Command(name,in,out,in_desc,out_desc, level)	{};

	RawAbsPosClass(const char   *name,
	               Tango::CmdArgType in,
				   Tango::CmdArgType out)
	:Command(name,in,out)	{};
	~RawAbsPosClass() {};
	
	virtual CORBA::Any *execute (Tango::DeviceImpl *dev, const CORBA::Any &any);
	virtual bool is_allowed (Tango::DeviceImpl *dev, const CORBA::Any &any)
	{return (static_cast<AxisG2 *>(dev))->is_RawAbsPos_allowed(any);}
};

//	Command RawRelPos class definition
class RawRelPosClass : public Tango::Command
{
public:
	RawRelPosClass(const char   *name,
	               Tango::CmdArgType in,
				   Tango::CmdArgType out,
				   const char        *in_desc,
				   const char        *out_desc,
				   Tango::DispLevel  level)
	:Command(name,in,out,in_desc,out_desc, level)	{};

	RawRelPosClass(const char   *name,
	               Tango::CmdArgType in,
				   Tango::CmdArgType out)
	:Command(name,in,out)	{};
	~RawRelPosClass() {};
	
	virtual CORBA::Any *execute (Tango::DeviceImpl *dev, const CORBA::Any &any);
	virtual bool is_allowed (Tango::DeviceImpl *dev, const CORBA::Any &any)
	{return (static_cast<AxisG2 *>(dev))->is_RawRelPos_allowed(any);}
};

//	Command UserRawAbsPos class definition
class UserRawAbsPosClass : public Tango::Command
{
public:
	UserRawAbsPosClass(const char   *name,
	               Tango::CmdArgType in,
				   Tango::CmdArgType out,
				   const char        *in_desc,
				   const char        *out_desc,
				   Tango::DispLevel  level)
	:Command(name,in,out,in_desc,out_desc, level)	{};

	UserRawAbsPosClass(const char   *name,
	               Tango::CmdArgType in,
				   Tango::CmdArgType out)
	:Command(name,in,out)	{};
	~UserRawAbsPosClass() {};
	
	virtual CORBA::Any *execute (Tango::DeviceImpl *dev, const CORBA::Any &any);
	virtual bool is_allowed (Tango::DeviceImpl *dev, const CORBA::Any &any)
	{return (static_cast<AxisG2 *>(dev))->is_UserRawAbsPos_allowed(any);}
};

//	Command UserRawRelPos class definition
class UserRawRelPosClass : public Tango::Command
{
public:
	UserRawRelPosClass(const char   *name,
	               Tango::CmdArgType in,
				   Tango::CmdArgType out,
				   const char        *in_desc,
				   const char        *out_desc,
				   Tango::DispLevel  level)
	:Command(name,in,out,in_desc,out_desc, level)	{};

	UserRawRelPosClass(const char   *name,
	               Tango::CmdArgType in,
				   Tango::CmdArgType out)
	:Command(name,in,out)	{};
	~UserRawRelPosClass() {};
	
	virtual CORBA::Any *execute (Tango::DeviceImpl *dev, const CORBA::Any &any);
	virtual bool is_allowed (Tango::DeviceImpl *dev, const CORBA::Any &any)
	{return (static_cast<AxisG2 *>(dev))->is_UserRawRelPos_allowed(any);}
};

//	Command get_p4e class definition
class get_p4eClass : public Tango::Command
{
public:
	get_p4eClass(const char   *name,
	               Tango::CmdArgType in,
				   Tango::CmdArgType out,
				   const char        *in_desc,
				   const char        *out_desc,
				   Tango::DispLevel  level)
	:Command(name,in,out,in_desc,out_desc, level)	{};

	get_p4eClass(const char   *name,
	               Tango::CmdArgType in,
				   Tango::CmdArgType out)
	:Command(name,in,out)	{};
	~get_p4eClass() {};
	
	virtual CORBA::Any *execute (Tango::DeviceImpl *dev, const CORBA::Any &any);
	virtual bool is_allowed (Tango::DeviceImpl *dev, const CORBA::Any &any)
	{return (static_cast<AxisG2 *>(dev))->is_get_p4e_allowed(any);}
};

//	Command get_e4p class definition
class get_e4pClass : public Tango::Command
{
public:
	get_e4pClass(const char   *name,
	               Tango::CmdArgType in,
				   Tango::CmdArgType out,
				   const char        *in_desc,
				   const char        *out_desc,
				   Tango::DispLevel  level)
	:Command(name,in,out,in_desc,out_desc, level)	{};

	get_e4pClass(const char   *name,
	               Tango::CmdArgType in,
				   Tango::CmdArgType out)
	:Command(name,in,out)	{};
	~get_e4pClass() {};
	
	virtual CORBA::Any *execute (Tango::DeviceImpl *dev, const CORBA::Any &any);
	virtual bool is_allowed (Tango::DeviceImpl *dev, const CORBA::Any &any)
	{return (static_cast<AxisG2 *>(dev))->is_get_e4p_allowed(any);}
};

//	Command get_u4p class definition
class get_u4pClass : public Tango::Command
{
public:
	get_u4pClass(const char   *name,
	               Tango::CmdArgType in,
				   Tango::CmdArgType out,
				   const char        *in_desc,
				   const char        *out_desc,
				   Tango::DispLevel  level)
	:Command(name,in,out,in_desc,out_desc, level)	{};

	get_u4pClass(const char   *name,
	               Tango::CmdArgType in,
				   Tango::CmdArgType out)
	:Command(name,in,out)	{};
	~get_u4pClass() {};
	
	virtual CORBA::Any *execute (Tango::DeviceImpl *dev, const CORBA::Any &any);
	virtual bool is_allowed (Tango::DeviceImpl *dev, const CORBA::Any &any)
	{return (static_cast<AxisG2 *>(dev))->is_get_u4p_allowed(any);}
};

//	Command get_p4u class definition
class get_p4uClass : public Tango::Command
{
public:
	get_p4uClass(const char   *name,
	               Tango::CmdArgType in,
				   Tango::CmdArgType out,
				   const char        *in_desc,
				   const char        *out_desc,
				   Tango::DispLevel  level)
	:Command(name,in,out,in_desc,out_desc, level)	{};

	get_p4uClass(const char   *name,
	               Tango::CmdArgType in,
				   Tango::CmdArgType out)
	:Command(name,in,out)	{};
	~get_p4uClass() {};
	
	virtual CORBA::Any *execute (Tango::DeviceImpl *dev, const CORBA::Any &any);
	virtual bool is_allowed (Tango::DeviceImpl *dev, const CORBA::Any &any)
	{return (static_cast<AxisG2 *>(dev))->is_get_p4u_allowed(any);}
};

//	Command get_u4e class definition
class get_u4eClass : public Tango::Command
{
public:
	get_u4eClass(const char   *name,
	               Tango::CmdArgType in,
				   Tango::CmdArgType out,
				   const char        *in_desc,
				   const char        *out_desc,
				   Tango::DispLevel  level)
	:Command(name,in,out,in_desc,out_desc, level)	{};

	get_u4eClass(const char   *name,
	               Tango::CmdArgType in,
				   Tango::CmdArgType out)
	:Command(name,in,out)	{};
	~get_u4eClass() {};
	
	virtual CORBA::Any *execute (Tango::DeviceImpl *dev, const CORBA::Any &any);
	virtual bool is_allowed (Tango::DeviceImpl *dev, const CORBA::Any &any)
	{return (static_cast<AxisG2 *>(dev))->is_get_u4e_allowed(any);}
};

//	Command get_e4u class definition
class get_e4uClass : public Tango::Command
{
public:
	get_e4uClass(const char   *name,
	               Tango::CmdArgType in,
				   Tango::CmdArgType out,
				   const char        *in_desc,
				   const char        *out_desc,
				   Tango::DispLevel  level)
	:Command(name,in,out,in_desc,out_desc, level)	{};

	get_e4uClass(const char   *name,
	               Tango::CmdArgType in,
				   Tango::CmdArgType out)
	:Command(name,in,out)	{};
	~get_e4uClass() {};
	
	virtual CORBA::Any *execute (Tango::DeviceImpl *dev, const CORBA::Any &any);
	virtual bool is_allowed (Tango::DeviceImpl *dev, const CORBA::Any &any)
	{return (static_cast<AxisG2 *>(dev))->is_get_e4u_allowed(any);}
};

//	Command StorePosition4Fake class definition
class StorePosition4FakeClass : public Tango::Command
{
public:
	StorePosition4FakeClass(const char   *name,
	               Tango::CmdArgType in,
				   Tango::CmdArgType out,
				   const char        *in_desc,
				   const char        *out_desc,
				   Tango::DispLevel  level)
	:Command(name,in,out,in_desc,out_desc, level)	{};

	StorePosition4FakeClass(const char   *name,
	               Tango::CmdArgType in,
				   Tango::CmdArgType out)
	:Command(name,in,out)	{};
	~StorePosition4FakeClass() {};
	
	virtual CORBA::Any *execute (Tango::DeviceImpl *dev, const CORBA::Any &any);
	virtual bool is_allowed (Tango::DeviceImpl *dev, const CORBA::Any &any)
	{return (static_cast<AxisG2 *>(dev))->is_StorePosition4Fake_allowed(any);}
};

//	Command FakeAxisInit class definition
class FakeAxisInitClass : public Tango::Command
{
public:
	FakeAxisInitClass(const char   *name,
	               Tango::CmdArgType in,
				   Tango::CmdArgType out,
				   const char        *in_desc,
				   const char        *out_desc,
				   Tango::DispLevel  level)
	:Command(name,in,out,in_desc,out_desc, level)	{};

	FakeAxisInitClass(const char   *name,
	               Tango::CmdArgType in,
				   Tango::CmdArgType out)
	:Command(name,in,out)	{};
	~FakeAxisInitClass() {};
	
	virtual CORBA::Any *execute (Tango::DeviceImpl *dev, const CORBA::Any &any);
	virtual bool is_allowed (Tango::DeviceImpl *dev, const CORBA::Any &any)
	{return (static_cast<AxisG2 *>(dev))->is_FakeAxisInit_allowed(any);}
};


/**
 *	The AxisG2Class singleton definition
 */

#ifdef _TG_WINDOWS_
class __declspec(dllexport)  AxisG2Class : public Tango::DeviceClass
#else
class AxisG2Class : public Tango::DeviceClass
#endif
{
	/*----- PROTECTED REGION ID(AxisG2Class::Additionnal DServer data members) ENABLED START -----*/
	
	
	/*----- PROTECTED REGION END -----*/	//	AxisG2Class::Additionnal DServer data members

	public:
		//	write class properties data members
		Tango::DbData	cl_prop;
		Tango::DbData	cl_def_prop;
		Tango::DbData	dev_def_prop;
	
		//	Method prototypes
		static AxisG2Class *init(const char *);
		static AxisG2Class *instance();
		~AxisG2Class();
		Tango::DbDatum	get_class_property(string &);
		Tango::DbDatum	get_default_device_property(string &);
		Tango::DbDatum	get_default_class_property(string &);
	
	protected:
		AxisG2Class(string &);
		static AxisG2Class *_instance;
		void command_factory();
		void attribute_factory(vector<Tango::Attr *> &);
		void pipe_factory();
		void write_class_property();
		void set_default_property();
		void get_class_property();
		string get_cvstag();
		string get_cvsroot();
	
	private:
		void device_factory(const Tango::DevVarStringArray *);
		void create_static_attribute_list(vector<Tango::Attr *> &);
		void erase_dynamic_attributes(const Tango::DevVarStringArray *,vector<Tango::Attr *> &);
		vector<string>	defaultAttList;
		Tango::Attr *get_attr_object_by_name(vector<Tango::Attr *> &att_list, string attname);
};

}	//	End of namespace

#endif   //	AxisG2_H
