
#include "AxisG2.h"

namespace AxisG2_ns
{


//--------------------------------------------------------
/**
 *
 *
 *
 */
//--------------------------------------------------------
bool AxisG2::RawPos(double v, bool rel){

	DEBUG_STREAM << "AxisG2::RawPos()  - " << device_name << endl;
	/*----- PROTECTED REGION ID(AxisG2::raw_abs_pos) ENABLED START -----*/
	
	//	Add your own code
	// MYCODE-START

	std::stringstream es;
	es << "AxisG2::RawPos(" << v << ", " << rel << ")";
	INFOLOG(es.str());

	//cout << "AxisG2::RawPos(" << v << ", " << rel << ")" << endl;
        if ( isnan(v) ) {
			INFOLOG("AxisG2::raw_abs_pos(): Invalid Value (NaN)");
			Tango::Except::throw_exception (
				(const char *)"AxisG2",
                        	(const char *)"Invalid Value (NaN)",
                        	(const char *)"AxisG2::RawPos()");
	}
	if ( !axis ){
			INFOLOG("AxisG2::raw_abs_pos(): Axis not created!");
			Tango::Except::throw_exception (
				(const char *)"AxisG2",
               			(const char *)"Axis not created!",
               			(const char *)"AxisG2::RawPos()");
	}
        if ( !*attr_IsMicrocodeOK_read ){
			INFOLOG("AxisG2::raw_abs_pos(): Invalid Cmd while MicroCode NOT running !!");
                        Tango::Except::throw_exception (
				(const char *)"AxisG2",
                        	(const char *)"Invalid Cmd while MicroCode NOT running !!",
                        	(const char *)"AxisG2::RawPos()");
        }
	if ( *attr_CheckEncoder_read ) {
		switch (_chk_enc){
			case Axis_ns::CHK_ENC_ERROR:
			case Axis_ns::CHK_ENC_ERROR_ONSTAY:
			case Axis_ns::CHK_ENC_ERROR_ONRUN:
				INFOLOG("AxisG2::raw_abs_pos(): Invalid Cmd while Check Encoder Enabled & not ok !!");
                        	Tango::Except::throw_exception (
					(const char *)"AxisG2",
                        		(const char *)"Invalid Cmd while Check Encoder Enabled & not ok !!",
                        		(const char *)"AxisG2::RawPos()");
				break;
			default:
				break;
		}
	}

	INFOLOG("AxisG2::RawPos(): pre pos()");

	bool posret = false;
	double oldpos = axis->position();
	if (rel) posret = axis->rawposition(v, true);
	else posret = axis->rawposition(v, false);
	if ( !posret ){
			std::stringstream es;
			es << "AxisG2::raw_abs_pos(): " << axis->axis_error_str();
			INFOLOG(es.str());
                        Tango::Except::throw_exception (
				(const char *)"AxisG2",
                        	(const char *)axis->axis_error_str().c_str(),
                        	(const char *)"AxisG2::RawPos()");
	}

	INFOLOG("AxisG2::RawPos(): post pos()");

	if (rel) v += oldpos;
        Tango::DbDatum _attr_prop("__value");
        _attr_prop << v;
	if ( !put_memorized_attribute("Position", _attr_prop) ){
				INFOLOG("AxisG2::raw_abs_pos(): Error in put new memorized value");
                        	Tango::Except::throw_exception (
					(const char *)"AxisG2",
                        		(const char *)"Error in put new memorized value",
                        		(const char *)"AxisG2::RawPos()");
	}
	try {
		Tango::WAttribute &attr = dev_attr->get_w_attr_by_name("Position");
		//Tango::DevDouble w;
		//attr.get_write_value(w);
		//cout << "attr.get_write_value() =" << w << endl;
		attr.set_write_value(v);
	} catch(...) {
		INFOLOG("AxisG2::RawPos(): Error in update Position write value");
		cout << "AxisG2::axis_RawPos EXCEPTION!" << endl;
                Tango::Except::throw_exception (
			(const char *)"AxisG2",
                       	(const char *)"Error in update Position write value",
                       	(const char *)"AxisG2::RawPos()");
	}

	INFOLOG("AxisG2::RawPos(): done");
	
	return false;
}

} //namespace
