/*----- PROTECTED REGION ID(AxisG2StateMachine.cpp) ENABLED START -----*/
//=============================================================================
//
// file :        AxisG2StateMachine.cpp
//
// description : State machine file for the AxisG2 class
//
// project :     Axis
//
// This file is part of Tango device class.
// 
// Tango is free software: you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation, either version 3 of the License, or
// (at your option) any later version.
// 
// Tango is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
// 
// You should have received a copy of the GNU General Public License
// along with Tango.  If not, see <http://www.gnu.org/licenses/>.
// 
// $Author: abrami $
//
//
//=============================================================================
//                This file is generated by POGO
//        (Program Obviously used to Generate tango Object)
//=============================================================================

#include <AxisG2.h>

/*----- PROTECTED REGION END -----*/	//	AxisG2::AxisG2StateMachine.cpp

//================================================================
//  States   |  Description
//================================================================
//  OFF      |  Communication broken with the motion controller
//  STANDBY  |  Axis OK, waiting for commands
//  MOVING   |  Axis is moving
//  FAULT    |  Failure on the axis. Can be hardware failure .
//  ALARM    |  Alarm on the axis. can be soft or hard limit, abort input...
//  DISABLE  |  For debug purpose


namespace AxisG2_ns
{
//=================================================
//		Attributes Allowed Methods
//=================================================

//--------------------------------------------------------
/**
 *	Method      : AxisG2::is_Position_allowed()
 *	Description : Execution allowed for Position attribute
 */
//--------------------------------------------------------
bool AxisG2::is_Position_allowed(TANGO_UNUSED(Tango::AttReqType type))
{
	//	Check access type.
	if ( type!=Tango::READ_REQ )
	{
		//	Compare device state with not allowed states for WRITE 
		if (get_state()==Tango::FAULT)
		{
		/*----- PROTECTED REGION ID(AxisG2::PositionStateAllowed_WRITE) ENABLED START -----*/
		
		/*----- PROTECTED REGION END -----*/	//	AxisG2::PositionStateAllowed_WRITE
			return false;
		}
		return true;
	}
	else

	//	Not any excluded states for Position attribute in read access.
	/*----- PROTECTED REGION ID(AxisG2::PositionStateAllowed_READ) ENABLED START -----*/
	
	/*----- PROTECTED REGION END -----*/	//	AxisG2::PositionStateAllowed_READ
	return true;
}

//--------------------------------------------------------
/**
 *	Method      : AxisG2::is_PositiveLimitSwitch_allowed()
 *	Description : Execution allowed for PositiveLimitSwitch attribute
 */
//--------------------------------------------------------
bool AxisG2::is_PositiveLimitSwitch_allowed(TANGO_UNUSED(Tango::AttReqType type))
{

	//	Not any excluded states for PositiveLimitSwitch attribute in read access.
	/*----- PROTECTED REGION ID(AxisG2::PositiveLimitSwitchStateAllowed_READ) ENABLED START -----*/
	
	/*----- PROTECTED REGION END -----*/	//	AxisG2::PositiveLimitSwitchStateAllowed_READ
	return true;
}

//--------------------------------------------------------
/**
 *	Method      : AxisG2::is_NegativeLimitSwitch_allowed()
 *	Description : Execution allowed for NegativeLimitSwitch attribute
 */
//--------------------------------------------------------
bool AxisG2::is_NegativeLimitSwitch_allowed(TANGO_UNUSED(Tango::AttReqType type))
{

	//	Not any excluded states for NegativeLimitSwitch attribute in read access.
	/*----- PROTECTED REGION ID(AxisG2::NegativeLimitSwitchStateAllowed_READ) ENABLED START -----*/
	
	/*----- PROTECTED REGION END -----*/	//	AxisG2::NegativeLimitSwitchStateAllowed_READ
	return true;
}

//--------------------------------------------------------
/**
 *	Method      : AxisG2::is_HomeSwitch_allowed()
 *	Description : Execution allowed for HomeSwitch attribute
 */
//--------------------------------------------------------
bool AxisG2::is_HomeSwitch_allowed(TANGO_UNUSED(Tango::AttReqType type))
{

	//	Not any excluded states for HomeSwitch attribute in read access.
	/*----- PROTECTED REGION ID(AxisG2::HomeSwitchStateAllowed_READ) ENABLED START -----*/
	
	/*----- PROTECTED REGION END -----*/	//	AxisG2::HomeSwitchStateAllowed_READ
	return true;
}

//--------------------------------------------------------
/**
 *	Method      : AxisG2::is_MotorStatus_allowed()
 *	Description : Execution allowed for MotorStatus attribute
 */
//--------------------------------------------------------
bool AxisG2::is_MotorStatus_allowed(TANGO_UNUSED(Tango::AttReqType type))
{

	//	Not any excluded states for MotorStatus attribute in read access.
	/*----- PROTECTED REGION ID(AxisG2::MotorStatusStateAllowed_READ) ENABLED START -----*/
	
	/*----- PROTECTED REGION END -----*/	//	AxisG2::MotorStatusStateAllowed_READ
	return true;
}

//--------------------------------------------------------
/**
 *	Method      : AxisG2::is_EncoderPosition_allowed()
 *	Description : Execution allowed for EncoderPosition attribute
 */
//--------------------------------------------------------
bool AxisG2::is_EncoderPosition_allowed(TANGO_UNUSED(Tango::AttReqType type))
{

	//	Not any excluded states for EncoderPosition attribute in read access.
	/*----- PROTECTED REGION ID(AxisG2::EncoderPositionStateAllowed_READ) ENABLED START -----*/
	
	/*----- PROTECTED REGION END -----*/	//	AxisG2::EncoderPositionStateAllowed_READ
	return true;
}

//--------------------------------------------------------
/**
 *	Method      : AxisG2::is_MotorPosition_allowed()
 *	Description : Execution allowed for MotorPosition attribute
 */
//--------------------------------------------------------
bool AxisG2::is_MotorPosition_allowed(TANGO_UNUSED(Tango::AttReqType type))
{
	//	Check access type.
	if ( type!=Tango::READ_REQ )
	{
		//	Compare device state with not allowed states for WRITE 
		if (get_state()==Tango::FAULT)
		{
		/*----- PROTECTED REGION ID(AxisG2::MotorPositionStateAllowed_WRITE) ENABLED START -----*/
		
		/*----- PROTECTED REGION END -----*/	//	AxisG2::MotorPositionStateAllowed_WRITE
			return false;
		}
		return true;
	}
	else

	//	Not any excluded states for MotorPosition attribute in read access.
	/*----- PROTECTED REGION ID(AxisG2::MotorPositionStateAllowed_READ) ENABLED START -----*/
	
	/*----- PROTECTED REGION END -----*/	//	AxisG2::MotorPositionStateAllowed_READ
	return true;
}

//--------------------------------------------------------
/**
 *	Method      : AxisG2::is_UserPosition_allowed()
 *	Description : Execution allowed for UserPosition attribute
 */
//--------------------------------------------------------
bool AxisG2::is_UserPosition_allowed(TANGO_UNUSED(Tango::AttReqType type))
{
	//	Check access type.
	if ( type!=Tango::READ_REQ )
	{
		//	Compare device state with not allowed states for WRITE 
		if (get_state()==Tango::FAULT)
		{
		/*----- PROTECTED REGION ID(AxisG2::UserPositionStateAllowed_WRITE) ENABLED START -----*/
	
	/*----- PROTECTED REGION END -----*/	//	AxisG2::UserPositionStateAllowed_WRITE
			return false;
		}
		return true;
	}
	else

	//	Not any excluded states for UserPosition attribute in read access.
	/*----- PROTECTED REGION ID(AxisG2::UserPositionStateAllowed_READ) ENABLED START -----*/
	
	/*----- PROTECTED REGION END -----*/	//	AxisG2::UserPositionStateAllowed_READ
	return true;
}

//--------------------------------------------------------
/**
 *	Method      : AxisG2::is_UserScale_allowed()
 *	Description : Execution allowed for UserScale attribute
 */
//--------------------------------------------------------
bool AxisG2::is_UserScale_allowed(TANGO_UNUSED(Tango::AttReqType type))
{
	//	Not any excluded states for UserScale attribute in Write access.
	/*----- PROTECTED REGION ID(AxisG2::UserScaleStateAllowed_WRITE) ENABLED START -----*/
	
	/*----- PROTECTED REGION END -----*/	//	AxisG2::UserScaleStateAllowed_WRITE

	//	Not any excluded states for UserScale attribute in read access.
	/*----- PROTECTED REGION ID(AxisG2::UserScaleStateAllowed_READ) ENABLED START -----*/
	
	/*----- PROTECTED REGION END -----*/	//	AxisG2::UserScaleStateAllowed_READ
	return true;
}

//--------------------------------------------------------
/**
 *	Method      : AxisG2::is_UserOffset_allowed()
 *	Description : Execution allowed for UserOffset attribute
 */
//--------------------------------------------------------
bool AxisG2::is_UserOffset_allowed(TANGO_UNUSED(Tango::AttReqType type))
{
	//	Not any excluded states for UserOffset attribute in Write access.
	/*----- PROTECTED REGION ID(AxisG2::UserOffsetStateAllowed_WRITE) ENABLED START -----*/
	
	/*----- PROTECTED REGION END -----*/	//	AxisG2::UserOffsetStateAllowed_WRITE

	//	Not any excluded states for UserOffset attribute in read access.
	/*----- PROTECTED REGION ID(AxisG2::UserOffsetStateAllowed_READ) ENABLED START -----*/
	
	/*----- PROTECTED REGION END -----*/	//	AxisG2::UserOffsetStateAllowed_READ
	return true;
}

//--------------------------------------------------------
/**
 *	Method      : AxisG2::is_UserSpeed_allowed()
 *	Description : Execution allowed for UserSpeed attribute
 */
//--------------------------------------------------------
bool AxisG2::is_UserSpeed_allowed(TANGO_UNUSED(Tango::AttReqType type))
{
	//	Check access type.
	if ( type!=Tango::READ_REQ )
	{
		//	Compare device state with not allowed states for WRITE 
		if (get_state()==Tango::FAULT)
		{
		/*----- PROTECTED REGION ID(AxisG2::UserSpeedStateAllowed_WRITE) ENABLED START -----*/
		
		/*----- PROTECTED REGION END -----*/	//	AxisG2::UserSpeedStateAllowed_WRITE
			return false;
		}
		return true;
	}
	else

	//	Not any excluded states for UserSpeed attribute in read access.
	/*----- PROTECTED REGION ID(AxisG2::UserSpeedStateAllowed_READ) ENABLED START -----*/
	
	/*----- PROTECTED REGION END -----*/	//	AxisG2::UserSpeedStateAllowed_READ
	return true;
}

//--------------------------------------------------------
/**
 *	Method      : AxisG2::is_Speed_allowed()
 *	Description : Execution allowed for Speed attribute
 */
//--------------------------------------------------------
bool AxisG2::is_Speed_allowed(TANGO_UNUSED(Tango::AttReqType type))
{
	//	Check access type.
	if ( type!=Tango::READ_REQ )
	{
		//	Compare device state with not allowed states for WRITE 
		if (get_state()==Tango::FAULT)
		{
		/*----- PROTECTED REGION ID(AxisG2::SpeedStateAllowed_WRITE) ENABLED START -----*/
		
		/*----- PROTECTED REGION END -----*/	//	AxisG2::SpeedStateAllowed_WRITE
			return false;
		}
		return true;
	}
	else

	//	Not any excluded states for Speed attribute in read access.
	/*----- PROTECTED REGION ID(AxisG2::SpeedStateAllowed_READ) ENABLED START -----*/
	
	/*----- PROTECTED REGION END -----*/	//	AxisG2::SpeedStateAllowed_READ
	return true;
}

//--------------------------------------------------------
/**
 *	Method      : AxisG2::is_Acceleration_allowed()
 *	Description : Execution allowed for Acceleration attribute
 */
//--------------------------------------------------------
bool AxisG2::is_Acceleration_allowed(TANGO_UNUSED(Tango::AttReqType type))
{
	//	Check access type.
	if ( type!=Tango::READ_REQ )
	{
		//	Compare device state with not allowed states for WRITE 
		if (get_state()==Tango::FAULT)
		{
		/*----- PROTECTED REGION ID(AxisG2::AccelerationStateAllowed_WRITE) ENABLED START -----*/
		
		/*----- PROTECTED REGION END -----*/	//	AxisG2::AccelerationStateAllowed_WRITE
			return false;
		}
		return true;
	}
	else

	//	Not any excluded states for Acceleration attribute in read access.
	/*----- PROTECTED REGION ID(AxisG2::AccelerationStateAllowed_READ) ENABLED START -----*/
	
	/*----- PROTECTED REGION END -----*/	//	AxisG2::AccelerationStateAllowed_READ
	return true;
}

//--------------------------------------------------------
/**
 *	Method      : AxisG2::is_Deceleration_allowed()
 *	Description : Execution allowed for Deceleration attribute
 */
//--------------------------------------------------------
bool AxisG2::is_Deceleration_allowed(TANGO_UNUSED(Tango::AttReqType type))
{
	//	Check access type.
	if ( type!=Tango::READ_REQ )
	{
		//	Compare device state with not allowed states for WRITE 
		if (get_state()==Tango::FAULT)
		{
		/*----- PROTECTED REGION ID(AxisG2::DecelerationStateAllowed_WRITE) ENABLED START -----*/
		
		/*----- PROTECTED REGION END -----*/	//	AxisG2::DecelerationStateAllowed_WRITE
			return false;
		}
		return true;
	}
	else

	//	Not any excluded states for Deceleration attribute in read access.
	/*----- PROTECTED REGION ID(AxisG2::DecelerationStateAllowed_READ) ENABLED START -----*/
	
	/*----- PROTECTED REGION END -----*/	//	AxisG2::DecelerationStateAllowed_READ
	return true;
}

//--------------------------------------------------------
/**
 *	Method      : AxisG2::is_MotionAccuracy_allowed()
 *	Description : Execution allowed for MotionAccuracy attribute
 */
//--------------------------------------------------------
bool AxisG2::is_MotionAccuracy_allowed(TANGO_UNUSED(Tango::AttReqType type))
{
	//	Not any excluded states for MotionAccuracy attribute in Write access.
	/*----- PROTECTED REGION ID(AxisG2::MotionAccuracyStateAllowed_WRITE) ENABLED START -----*/
	
	/*----- PROTECTED REGION END -----*/	//	AxisG2::MotionAccuracyStateAllowed_WRITE

	//	Not any excluded states for MotionAccuracy attribute in read access.
	/*----- PROTECTED REGION ID(AxisG2::MotionAccuracyStateAllowed_READ) ENABLED START -----*/
	
	/*----- PROTECTED REGION END -----*/	//	AxisG2::MotionAccuracyStateAllowed_READ
	return true;
}

//--------------------------------------------------------
/**
 *	Method      : AxisG2::is_MotionPercent_allowed()
 *	Description : Execution allowed for MotionPercent attribute
 */
//--------------------------------------------------------
bool AxisG2::is_MotionPercent_allowed(TANGO_UNUSED(Tango::AttReqType type))
{
	//	Not any excluded states for MotionPercent attribute in Write access.
	/*----- PROTECTED REGION ID(AxisG2::MotionPercentStateAllowed_WRITE) ENABLED START -----*/
	
	/*----- PROTECTED REGION END -----*/	//	AxisG2::MotionPercentStateAllowed_WRITE

	//	Not any excluded states for MotionPercent attribute in read access.
	/*----- PROTECTED REGION ID(AxisG2::MotionPercentStateAllowed_READ) ENABLED START -----*/
	
	/*----- PROTECTED REGION END -----*/	//	AxisG2::MotionPercentStateAllowed_READ
	return true;
}

//--------------------------------------------------------
/**
 *	Method      : AxisG2::is_MotionRetry_allowed()
 *	Description : Execution allowed for MotionRetry attribute
 */
//--------------------------------------------------------
bool AxisG2::is_MotionRetry_allowed(TANGO_UNUSED(Tango::AttReqType type))
{
	//	Not any excluded states for MotionRetry attribute in Write access.
	/*----- PROTECTED REGION ID(AxisG2::MotionRetryStateAllowed_WRITE) ENABLED START -----*/
	
	/*----- PROTECTED REGION END -----*/	//	AxisG2::MotionRetryStateAllowed_WRITE

	//	Not any excluded states for MotionRetry attribute in read access.
	/*----- PROTECTED REGION ID(AxisG2::MotionRetryStateAllowed_READ) ENABLED START -----*/
	
	/*----- PROTECTED REGION END -----*/	//	AxisG2::MotionRetryStateAllowed_READ
	return true;
}

//--------------------------------------------------------
/**
 *	Method      : AxisG2::is_Backlash_allowed()
 *	Description : Execution allowed for Backlash attribute
 */
//--------------------------------------------------------
bool AxisG2::is_Backlash_allowed(TANGO_UNUSED(Tango::AttReqType type))
{
	//	Not any excluded states for Backlash attribute in Write access.
	/*----- PROTECTED REGION ID(AxisG2::BacklashStateAllowed_WRITE) ENABLED START -----*/
	
	/*----- PROTECTED REGION END -----*/	//	AxisG2::BacklashStateAllowed_WRITE

	//	Not any excluded states for Backlash attribute in read access.
	/*----- PROTECTED REGION ID(AxisG2::BacklashStateAllowed_READ) ENABLED START -----*/
	
	/*----- PROTECTED REGION END -----*/	//	AxisG2::BacklashStateAllowed_READ
	return true;
}

//--------------------------------------------------------
/**
 *	Method      : AxisG2::is_BacklashDirection_allowed()
 *	Description : Execution allowed for BacklashDirection attribute
 */
//--------------------------------------------------------
bool AxisG2::is_BacklashDirection_allowed(TANGO_UNUSED(Tango::AttReqType type))
{
	//	Not any excluded states for BacklashDirection attribute in Write access.
	/*----- PROTECTED REGION ID(AxisG2::BacklashDirectionStateAllowed_WRITE) ENABLED START -----*/
	
	/*----- PROTECTED REGION END -----*/	//	AxisG2::BacklashDirectionStateAllowed_WRITE

	//	Not any excluded states for BacklashDirection attribute in read access.
	/*----- PROTECTED REGION ID(AxisG2::BacklashDirectionStateAllowed_READ) ENABLED START -----*/
	
	/*----- PROTECTED REGION END -----*/	//	AxisG2::BacklashDirectionStateAllowed_READ
	return true;
}

//--------------------------------------------------------
/**
 *	Method      : AxisG2::is_Velocity_allowed()
 *	Description : Execution allowed for Velocity attribute
 */
//--------------------------------------------------------
bool AxisG2::is_Velocity_allowed(TANGO_UNUSED(Tango::AttReqType type))
{

	//	Not any excluded states for Velocity attribute in read access.
	/*----- PROTECTED REGION ID(AxisG2::VelocityStateAllowed_READ) ENABLED START -----*/
	
	/*----- PROTECTED REGION END -----*/	//	AxisG2::VelocityStateAllowed_READ
	return true;
}

//--------------------------------------------------------
/**
 *	Method      : AxisG2::is_IsInitialised_allowed()
 *	Description : Execution allowed for IsInitialised attribute
 */
//--------------------------------------------------------
bool AxisG2::is_IsInitialised_allowed(TANGO_UNUSED(Tango::AttReqType type))
{

	//	Not any excluded states for IsInitialised attribute in read access.
	/*----- PROTECTED REGION ID(AxisG2::IsInitialisedStateAllowed_READ) ENABLED START -----*/
	
	/*----- PROTECTED REGION END -----*/	//	AxisG2::IsInitialisedStateAllowed_READ
	return true;
}

//--------------------------------------------------------
/**
 *	Method      : AxisG2::is_DeviceState_allowed()
 *	Description : Execution allowed for DeviceState attribute
 */
//--------------------------------------------------------
bool AxisG2::is_DeviceState_allowed(TANGO_UNUSED(Tango::AttReqType type))
{
	//	Not any excluded states for DeviceState attribute in Write access.
	/*----- PROTECTED REGION ID(AxisG2::DeviceStateStateAllowed_WRITE) ENABLED START -----*/
	
	/*----- PROTECTED REGION END -----*/	//	AxisG2::DeviceStateStateAllowed_WRITE

	//	Not any excluded states for DeviceState attribute in read access.
	/*----- PROTECTED REGION ID(AxisG2::DeviceStateStateAllowed_READ) ENABLED START -----*/
	
	/*----- PROTECTED REGION END -----*/	//	AxisG2::DeviceStateStateAllowed_READ
	return true;
}

//--------------------------------------------------------
/**
 *	Method      : AxisG2::is_DeviceStatus_allowed()
 *	Description : Execution allowed for DeviceStatus attribute
 */
//--------------------------------------------------------
bool AxisG2::is_DeviceStatus_allowed(TANGO_UNUSED(Tango::AttReqType type))
{

	//	Not any excluded states for DeviceStatus attribute in read access.
	/*----- PROTECTED REGION ID(AxisG2::DeviceStatusStateAllowed_READ) ENABLED START -----*/
	
	/*----- PROTECTED REGION END -----*/	//	AxisG2::DeviceStatusStateAllowed_READ
	return true;
}

//--------------------------------------------------------
/**
 *	Method      : AxisG2::is_IsMicrocodeOK_allowed()
 *	Description : Execution allowed for IsMicrocodeOK attribute
 */
//--------------------------------------------------------
bool AxisG2::is_IsMicrocodeOK_allowed(TANGO_UNUSED(Tango::AttReqType type))
{

	//	Not any excluded states for IsMicrocodeOK attribute in read access.
	/*----- PROTECTED REGION ID(AxisG2::IsMicrocodeOKStateAllowed_READ) ENABLED START -----*/
	
	/*----- PROTECTED REGION END -----*/	//	AxisG2::IsMicrocodeOKStateAllowed_READ
	return true;
}

//--------------------------------------------------------
/**
 *	Method      : AxisG2::is_CheckEncoder_allowed()
 *	Description : Execution allowed for CheckEncoder attribute
 */
//--------------------------------------------------------
bool AxisG2::is_CheckEncoder_allowed(TANGO_UNUSED(Tango::AttReqType type))
{

	//	Not any excluded states for CheckEncoder attribute in read access.
	/*----- PROTECTED REGION ID(AxisG2::CheckEncoderStateAllowed_READ) ENABLED START -----*/
	
	/*----- PROTECTED REGION END -----*/	//	AxisG2::CheckEncoderStateAllowed_READ
	return true;
}

//--------------------------------------------------------
/**
 *	Method      : AxisG2::is_CheckEncoderHoldOn_allowed()
 *	Description : Execution allowed for CheckEncoderHoldOn attribute
 */
//--------------------------------------------------------
bool AxisG2::is_CheckEncoderHoldOn_allowed(TANGO_UNUSED(Tango::AttReqType type))
{
	//	Not any excluded states for CheckEncoderHoldOn attribute in Write access.
	/*----- PROTECTED REGION ID(AxisG2::CheckEncoderHoldOnStateAllowed_WRITE) ENABLED START -----*/
	
	/*----- PROTECTED REGION END -----*/	//	AxisG2::CheckEncoderHoldOnStateAllowed_WRITE

	//	Not any excluded states for CheckEncoderHoldOn attribute in read access.
	/*----- PROTECTED REGION ID(AxisG2::CheckEncoderHoldOnStateAllowed_READ) ENABLED START -----*/
	
	/*----- PROTECTED REGION END -----*/	//	AxisG2::CheckEncoderHoldOnStateAllowed_READ
	return true;
}

//--------------------------------------------------------
/**
 *	Method      : AxisG2::is_StoredPosition4Fake_allowed()
 *	Description : Execution allowed for StoredPosition4Fake attribute
 */
//--------------------------------------------------------
bool AxisG2::is_StoredPosition4Fake_allowed(TANGO_UNUSED(Tango::AttReqType type))
{

	//	Not any excluded states for StoredPosition4Fake attribute in read access.
	/*----- PROTECTED REGION ID(AxisG2::StoredPosition4FakeStateAllowed_READ) ENABLED START -----*/
	
	/*----- PROTECTED REGION END -----*/	//	AxisG2::StoredPosition4FakeStateAllowed_READ
	return true;
}

//--------------------------------------------------------
/**
 *	Method      : AxisG2::is_ExtStatus_allowed()
 *	Description : Execution allowed for ExtStatus attribute
 */
//--------------------------------------------------------
bool AxisG2::is_ExtStatus_allowed(TANGO_UNUSED(Tango::AttReqType type))
{

	//	Not any excluded states for ExtStatus attribute in read access.
	/*----- PROTECTED REGION ID(AxisG2::ExtStatusStateAllowed_READ) ENABLED START -----*/
	
	/*----- PROTECTED REGION END -----*/	//	AxisG2::ExtStatusStateAllowed_READ
	return true;
}

//--------------------------------------------------------
/**
 *	Method      : AxisG2::is_History_allowed()
 *	Description : Execution allowed for History attribute
 */
//--------------------------------------------------------
bool AxisG2::is_History_allowed(TANGO_UNUSED(Tango::AttReqType type))
{

	//	Not any excluded states for History attribute in read access.
	/*----- PROTECTED REGION ID(AxisG2::HistoryStateAllowed_READ) ENABLED START -----*/
	
	/*----- PROTECTED REGION END -----*/	//	AxisG2::HistoryStateAllowed_READ
	return true;
}


//=================================================
//		Commands Allowed Methods
//=================================================

//--------------------------------------------------------
/**
 *	Method      : AxisG2::is_Forward_allowed()
 *	Description : Execution allowed for Forward attribute
 */
//--------------------------------------------------------
bool AxisG2::is_Forward_allowed(TANGO_UNUSED(const CORBA::Any &any))
{
	//	Compare device state with not allowed states.
	if (get_state()==Tango::FAULT)
	{
	/*----- PROTECTED REGION ID(AxisG2::ForwardStateAllowed) ENABLED START -----*/
	
	/*----- PROTECTED REGION END -----*/	//	AxisG2::ForwardStateAllowed
		return false;
	}
	return true;
}

//--------------------------------------------------------
/**
 *	Method      : AxisG2::is_Stop_allowed()
 *	Description : Execution allowed for Stop attribute
 */
//--------------------------------------------------------
bool AxisG2::is_Stop_allowed(TANGO_UNUSED(const CORBA::Any &any))
{
	//	Not any excluded states for Stop command.
	/*----- PROTECTED REGION ID(AxisG2::StopStateAllowed) ENABLED START -----*/
	
	/*----- PROTECTED REGION END -----*/	//	AxisG2::StopStateAllowed
	return true;
}

//--------------------------------------------------------
/**
 *	Method      : AxisG2::is_Backward_allowed()
 *	Description : Execution allowed for Backward attribute
 */
//--------------------------------------------------------
bool AxisG2::is_Backward_allowed(TANGO_UNUSED(const CORBA::Any &any))
{
	//	Compare device state with not allowed states.
	if (get_state()==Tango::FAULT)
	{
	/*----- PROTECTED REGION ID(AxisG2::BackwardStateAllowed) ENABLED START -----*/
	
	/*----- PROTECTED REGION END -----*/	//	AxisG2::BackwardStateAllowed
		return false;
	}
	return true;
}

//--------------------------------------------------------
/**
 *	Method      : AxisG2::is_GoToRelativePosition_allowed()
 *	Description : Execution allowed for GoToRelativePosition attribute
 */
//--------------------------------------------------------
bool AxisG2::is_GoToRelativePosition_allowed(TANGO_UNUSED(const CORBA::Any &any))
{
	//	Not any excluded states for GoToRelativePosition command.
	/*----- PROTECTED REGION ID(AxisG2::GoToRelativePositionStateAllowed) ENABLED START -----*/
	
	/*----- PROTECTED REGION END -----*/	//	AxisG2::GoToRelativePositionStateAllowed
	return true;
}

//--------------------------------------------------------
/**
 *	Method      : AxisG2::is_GoToPosition_allowed()
 *	Description : Execution allowed for GoToPosition attribute
 */
//--------------------------------------------------------
bool AxisG2::is_GoToPosition_allowed(TANGO_UNUSED(const CORBA::Any &any))
{
	//	Compare device state with not allowed states.
	if (get_state()==Tango::FAULT)
	{
	/*----- PROTECTED REGION ID(AxisG2::GoToPositionStateAllowed) ENABLED START -----*/
	
	/*----- PROTECTED REGION END -----*/	//	AxisG2::GoToPositionStateAllowed
		return false;
	}
	return true;
}

//--------------------------------------------------------
/**
 *	Method      : AxisG2::is_DefinePosition_allowed()
 *	Description : Execution allowed for DefinePosition attribute
 */
//--------------------------------------------------------
bool AxisG2::is_DefinePosition_allowed(TANGO_UNUSED(const CORBA::Any &any))
{
	//	Compare device state with not allowed states.
	if (get_state()==Tango::FAULT)
	{
	/*----- PROTECTED REGION ID(AxisG2::DefinePositionStateAllowed) ENABLED START -----*/
	
	/*----- PROTECTED REGION END -----*/	//	AxisG2::DefinePositionStateAllowed
		return false;
	}
	return true;
}

//--------------------------------------------------------
/**
 *	Method      : AxisG2::is_GetMotionStatus_allowed()
 *	Description : Execution allowed for GetMotionStatus attribute
 */
//--------------------------------------------------------
bool AxisG2::is_GetMotionStatus_allowed(TANGO_UNUSED(const CORBA::Any &any))
{
	//	Not any excluded states for GetMotionStatus command.
	/*----- PROTECTED REGION ID(AxisG2::GetMotionStatusStateAllowed) ENABLED START -----*/
	
	/*----- PROTECTED REGION END -----*/	//	AxisG2::GetMotionStatusStateAllowed
	return true;
}

//--------------------------------------------------------
/**
 *	Method      : AxisG2::is_FindEdge_allowed()
 *	Description : Execution allowed for FindEdge attribute
 */
//--------------------------------------------------------
bool AxisG2::is_FindEdge_allowed(TANGO_UNUSED(const CORBA::Any &any))
{
	//	Not any excluded states for FindEdge command.
	/*----- PROTECTED REGION ID(AxisG2::FindEdgeStateAllowed) ENABLED START -----*/
	
	/*----- PROTECTED REGION END -----*/	//	AxisG2::FindEdgeStateAllowed
	return true;
}

//--------------------------------------------------------
/**
 *	Method      : AxisG2::is_FindIndex_allowed()
 *	Description : Execution allowed for FindIndex attribute
 */
//--------------------------------------------------------
bool AxisG2::is_FindIndex_allowed(TANGO_UNUSED(const CORBA::Any &any))
{
	//	Not any excluded states for FindIndex command.
	/*----- PROTECTED REGION ID(AxisG2::FindIndexStateAllowed) ENABLED START -----*/
	
	/*----- PROTECTED REGION END -----*/	//	AxisG2::FindIndexStateAllowed
	return true;
}

//--------------------------------------------------------
/**
 *	Method      : AxisG2::is_FindHome_allowed()
 *	Description : Execution allowed for FindHome attribute
 */
//--------------------------------------------------------
bool AxisG2::is_FindHome_allowed(TANGO_UNUSED(const CORBA::Any &any))
{
	//	Not any excluded states for FindHome command.
	/*----- PROTECTED REGION ID(AxisG2::FindHomeStateAllowed) ENABLED START -----*/
	
	/*----- PROTECTED REGION END -----*/	//	AxisG2::FindHomeStateAllowed
	return true;
}

//--------------------------------------------------------
/**
 *	Method      : AxisG2::is_GetErrorStatus_allowed()
 *	Description : Execution allowed for GetErrorStatus attribute
 */
//--------------------------------------------------------
bool AxisG2::is_GetErrorStatus_allowed(TANGO_UNUSED(const CORBA::Any &any))
{
	//	Not any excluded states for GetErrorStatus command.
	/*----- PROTECTED REGION ID(AxisG2::GetErrorStatusStateAllowed) ENABLED START -----*/
	
	/*----- PROTECTED REGION END -----*/	//	AxisG2::GetErrorStatusStateAllowed
	return true;
}

//--------------------------------------------------------
/**
 *	Method      : AxisG2::is_DirectCmd_allowed()
 *	Description : Execution allowed for DirectCmd attribute
 */
//--------------------------------------------------------
bool AxisG2::is_DirectCmd_allowed(TANGO_UNUSED(const CORBA::Any &any))
{
	//	Not any excluded states for DirectCmd command.
	/*----- PROTECTED REGION ID(AxisG2::DirectCmdStateAllowed) ENABLED START -----*/
	
	/*----- PROTECTED REGION END -----*/	//	AxisG2::DirectCmdStateAllowed
	return true;
}

//--------------------------------------------------------
/**
 *	Method      : AxisG2::is_AxisInit_allowed()
 *	Description : Execution allowed for AxisInit attribute
 */
//--------------------------------------------------------
bool AxisG2::is_AxisInit_allowed(TANGO_UNUSED(const CORBA::Any &any))
{
	//	Not any excluded states for AxisInit command.
	/*----- PROTECTED REGION ID(AxisG2::AxisInitStateAllowed) ENABLED START -----*/
	
	/*----- PROTECTED REGION END -----*/	//	AxisG2::AxisInitStateAllowed
	return true;
}

//--------------------------------------------------------
/**
 *	Method      : AxisG2::is_MotorOFF_allowed()
 *	Description : Execution allowed for MotorOFF attribute
 */
//--------------------------------------------------------
bool AxisG2::is_MotorOFF_allowed(TANGO_UNUSED(const CORBA::Any &any))
{
	//	Not any excluded states for MotorOFF command.
	/*----- PROTECTED REGION ID(AxisG2::MotorOFFStateAllowed) ENABLED START -----*/
	
	/*----- PROTECTED REGION END -----*/	//	AxisG2::MotorOFFStateAllowed
	return true;
}

//--------------------------------------------------------
/**
 *	Method      : AxisG2::is_MotorON_allowed()
 *	Description : Execution allowed for MotorON attribute
 */
//--------------------------------------------------------
bool AxisG2::is_MotorON_allowed(TANGO_UNUSED(const CORBA::Any &any))
{
	//	Not any excluded states for MotorON command.
	/*----- PROTECTED REGION ID(AxisG2::MotorONStateAllowed) ENABLED START -----*/
	
	/*----- PROTECTED REGION END -----*/	//	AxisG2::MotorONStateAllowed
	return true;
}

//--------------------------------------------------------
/**
 *	Method      : AxisG2::is_ReadHWConf_allowed()
 *	Description : Execution allowed for ReadHWConf attribute
 */
//--------------------------------------------------------
bool AxisG2::is_ReadHWConf_allowed(TANGO_UNUSED(const CORBA::Any &any))
{
	//	Not any excluded states for ReadHWConf command.
	/*----- PROTECTED REGION ID(AxisG2::ReadHWConfStateAllowed) ENABLED START -----*/
	
	/*----- PROTECTED REGION END -----*/	//	AxisG2::ReadHWConfStateAllowed
	return true;
}

//--------------------------------------------------------
/**
 *	Method      : AxisG2::is_GetUserEncoderRatio_allowed()
 *	Description : Execution allowed for GetUserEncoderRatio attribute
 */
//--------------------------------------------------------
bool AxisG2::is_GetUserEncoderRatio_allowed(TANGO_UNUSED(const CORBA::Any &any))
{
	//	Not any excluded states for GetUserEncoderRatio command.
	/*----- PROTECTED REGION ID(AxisG2::GetUserEncoderRatioStateAllowed) ENABLED START -----*/
	
	/*----- PROTECTED REGION END -----*/	//	AxisG2::GetUserEncoderRatioStateAllowed
	return true;
}

//--------------------------------------------------------
/**
 *	Method      : AxisG2::is_Service_allowed()
 *	Description : Execution allowed for Service attribute
 */
//--------------------------------------------------------
bool AxisG2::is_Service_allowed(TANGO_UNUSED(const CORBA::Any &any))
{
	//	Not any excluded states for Service command.
	/*----- PROTECTED REGION ID(AxisG2::ServiceStateAllowed) ENABLED START -----*/
	
	/*----- PROTECTED REGION END -----*/	//	AxisG2::ServiceStateAllowed
	return true;
}

//--------------------------------------------------------
/**
 *	Method      : AxisG2::is_GetMotionHistory_allowed()
 *	Description : Execution allowed for GetMotionHistory attribute
 */
//--------------------------------------------------------
bool AxisG2::is_GetMotionHistory_allowed(TANGO_UNUSED(const CORBA::Any &any))
{
	//	Not any excluded states for GetMotionHistory command.
	/*----- PROTECTED REGION ID(AxisG2::GetMotionHistoryStateAllowed) ENABLED START -----*/
	
	/*----- PROTECTED REGION END -----*/	//	AxisG2::GetMotionHistoryStateAllowed
	return true;
}

//--------------------------------------------------------
/**
 *	Method      : AxisG2::is_RestoreLastPosition_allowed()
 *	Description : Execution allowed for RestoreLastPosition attribute
 */
//--------------------------------------------------------
bool AxisG2::is_RestoreLastPosition_allowed(TANGO_UNUSED(const CORBA::Any &any))
{
	//	Not any excluded states for RestoreLastPosition command.
	/*----- PROTECTED REGION ID(AxisG2::RestoreLastPositionStateAllowed) ENABLED START -----*/
	
	/*----- PROTECTED REGION END -----*/	//	AxisG2::RestoreLastPositionStateAllowed
	return true;
}

//--------------------------------------------------------
/**
 *	Method      : AxisG2::is_AckCheckEnc_allowed()
 *	Description : Execution allowed for AckCheckEnc attribute
 */
//--------------------------------------------------------
bool AxisG2::is_AckCheckEnc_allowed(TANGO_UNUSED(const CORBA::Any &any))
{
	//	Not any excluded states for AckCheckEnc command.
	/*----- PROTECTED REGION ID(AxisG2::AckCheckEncStateAllowed) ENABLED START -----*/
	
	/*----- PROTECTED REGION END -----*/	//	AxisG2::AckCheckEncStateAllowed
	return true;
}

//--------------------------------------------------------
/**
 *	Method      : AxisG2::is_RawAbsPos_allowed()
 *	Description : Execution allowed for RawAbsPos attribute
 */
//--------------------------------------------------------
bool AxisG2::is_RawAbsPos_allowed(TANGO_UNUSED(const CORBA::Any &any))
{
	//	Not any excluded states for RawAbsPos command.
	/*----- PROTECTED REGION ID(AxisG2::RawAbsPosStateAllowed) ENABLED START -----*/
	
	/*----- PROTECTED REGION END -----*/	//	AxisG2::RawAbsPosStateAllowed
	return true;
}

//--------------------------------------------------------
/**
 *	Method      : AxisG2::is_RawRelPos_allowed()
 *	Description : Execution allowed for RawRelPos attribute
 */
//--------------------------------------------------------
bool AxisG2::is_RawRelPos_allowed(TANGO_UNUSED(const CORBA::Any &any))
{
	//	Not any excluded states for RawRelPos command.
	/*----- PROTECTED REGION ID(AxisG2::RawRelPosStateAllowed) ENABLED START -----*/
	
	/*----- PROTECTED REGION END -----*/	//	AxisG2::RawRelPosStateAllowed
	return true;
}

//--------------------------------------------------------
/**
 *	Method      : AxisG2::is_UserRawAbsPos_allowed()
 *	Description : Execution allowed for UserRawAbsPos attribute
 */
//--------------------------------------------------------
bool AxisG2::is_UserRawAbsPos_allowed(TANGO_UNUSED(const CORBA::Any &any))
{
	//	Not any excluded states for UserRawAbsPos command.
	/*----- PROTECTED REGION ID(AxisG2::UserRawAbsPosStateAllowed) ENABLED START -----*/
	
	/*----- PROTECTED REGION END -----*/	//	AxisG2::UserRawAbsPosStateAllowed
	return true;
}

//--------------------------------------------------------
/**
 *	Method      : AxisG2::is_UserRawRelPos_allowed()
 *	Description : Execution allowed for UserRawRelPos attribute
 */
//--------------------------------------------------------
bool AxisG2::is_UserRawRelPos_allowed(TANGO_UNUSED(const CORBA::Any &any))
{
	//	Not any excluded states for UserRawRelPos command.
	/*----- PROTECTED REGION ID(AxisG2::UserRawRelPosStateAllowed) ENABLED START -----*/
	
	/*----- PROTECTED REGION END -----*/	//	AxisG2::UserRawRelPosStateAllowed
	return true;
}

//--------------------------------------------------------
/**
 *	Method      : AxisG2::is_get_p4e_allowed()
 *	Description : Execution allowed for get_p4e attribute
 */
//--------------------------------------------------------
bool AxisG2::is_get_p4e_allowed(TANGO_UNUSED(const CORBA::Any &any))
{
	//	Not any excluded states for get_p4e command.
	/*----- PROTECTED REGION ID(AxisG2::get_p4eStateAllowed) ENABLED START -----*/
	
	/*----- PROTECTED REGION END -----*/	//	AxisG2::get_p4eStateAllowed
	return true;
}

//--------------------------------------------------------
/**
 *	Method      : AxisG2::is_get_e4p_allowed()
 *	Description : Execution allowed for get_e4p attribute
 */
//--------------------------------------------------------
bool AxisG2::is_get_e4p_allowed(TANGO_UNUSED(const CORBA::Any &any))
{
	//	Not any excluded states for get_e4p command.
	/*----- PROTECTED REGION ID(AxisG2::get_e4pStateAllowed) ENABLED START -----*/
	
	/*----- PROTECTED REGION END -----*/	//	AxisG2::get_e4pStateAllowed
	return true;
}

//--------------------------------------------------------
/**
 *	Method      : AxisG2::is_get_u4p_allowed()
 *	Description : Execution allowed for get_u4p attribute
 */
//--------------------------------------------------------
bool AxisG2::is_get_u4p_allowed(TANGO_UNUSED(const CORBA::Any &any))
{
	//	Not any excluded states for get_u4p command.
	/*----- PROTECTED REGION ID(AxisG2::get_u4pStateAllowed) ENABLED START -----*/
	
	/*----- PROTECTED REGION END -----*/	//	AxisG2::get_u4pStateAllowed
	return true;
}

//--------------------------------------------------------
/**
 *	Method      : AxisG2::is_get_p4u_allowed()
 *	Description : Execution allowed for get_p4u attribute
 */
//--------------------------------------------------------
bool AxisG2::is_get_p4u_allowed(TANGO_UNUSED(const CORBA::Any &any))
{
	//	Not any excluded states for get_p4u command.
	/*----- PROTECTED REGION ID(AxisG2::get_p4uStateAllowed) ENABLED START -----*/
	
	/*----- PROTECTED REGION END -----*/	//	AxisG2::get_p4uStateAllowed
	return true;
}

//--------------------------------------------------------
/**
 *	Method      : AxisG2::is_get_u4e_allowed()
 *	Description : Execution allowed for get_u4e attribute
 */
//--------------------------------------------------------
bool AxisG2::is_get_u4e_allowed(TANGO_UNUSED(const CORBA::Any &any))
{
	//	Not any excluded states for get_u4e command.
	/*----- PROTECTED REGION ID(AxisG2::get_u4eStateAllowed) ENABLED START -----*/
	
	/*----- PROTECTED REGION END -----*/	//	AxisG2::get_u4eStateAllowed
	return true;
}

//--------------------------------------------------------
/**
 *	Method      : AxisG2::is_get_e4u_allowed()
 *	Description : Execution allowed for get_e4u attribute
 */
//--------------------------------------------------------
bool AxisG2::is_get_e4u_allowed(TANGO_UNUSED(const CORBA::Any &any))
{
	//	Not any excluded states for get_e4u command.
	/*----- PROTECTED REGION ID(AxisG2::get_e4uStateAllowed) ENABLED START -----*/
	
	/*----- PROTECTED REGION END -----*/	//	AxisG2::get_e4uStateAllowed
	return true;
}

//--------------------------------------------------------
/**
 *	Method      : AxisG2::is_StorePosition4Fake_allowed()
 *	Description : Execution allowed for StorePosition4Fake attribute
 */
//--------------------------------------------------------
bool AxisG2::is_StorePosition4Fake_allowed(TANGO_UNUSED(const CORBA::Any &any))
{
	//	Not any excluded states for StorePosition4Fake command.
	/*----- PROTECTED REGION ID(AxisG2::StorePosition4FakeStateAllowed) ENABLED START -----*/
	
	/*----- PROTECTED REGION END -----*/	//	AxisG2::StorePosition4FakeStateAllowed
	return true;
}

//--------------------------------------------------------
/**
 *	Method      : AxisG2::is_FakeAxisInit_allowed()
 *	Description : Execution allowed for FakeAxisInit attribute
 */
//--------------------------------------------------------
bool AxisG2::is_FakeAxisInit_allowed(TANGO_UNUSED(const CORBA::Any &any))
{
	//	Not any excluded states for FakeAxisInit command.
	/*----- PROTECTED REGION ID(AxisG2::FakeAxisInitStateAllowed) ENABLED START -----*/
	
	/*----- PROTECTED REGION END -----*/	//	AxisG2::FakeAxisInitStateAllowed
	return true;
}


/*----- PROTECTED REGION ID(AxisG2::AxisG2StateAllowed.AdditionalMethods) ENABLED START -----*/

//	Additional Methods

/*----- PROTECTED REGION END -----*/	//	AxisG2::AxisG2StateAllowed.AdditionalMethods

}	//	End of namespace
