#include "AxisG2.h"

namespace AxisG2_ns
{


//--------------------------------------------------------
/**
 *
 *
 *
 */
//--------------------------------------------------------
void AxisG2::ExtStatus(Tango::DevString *extstatusattr, int *riga, string msg){
        char buff[1000];

	#ifdef _DBG_EXTSTATUS
                cout << "== [ riga =";
		cout << (*riga);
		cout << "] ==" << endl;

                cout << "== (";
		cout << extstatusattr[*riga];
		cout << ") ==" << endl;
        #endif /*_DBG_EXTSTATUS*/

        if (extstatusattr[*riga] != NULL){
                delete[] extstatusattr[*riga];
                extstatusattr[*riga] = NULL;
        }

        snprintf(buff, 1000, "%s", msg.c_str());
        extstatusattr[*riga] = new char[strlen(buff)+1];
        strcpy(extstatusattr[*riga], buff);

        (*riga)++;

}





//+------------------------------------------------------------------
/**
 *      method: AxisG2::read_memorized_attribute
 */
//+------------------------------------------------------------------
bool AxisG2::read_memorized_attribute(string attr_name, Tango::DbDatum & dbdatum) {
	DEBUG_STREAM << "AxisG2::read_memorized_attribute(): entering... !" << endl;

	bool read_is_valid = false;

	if (Tango::Util::instance()->_UseDb==true) {
		Tango::Database *db = Tango::Util::instance()->get_database();

		Tango::DbData dbdata;
		dbdata.push_back(Tango::DbDatum(attr_name));
		db->get_device_attribute_property(get_name(), dbdata);

		for(unsigned int i=0; i<dbdata.size(); i++) {
			if(!dbdata[i].is_empty() && !dbdata[i].name.compare("__value")) {
				dbdatum = dbdata[i];
				read_is_valid = true;
			}
		}

	} else {
		WARN_STREAM << "AxisG2::read_memorized_attribute(): use database false!" << endl;
	}

	return read_is_valid;
}

//+------------------------------------------------------------------
/**
 *      method: AxisG2::read_memorized_attribute(attr_name, attr_prop_name, &dbdatum);
 */
//+------------------------------------------------------------------
bool AxisG2::read_memorized_attribute(string attr_name, string attr_prop_name, Tango::DbDatum & dbdatum){
	DEBUG_STREAM << "AxisG2::read_memorized_attribute(): entering... !" << endl;

	bool read_is_valid = false;

	if (Tango::Util::instance()->_UseDb==true) {
		Tango::Database *db = Tango::Util::instance()->get_database();

		Tango::DbData dbdata;
		dbdata.push_back(Tango::DbDatum(attr_name));
		db->get_device_attribute_property(get_name(), dbdata);

		for(unsigned int i=0; i<dbdata.size(); i++) {
			if(!dbdata[i].is_empty() && !dbdata[i].name.compare(attr_prop_name)) {
				dbdatum = dbdata[i];
				read_is_valid = true;
			}
		}

	} else {
		WARN_STREAM << "AxisG2::read_memorized_attribute(): use database false!" << endl;
	}

	return read_is_valid;
}

//+------------------------------------------------------------------
/**
 *      method: AxisG2::put_memorized_attribute
 */
//+------------------------------------------------------------------
bool AxisG2::put_memorized_attribute(string attr_name, Tango::DbDatum dbdatum){
	DEBUG_STREAM << "AxisG2::put_memorized_attribute(): entering... !" << endl;

	bool put_is_valid = false;

	if (Tango::Util::instance()->_UseDb==true) {
		try {
			Tango::Database *db = Tango::Util::instance()->get_database();
			Tango::DbData db_data;

        		Tango::DbDatum _attr(attr_name);
        		_attr << (Tango::DevLong)1 ; // una property

        		db_data.push_back(_attr);
        		db_data.push_back(dbdatum);

        		db->put_device_attribute_property(get_name(), db_data);
			put_is_valid = true;

		} catch(...) {
			cout << "put_memorized_attribute EXCEPT " << endl;
			put_is_valid = false;
		}

	} else {
		WARN_STREAM << "AxisG2::put_memorized_attribute(): use database false!" << endl;
	}


	return put_is_valid;
}


//+------------------------------------------------------------------
/**
 *      method: AxisG2::delete_memorized_attribute_property
 */
//+------------------------------------------------------------------
bool AxisG2::delete_memorized_attribute_property(string attr_name, Tango::DbDatum dbdatum){
	DEBUG_STREAM << "AxisG2::delete_memorized_attribute_property(): entering... !" << endl;

	bool del_is_valid = false;

	if (Tango::Util::instance()->_UseDb==true) {
		try {
			Tango::Database *db = Tango::Util::instance()->get_database();
			Tango::DbData db_data;

        		Tango::DbDatum _attr(attr_name);

        		db_data.push_back(_attr);
        		db_data.push_back(dbdatum);

        		db->delete_device_attribute_property(get_name(), db_data);
			del_is_valid = true;

		} catch(...) {
			cout << "delete_memorized_attribute_property EXCEPT " << endl;
			del_is_valid = false;
		}

	} else {
		WARN_STREAM << "AxisG2::delete_memorized_attribute_property(): use database false!" << endl;
	}


	return del_is_valid;
}

//--------------------------------------------------------
/**
 *
 *
 *
 */
//--------------------------------------------------------
bool AxisG2::sethw_MotionAccuracy(double v){
	long dbw;
        Controller_ns::mconf_t hw_mc = axis->mconf();
        switch (controller->controller()){
                case Controller_ns::Yams:
                case Controller_ns::N5:
			dbw = (long) fabs(axis->position2enc(0 + v) - axis->position2enc(0));
			#ifdef _DBG_CONF
				cout << "sethw_MotionAccuracy .. axis->position2enc(0)=" << axis->position2enc(0) << endl;
				cout << "sethw_MotionAccuracy .. axis->position2enc(0 + v)=" << axis->position2enc(0 + v) << endl;
				cout << "sethw_MotionAccuracy .. dbw = " << dbw << endl;
			#endif /* _DBG_CONF */
                        if ( dbw <= 0 ) dbw = 2;
			hw_mc.yc.dbw   = (long)  dbw;
			return axis->mconf(hw_mc);
                        break;
                default:
                        break;
        };
	return false;
}

//--------------------------------------------------------
/**
 *
 *
 *
 */
//--------------------------------------------------------
bool AxisG2::sethw_MotionPercent(double v){
        Controller_ns::mconf_t hw_mc = axis->mconf();
        switch (controller->controller()){
                case Controller_ns::Yams:
                case Controller_ns::N5:
			if (( v <= 0 ) || ( v > 1 )) v = 1;
                        hw_mc.yc.pc = v;
			return axis->mconf(hw_mc);
                        break;
                default:
                        break;
        };
	return false;
}

//--------------------------------------------------------
/**
 *
 *
 *
 */
//--------------------------------------------------------
bool AxisG2::sethw_Backlash(double v){
        Controller_ns::mconf_t hw_mc = axis->mconf();
        switch (controller->controller()){
                case Controller_ns::Yams:
                case Controller_ns::N5:
			hw_mc.yc.bck = (axis->position2enc(0 + v) - axis->position2enc(0));
			return axis->mconf(hw_mc);
                        break;
                default:
                        break;
        };
	return false;
}

//--------------------------------------------------------
/**
 *
 *
 *
 */
//--------------------------------------------------------
bool AxisG2::sethw_BacklashDirection(double v){
	long l;
        Controller_ns::mconf_t hw_mc = axis->mconf();
        switch (controller->controller()){
                case Controller_ns::Yams:
                case Controller_ns::N5:
			l = (long)v;
                        switch (l){
                                case -1:
                                case  0:
                                case  1:
                                        hw_mc.yc.dir= l;
                                        break;
                                default:
                                        break;
                        }
			return axis->mconf(hw_mc);
                        break;
                default:
                        break;
        };
	return false;
}

//--------------------------------------------------------
/**
 *
 *
 *
 */
//--------------------------------------------------------
bool AxisG2::sethw_MotionRetry(double v){
        Controller_ns::mconf_t hw_mc = axis->mconf();
        switch (controller->controller()){
                case Controller_ns::Yams:
                case Controller_ns::N5:
			if ( v > 0 ) hw_mc.yc.nbrtr = (long)v;
			return axis->mconf(hw_mc);
                        break;
                default:
                        break;
        };
	return false;
}

//--------------------------------------------------------
/**
 *
 *
 *
 */
//--------------------------------------------------------
bool AxisG2::check_MotionAccuracy(double v){

	if ( (fabs(axis->position2enc(0 + v)   - axis->position2enc(0))   >=  encoderPrecision) &&
	     (fabs(axis->position2motor(0 + v) - axis->position2motor(0)) >= 1)
	   ) return true;
	return false;
}

//--------------------------------------------------------
/**
 *
 *
 *
 */
//--------------------------------------------------------
bool AxisG2::check_Backlash(double v){

	if ( (fabs(axis->position2enc(0 + v)   - axis->position2enc(0))   >=  encoderPrecision) &&
	     (fabs(axis->position2motor(0 + v) - axis->position2motor(0)) >= 1)
	   ) return true;
	return false;
}


//--------------------------------------------------------
/**
 *
 *
 *
 */
//--------------------------------------------------------
Tango::DevState AxisG2::string2state(std::string state_str) {

        DEBUG_STREAM << "AxisG2::from_string_to_state()  - " << device_name << endl;

/* ON, OFF, CLOSE, OPEN, INSERT, EXTRACT, MOVING, STANDBY, FAULT, INIT, RUNNING, ALARM, DISABLE, UNKNOWN */

        if      (state_str == "ON")      { return Tango::ON; }
        else if (state_str == "OFF")     { return Tango::OFF; }
        else if (state_str == "CLOSE")   { return Tango::CLOSE; }
        else if (state_str == "OPEN")    { return Tango::OPEN; }
        else if (state_str == "INSERT")  { return Tango::INSERT; }
        else if (state_str == "EXTRACT") { return Tango::EXTRACT; }
        else if (state_str == "MOVING")  { return Tango::MOVING; }
        else if (state_str == "STANDBY") { return Tango::STANDBY; }
        else if (state_str == "FAULT")   { return Tango::FAULT; }
        else if (state_str == "INIT")    { return Tango::INIT; }
        else if (state_str == "RUNNING") { return Tango::RUNNING; }
        else if (state_str == "ALARM")   { return Tango::ALARM; }
        else if (state_str == "DISABLE") { return Tango::DISABLE; }
        else { return Tango::UNKNOWN; }
}

//--------------------------------------------------------
/**
 *
 *
 *
 */
//--------------------------------------------------------
/*
   FROM: tango-8.1.2.c/lib/cpp/server/utils.tpp
	
    Tango::Attribute &att = dev->get_device_attr()->get_attr_by_name(att_name.c_str());
    Tango::WAttribute *w_att_ptr = NULL;
    Tango::AttrWriteType w_type = att.get_writable();
    if (w_type == Tango::READ_WRITE)
        w_att_ptr = &(dev->get_device_attr()->get_w_attr_by_name(att_name.c_str()));
*/

Tango::WAttribute* AxisG2::get_wattr_by_name(string att_name){

	Tango::Attribute &att = get_device_attr()->get_attr_by_name(att_name.c_str());
	Tango::WAttribute *w_att_ptr = NULL;
	Tango::AttrWriteType w_type = att.get_writable();
	if (w_type == Tango::READ_WRITE) w_att_ptr = &(get_device_attr()->get_w_attr_by_name(att_name.c_str()));

	return w_att_ptr;
}

Tango::Attribute* AxisG2::get_attr_by_name(string att_name){

	Tango::Attribute *att_ptr = NULL;
	att_ptr = &(get_device_attr()->get_attr_by_name(att_name.c_str()));

	return att_ptr;
}

Tango::Attribute& AxisG2::rget_attr_by_name(string att_name){
	return get_device_attr()->get_attr_by_name(att_name.c_str());
}

//--------------------------------------------------------
/**
 *
 *
 *
 */
//--------------------------------------------------------
bool AxisG2::configSencEnc(vector<string>  ee){
	#ifdef _DBG_ENCODER_EXTRAS
		cout << "configSencEnc()" << endl;
	#endif
	int eesize = ee.size();
	if (eesize == 3){
		/*
		typedef struct {
	        	EncoderLimit_t startPoint;
	        	double SencRes;
	        	double SencPitch;
		} SencParams_t;
		*/

		Encoder_ns::SencParams_t sp;

		if ( ee[0].compare("RLS") == 0 ) sp.startPoint = Encoder_ns::LIMIT_RLS; else
		if ( ee[0].compare("FLS") == 0 ) sp.startPoint = Encoder_ns::LIMIT_FLS; else {
		  #ifdef _DBG_ENCODER_EXTRAS
			cout << "configSencEnc() error on RLS/FLS" << endl;
		  #endif
		  return false;
		}

		int n;
		float f;
		#ifdef _DBG_ENCODER_EXTRAS
			cout << "configSencEnc() ee[1]" << ee[1] << endl;
			cout << "configSencEnc() ee[2]" << ee[2] << endl;
		#endif
		n = sscanf((ee[1]).c_str(), "%f", &f);
		if (n==1) sp.SencRes = (double)f; else {
		  	#ifdef _DBG_ENCODER_EXTRAS
				cout << "configSencEnc() error on SencRes n=" << n << endl;
		  	#endif
			return false;
		}
		n = sscanf((ee[2]).c_str(), "%f", &f);
		if (n==1) sp.SencPitch = (double)f; else {
		  	#ifdef _DBG_ENCODER_EXTRAS
				cout << "configSencEnc() error on SencPitch n=" << n << endl;
		  	#endif
			return false;
		}
		
		return axis->SencParams(sp);
	}

	return false;
}

void AxisG2::INFOLOG(string x) {
	INFO_STREAM << "LOG: " << x << endl; 
}

// _IF_MAX

void AxisG2::INFOLOG(bool once, string x) {
#ifdef _INFO_LOG
        #if 1
       		//cout << "BLOG: " <<  _il_count << " " << _il_last << " "   << x << endl;
            if ( _il_last.compare(x) == 0 ){  
		if (once){
			return;
		} else {
            		_il_count++;                           
                	if (_il_count > _IF_MAX){            
                		INFO_STREAM << "LOG: last msg repeted " << _il_count << " times";
                        	_il_count = 0;              
                	}                                  
		}
            } else {                              
               _il_last = x;          
               _il_count = 0;                   
               INFO_STREAM << "LOG: " << x << endl; 
            }                                             
        #else
        	cout << "ALOG: " << x << endl;
        #endif
#else /*_INFO_LOG*/
#endif /*_INFO_LOG*/
}


} //    namespace
