/*----- PROTECTED REGION ID(GalilAxisG2.cpp) ENABLED START -----*/
//=============================================================================
//
// file :        GalilAxisG2.cpp
//
// description : C++ source for the GalilAxisG2 class and its commands.
//               The class is derived from Device. It represents the
//               CORBA servant object which will be accessed from the
//               network. All commands which can be executed on the
//               GalilAxisG2 are implemented in this file.
//
// project :     
//
// This file is part of Tango device class.
// 
// Tango is free software: you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation, either version 3 of the License, or
// (at your option) any later version.
// 
// Tango is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
// 
// You should have received a copy of the GNU General Public License
// along with Tango.  If not, see <http://www.gnu.org/licenses/>.
// 
// $Author: abrami $
//
//=============================================================================
//                This file is generated by POGO
//        (Program Obviously used to Generate tango Object)
//=============================================================================


#include <GalilAxisG2.h>
#include <GalilAxisG2Class.h>

/*----- PROTECTED REGION END -----*/	//	GalilAxisG2.cpp

/**
 *  GalilAxisG2 class description:
 *    
 */

//================================================================
//  The following table gives the correspondence
//  between command and method names.
//
//  Command name              |  Method name
//================================================================
//  State                     |  Inherited (no method)
//  Status                    |  Inherited (no method)
//  Forward                   |  Inherited (no method)
//  Stop                      |  Inherited (no method)
//  Backward                  |  Inherited (no method)
//  GoToRelativePosition      |  Inherited (no method)
//  GoToPosition              |  Inherited (no method)
//  DefinePosition            |  Inherited (no method)
//  GetMotionStatus           |  Inherited (no method)
//  FindEdge                  |  Inherited (no method)
//  FindIndex                 |  Inherited (no method)
//  FindHome                  |  Inherited (no method)
//  GetErrorStatus            |  Inherited (no method)
//  DirectCmd                 |  Inherited (no method)
//  AxisInit                  |  Inherited (no method)
//  MotorOFF                  |  Inherited (no method)
//  MotorON                   |  Inherited (no method)
//  ReadHWConf                |  Inherited (no method)
//  GetUserEncoderRatio       |  Inherited (no method)
//  Service                   |  Inherited (no method)
//  GetMotionHistory          |  Inherited (no method)
//  RestoreLastPosition       |  Inherited (no method)
//  AckCheckEnc               |  Inherited (no method)
//  AxisStop                  |  axis_stop
//  AxisGoToRelativePosition  |  axis_go_to_relative_position
//================================================================

//================================================================
//  Attributes managed are:
//================================================================
//  Position                    |  Tango::DevDouble	Scalar
//  PositiveLimitSwitch         |  Tango::DevBoolean	Scalar
//  NegativeLimitSwitch         |  Tango::DevBoolean	Scalar
//  HomeSwitch                  |  Tango::DevBoolean	Scalar
//  MotorStatus                 |  Tango::DevString	Scalar
//  EncoderPosition             |  Tango::DevDouble	Scalar
//  MotorPosition               |  Tango::DevLong	Scalar
//  UserPosition                |  Tango::DevDouble	Scalar
//  UserScale                   |  Tango::DevDouble	Scalar
//  UserOffset                  |  Tango::DevDouble	Scalar
//  Speed                       |  Tango::DevDouble	Scalar
//  Acceleration                |  Tango::DevDouble	Scalar
//  Deceleration                |  Tango::DevDouble	Scalar
//  MotionAccuracy              |  Tango::DevDouble	Scalar
//  MotionPercent               |  Tango::DevDouble	Scalar
//  MotionRetry                 |  Tango::DevDouble	Scalar
//  Backlash                    |  Tango::DevDouble	Scalar
//  BacklashDirection           |  Tango::DevDouble	Scalar
//  Velocity                    |  Tango::DevDouble	Scalar
//  IsInitialised               |  Tango::DevShort	Scalar
//  DeviceState                 |  Tango::DevUShort	Scalar
//  DeviceStatus                |  Tango::DevString	Scalar
//  IsMicrocodeOK               |  Tango::DevBoolean	Scalar
//  CheckEncoder                |  Tango::DevBoolean	Scalar
//  CheckEncoderHoldOn          |  Tango::DevBoolean	Scalar
//  AxisCurrentPosition         |  Tango::DevDouble	Scalar
//  AxisCurrentEncoderPosition  |  Tango::DevDouble	Scalar
//  AxisCurrentMotorPosition    |  Tango::DevLong	Scalar
//  AxisOffset                  |  Tango::DevDouble	Scalar
//  AxisVelocity                |  Tango::DevDouble	Scalar
//  UserSpeed                   |  Tango::DevDouble	Scalar
//  ExtStatus                   |  Tango::DevString	Spectrum  ( max = 100)
//================================================================

namespace GalilAxisG2_ns
{
/*----- PROTECTED REGION ID(GalilAxisG2::namespace_starting) ENABLED START -----*/

//	static initializations

/*----- PROTECTED REGION END -----*/	//	GalilAxisG2::namespace_starting

//--------------------------------------------------------
/**
 *	Method      : GalilAxisG2::GalilAxisG2()
 *	Description : Constructors for a Tango device
 *                implementing the classGalilAxisG2
 */
//--------------------------------------------------------
GalilAxisG2::GalilAxisG2(Tango::DeviceClass *cl, string &s)
 : AxisG2(cl, s.c_str())
{
	/*----- PROTECTED REGION ID(GalilAxisG2::constructor_1) ENABLED START -----*/
	init_device();
	
	/*----- PROTECTED REGION END -----*/	//	GalilAxisG2::constructor_1
}
//--------------------------------------------------------
GalilAxisG2::GalilAxisG2(Tango::DeviceClass *cl, const char *s)
 : AxisG2(cl, s)
{
	/*----- PROTECTED REGION ID(GalilAxisG2::constructor_2) ENABLED START -----*/
	init_device();
	
	/*----- PROTECTED REGION END -----*/	//	GalilAxisG2::constructor_2
}
//--------------------------------------------------------
GalilAxisG2::GalilAxisG2(Tango::DeviceClass *cl, const char *s, const char *d)
 : AxisG2(cl, s, d)
{
	/*----- PROTECTED REGION ID(GalilAxisG2::constructor_3) ENABLED START -----*/
	init_device();
	
	/*----- PROTECTED REGION END -----*/	//	GalilAxisG2::constructor_3
}

//--------------------------------------------------------
/**
 *	Method      : GalilAxisG2::delete_device()
 *	Description : will be called at device destruction or at init command
 */
//--------------------------------------------------------
void GalilAxisG2::delete_device()
{
	DEBUG_STREAM << "GalilAxisG2::delete_device() " << device_name << endl;
	/*----- PROTECTED REGION ID(GalilAxisG2::delete_device) ENABLED START -----*/
	
	//	Delete device allocated objects
	std::string obj("GalilAxisG2::delete_device()");
	std::stringstream ss("");
	ss << " ::BEGIN:: ";
	prtlog(obj, ss.str());
	
	/*----- PROTECTED REGION END -----*/	//	GalilAxisG2::delete_device
	delete[] attr_AxisCurrentPosition_read;
	delete[] attr_AxisCurrentEncoderPosition_read;
	delete[] attr_AxisCurrentMotorPosition_read;
	delete[] attr_AxisOffset_read;
	delete[] attr_AxisVelocity_read;

/*??????????????????????????????????????????????????????????????????????????????????

== questa classe derivata era stata creata in T8, dove funziona.
== MA ! in T9, questo mi crea core quando faccio restart del singolo device

	if (Tango::Util::instance()->is_svr_shutting_down()==false  &&
		Tango::Util::instance()->is_device_restarting(device_name)==false &&
		Tango::Util::instance()->is_svr_starting()==false)
	{
		//	If not shutting down call delete device for inherited object
		AxisG2_ns::AxisG2::delete_device();
	}
??????????????????????????????????????????????????????????????????????????????????*/

	delete[] attr_IsInitialised_Galilold;

	ss.str("");
	ss << " ::END:: ";
	prtlog(obj, ss.str());
}

//--------------------------------------------------------
/**
 *	Method      : GalilAxisG2::init_device()
 *	Description : will be called at device initialization.
 */
//--------------------------------------------------------
void GalilAxisG2::init_device()
{
	DEBUG_STREAM << "GalilAxisG2::init_device() create device " << device_name << endl;
	/*----- PROTECTED REGION ID(GalilAxisG2::init_device_before) ENABLED START -----*/
	
	//	Initialization before get_device_property() call
	std::string obj("GalilAxisG2::init_device()");
	std::stringstream ss("");

	prtlog(obj, ss.str());
	
	/*----- PROTECTED REGION END -----*/	//	GalilAxisG2::init_device_before
	
	if (Tango::Util::instance()->is_svr_starting() == false  &&
		Tango::Util::instance()->is_device_restarting(device_name)==false)
	{
		//	If not starting up call init device for inherited object
		AxisG2_ns::AxisG2::init_device();
	}
	//	No device property to be read from database
	
	attr_AxisCurrentPosition_read = new Tango::DevDouble[1];
	attr_AxisCurrentEncoderPosition_read = new Tango::DevDouble[1];
	attr_AxisCurrentMotorPosition_read = new Tango::DevLong[1];
	attr_AxisOffset_read = new Tango::DevDouble[1];
	attr_AxisVelocity_read = new Tango::DevDouble[1];

	/*----- PROTECTED REGION ID(GalilAxisG2::init_device) ENABLED START -----*/
	
	//	Initialize device

        attr_IsInitialised_Galilold = new Tango::DevShort[1];
        attr_IsInitialised_Galilold[0] = 0;

	
	ss.str("");
	ss << " ! end !";
	prtlog(obj, ss.str());
	/*----- PROTECTED REGION END -----*/	//	GalilAxisG2::init_device
}


//--------------------------------------------------------
/**
 *	Method      : GalilAxisG2::always_executed_hook()
 *	Description : method always executed before any command is executed
 */
//--------------------------------------------------------
void GalilAxisG2::always_executed_hook()
{
	DEBUG_STREAM << "GalilAxisG2::always_executed_hook()  " << device_name << endl;
	if (AxisG2_ns::AxisG2::mandatoryNotDefined)
	{
		string	status(get_status());
		Tango::Except::throw_exception(
					(const char *)"PROPERTY_NOT_SET",
					status.c_str(),
					(const char *)"GalilAxisG2::always_executed_hook()");
	}
	/*----- PROTECTED REGION ID(GalilAxisG2::always_executed_hook) ENABLED START -----*/
	
	//	code always executed before all requests

	// MYCODE-START
	#ifdef _DBG_GALILAXISG2
		cout << "GalilAxisG2::always_executed_hook()  " << device_name << " ... entering ... " << endl;
	#endif /* _DBG_GALILAXISG2 */

	AxisG2_ns::AxisG2::always_executed_hook();

	//cout << "AEH():: *attr_MotorPosition_read = " << *AxisG2_ns::AxisG2::attr_MotorPosition_read << endl;
	#ifdef _DBG_GALILAXISG2
		cout << "GalilAxisG2::always_executed_hook()  " << device_name << " ... leaving ... " << endl;
	#endif /* _DBG_GALILAXISG2 */
	// MYCODE-END
	
	/*----- PROTECTED REGION END -----*/	//	GalilAxisG2::always_executed_hook
}

//--------------------------------------------------------
/**
 *	Method      : GalilAxisG2::read_attr_hardware()
 *	Description : Hardware acquisition for attributes
 */
//--------------------------------------------------------
void GalilAxisG2::read_attr_hardware(TANGO_UNUSED(vector<long> &attr_list))
{
	DEBUG_STREAM << "GalilAxisG2::read_attr_hardware(vector<long> &attr_list) entering... " << endl;
	/*----- PROTECTED REGION ID(GalilAxisG2::read_attr_hardware) ENABLED START -----*/
	
	//	Add your own code
	AxisG2_ns::AxisG2::read_attr_hardware(attr_list);
	
	/*----- PROTECTED REGION END -----*/	//	GalilAxisG2::read_attr_hardware
}
//--------------------------------------------------------
/**
 *	Method      : GalilAxisG2::write_attr_hardware()
 *	Description : Hardware writing for attributes
 */
//--------------------------------------------------------
void GalilAxisG2::write_attr_hardware(TANGO_UNUSED(vector<long> &attr_list))
{
	DEBUG_STREAM << "GalilAxisG2::write_attr_hardware(vector<long> &attr_list) entering... " << endl;
	/*----- PROTECTED REGION ID(GalilAxisG2::write_attr_hardware) ENABLED START -----*/
	
	//	Add your own code
	
	/*----- PROTECTED REGION END -----*/	//	GalilAxisG2::write_attr_hardware
}

//--------------------------------------------------------
/**
 *	Read attribute AxisCurrentPosition related method
 *	Description: 
 *
 *	Data type:	Tango::DevDouble
 *	Attr type:	Scalar
 */
//--------------------------------------------------------
void GalilAxisG2::read_AxisCurrentPosition(Tango::Attribute &attr)
{
	DEBUG_STREAM << "GalilAxisG2::read_AxisCurrentPosition(Tango::Attribute &attr) entering... " << endl;
	/*----- PROTECTED REGION ID(GalilAxisG2::read_AxisCurrentPosition) ENABLED START -----*/

	// MYCODE-START
	#ifdef _DBG_GALILAXISG2
		cout << "GalilAxisG2::read_AxisCurrentPosition(Tango::Attribute &attr) entering... " << endl;
	#endif /* _DBG_GALILAXISG2 */
	try {
		read_UserPosition(attr);
	} catch (...) {
		cout << "Except! GalilAxisG2::read_AxisCurrentPosition()" << endl;
	}
        // MYCODE-START
        bool ai = AInit();
        if ( !ai ) attr.set_quality(Tango::ATTR_INVALID);

        if ( (attr_IsInitialised_Galilold[0] == 0) && ai ){
                double upos = attr_UserPosition_read[0];
		UpdateRelative("AxisCurrentPosition", upos);
        }
        attr_IsInitialised_Galilold[0] = (Tango::DevShort)ai;


	#ifdef _DBG_GALILAXISG2
		cout << "GalilAxisG2::read_AxisCurrentPosition(Tango::Attribute &attr) leaving... " << endl;
	#endif /* _DBG_GALILAXISG2 */
	
	// MYCODE-END
	
	/*----- PROTECTED REGION END -----*/	//	GalilAxisG2::read_AxisCurrentPosition
}
//--------------------------------------------------------
/**
 *	Write attribute AxisCurrentPosition related method
 *	Description: 
 *
 *	Data type:	Tango::DevDouble
 *	Attr type:	Scalar
 */
//--------------------------------------------------------
void GalilAxisG2::write_AxisCurrentPosition(Tango::WAttribute &attr)
{
	DEBUG_STREAM << "GalilAxisG2::write_AxisCurrentPosition(Tango::WAttribute &attr) entering... " << endl;
	//	Retrieve write value
	Tango::DevDouble	w_val;
	attr.get_write_value(w_val);
	/*----- PROTECTED REGION ID(GalilAxisG2::write_AxisCurrentPosition) ENABLED START -----*/

	// MYCODE-START
	#ifdef _DBG_GALILAXISG2
		cout << "GalilAxisG2::write_AxisCurrentPosition(Tango::WAttribute &attr) entering... " << endl;
	#endif /* _DBG_GALILAXISG2 */

        Tango::WAttribute* w_att_ptr = get_wattr_by_name("UserPosition");
        if (w_att_ptr){
                //cout << "***** " << w_att_ptr->get_name() << endl;
                w_att_ptr->set_write_value(w_val);
		
		try {
                	AxisG2::write_UserPosition(*w_att_ptr);
		} catch (...) {
			throw;
		}
        } else {
                cout << "***** NOT WAttr UserPosition !!!!" << endl;
        }

	// MYCODE-END
	
	/*----- PROTECTED REGION END -----*/	//	GalilAxisG2::write_AxisCurrentPosition
}
//--------------------------------------------------------
/**
 *	Read attribute AxisCurrentEncoderPosition related method
 *	Description: 
 *
 *	Data type:	Tango::DevDouble
 *	Attr type:	Scalar
 */
//--------------------------------------------------------
void GalilAxisG2::read_AxisCurrentEncoderPosition(Tango::Attribute &attr)
{
	DEBUG_STREAM << "GalilAxisG2::read_AxisCurrentEncoderPosition(Tango::Attribute &attr) entering... " << endl;
	/*----- PROTECTED REGION ID(GalilAxisG2::read_AxisCurrentEncoderPosition) ENABLED START -----*/

	// MYCODE-START
	#ifdef _DBG_GALILAXISG2
		cout << "GalilAxisG2::read_AxisCurrentEncoderPosition(Tango::Attribute &attr) entering... " << endl;
	#endif /* _DBG_GALILAXISG2 */

	try {
		read_EncoderPosition(attr);

	} catch (...) {
		cout << "Except! GalilAxisG2::read_AxisCurrentEncoderPosition()" << endl;
	}

	// MYCODE-END

	
	#ifdef _DBG_GALILAXISG2
		cout << "GalilAxisG2::read_AxisCurrentEncoderPosition(Tango::Attribute &attr) leaving... " << endl;
	#endif /* _DBG_GALILAXISG2 */
	/*----- PROTECTED REGION END -----*/	//	GalilAxisG2::read_AxisCurrentEncoderPosition
}
//--------------------------------------------------------
/**
 *	Read attribute AxisCurrentMotorPosition related method
 *	Description: 
 *
 *	Data type:	Tango::DevLong
 *	Attr type:	Scalar
 */
//--------------------------------------------------------
void GalilAxisG2::read_AxisCurrentMotorPosition(Tango::Attribute &attr)
{
	DEBUG_STREAM << "GalilAxisG2::read_AxisCurrentMotorPosition(Tango::Attribute &attr) entering... " << endl;
	/*----- PROTECTED REGION ID(GalilAxisG2::read_AxisCurrentMotorPosition) ENABLED START -----*/

	// MYCODE-START
	#ifdef _DBG_GALILAXISG2
		cout << "GalilAxisG2::read_AxisCurrentMotorPosition(Tango::Attribute &attr) entering... " << endl;
	#endif /* _DBG_GALILAXISG2 */

	try {
		read_MotorPosition(attr);
	} catch (...) {
		cout << "Except! GalilAxisG2::read_AxisCurrentMotorPosition()" << endl;
	}

	// MYCODE-END
	
	#ifdef _DBG_GALILAXISG2
		cout << "GalilAxisG2::read_AxisCurrentMotorPosition(Tango::Attribute &attr) leaving... " << endl;
	#endif /* _DBG_GALILAXISG2 */
	/*----- PROTECTED REGION END -----*/	//	GalilAxisG2::read_AxisCurrentMotorPosition
}
//--------------------------------------------------------
/**
 *	Read attribute AxisOffset related method
 *	Description: 
 *
 *	Data type:	Tango::DevDouble
 *	Attr type:	Scalar
 */
//--------------------------------------------------------
void GalilAxisG2::read_AxisOffset(Tango::Attribute &attr)
{
	DEBUG_STREAM << "GalilAxisG2::read_AxisOffset(Tango::Attribute &attr) entering... " << endl;
	/*----- PROTECTED REGION ID(GalilAxisG2::read_AxisOffset) ENABLED START -----*/

	// MYCODE-START
	#ifdef _DBG_GALILAXISG2
		cout << "GalilAxisG2::read_AxisOffset(Tango::Attribute &attr) entering... " << endl;
	#endif /* _DBG_GALILAXISG2 */

	try {
		read_UserOffset(attr);
	} catch (...) {
		cout << "Except! GalilAxisG2::read_AxisOffset()" << endl;
	}
	// MYCODE-END

	#ifdef _DBG_GALILAXISG2
		cout << "GalilAxisG2::read_AxisOffset(Tango::Attribute &attr) leaving... " << endl;
	#endif /* _DBG_GALILAXISG2 */
	/*----- PROTECTED REGION END -----*/	//	GalilAxisG2::read_AxisOffset
}
//--------------------------------------------------------
/**
 *	Write attribute AxisOffset related method
 *	Description: 
 *
 *	Data type:	Tango::DevDouble
 *	Attr type:	Scalar
 */
//--------------------------------------------------------
void GalilAxisG2::write_AxisOffset(Tango::WAttribute &attr)
{
	DEBUG_STREAM << "GalilAxisG2::write_AxisOffset(Tango::WAttribute &attr) entering... " << endl;
	//	Retrieve write value
	Tango::DevDouble	w_val;
	attr.get_write_value(w_val);
	/*----- PROTECTED REGION ID(GalilAxisG2::write_AxisOffset) ENABLED START -----*/

	// MYCODE-START
	#ifdef _DBG_GALILAXISG2
		cout << "GalilAxisG2::write_AxisOffset(Tango::WAttribute &attr) entering... " << endl;
	#endif /* _DBG_GALILAXISG2 */

        Tango::WAttribute* w_att_ptr = get_wattr_by_name("UserOffset");
        if (w_att_ptr){
                //cout << "***** " << w_att_ptr->get_name() << endl;
                w_att_ptr->set_write_value(w_val);
		
		try {
                	write_UserOffset(*w_att_ptr);
		} catch (...) {
			throw;
		}

                Tango::DbDatum _attr_prop("__value");
                _attr_prop << w_val;

                if ( !put_memorized_attribute("UserOffset", _attr_prop) )
                                Tango::Except::throw_exception (
                                        (const char *)"AxisG2",
                                        (const char *)"Error in put new memorized value",
                                        (const char *)"AxisG2::write_Axis/UserOffset()");

        } else {
                cout << "***** NOT WAttr UserOffset !!!!" << endl;
        }
	// MYCODE-END
	
	/*----- PROTECTED REGION END -----*/	//	GalilAxisG2::write_AxisOffset
}
//--------------------------------------------------------
/**
 *	Read attribute AxisVelocity related method
 *	Description: 
 *
 *	Data type:	Tango::DevDouble
 *	Attr type:	Scalar
 */
//--------------------------------------------------------
void GalilAxisG2::read_AxisVelocity(Tango::Attribute &attr)
{
	DEBUG_STREAM << "GalilAxisG2::read_AxisVelocity(Tango::Attribute &attr) entering... " << endl;
	/*----- PROTECTED REGION ID(GalilAxisG2::read_AxisVelocity) ENABLED START -----*/

	// MYCODE-START
	#ifdef _DBG_GALILAXISG2
		cout << "GalilAxisG2::read_AxisVelocity(Tango::Attribute &attr) entering... " << endl;
	#endif /* _DBG_GALILAXISG2 */

	try {
		read_UserSpeed(attr);
	} catch (...) {
		cout << "Except! GalilAxisG2::read_AxisVelocity()" << endl;
	}

	#ifdef _DBG_GALILAXISG2
		cout << "GalilAxisG2::read_AxisVelocity(Tango::Attribute &attr) leaving... " << endl;
	#endif /* _DBG_GALILAXISG2 */
	// MYCODE-END
	
	/*----- PROTECTED REGION END -----*/	//	GalilAxisG2::read_AxisVelocity
}
//--------------------------------------------------------
/**
 *	Write attribute AxisVelocity related method
 *	Description: 
 *
 *	Data type:	Tango::DevDouble
 *	Attr type:	Scalar
 */
//--------------------------------------------------------
void GalilAxisG2::write_AxisVelocity(Tango::WAttribute &attr)
{
	DEBUG_STREAM << "GalilAxisG2::write_AxisVelocity(Tango::WAttribute &attr) entering... " << endl;
	//	Retrieve write value
	Tango::DevDouble	w_val;
	attr.get_write_value(w_val);
	/*----- PROTECTED REGION ID(GalilAxisG2::write_AxisVelocity) ENABLED START -----*/

	// MYCODE-START
        Tango::WAttribute* w_att_ptr = get_wattr_by_name("UserSpeed");
        if (w_att_ptr){
                //cout << "***** " << w_att_ptr->get_name() << endl;
                w_att_ptr->set_write_value(w_val);

		try {
                	write_UserSpeed(*w_att_ptr);
		} catch (...) {
			throw;
		}

        } else {
                cout << "***** NOT WAttr UserSpeed !!!!" << endl;
        }

	// MYCODE-END
	
	
	/*----- PROTECTED REGION END -----*/	//	GalilAxisG2::write_AxisVelocity
}

//--------------------------------------------------------
/**
 *	Method      : GalilAxisG2::add_dynamic_attributes()
 *	Description : Create the dynamic attributes if any
 *                for specified device.
 */
//--------------------------------------------------------
void GalilAxisG2::add_dynamic_attributes()
{
	/*----- PROTECTED REGION ID(GalilAxisG2::add_dynamic_attributes) ENABLED START -----*/
	
	//	Add your own code to create and add dynamic attributes if any
	
	/*----- PROTECTED REGION END -----*/	//	GalilAxisG2::add_dynamic_attributes
}

//--------------------------------------------------------
/**
 *	Command AxisStop related method
 *	Description: 
 *
 */
//--------------------------------------------------------
void GalilAxisG2::axis_stop()
{
	DEBUG_STREAM << "GalilAxisG2::AxisStop()  - " << device_name << endl;
	/*----- PROTECTED REGION ID(GalilAxisG2::axis_stop) ENABLED START -----*/
	
	//	Add your own code

	// MYCODE-START
	AxisG2_ns::AxisG2::stop();
	// MYCODE-END
	
	/*----- PROTECTED REGION END -----*/	//	GalilAxisG2::axis_stop
}
//--------------------------------------------------------
/**
 *	Command AxisGoToRelativePosition related method
 *	Description: 
 *
 *	@param argin 
 */
//--------------------------------------------------------
void GalilAxisG2::axis_go_to_relative_position(Tango::DevDouble argin)
{
	DEBUG_STREAM << "GalilAxisG2::AxisGoToRelativePosition()  - " << device_name << endl;
	/*----- PROTECTED REGION ID(GalilAxisG2::axis_go_to_relative_position) ENABLED START -----*/
	
	//	Add your own code

	// MYCODE-START
        Tango::WAttribute* w_att_ptr = get_wattr_by_name("UserPosition");

        if (w_att_ptr){
		AxisG2_ns::AxisG2::read_UserPosition(*w_att_ptr);
		double abs_pos = *attr_UserPosition_read;
		double upos = abs_pos + argin;
                w_att_ptr->set_write_value(upos);

		try {
                	write_UserPosition(*w_att_ptr);
			UpdateRelative("AxisCurrentPosition", upos);
		} catch (...) {
			throw;
		}

        } else {
                cout << "***** NOT WAttr UserPosition !!!!" << endl;
        }
	// MYCODE-END
	
	/*----- PROTECTED REGION END -----*/	//	GalilAxisG2::axis_go_to_relative_position
}

/*----- PROTECTED REGION ID(GalilAxisG2::namespace_ending) ENABLED START -----*/

//	Additional Methods

/************************************************
*
*/
#if 0
	void GalilAxisG2::UpdateRelative(string RelativeName, double value){

        	Tango::WAttribute* w_att_ptr = get_wattr_by_name(RelativeName);
        	if (w_att_ptr){
                	//cout << "***** " << w_att_ptr->get_name() << endl;
                	w_att_ptr->set_write_value(value);

                	Tango::DbDatum _attr_prop("__value");
                	_attr_prop << value;

                	if ( !put_memorized_attribute(RelativeName, _attr_prop) ) {
                                INFOLOG("GalilAxisG2::write_UserPosition(): Error in put new memorized value");
                                /****************************************************************
                                NON attivo il seguente throw in quanto perderei l'aggiornamento della
                                parte write di Position
                                Tango::Except::throw_exception (
                                        (const char *)"GalilAxisG2",
                                        (const char *)"Error in put new memorized value",
                                        (const char *)"GalilAxisG2::UpdateRelative()");
                                ****************************************************************/
			};

        	} else {
                	cout << "***** NOT WAttr " << RelativeName << " !!!!" << endl;
        	}
	}
#endif

/************************************************
*
*/
        void GalilAxisG2::write_UserPosition(Tango::WAttribute &attr){

		//	Retrieve write value
		Tango::DevDouble	w_val;
		attr.get_write_value(w_val);

		//cout << __FILE__ << "@" << __LINE__ << ":" << __func__ << endl;

		try {
               		AxisG2::write_UserPosition(attr);
			UpdateRelative("AxisCurrentPosition", w_val);
		} catch (...) {
			throw;
		}

	}

/************************************************
*
*/
        void GalilAxisG2::write_Position(Tango::WAttribute &attr){

		//	Retrieve write value
		Tango::DevDouble	w_val;
		attr.get_write_value(w_val);

		//cout << __FILE__ << "@" << __LINE__ << ":" << __func__ << endl;


		try {
       			AxisG2::write_Position(attr);

        		double upos = w_val;
        		if ( lib_func_ok ) {
               			upos = DirectFunc(upos, userDirectFuncParams);
        		};
        		upos = (*attr_UserScale_read) * upos + (*attr_UserOffset_read);
			UpdateRelative("AxisCurrentPosition", upos);
		} catch (...) {
			throw;
		}

	}

/************************************************
*
*/
        void GalilAxisG2::go_to_relative_position(Tango::DevDouble argin){
		//cout << __FILE__ << "@" << __LINE__ << ":" << __func__ << endl;
		double nowpos = attr_Position_read[0]; // non proprio il massimo ma... per ora va bene cosi'!
		AxisG2::go_to_relative_position(argin);
		try {
        		double upos = nowpos + argin;
        		if ( lib_func_ok ) {
               			upos = DirectFunc(upos, userDirectFuncParams);
        		};
        		upos = (*attr_UserScale_read) * upos + (*attr_UserOffset_read);
			UpdateRelative("AxisCurrentPosition", upos);
		} catch (...) {
			throw;
		}
	}

/************************************************
*
*/
        void GalilAxisG2::go_to_position(Tango::DevDouble argin){
		//cout << __FILE__ << "@" << __LINE__ << ":" << __func__ << endl;
		AxisG2::go_to_position(argin);
		try {
        		double upos = argin;
        		if ( lib_func_ok ) {
               			upos = DirectFunc(upos, userDirectFuncParams);
        		};
        		upos = (*attr_UserScale_read) * upos + (*attr_UserOffset_read);
			UpdateRelative("AxisCurrentPosition", upos);
		} catch (...) {
			throw;
		}
	}

/************************************************
*
*/
        Tango::DevString GalilAxisG2::define_position(Tango::DevDouble argin){
	
		Tango::DevString argout = AxisG2::define_position(argin);
		try {
        		double upos = argin;
        		if ( lib_func_ok ) {
               			upos = DirectFunc(upos, userDirectFuncParams);
        		};
        		upos = (*attr_UserScale_read) * upos + (*attr_UserOffset_read);
			UpdateRelative("AxisCurrentPosition", upos);
		} catch (...) {
			throw;
		}

		return argout;
	}


/*----- PROTECTED REGION END -----*/	//	GalilAxisG2::namespace_ending
} //	namespace
