/*----- PROTECTED REGION ID(GalilAxisG2.h) ENABLED START -----*/
//=============================================================================
//
// file :        GalilAxisG2.h
//
// description : Include file for the GalilAxisG2 class
//
// project :     
//
// This file is part of Tango device class.
// 
// Tango is free software: you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation, either version 3 of the License, or
// (at your option) any later version.
// 
// Tango is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
// 
// You should have received a copy of the GNU General Public License
// along with Tango.  If not, see <http://www.gnu.org/licenses/>.
// 
// $Author: abrami $
//
//=============================================================================
//                This file is generated by POGO
//        (Program Obviously used to Generate tango Object)
//=============================================================================


#ifndef GalilAxisG2_H
#define GalilAxisG2_H

#include <tango.h>
#include <AxisG2.h>


/*----- PROTECTED REGION END -----*/	//	GalilAxisG2.h

/**
 *  GalilAxisG2 class description:
 *    
 */

namespace GalilAxisG2_ns
{
/*----- PROTECTED REGION ID(GalilAxisG2::Additional Class Declarations) ENABLED START -----*/

//	Additional Class Declarations

/*----- PROTECTED REGION END -----*/	//	GalilAxisG2::Additional Class Declarations

class GalilAxisG2 : public AxisG2_ns::AxisG2
{

/*----- PROTECTED REGION ID(GalilAxisG2::Data Members) ENABLED START -----*/

//	Add your own data members
        Tango::DevShort *attr_IsInitialised_Galilold;


/*----- PROTECTED REGION END -----*/	//	GalilAxisG2::Data Members

//	Device property data members
public:

	bool	mandatoryNotDefined;

//	Attribute data members
public:
	Tango::DevDouble	*attr_AxisCurrentPosition_read;
	Tango::DevDouble	*attr_AxisCurrentEncoderPosition_read;
	Tango::DevLong	*attr_AxisCurrentMotorPosition_read;
	Tango::DevDouble	*attr_AxisOffset_read;
	Tango::DevDouble	*attr_AxisVelocity_read;

//	Constructors and destructors
public:
	/**
	 * Constructs a newly device object.
	 *
	 *	@param cl	Class.
	 *	@param s 	Device Name
	 */
	GalilAxisG2(Tango::DeviceClass *cl,string &s);
	/**
	 * Constructs a newly device object.
	 *
	 *	@param cl	Class.
	 *	@param s 	Device Name
	 */
	GalilAxisG2(Tango::DeviceClass *cl,const char *s);
	/**
	 * Constructs a newly device object.
	 *
	 *	@param cl	Class.
	 *	@param s 	Device name
	 *	@param d	Device description.
	 */
	GalilAxisG2(Tango::DeviceClass *cl,const char *s,const char *d);
	/**
	 * The device object destructor.
	 */	
	~GalilAxisG2() {delete_device();};


//	Miscellaneous methods
public:
	/*
	 *	will be called at device destruction or at init command.
	 */
	void delete_device();
	/*
	 *	Initialize the device
	 */
	virtual void init_device();
	/*
	 *	Always executed method before execution command method.
	 */
	virtual void always_executed_hook();

	/*
	 *	Check if mandatory property has been set
	 */
	 void check_mandatory_property(Tango::DbDatum &class_prop, Tango::DbDatum &dev_prop);

//	Attribute methods
public:
	//--------------------------------------------------------
	/*
	 *	Method      : GalilAxisG2::read_attr_hardware()
	 *	Description : Hardware acquisition for attributes.
	 */
	//--------------------------------------------------------
	virtual void read_attr_hardware(vector<long> &attr_list);
	//--------------------------------------------------------
	/*
	 *	Method      : GalilAxisG2::write_attr_hardware()
	 *	Description : Hardware writing for attributes.
	 */
	//--------------------------------------------------------
	virtual void write_attr_hardware(vector<long> &attr_list);

/**
 *	Attribute AxisCurrentPosition related methods
 *	Description: 
 *
 *	Data type:	Tango::DevDouble
 *	Attr type:	Scalar
 */
	virtual void read_AxisCurrentPosition(Tango::Attribute &attr);
	virtual void write_AxisCurrentPosition(Tango::WAttribute &attr);
	virtual bool is_AxisCurrentPosition_allowed(Tango::AttReqType type);
/**
 *	Attribute AxisCurrentEncoderPosition related methods
 *	Description: 
 *
 *	Data type:	Tango::DevDouble
 *	Attr type:	Scalar
 */
	virtual void read_AxisCurrentEncoderPosition(Tango::Attribute &attr);
	virtual bool is_AxisCurrentEncoderPosition_allowed(Tango::AttReqType type);
/**
 *	Attribute AxisCurrentMotorPosition related methods
 *	Description: 
 *
 *	Data type:	Tango::DevLong
 *	Attr type:	Scalar
 */
	virtual void read_AxisCurrentMotorPosition(Tango::Attribute &attr);
	virtual bool is_AxisCurrentMotorPosition_allowed(Tango::AttReqType type);
/**
 *	Attribute AxisOffset related methods
 *	Description: 
 *
 *	Data type:	Tango::DevDouble
 *	Attr type:	Scalar
 */
	virtual void read_AxisOffset(Tango::Attribute &attr);
	virtual void write_AxisOffset(Tango::WAttribute &attr);
	virtual bool is_AxisOffset_allowed(Tango::AttReqType type);
/**
 *	Attribute AxisVelocity related methods
 *	Description: 
 *
 *	Data type:	Tango::DevDouble
 *	Attr type:	Scalar
 */
	virtual void read_AxisVelocity(Tango::Attribute &attr);
	virtual void write_AxisVelocity(Tango::WAttribute &attr);
	virtual bool is_AxisVelocity_allowed(Tango::AttReqType type);


	//--------------------------------------------------------
	/**
	 *	Method      : GalilAxisG2::add_dynamic_attributes()
	 *	Description : Add dynamic attributes if any.
	 */
	//--------------------------------------------------------
	void add_dynamic_attributes();



//	Command related methods
public:
	/**
	 *	Command AxisStop related method
	 *	Description: 
	 *
	 */
	virtual void axis_stop();
	virtual bool is_AxisStop_allowed(const CORBA::Any &any);
	/**
	 *	Command AxisGoToRelativePosition related method
	 *	Description: 
	 *
	 *	@param argin 
	 */
	virtual void axis_go_to_relative_position(Tango::DevDouble argin);
	virtual bool is_AxisGoToRelativePosition_allowed(const CORBA::Any &any);


/*----- PROTECTED REGION ID(GalilAxisG2::Additional Method prototypes) ENABLED START -----*/

//	Additional Method prototypes

//        void UpdateRelative(string RelativeName, double value);

        void write_UserPosition(Tango::WAttribute &attr);
	void write_Position(Tango::WAttribute &attr);

        void go_to_relative_position(Tango::DevDouble argin);
        void go_to_position(Tango::DevDouble argin);

        Tango::DevString define_position(Tango::DevDouble argin);


/*----- PROTECTED REGION END -----*/	//	GalilAxisG2::Additional Method prototypes
};

/*----- PROTECTED REGION ID(GalilAxisG2::Additional Classes Definitions) ENABLED START -----*/

//	Additional Classes Definitions

/*----- PROTECTED REGION END -----*/	//	GalilAxisG2::Additional Classes Definitions

}	//	End of namespace

#endif   //	GalilAxisG2_H
