/*----- PROTECTED REGION ID(GalilAxisG2Class.cpp) ENABLED START -----*/
//=============================================================================
//
// file :        GalilAxisG2Class.cpp
//
// description : C++ source for the GalilAxisG2Class.
//               A singleton class derived from DeviceClass.
//               It implements the command and attribute list
//               and all properties and methods required
//               by the GalilAxisG2 once per process.
//
// project :     
//
// This file is part of Tango device class.
// 
// Tango is free software: you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation, either version 3 of the License, or
// (at your option) any later version.
// 
// Tango is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
// 
// You should have received a copy of the GNU General Public License
// along with Tango.  If not, see <http://www.gnu.org/licenses/>.
// 
// $Author: abrami $
//
//=============================================================================
//                This file is generated by POGO
//        (Program Obviously used to Generate tango Object)
//=============================================================================


#include <GalilAxisG2Class.h>

/*----- PROTECTED REGION END -----*/	//	GalilAxisG2Class.cpp

//-------------------------------------------------------------------
/**
 *	Create GalilAxisG2Class singleton and
 *	return it in a C function for Python usage
 */
//-------------------------------------------------------------------
extern "C" {
#ifdef _TG_WINDOWS_

__declspec(dllexport)

#endif

	Tango::DeviceClass *_create_GalilAxisG2_class(const char *name) {
		return GalilAxisG2_ns::GalilAxisG2Class::init(name);
	}
}

namespace GalilAxisG2_ns
{
//===================================================================
//	Initialize pointer for singleton pattern
//===================================================================
GalilAxisG2Class *GalilAxisG2Class::_instance = NULL;

//--------------------------------------------------------
/**
 * method : 		GalilAxisG2Class::GalilAxisG2Class(string &s)
 * description : 	constructor for the GalilAxisG2Class
 *
 * @param s	The class name
 */
//--------------------------------------------------------
GalilAxisG2Class::GalilAxisG2Class(string &s):AxisG2_ns::AxisG2Class(s)
{
	cout2 << "Entering GalilAxisG2Class constructor" << endl;
	set_default_property();
	write_class_property();

	/*----- PROTECTED REGION ID(GalilAxisG2Class::constructor) ENABLED START -----*/

        // version tag

        string Release(RELEASE);
        set_cvs_tag(Release);

        string Repository(REPO);
        set_cvs_location(Repository);

        doc_url = REPO;
	
	/*----- PROTECTED REGION END -----*/	//	GalilAxisG2Class::constructor

	cout2 << "Leaving GalilAxisG2Class constructor" << endl;
}

//--------------------------------------------------------
/**
 * method : 		GalilAxisG2Class::~GalilAxisG2Class()
 * description : 	destructor for the GalilAxisG2Class
 */
//--------------------------------------------------------
GalilAxisG2Class::~GalilAxisG2Class()
{
	/*----- PROTECTED REGION ID(GalilAxisG2Class::destructor) ENABLED START -----*/
	
	/*----- PROTECTED REGION END -----*/	//	GalilAxisG2Class::destructor

	_instance = NULL;
}


//--------------------------------------------------------
/**
 * method : 		GalilAxisG2Class::init
 * description : 	Create the object if not already done.
 *                  Otherwise, just return a pointer to the object
 *
 * @param	name	The class name
 */
//--------------------------------------------------------
GalilAxisG2Class *GalilAxisG2Class::init(const char *name)
{
	if (_instance == NULL)
	{
		try
		{
			string s(name);
			_instance = new GalilAxisG2Class(s);
		}
		catch (bad_alloc &)
		{
			throw;
		}		
	}		
	return _instance;
}

//--------------------------------------------------------
/**
 * method : 		GalilAxisG2Class::instance
 * description : 	Check if object already created,
 *                  and return a pointer to the object
 */
//--------------------------------------------------------
GalilAxisG2Class *GalilAxisG2Class::instance()
{
	if (_instance == NULL)
	{
		cerr << "Class is not initialised !!" << endl;
		exit(-1);
	}
	return _instance;
}



//===================================================================
//	Command execution method calls
//===================================================================
//--------------------------------------------------------
/**
 * method : 		AxisStopClass::execute()
 * description : 	method to trigger the execution of the command.
 *
 * @param	device	The device on which the command must be executed
 * @param	in_any	The command input data
 *
 *	returns The command output data (packed in the Any object)
 */
//--------------------------------------------------------
CORBA::Any *AxisStopClass::execute(Tango::DeviceImpl *device, TANGO_UNUSED(const CORBA::Any &in_any))
{
	cout2 << "AxisStopClass::execute(): arrived" << endl;
	((static_cast<GalilAxisG2 *>(device))->axis_stop());
	return new CORBA::Any();
}

//--------------------------------------------------------
/**
 * method : 		AxisGoToRelativePositionClass::execute()
 * description : 	method to trigger the execution of the command.
 *
 * @param	device	The device on which the command must be executed
 * @param	in_any	The command input data
 *
 *	returns The command output data (packed in the Any object)
 */
//--------------------------------------------------------
CORBA::Any *AxisGoToRelativePositionClass::execute(Tango::DeviceImpl *device, const CORBA::Any &in_any)
{
	cout2 << "AxisGoToRelativePositionClass::execute(): arrived" << endl;
	Tango::DevDouble argin;
	extract(in_any, argin);
	((static_cast<GalilAxisG2 *>(device))->axis_go_to_relative_position(argin));
	return new CORBA::Any();
}


//===================================================================
//	Properties management
//===================================================================
//--------------------------------------------------------
/**
 *	Method      : GalilAxisG2Class::get_class_property()
 *	Description : Get the class property for specified name.
 */
//--------------------------------------------------------
Tango::DbDatum GalilAxisG2Class::get_class_property(string &prop_name)
{
	for (unsigned int i=0 ; i<cl_prop.size() ; i++)
		if (cl_prop[i].name == prop_name)
			return cl_prop[i];
	//	if not found, returns  an empty DbDatum
	return Tango::DbDatum(prop_name);
}

//--------------------------------------------------------
/**
 *	Method      : GalilAxisG2Class::get_default_device_property()
 *	Description : Return the default value for device property.
 */
//--------------------------------------------------------
Tango::DbDatum GalilAxisG2Class::get_default_device_property(string &prop_name)
{
	for (unsigned int i=0 ; i<dev_def_prop.size() ; i++)
		if (dev_def_prop[i].name == prop_name)
			return dev_def_prop[i];
	//	if not found, return  an empty DbDatum
	return Tango::DbDatum(prop_name);
}

//--------------------------------------------------------
/**
 *	Method      : GalilAxisG2Class::get_default_class_property()
 *	Description : Return the default value for class property.
 */
//--------------------------------------------------------
Tango::DbDatum GalilAxisG2Class::get_default_class_property(string &prop_name)
{
	for (unsigned int i=0 ; i<cl_def_prop.size() ; i++)
		if (cl_def_prop[i].name == prop_name)
			return cl_def_prop[i];
	//	if not found, return  an empty DbDatum
	return Tango::DbDatum(prop_name);
}


//--------------------------------------------------------
/**
 *	Method      : GalilAxisG2Class::set_default_property()
 *	Description : Set default property (class and device) for wizard.
 *                For each property, add to wizard property name and description.
 *                If default value has been set, add it to wizard property and
 *                store it in a DbDatum.
 */
//--------------------------------------------------------
void GalilAxisG2Class::set_default_property()
{
	string	prop_name;
	string	prop_desc;
	string	prop_def;
	vector<string>	vect_data;

	//	Set Default Class Properties

	//	Set Default device Properties
}

//--------------------------------------------------------
/**
 *	Method      : GalilAxisG2Class::write_class_property()
 *	Description : Set class description fields as property in database
 */
//--------------------------------------------------------
void GalilAxisG2Class::write_class_property()
{
	//	First time, check if database used
	if (Tango::Util::_UseDb == false)
		return;

	Tango::DbData	data;
	string	classname = get_name();
	string	header;
	string::size_type	start, end;

	//	Put title
	Tango::DbDatum	title("ProjectTitle");
	string	str_title("");
	title << str_title;
	data.push_back(title);

	//	Put Description
	Tango::DbDatum	description("Description");
	vector<string>	str_desc;
	str_desc.push_back("");
	description << str_desc;
	data.push_back(description);

	//  Put inheritance
	Tango::DbDatum	inher_datum("InheritedFrom");
	vector<string> inheritance;
	inheritance.push_back("TANGO_BASE_CLASS");
	inher_datum << inheritance;
	data.push_back(inher_datum);

	//	Call database and and values
	get_db_class()->put_property(data);
}

//===================================================================
//	Factory methods
//===================================================================

//--------------------------------------------------------
/**
 *	Method      : GalilAxisG2Class::device_factory()
 *	Description : Create the device object(s)
 *                and store them in the device list
 */
//--------------------------------------------------------
void GalilAxisG2Class::device_factory(const Tango::DevVarStringArray *devlist_ptr)
{
	/*----- PROTECTED REGION ID(GalilAxisG2Class::device_factory_before) ENABLED START -----*/
	
	//	Add your own code
	
	/*----- PROTECTED REGION END -----*/	//	GalilAxisG2Class::device_factory_before

	//	Create devices and add it into the device list
	for (unsigned long i=0 ; i<devlist_ptr->length() ; i++)
	{
		cout4 << "Device name : " << (*devlist_ptr)[i].in() << endl;
		device_list.push_back(new GalilAxisG2(this, (*devlist_ptr)[i]));							 
	}

	//	Manage dynamic attributes if any
	erase_dynamic_attributes(devlist_ptr, get_class_attr()->get_attr_list());

	//	Export devices to the outside world
	for (unsigned long i=1 ; i<=devlist_ptr->length() ; i++)
	{
		//	Add dynamic attributes if any
		GalilAxisG2 *dev = static_cast<GalilAxisG2 *>(device_list[device_list.size()-i]);
		dev->add_dynamic_attributes();

		//	Check before if database used.
		if ((Tango::Util::_UseDb == true) && (Tango::Util::_FileDb == false))
			export_device(dev);
		else
			export_device(dev, dev->get_name().c_str());
	}

	/*----- PROTECTED REGION ID(GalilAxisG2Class::device_factory_after) ENABLED START -----*/
	
	//	Add your own code
	
	/*----- PROTECTED REGION END -----*/	//	GalilAxisG2Class::device_factory_after
}
//--------------------------------------------------------
/**
 *	Method      : GalilAxisG2Class::attribute_factory()
 *	Description : Create the attribute object(s)
 *                and store them in the attribute list
 */
//--------------------------------------------------------
void GalilAxisG2Class::attribute_factory(vector<Tango::Attr *> &att_list)
{
	/*----- PROTECTED REGION ID(GalilAxisG2Class::attribute_factory_before) ENABLED START -----*/
	
	//	Add your own code
	
	/*----- PROTECTED REGION END -----*/	//	GalilAxisG2Class::attribute_factory_before
	//	Call atribute_factory for inherited class
	AxisG2_ns::AxisG2Class::attribute_factory(att_list);

	//	Attribute : Position - Check if not concrete in inherited class
	Tango::Attr *PositionAttr = get_attr_object_by_name(att_list, "Position");
	if (PositionAttr == NULL)
	{
	}

	//	Attribute : PositiveLimitSwitch - Check if not concrete in inherited class
	Tango::Attr *PositiveLimitSwitchAttr = get_attr_object_by_name(att_list, "PositiveLimitSwitch");
	if (PositiveLimitSwitchAttr == NULL)
	{
	}

	//	Attribute : NegativeLimitSwitch - Check if not concrete in inherited class
	Tango::Attr *NegativeLimitSwitchAttr = get_attr_object_by_name(att_list, "NegativeLimitSwitch");
	if (NegativeLimitSwitchAttr == NULL)
	{
	}

	//	Attribute : HomeSwitch - Check if not concrete in inherited class
	Tango::Attr *HomeSwitchAttr = get_attr_object_by_name(att_list, "HomeSwitch");
	if (HomeSwitchAttr == NULL)
	{
	}

	//	Attribute : MotorStatus - Check if not concrete in inherited class
	Tango::Attr *MotorStatusAttr = get_attr_object_by_name(att_list, "MotorStatus");
	if (MotorStatusAttr == NULL)
	{
	}

	//	Attribute : EncoderPosition - Check if not concrete in inherited class
	Tango::Attr *EncoderPositionAttr = get_attr_object_by_name(att_list, "EncoderPosition");
	if (EncoderPositionAttr == NULL)
	{
	}

	//	Attribute : MotorPosition - Check if not concrete in inherited class
	Tango::Attr *MotorPositionAttr = get_attr_object_by_name(att_list, "MotorPosition");
	if (MotorPositionAttr == NULL)
	{
	}

	//	Attribute : UserPosition - Check if not concrete in inherited class
	Tango::Attr *UserPositionAttr = get_attr_object_by_name(att_list, "UserPosition");
	if (UserPositionAttr == NULL)
	{
	}

	//	Attribute : UserScale - Check if not concrete in inherited class
	Tango::Attr *UserScaleAttr = get_attr_object_by_name(att_list, "UserScale");
	if (UserScaleAttr == NULL)
	{
	}

	//	Attribute : UserOffset - Check if not concrete in inherited class
	Tango::Attr *UserOffsetAttr = get_attr_object_by_name(att_list, "UserOffset");
	if (UserOffsetAttr == NULL)
	{
	}

	//	Attribute : Speed - Check if not concrete in inherited class
	Tango::Attr *SpeedAttr = get_attr_object_by_name(att_list, "Speed");
	if (SpeedAttr == NULL)
	{
	}

	//	Attribute : Acceleration - Check if not concrete in inherited class
	Tango::Attr *AccelerationAttr = get_attr_object_by_name(att_list, "Acceleration");
	if (AccelerationAttr == NULL)
	{
	}

	//	Attribute : Deceleration - Check if not concrete in inherited class
	Tango::Attr *DecelerationAttr = get_attr_object_by_name(att_list, "Deceleration");
	if (DecelerationAttr == NULL)
	{
	}

	//	Attribute : MotionAccuracy - Check if not concrete in inherited class
	Tango::Attr *MotionAccuracyAttr = get_attr_object_by_name(att_list, "MotionAccuracy");
	if (MotionAccuracyAttr == NULL)
	{
	}

	//	Attribute : MotionPercent - Check if not concrete in inherited class
	Tango::Attr *MotionPercentAttr = get_attr_object_by_name(att_list, "MotionPercent");
	if (MotionPercentAttr == NULL)
	{
	}

	//	Attribute : MotionRetry - Check if not concrete in inherited class
	Tango::Attr *MotionRetryAttr = get_attr_object_by_name(att_list, "MotionRetry");
	if (MotionRetryAttr == NULL)
	{
	}

	//	Attribute : Backlash - Check if not concrete in inherited class
	Tango::Attr *BacklashAttr = get_attr_object_by_name(att_list, "Backlash");
	if (BacklashAttr == NULL)
	{
	}

	//	Attribute : BacklashDirection - Check if not concrete in inherited class
	Tango::Attr *BacklashDirectionAttr = get_attr_object_by_name(att_list, "BacklashDirection");
	if (BacklashDirectionAttr == NULL)
	{
	}

	//	Attribute : Velocity - Check if not concrete in inherited class
	Tango::Attr *VelocityAttr = get_attr_object_by_name(att_list, "Velocity");
	if (VelocityAttr == NULL)
	{
	}

	//	Attribute : IsInitialised - Check if not concrete in inherited class
	Tango::Attr *IsInitialisedAttr = get_attr_object_by_name(att_list, "IsInitialised");
	if (IsInitialisedAttr == NULL)
	{
	}

	//	Attribute : DeviceState - Check if not concrete in inherited class
	Tango::Attr *DeviceStateAttr = get_attr_object_by_name(att_list, "DeviceState");
	if (DeviceStateAttr == NULL)
	{
	}

	//	Attribute : DeviceStatus - Check if not concrete in inherited class
	Tango::Attr *DeviceStatusAttr = get_attr_object_by_name(att_list, "DeviceStatus");
	if (DeviceStatusAttr == NULL)
	{
	}

	//	Attribute : IsMicrocodeOK - Check if not concrete in inherited class
	Tango::Attr *IsMicrocodeOKAttr = get_attr_object_by_name(att_list, "IsMicrocodeOK");
	if (IsMicrocodeOKAttr == NULL)
	{
	}

	//	Attribute : CheckEncoder - Check if not concrete in inherited class
	Tango::Attr *CheckEncoderAttr = get_attr_object_by_name(att_list, "CheckEncoder");
	if (CheckEncoderAttr == NULL)
	{
	}

	//	Attribute : CheckEncoderHoldOn - Check if not concrete in inherited class
	Tango::Attr *CheckEncoderHoldOnAttr = get_attr_object_by_name(att_list, "CheckEncoderHoldOn");
	if (CheckEncoderHoldOnAttr == NULL)
	{
	}

	//	Attribute : AxisCurrentPosition
	AxisCurrentPositionAttrib	*axiscurrentposition = new AxisCurrentPositionAttrib();
	Tango::UserDefaultAttrProp	axiscurrentposition_prop;
	//	description	not set for AxisCurrentPosition
	axiscurrentposition_prop.set_label("#Current position");
	//	unit	not set for AxisCurrentPosition
	//	standard_unit	not set for AxisCurrentPosition
	//	display_unit	not set for AxisCurrentPosition
	//	format	not set for AxisCurrentPosition
	//	max_value	not set for AxisCurrentPosition
	//	min_value	not set for AxisCurrentPosition
	//	max_alarm	not set for AxisCurrentPosition
	//	min_alarm	not set for AxisCurrentPosition
	//	max_warning	not set for AxisCurrentPosition
	//	min_warning	not set for AxisCurrentPosition
	//	delta_t	not set for AxisCurrentPosition
	//	delta_val	not set for AxisCurrentPosition
	
	axiscurrentposition->set_default_properties(axiscurrentposition_prop);
	//	Not Polled
	axiscurrentposition->set_disp_level(Tango::EXPERT);
	axiscurrentposition->set_memorized();
	axiscurrentposition->set_memorized_init(false);
	att_list.push_back(axiscurrentposition);

	//	Attribute : AxisCurrentEncoderPosition
	AxisCurrentEncoderPositionAttrib	*axiscurrentencoderposition = new AxisCurrentEncoderPositionAttrib();
	Tango::UserDefaultAttrProp	axiscurrentencoderposition_prop;
	//	description	not set for AxisCurrentEncoderPosition
	axiscurrentencoderposition_prop.set_label("#Encoder position");
	axiscurrentencoderposition_prop.set_unit("EncoderUnits");
	//	standard_unit	not set for AxisCurrentEncoderPosition
	//	display_unit	not set for AxisCurrentEncoderPosition
	//	format	not set for AxisCurrentEncoderPosition
	//	max_value	not set for AxisCurrentEncoderPosition
	//	min_value	not set for AxisCurrentEncoderPosition
	//	max_alarm	not set for AxisCurrentEncoderPosition
	//	min_alarm	not set for AxisCurrentEncoderPosition
	//	max_warning	not set for AxisCurrentEncoderPosition
	//	min_warning	not set for AxisCurrentEncoderPosition
	//	delta_t	not set for AxisCurrentEncoderPosition
	//	delta_val	not set for AxisCurrentEncoderPosition
	
	axiscurrentencoderposition->set_default_properties(axiscurrentencoderposition_prop);
	//	Not Polled
	axiscurrentencoderposition->set_disp_level(Tango::EXPERT);
	//	Not Memorized
	att_list.push_back(axiscurrentencoderposition);

	//	Attribute : AxisCurrentMotorPosition
	AxisCurrentMotorPositionAttrib	*axiscurrentmotorposition = new AxisCurrentMotorPositionAttrib();
	Tango::UserDefaultAttrProp	axiscurrentmotorposition_prop;
	//	description	not set for AxisCurrentMotorPosition
	axiscurrentmotorposition_prop.set_label("#Motor position");
	axiscurrentmotorposition_prop.set_unit("steps");
	axiscurrentmotorposition_prop.set_standard_unit("steps");
	axiscurrentmotorposition_prop.set_display_unit("steps");
	axiscurrentmotorposition_prop.set_format("%10d");
	//	max_value	not set for AxisCurrentMotorPosition
	//	min_value	not set for AxisCurrentMotorPosition
	//	max_alarm	not set for AxisCurrentMotorPosition
	//	min_alarm	not set for AxisCurrentMotorPosition
	//	max_warning	not set for AxisCurrentMotorPosition
	//	min_warning	not set for AxisCurrentMotorPosition
	//	delta_t	not set for AxisCurrentMotorPosition
	//	delta_val	not set for AxisCurrentMotorPosition
	
	axiscurrentmotorposition->set_default_properties(axiscurrentmotorposition_prop);
	//	Not Polled
	axiscurrentmotorposition->set_disp_level(Tango::EXPERT);
	//	Not Memorized
	att_list.push_back(axiscurrentmotorposition);

	//	Attribute : AxisOffset
	AxisOffsetAttrib	*axisoffset = new AxisOffsetAttrib();
	Tango::UserDefaultAttrProp	axisoffset_prop;
	//	description	not set for AxisOffset
	axisoffset_prop.set_label("#Axis Offset");
	//	unit	not set for AxisOffset
	//	standard_unit	not set for AxisOffset
	//	display_unit	not set for AxisOffset
	//	format	not set for AxisOffset
	//	max_value	not set for AxisOffset
	//	min_value	not set for AxisOffset
	//	max_alarm	not set for AxisOffset
	//	min_alarm	not set for AxisOffset
	//	max_warning	not set for AxisOffset
	//	min_warning	not set for AxisOffset
	//	delta_t	not set for AxisOffset
	//	delta_val	not set for AxisOffset
	
	axisoffset->set_default_properties(axisoffset_prop);
	//	Not Polled
	axisoffset->set_disp_level(Tango::EXPERT);
	axisoffset->set_memorized();
	axisoffset->set_memorized_init(false);
	att_list.push_back(axisoffset);

	//	Attribute : AxisVelocity
	AxisVelocityAttrib	*axisvelocity = new AxisVelocityAttrib();
	Tango::UserDefaultAttrProp	axisvelocity_prop;
	//	description	not set for AxisVelocity
	axisvelocity_prop.set_label("#AxisVelocity");
	//	unit	not set for AxisVelocity
	//	standard_unit	not set for AxisVelocity
	//	display_unit	not set for AxisVelocity
	//	format	not set for AxisVelocity
	//	max_value	not set for AxisVelocity
	//	min_value	not set for AxisVelocity
	//	max_alarm	not set for AxisVelocity
	//	min_alarm	not set for AxisVelocity
	//	max_warning	not set for AxisVelocity
	//	min_warning	not set for AxisVelocity
	//	delta_t	not set for AxisVelocity
	//	delta_val	not set for AxisVelocity
	
	axisvelocity->set_default_properties(axisvelocity_prop);
	//	Not Polled
	axisvelocity->set_disp_level(Tango::EXPERT);
	axisvelocity->set_memorized();
	axisvelocity->set_memorized_init(false);
	att_list.push_back(axisvelocity);

	//	Attribute : UserSpeed - Check if not concrete in inherited class
	Tango::Attr *UserSpeedAttr = get_attr_object_by_name(att_list, "UserSpeed");
	if (UserSpeedAttr == NULL)
	{
	}

	//	Attribute : ExtStatus - Check if not concrete in inherited class
	Tango::Attr *ExtStatusAttr = get_attr_object_by_name(att_list, "ExtStatus");
	if (ExtStatusAttr == NULL)
	{
	}

	//	Create a list of static attributes
	create_static_attribute_list(get_class_attr()->get_attr_list());
	/*----- PROTECTED REGION ID(GalilAxisG2Class::attribute_factory_after) ENABLED START -----*/
	
	//	Add your own code
	
	/*----- PROTECTED REGION END -----*/	//	GalilAxisG2Class::attribute_factory_after
}
//--------------------------------------------------------
/**
 *	Method      : GalilAxisG2Class::command_factory()
 *	Description : Create the command object(s)
 *                and store them in the command list
 */
//--------------------------------------------------------
void GalilAxisG2Class::command_factory()
{
	/*----- PROTECTED REGION ID(GalilAxisG2Class::command_factory_before) ENABLED START -----*/
	
	//	Add your own code
	
	/*----- PROTECTED REGION END -----*/	//	GalilAxisG2Class::command_factory_before
	//	Call command_factory for inherited class
	AxisG2_ns::AxisG2Class::command_factory();
























	//	Command AxisStop
	AxisStopClass	*pAxisStopCmd =
		new AxisStopClass("AxisStop",
			Tango::DEV_VOID, Tango::DEV_VOID,
			"",
			"",
			Tango::OPERATOR);
	command_list.push_back(pAxisStopCmd);

	//	Command AxisGoToRelativePosition
	AxisGoToRelativePositionClass	*pAxisGoToRelativePositionCmd =
		new AxisGoToRelativePositionClass("AxisGoToRelativePosition",
			Tango::DEV_DOUBLE, Tango::DEV_VOID,
			"",
			"",
			Tango::OPERATOR);
	command_list.push_back(pAxisGoToRelativePositionCmd);

	/*----- PROTECTED REGION ID(GalilAxisG2Class::command_factory_after) ENABLED START -----*/
	
	//	Add your own code
	
	/*----- PROTECTED REGION END -----*/	//	GalilAxisG2Class::command_factory_after
}

//===================================================================
//	Dynamic attributes related methods
//===================================================================

//--------------------------------------------------------
/**
 * method : 		GalilAxisG2Class::create_static_attribute_list
 * description : 	Create the a list of static attributes
 *
 * @param	att_list	the ceated attribute list 
 */
//--------------------------------------------------------
void GalilAxisG2Class::create_static_attribute_list(vector<Tango::Attr *> &att_list)
{
	for (unsigned long i=0 ; i<att_list.size() ; i++)
	{
		string att_name(att_list[i]->get_name());
		transform(att_name.begin(), att_name.end(), att_name.begin(), ::tolower);
		defaultAttList.push_back(att_name);
	}

	cout2 << defaultAttList.size() << " attributes in default list" << endl;

	/*----- PROTECTED REGION ID(GalilAxisG2Class::create_static_att_list) ENABLED START -----*/
	
	/*----- PROTECTED REGION END -----*/	//	GalilAxisG2Class::create_static_att_list
}


//--------------------------------------------------------
/**
 * method : 		GalilAxisG2Class::erase_dynamic_attributes
 * description : 	delete the dynamic attributes if any.
 *
 * @param	devlist_ptr	the device list pointer
 * @param	list of all attributes
 */
//--------------------------------------------------------
void GalilAxisG2Class::erase_dynamic_attributes(const Tango::DevVarStringArray *devlist_ptr, vector<Tango::Attr *> &att_list)
{
	Tango::Util *tg = Tango::Util::instance();

	for (unsigned long i=0 ; i<devlist_ptr->length() ; i++)
	{	
		Tango::DeviceImpl *dev_impl = tg->get_device_by_name(((string)(*devlist_ptr)[i]).c_str());
		GalilAxisG2 *dev = static_cast<GalilAxisG2 *> (dev_impl);
		
		vector<Tango::Attribute *> &dev_att_list = dev->get_device_attr()->get_attribute_list();
		vector<Tango::Attribute *>::iterator ite_att;
		for (ite_att=dev_att_list.begin() ; ite_att != dev_att_list.end() ; ++ite_att)
		{
			string att_name((*ite_att)->get_name_lower());
			if ((att_name == "state") || (att_name == "status"))
				continue;
			vector<string>::iterator ite_str = find(defaultAttList.begin(), defaultAttList.end(), att_name);
			if (ite_str == defaultAttList.end())
			{
				cout2 << att_name << " is a UNWANTED dynamic attribute for device " << (*devlist_ptr)[i] << endl;
				Tango::Attribute &att = dev->get_device_attr()->get_attr_by_name(att_name.c_str());
				dev->remove_attribute(att_list[att.get_attr_idx()], true, false);
				--ite_att;
			}
		}
	}
	/*----- PROTECTED REGION ID(GalilAxisG2Class::erase_dynamic_attributes) ENABLED START -----*/
	
	/*----- PROTECTED REGION END -----*/	//	GalilAxisG2Class::erase_dynamic_attributes
}

//--------------------------------------------------------
/**
 *	Method      : GalilAxisG2Class::get_attr_by_name()
 *	Description : returns Tango::Attr * object found by name
 */
//--------------------------------------------------------
Tango::Attr *GalilAxisG2Class::get_attr_object_by_name(vector<Tango::Attr *> &att_list, string attname)
{
	vector<Tango::Attr *>::iterator it;
	for (it=att_list.begin() ; it<att_list.end() ; it++)
		if ((*it)->get_name()==attname)
			return (*it);
	//	Attr does not exist
	return NULL;
}


/*----- PROTECTED REGION ID(GalilAxisG2Class::Additional Methods) ENABLED START -----*/

/*----- PROTECTED REGION END -----*/	//	GalilAxisG2Class::Additional Methods
} //	namespace
