/*----- PROTECTED REGION ID(GalilAxisG2Class.h) ENABLED START -----*/
//=============================================================================
//
// file :        GalilAxisG2Class.h
//
// description : Include for the GalilAxisG2 root class.
//               This class is the singleton class for
//                the GalilAxisG2 device class.
//               It contains all properties and methods which the 
//               GalilAxisG2 requires only once e.g. the commands.
//
// project :     
//
// This file is part of Tango device class.
// 
// Tango is free software: you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation, either version 3 of the License, or
// (at your option) any later version.
// 
// Tango is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
// 
// You should have received a copy of the GNU General Public License
// along with Tango.  If not, see <http://www.gnu.org/licenses/>.
// 
// $Author: abrami $
//
//=============================================================================
//                This file is generated by POGO
//        (Program Obviously used to Generate tango Object)
//=============================================================================


#ifndef GalilAxisG2Class_H
#define GalilAxisG2Class_H

#include <tango.h>
#include <AxisG2Class.h>
#include <GalilAxisG2.h>


/*----- PROTECTED REGION END -----*/	//	GalilAxisG2Class.h


namespace GalilAxisG2_ns
{
/*----- PROTECTED REGION ID(GalilAxisG2Class::classes for dynamic creation) ENABLED START -----*/


/*----- PROTECTED REGION END -----*/	//	GalilAxisG2Class::classes for dynamic creation

//=========================================
//	Define classes for attributes
//=========================================
//	Attribute AxisCurrentPosition class definition
class AxisCurrentPositionAttrib: public Tango::Attr
{
public:
	AxisCurrentPositionAttrib():Attr("AxisCurrentPosition",
			Tango::DEV_DOUBLE, Tango::READ_WRITE) {};
	~AxisCurrentPositionAttrib() {};
	virtual void read(Tango::DeviceImpl *dev,Tango::Attribute &att)
		{(static_cast<GalilAxisG2 *>(dev))->read_AxisCurrentPosition(att);}
	virtual void write(Tango::DeviceImpl *dev,Tango::WAttribute &att)
		{(static_cast<GalilAxisG2 *>(dev))->write_AxisCurrentPosition(att);}
	virtual bool is_allowed(Tango::DeviceImpl *dev,Tango::AttReqType ty)
		{return (static_cast<GalilAxisG2 *>(dev))->is_AxisCurrentPosition_allowed(ty);}
};

//	Attribute AxisCurrentEncoderPosition class definition
class AxisCurrentEncoderPositionAttrib: public Tango::Attr
{
public:
	AxisCurrentEncoderPositionAttrib():Attr("AxisCurrentEncoderPosition",
			Tango::DEV_DOUBLE, Tango::READ) {};
	~AxisCurrentEncoderPositionAttrib() {};
	virtual void read(Tango::DeviceImpl *dev,Tango::Attribute &att)
		{(static_cast<GalilAxisG2 *>(dev))->read_AxisCurrentEncoderPosition(att);}
	virtual bool is_allowed(Tango::DeviceImpl *dev,Tango::AttReqType ty)
		{return (static_cast<GalilAxisG2 *>(dev))->is_AxisCurrentEncoderPosition_allowed(ty);}
};

//	Attribute AxisCurrentMotorPosition class definition
class AxisCurrentMotorPositionAttrib: public Tango::Attr
{
public:
	AxisCurrentMotorPositionAttrib():Attr("AxisCurrentMotorPosition",
			Tango::DEV_LONG, Tango::READ) {};
	~AxisCurrentMotorPositionAttrib() {};
	virtual void read(Tango::DeviceImpl *dev,Tango::Attribute &att)
		{(static_cast<GalilAxisG2 *>(dev))->read_AxisCurrentMotorPosition(att);}
	virtual bool is_allowed(Tango::DeviceImpl *dev,Tango::AttReqType ty)
		{return (static_cast<GalilAxisG2 *>(dev))->is_AxisCurrentMotorPosition_allowed(ty);}
};

//	Attribute AxisOffset class definition
class AxisOffsetAttrib: public Tango::Attr
{
public:
	AxisOffsetAttrib():Attr("AxisOffset",
			Tango::DEV_DOUBLE, Tango::READ_WRITE) {};
	~AxisOffsetAttrib() {};
	virtual void read(Tango::DeviceImpl *dev,Tango::Attribute &att)
		{(static_cast<GalilAxisG2 *>(dev))->read_AxisOffset(att);}
	virtual void write(Tango::DeviceImpl *dev,Tango::WAttribute &att)
		{(static_cast<GalilAxisG2 *>(dev))->write_AxisOffset(att);}
	virtual bool is_allowed(Tango::DeviceImpl *dev,Tango::AttReqType ty)
		{return (static_cast<GalilAxisG2 *>(dev))->is_AxisOffset_allowed(ty);}
};

//	Attribute AxisVelocity class definition
class AxisVelocityAttrib: public Tango::Attr
{
public:
	AxisVelocityAttrib():Attr("AxisVelocity",
			Tango::DEV_DOUBLE, Tango::READ_WRITE) {};
	~AxisVelocityAttrib() {};
	virtual void read(Tango::DeviceImpl *dev,Tango::Attribute &att)
		{(static_cast<GalilAxisG2 *>(dev))->read_AxisVelocity(att);}
	virtual void write(Tango::DeviceImpl *dev,Tango::WAttribute &att)
		{(static_cast<GalilAxisG2 *>(dev))->write_AxisVelocity(att);}
	virtual bool is_allowed(Tango::DeviceImpl *dev,Tango::AttReqType ty)
		{return (static_cast<GalilAxisG2 *>(dev))->is_AxisVelocity_allowed(ty);}
};


//=========================================
//	Define classes for commands
//=========================================
//	Command AxisStop class definition
class AxisStopClass : public Tango::Command
{
public:
	AxisStopClass(const char   *name,
	               Tango::CmdArgType in,
				   Tango::CmdArgType out,
				   const char        *in_desc,
				   const char        *out_desc,
				   Tango::DispLevel  level)
	:Command(name,in,out,in_desc,out_desc, level)	{};

	AxisStopClass(const char   *name,
	               Tango::CmdArgType in,
				   Tango::CmdArgType out)
	:Command(name,in,out)	{};
	~AxisStopClass() {};
	
	virtual CORBA::Any *execute (Tango::DeviceImpl *dev, const CORBA::Any &any);
	virtual bool is_allowed (Tango::DeviceImpl *dev, const CORBA::Any &any)
	{return (static_cast<GalilAxisG2 *>(dev))->is_AxisStop_allowed(any);}
};

//	Command AxisGoToRelativePosition class definition
class AxisGoToRelativePositionClass : public Tango::Command
{
public:
	AxisGoToRelativePositionClass(const char   *name,
	               Tango::CmdArgType in,
				   Tango::CmdArgType out,
				   const char        *in_desc,
				   const char        *out_desc,
				   Tango::DispLevel  level)
	:Command(name,in,out,in_desc,out_desc, level)	{};

	AxisGoToRelativePositionClass(const char   *name,
	               Tango::CmdArgType in,
				   Tango::CmdArgType out)
	:Command(name,in,out)	{};
	~AxisGoToRelativePositionClass() {};
	
	virtual CORBA::Any *execute (Tango::DeviceImpl *dev, const CORBA::Any &any);
	virtual bool is_allowed (Tango::DeviceImpl *dev, const CORBA::Any &any)
	{return (static_cast<GalilAxisG2 *>(dev))->is_AxisGoToRelativePosition_allowed(any);}
};


/**
 *	The GalilAxisG2Class singleton definition
 */

#ifdef _TG_WINDOWS_
class __declspec(dllexport)  GalilAxisG2Class : public AxisG2_ns::AxisG2Class
#else
class GalilAxisG2Class : public AxisG2_ns::AxisG2Class
#endif
{
	/*----- PROTECTED REGION ID(GalilAxisG2Class::Additionnal DServer data members) ENABLED START -----*/
	
	
	/*----- PROTECTED REGION END -----*/	//	GalilAxisG2Class::Additionnal DServer data members

	public:
		//	write class properties data members
		Tango::DbData	cl_prop;
		Tango::DbData	cl_def_prop;
		Tango::DbData	dev_def_prop;
	
		//	Method prototypes
		static GalilAxisG2Class *init(const char *);
		static GalilAxisG2Class *instance();
		~GalilAxisG2Class();
		Tango::DbDatum	get_class_property(string &);
		Tango::DbDatum	get_default_device_property(string &);
		Tango::DbDatum	get_default_class_property(string &);
	
	protected:
		GalilAxisG2Class(string &);
		static GalilAxisG2Class *_instance;
		void command_factory();
		void attribute_factory(vector<Tango::Attr *> &);
		void write_class_property();
		void set_default_property();
		void get_class_property();
		string get_cvstag();
		string get_cvsroot();
	
	private:
		void device_factory(const Tango::DevVarStringArray *);
		void create_static_attribute_list(vector<Tango::Attr *> &);
		void erase_dynamic_attributes(const Tango::DevVarStringArray *,vector<Tango::Attr *> &);
		vector<string>	defaultAttList;
		Tango::Attr *get_attr_object_by_name(vector<Tango::Attr *> &att_list, string attname);
};

}	//	End of namespace

#endif   //	GalilAxisG2_H
