/*----- PROTECTED REGION ID(GalilAxisG2StateMachine.cpp) ENABLED START -----*/
//=============================================================================
//
// file :        GalilAxisG2StateMachine.cpp
//
// description : State machine file for the GalilAxisG2 class
//
// project :     
//
// This file is part of Tango device class.
// 
// Tango is free software: you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation, either version 3 of the License, or
// (at your option) any later version.
// 
// Tango is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
// 
// You should have received a copy of the GNU General Public License
// along with Tango.  If not, see <http://www.gnu.org/licenses/>.
// 
// $Author: abrami $
//
//=============================================================================
//                This file is generated by POGO
//        (Program Obviously used to Generate tango Object)
//=============================================================================

#include <GalilAxisG2.h>

/*----- PROTECTED REGION END -----*/	//	GalilAxisG2::GalilAxisG2StateMachine.cpp

//================================================================
//  States   |  Description
//================================================================
//  OFF      |  Communication broken with the motion controller
//  STANDBY  |  Axis OK, waiting for commands
//  MOVING   |  Axis is moving
//  FAULT    |  Failure on the axis. Can be hardware failure .
//  ALARM    |  Alarm on the axis. can be soft or hard limit, abort input...
//  DISABLE  |  For debug purpose


namespace GalilAxisG2_ns
{
//=================================================
//		Attributes Allowed Methods
//=================================================

//--------------------------------------------------------
/**
 *	Method      : GalilAxisG2::is_AxisCurrentPosition_allowed()
 *	Description : Execution allowed for AxisCurrentPosition attribute
 */
//--------------------------------------------------------
bool GalilAxisG2::is_AxisCurrentPosition_allowed(TANGO_UNUSED(Tango::AttReqType type))
{
	//	Not any excluded states for AxisCurrentPosition attribute in Write access.
	/*----- PROTECTED REGION ID(GalilAxisG2::AxisCurrentPositionStateAllowed_WRITE) ENABLED START -----*/
	
	/*----- PROTECTED REGION END -----*/	//	GalilAxisG2::AxisCurrentPositionStateAllowed_WRITE

	//	Not any excluded states for AxisCurrentPosition attribute in read access.
	/*----- PROTECTED REGION ID(GalilAxisG2::AxisCurrentPositionStateAllowed_READ) ENABLED START -----*/
	
	/*----- PROTECTED REGION END -----*/	//	GalilAxisG2::AxisCurrentPositionStateAllowed_READ
	return true;
}

//--------------------------------------------------------
/**
 *	Method      : GalilAxisG2::is_AxisCurrentEncoderPosition_allowed()
 *	Description : Execution allowed for AxisCurrentEncoderPosition attribute
 */
//--------------------------------------------------------
bool GalilAxisG2::is_AxisCurrentEncoderPosition_allowed(TANGO_UNUSED(Tango::AttReqType type))
{

	//	Not any excluded states for AxisCurrentEncoderPosition attribute in read access.
	/*----- PROTECTED REGION ID(GalilAxisG2::AxisCurrentEncoderPositionStateAllowed_READ) ENABLED START -----*/
	
	/*----- PROTECTED REGION END -----*/	//	GalilAxisG2::AxisCurrentEncoderPositionStateAllowed_READ
	return true;
}

//--------------------------------------------------------
/**
 *	Method      : GalilAxisG2::is_AxisCurrentMotorPosition_allowed()
 *	Description : Execution allowed for AxisCurrentMotorPosition attribute
 */
//--------------------------------------------------------
bool GalilAxisG2::is_AxisCurrentMotorPosition_allowed(TANGO_UNUSED(Tango::AttReqType type))
{

	//	Not any excluded states for AxisCurrentMotorPosition attribute in read access.
	/*----- PROTECTED REGION ID(GalilAxisG2::AxisCurrentMotorPositionStateAllowed_READ) ENABLED START -----*/
	
	/*----- PROTECTED REGION END -----*/	//	GalilAxisG2::AxisCurrentMotorPositionStateAllowed_READ
	return true;
}

//--------------------------------------------------------
/**
 *	Method      : GalilAxisG2::is_AxisOffset_allowed()
 *	Description : Execution allowed for AxisOffset attribute
 */
//--------------------------------------------------------
bool GalilAxisG2::is_AxisOffset_allowed(TANGO_UNUSED(Tango::AttReqType type))
{
	//	Not any excluded states for AxisOffset attribute in Write access.
	/*----- PROTECTED REGION ID(GalilAxisG2::AxisOffsetStateAllowed_WRITE) ENABLED START -----*/
	
	/*----- PROTECTED REGION END -----*/	//	GalilAxisG2::AxisOffsetStateAllowed_WRITE

	//	Not any excluded states for AxisOffset attribute in read access.
	/*----- PROTECTED REGION ID(GalilAxisG2::AxisOffsetStateAllowed_READ) ENABLED START -----*/
	
	/*----- PROTECTED REGION END -----*/	//	GalilAxisG2::AxisOffsetStateAllowed_READ
	return true;
}

//--------------------------------------------------------
/**
 *	Method      : GalilAxisG2::is_AxisVelocity_allowed()
 *	Description : Execution allowed for AxisVelocity attribute
 */
//--------------------------------------------------------
bool GalilAxisG2::is_AxisVelocity_allowed(TANGO_UNUSED(Tango::AttReqType type))
{
	//	Not any excluded states for AxisVelocity attribute in Write access.
	/*----- PROTECTED REGION ID(GalilAxisG2::AxisVelocityStateAllowed_WRITE) ENABLED START -----*/
	
	/*----- PROTECTED REGION END -----*/	//	GalilAxisG2::AxisVelocityStateAllowed_WRITE

	//	Not any excluded states for AxisVelocity attribute in read access.
	/*----- PROTECTED REGION ID(GalilAxisG2::AxisVelocityStateAllowed_READ) ENABLED START -----*/
	
	/*----- PROTECTED REGION END -----*/	//	GalilAxisG2::AxisVelocityStateAllowed_READ
	return true;
}

//=================================================
//		Commands Allowed Methods
//=================================================

//--------------------------------------------------------
/**
 *	Method      : GalilAxisG2::is_AxisStop_allowed()
 *	Description : Execution allowed for AxisStop attribute
 */
//--------------------------------------------------------
bool GalilAxisG2::is_AxisStop_allowed(TANGO_UNUSED(const CORBA::Any &any))
{
	//	Not any excluded states for AxisStop command.
	/*----- PROTECTED REGION ID(GalilAxisG2::AxisStopStateAllowed) ENABLED START -----*/
	
	/*----- PROTECTED REGION END -----*/	//	GalilAxisG2::AxisStopStateAllowed
	return true;
}

//--------------------------------------------------------
/**
 *	Method      : GalilAxisG2::is_AxisGoToRelativePosition_allowed()
 *	Description : Execution allowed for AxisGoToRelativePosition attribute
 */
//--------------------------------------------------------
bool GalilAxisG2::is_AxisGoToRelativePosition_allowed(TANGO_UNUSED(const CORBA::Any &any))
{
	//	Not any excluded states for AxisGoToRelativePosition command.
	/*----- PROTECTED REGION ID(GalilAxisG2::AxisGoToRelativePositionStateAllowed) ENABLED START -----*/
	
	/*----- PROTECTED REGION END -----*/	//	GalilAxisG2::AxisGoToRelativePositionStateAllowed
	return true;
}

}	//	End of namespace
